package org.eclipse.xtend.core.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.xtend.core.services.XtendGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
/*******************************************************************************
 * Copyright (c) 2010-2017 itemis AG (http://www.itemis.eu) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
@SuppressWarnings("all")
public class InternalXtendParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "KW_Package", "KW_Semicolon", "KW_Class", "KW_LessThanSign", "KW_Comma", "KW_GreaterThanSign", "KW_Extends", "KW_Implements", "KW_LeftCurlyBracket", "KW_RightCurlyBracket", "KW_Interface", "KW_Enum", "KW_Annotation", "KW_LeftParenthesis", "KW_RightParenthesis", "KW_EqualsSignGreaterThanSign", "KW_EqualsSign", "KW_Extension", "KW_Throws", "KW_New", "KW_FullStop", "KW_Public", "KW_Private", "KW_Protected", "KW_Abstract", "KW_Static", "KW_Dispatch", "KW_Final", "KW_Strictfp", "KW_Native", "KW_Volatile", "KW_Synchronized", "KW_Transient", "KW_Val", "KW_Var", "KW_Def", "KW_Override", "KW_Create", "KW_Colon", "KW_AFTER", "KW_BEFORE", "KW_SEPARATOR", "KW_Import", "KW_FullStopFullStopFullStop", "KW_Switch", "KW_Default", "KW_FOR", "KW_ENDFOR", "KW_IF", "KW_ELSE", "KW_ENDIF", "KW_ELSEIF", "KW_CommercialAt", "KW_NumberSign", "KW_LeftSquareBracket", "KW_RightSquareBracket", "KW_PlusSignEqualsSign", "KW_HyphenMinusEqualsSign", "KW_AsteriskEqualsSign", "KW_SolidusEqualsSign", "KW_PercentSignEqualsSign", "KW_GreaterThanSignEqualsSign", "KW_VerticalLineVerticalLine", "KW_AmpersandAmpersand", "KW_EqualsSignEqualsSign", "KW_ExclamationMarkEqualsSign", "KW_EqualsSignEqualsSignEqualsSign", "KW_ExclamationMarkEqualsSignEqualsSign", "KW_Instanceof", "KW_HyphenMinusGreaterThanSign", "KW_FullStopFullStopLessThanSign", "KW_FullStopFullStop", "KW_LessThanSignGreaterThanSign", "KW_QuestionMarkColon", "KW_PlusSign", "KW_HyphenMinus", "KW_Asterisk", "KW_AsteriskAsterisk", "KW_Solidus", "KW_PercentSign", "KW_ExclamationMark", "KW_As", "KW_PlusSignPlusSign", "KW_HyphenMinusHyphenMinus", "KW_ColonColon", "KW_QuestionMarkFullStop", "KW_VerticalLine", "KW_If", "KW_Else", "KW_Case", "KW_For", "KW_While", "KW_Do", "KW_Super", "KW_False", "KW_True", "KW_Null", "KW_Typeof", "KW_Throw", "KW_Return", "KW_Try", "KW_Finally", "KW_Catch", "KW_QuestionMark", "KW_Ampersand", "RULE_ID", "RULE_STRING", "RULE_RICH_TEXT", "RULE_RICH_TEXT_START", "RULE_RICH_TEXT_INBETWEEN", "RULE_COMMENT_RICH_TEXT_INBETWEEN", "RULE_RICH_TEXT_END", "RULE_COMMENT_RICH_TEXT_END", "RULE_HEX", "RULE_INT", "RULE_DECIMAL", "RULE_IDENTIFIER_START", "RULE_UNICODE_ESCAPE", "RULE_IDENTIFIER_PART", "RULE_HEX_DIGIT", "RULE_IN_RICH_STRING", "RULE_IDENTIFIER_PART_IMPL", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER"
    };
    public static final int KW_Case=93;
    public static final int RULE_HEX=117;
    public static final int KW_SolidusEqualsSign=63;
    public static final int KW_Else=92;
    public static final int KW_Throw=102;
    public static final int KW_PlusSignEqualsSign=60;
    public static final int KW_Solidus=82;
    public static final int KW_Comma=8;
    public static final int KW_Do=96;
    public static final int KW_ExclamationMarkEqualsSignEqualsSign=71;
    public static final int KW_Extends=10;
    public static final int KW_ExclamationMarkEqualsSign=69;
    public static final int KW_Package=4;
    public static final int KW_Finally=105;
    public static final int KW_Dispatch=30;
    public static final int RULE_ID=109;
    public static final int KW_False=98;
    public static final int KW_QuestionMark=107;
    public static final int RULE_RICH_TEXT_START=112;
    public static final int KW_AmpersandAmpersand=67;
    public static final int KW_AFTER=43;
    public static final int KW_Import=46;
    public static final int KW_HyphenMinus=79;
    public static final int KW_While=95;
    public static final int KW_Return=103;
    public static final int RULE_INT=118;
    public static final int KW_Catch=106;
    public static final int RULE_ML_COMMENT=126;
    public static final int KW_BEFORE=44;
    public static final int KW_PlusSignPlusSign=86;
    public static final int KW_Var=38;
    public static final int KW_Protected=27;
    public static final int KW_As=85;
    public static final int KW_FullStop=24;
    public static final int RULE_UNICODE_ESCAPE=121;
    public static final int KW_Enum=15;
    public static final int KW_GreaterThanSign=9;
    public static final int RULE_IDENTIFIER_PART=122;
    public static final int KW_RightSquareBracket=59;
    public static final int KW_VerticalLineVerticalLine=66;
    public static final int KW_Private=26;
    public static final int KW_Val=37;
    public static final int KW_ELSEIF=55;
    public static final int KW_Implements=11;
    public static final int KW_EqualsSign=20;
    public static final int KW_Transient=36;
    public static final int KW_LessThanSignGreaterThanSign=76;
    public static final int KW_Def=39;
    public static final int KW_FullStopFullStopFullStop=47;
    public static final int KW_FullStopFullStopLessThanSign=74;
    public static final int KW_ELSE=53;
    public static final int KW_NumberSign=57;
    public static final int KW_Interface=14;
    public static final int KW_EqualsSignEqualsSign=68;
    public static final int KW_ENDFOR=51;
    public static final int KW_HyphenMinusEqualsSign=61;
    public static final int RULE_HEX_DIGIT=123;
    public static final int KW_VerticalLine=90;
    public static final int KW_EqualsSignGreaterThanSign=19;
    public static final int KW_Synchronized=35;
    public static final int KW_Create=41;
    public static final int RULE_COMMENT_RICH_TEXT_END=116;
    public static final int KW_Volatile=34;
    public static final int KW_LeftSquareBracket=58;
    public static final int KW_LeftParenthesis=17;
    public static final int RULE_IDENTIFIER_START=120;
    public static final int KW_Override=40;
    public static final int KW_Ampersand=108;
    public static final int KW_Semicolon=5;
    public static final int KW_Public=25;
    public static final int KW_IF=52;
    public static final int KW_Colon=42;
    public static final int KW_Final=31;
    public static final int KW_HyphenMinusGreaterThanSign=73;
    public static final int KW_HyphenMinusHyphenMinus=87;
    public static final int KW_FOR=50;
    public static final int KW_For=94;
    public static final int KW_CommercialAt=56;
    public static final int KW_FullStopFullStop=75;
    public static final int KW_GreaterThanSignEqualsSign=65;
    public static final int KW_PercentSign=83;
    public static final int KW_Asterisk=80;
    public static final int RULE_DECIMAL=119;
    public static final int KW_RightParenthesis=18;
    public static final int KW_AsteriskAsterisk=81;
    public static final int KW_If=91;
    public static final int KW_Try=104;
    public static final int KW_Annotation=16;
    public static final int KW_Native=33;
    public static final int KW_RightCurlyBracket=13;
    public static final int KW_ENDIF=54;
    public static final int KW_LeftCurlyBracket=12;
    public static final int KW_Strictfp=32;
    public static final int KW_Instanceof=72;
    public static final int KW_Abstract=28;
    public static final int RULE_STRING=110;
    public static final int RULE_SL_COMMENT=127;
    public static final int RULE_IN_RICH_STRING=124;
    public static final int KW_Null=100;
    public static final int KW_Super=97;
    public static final int KW_Typeof=101;
    public static final int KW_SEPARATOR=45;
    public static final int RULE_COMMENT_RICH_TEXT_INBETWEEN=114;
    public static final int KW_ExclamationMark=84;
    public static final int KW_New=23;
    public static final int EOF=-1;
    public static final int KW_AsteriskEqualsSign=62;
    public static final int KW_ColonColon=88;
    public static final int RULE_RICH_TEXT=111;
    public static final int KW_Switch=48;
    public static final int RULE_WS=128;
    public static final int KW_QuestionMarkFullStop=89;
    public static final int RULE_RICH_TEXT_END=115;
    public static final int KW_Throws=22;
    public static final int KW_LessThanSign=7;
    public static final int KW_True=99;
    public static final int RULE_ANY_OTHER=129;
    public static final int RULE_RICH_TEXT_INBETWEEN=113;
    public static final int KW_Default=49;
    public static final int RULE_IDENTIFIER_PART_IMPL=125;
    public static final int KW_Class=6;
    public static final int KW_EqualsSignEqualsSignEqualsSign=70;
    public static final int KW_Static=29;
    public static final int KW_QuestionMarkColon=77;
    public static final int KW_PlusSign=78;
    public static final int KW_Extension=21;
    public static final int KW_PercentSignEqualsSign=64;


        public InternalXtendParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalXtendParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalXtendParser.tokenNames; }
    public String getGrammarFileName() { return "InternalXtend.g"; }



     	private XtendGrammarAccess grammarAccess;

        public InternalXtendParser(TokenStream input, XtendGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "File";
       	}

       	@Override
       	protected XtendGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}
    public final EObject entryRuleFile() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFile = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getFileRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleFile=ruleFile();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleFile; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleFile() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        AntlrDatatypeRuleToken lv_package_1_0 = null;

        EObject lv_importSection_3_0 = null;

        EObject lv_xtendTypes_4_0 = null;



        	enterRule();

        try {
            {
            {
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==KW_Package) ) {
                int LA2_1 = input.LA(2);

                if ( (LA2_1==KW_Annotation) ) {
                    int LA2_3 = input.LA(3);

                    if ( (LA2_3==KW_Annotation) ) {
                        int LA2_5 = input.LA(4);

                        if ( (LA2_5==KW_Annotation||LA2_5==KW_Create||(LA2_5>=KW_AFTER && LA2_5<=KW_SEPARATOR)||LA2_5==RULE_ID) ) {
                            alt2=1;
                        }
                    }
                    else if ( (LA2_3==EOF||(LA2_3>=KW_Package && LA2_3<=KW_Class)||(LA2_3>=KW_Interface && LA2_3<=KW_Enum)||(LA2_3>=KW_FullStop && LA2_3<=KW_Transient)||LA2_3==KW_Import||LA2_3==KW_CommercialAt) ) {
                        alt2=1;
                    }
                }
                else if ( (LA2_1==KW_Create||(LA2_1>=KW_AFTER && LA2_1<=KW_SEPARATOR)||LA2_1==RULE_ID) ) {
                    alt2=1;
                }
            }
            switch (alt2) {
                case 1 :
                    {
                    otherlv_0=(Token)match(input,KW_Package,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_0, grammarAccess.getFileAccess().getPackageKeyword_0_0());
                      			
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getFileAccess().getPackageQualifiedNameParserRuleCall_0_1_0());
                      					
                    }
                    pushFollow(FOLLOW_4);
                    lv_package_1_0=ruleQualifiedName();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getFileRule());
                      						}
                      						set(
                      							current,
                      							"package",
                      							lv_package_1_0,
                      							"org.eclipse.xtext.xbase.Xbase.QualifiedName");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }
                    int alt1=2;
                    int LA1_0 = input.LA(1);

                    if ( (LA1_0==KW_Semicolon) ) {
                        alt1=1;
                    }
                    switch (alt1) {
                        case 1 :
                            {
                            otherlv_2=(Token)match(input,KW_Semicolon,FOLLOW_5); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					newLeafNode(otherlv_2, grammarAccess.getFileAccess().getSemicolonKeyword_0_2());
                              				
                            }

                            }
                            break;

                    }


                    }
                    break;

            }
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==KW_Import) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getFileAccess().getImportSectionXImportSectionParserRuleCall_1_0());
                      				
                    }
                    pushFollow(FOLLOW_6);
                    lv_importSection_3_0=ruleXImportSection();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getFileRule());
                      					}
                      					set(
                      						current,
                      						"importSection",
                      						lv_importSection_3_0,
                      						"org.eclipse.xtext.xbase.Xtype.XImportSection");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( (LA4_0==KW_Package||LA4_0==KW_Class||(LA4_0>=KW_Interface && LA4_0<=KW_Annotation)||(LA4_0>=KW_Public && LA4_0<=KW_Transient)||LA4_0==KW_CommercialAt) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getFileAccess().getXtendTypesTypeParserRuleCall_2_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_6);
            	    lv_xtendTypes_4_0=ruleType();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getFileRule());
            	      					}
            	      					add(
            	      						current,
            	      						"xtendTypes",
            	      						lv_xtendTypes_4_0,
            	      						"org.eclipse.xtend.core.Xtend.Type");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleType() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleType = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getTypeRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleType=ruleType();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleType; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleType() throws RecognitionException {
        EObject current = null;

        Token otherlv_4=null;
        Token otherlv_6=null;
        Token otherlv_8=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        Token otherlv_13=null;
        Token otherlv_15=null;
        Token otherlv_17=null;
        Token otherlv_19=null;
        Token otherlv_22=null;
        Token otherlv_24=null;
        Token otherlv_26=null;
        Token otherlv_28=null;
        Token otherlv_29=null;
        Token otherlv_31=null;
        Token otherlv_33=null;
        Token otherlv_35=null;
        Token otherlv_38=null;
        Token otherlv_40=null;
        Token otherlv_42=null;
        Token otherlv_44=null;
        Token otherlv_45=null;
        Token otherlv_48=null;
        Token otherlv_50=null;
        Token otherlv_52=null;
        EObject lv_annotations_1_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_3_0 = null;

        AntlrDatatypeRuleToken lv_name_5_0 = null;

        EObject lv_typeParameters_7_0 = null;

        EObject lv_typeParameters_9_0 = null;

        EObject lv_extends_12_0 = null;

        EObject lv_implements_14_0 = null;

        EObject lv_implements_16_0 = null;

        EObject lv_members_18_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_21_0 = null;

        AntlrDatatypeRuleToken lv_name_23_0 = null;

        EObject lv_typeParameters_25_0 = null;

        EObject lv_typeParameters_27_0 = null;

        EObject lv_extends_30_0 = null;

        EObject lv_extends_32_0 = null;

        EObject lv_members_34_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_37_0 = null;

        AntlrDatatypeRuleToken lv_name_39_0 = null;

        EObject lv_members_41_0 = null;

        EObject lv_members_43_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_47_0 = null;

        AntlrDatatypeRuleToken lv_name_49_0 = null;

        EObject lv_members_51_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getTypeAccess().getXtendTypeDeclarationAction_0(),
              					current);
              			
            }

            }
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0==KW_CommercialAt) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getTypeAccess().getAnnotationsXAnnotationParserRuleCall_1_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_7);
            	    lv_annotations_1_0=ruleXAnnotation();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getTypeRule());
            	      					}
            	      					add(
            	      						current,
            	      						"annotations",
            	      						lv_annotations_1_0,
            	      						"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotation");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);
            int alt25=4;
            alt25 = dfa25.predict(input);
            switch (alt25) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getTypeAccess().getXtendClassAnnotationInfoAction_2_0_0(),
                      							current);
                      					
                    }

                    }
                    loop6:
                    do {
                        int alt6=2;
                        int LA6_0 = input.LA(1);

                        if ( (LA6_0==KW_Package||(LA6_0>=KW_Public && LA6_0<=KW_Transient)) ) {
                            alt6=1;
                        }


                        switch (alt6) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getTypeAccess().getModifiersCommonModifierParserRuleCall_2_0_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_8);
                    	    lv_modifiers_3_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getTypeRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_3_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop6;
                        }
                    } while (true);

                    otherlv_4=(Token)match(input,KW_Class,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_4, grammarAccess.getTypeAccess().getClassKeyword_2_0_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getTypeAccess().getNameValidIDParserRuleCall_2_0_3_0());
                      						
                    }
                    pushFollow(FOLLOW_9);
                    lv_name_5_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getTypeRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_5_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    int alt8=2;
                    int LA8_0 = input.LA(1);

                    if ( (LA8_0==KW_LessThanSign) ) {
                        alt8=1;
                    }
                    switch (alt8) {
                        case 1 :
                            {
                            otherlv_6=(Token)match(input,KW_LessThanSign,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_6, grammarAccess.getTypeAccess().getLessThanSignKeyword_2_0_4_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getTypeAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_0_4_1_0());
                              							
                            }
                            pushFollow(FOLLOW_10);
                            lv_typeParameters_7_0=ruleJvmTypeParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getTypeRule());
                              								}
                              								add(
                              									current,
                              									"typeParameters",
                              									lv_typeParameters_7_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop7:
                            do {
                                int alt7=2;
                                int LA7_0 = input.LA(1);

                                if ( (LA7_0==KW_Comma) ) {
                                    alt7=1;
                                }


                                switch (alt7) {
                            	case 1 :
                            	    {
                            	    otherlv_8=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_8, grammarAccess.getTypeAccess().getCommaKeyword_2_0_4_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getTypeAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_0_4_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_10);
                            	    lv_typeParameters_9_0=ruleJvmTypeParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getTypeRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"typeParameters",
                            	      										lv_typeParameters_9_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop7;
                                }
                            } while (true);

                            otherlv_10=(Token)match(input,KW_GreaterThanSign,FOLLOW_11); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_10, grammarAccess.getTypeAccess().getGreaterThanSignKeyword_2_0_4_3());
                              					
                            }

                            }
                            break;

                    }
                    int alt9=2;
                    int LA9_0 = input.LA(1);

                    if ( (LA9_0==KW_Extends) ) {
                        alt9=1;
                    }
                    switch (alt9) {
                        case 1 :
                            {
                            otherlv_11=(Token)match(input,KW_Extends,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_11, grammarAccess.getTypeAccess().getExtendsKeyword_2_0_5_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getTypeAccess().getExtendsJvmParameterizedTypeReferenceParserRuleCall_2_0_5_1_0());
                              							
                            }
                            pushFollow(FOLLOW_12);
                            lv_extends_12_0=ruleJvmParameterizedTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getTypeRule());
                              								}
                              								set(
                              									current,
                              									"extends",
                              									lv_extends_12_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }


                            }
                            break;

                    }
                    int alt11=2;
                    int LA11_0 = input.LA(1);

                    if ( (LA11_0==KW_Implements) ) {
                        alt11=1;
                    }
                    switch (alt11) {
                        case 1 :
                            {
                            otherlv_13=(Token)match(input,KW_Implements,FOLLOW_13); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_13, grammarAccess.getTypeAccess().getImplementsKeyword_2_0_6_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getTypeAccess().getImplementsJvmSuperTypeReferenceParserRuleCall_2_0_6_1_0());
                              							
                            }
                            pushFollow(FOLLOW_14);
                            lv_implements_14_0=ruleJvmSuperTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getTypeRule());
                              								}
                              								add(
                              									current,
                              									"implements",
                              									lv_implements_14_0,
                              									"org.eclipse.xtend.core.Xtend.JvmSuperTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop10:
                            do {
                                int alt10=2;
                                int LA10_0 = input.LA(1);

                                if ( (LA10_0==KW_Comma) ) {
                                    alt10=1;
                                }


                                switch (alt10) {
                            	case 1 :
                            	    {
                            	    otherlv_15=(Token)match(input,KW_Comma,FOLLOW_13); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_15, grammarAccess.getTypeAccess().getCommaKeyword_2_0_6_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getTypeAccess().getImplementsJvmSuperTypeReferenceParserRuleCall_2_0_6_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_14);
                            	    lv_implements_16_0=ruleJvmSuperTypeReference();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getTypeRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"implements",
                            	      										lv_implements_16_0,
                            	      										"org.eclipse.xtend.core.Xtend.JvmSuperTypeReference");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop10;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_17=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_15); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_17, grammarAccess.getTypeAccess().getLeftCurlyBracketKeyword_2_0_7());
                      				
                    }
                    loop12:
                    do {
                        int alt12=2;
                        int LA12_0 = input.LA(1);

                        if ( (LA12_0==KW_Package||LA12_0==KW_Class||(LA12_0>=KW_Interface && LA12_0<=KW_LeftParenthesis)||LA12_0==KW_EqualsSignGreaterThanSign||LA12_0==KW_Extension||LA12_0==KW_New||(LA12_0>=KW_Public && LA12_0<=KW_Create)||(LA12_0>=KW_AFTER && LA12_0<=KW_SEPARATOR)||LA12_0==KW_CommercialAt||LA12_0==RULE_ID) ) {
                            alt12=1;
                        }


                        switch (alt12) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getTypeAccess().getMembersMemberParserRuleCall_2_0_8_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_15);
                    	    lv_members_18_0=ruleMember();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getTypeRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"members",
                    	      								lv_members_18_0,
                    	      								"org.eclipse.xtend.core.Xtend.Member");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop12;
                        }
                    } while (true);

                    otherlv_19=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_19, grammarAccess.getTypeAccess().getRightCurlyBracketKeyword_2_0_9());
                      				
                    }

                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getTypeAccess().getXtendInterfaceAnnotationInfoAction_2_1_0(),
                      							current);
                      					
                    }

                    }
                    loop13:
                    do {
                        int alt13=2;
                        int LA13_0 = input.LA(1);

                        if ( (LA13_0==KW_Package||(LA13_0>=KW_Public && LA13_0<=KW_Transient)) ) {
                            alt13=1;
                        }


                        switch (alt13) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getTypeAccess().getModifiersCommonModifierParserRuleCall_2_1_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_16);
                    	    lv_modifiers_21_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getTypeRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_21_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop13;
                        }
                    } while (true);

                    otherlv_22=(Token)match(input,KW_Interface,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_22, grammarAccess.getTypeAccess().getInterfaceKeyword_2_1_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getTypeAccess().getNameValidIDParserRuleCall_2_1_3_0());
                      						
                    }
                    pushFollow(FOLLOW_17);
                    lv_name_23_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getTypeRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_23_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    int alt15=2;
                    int LA15_0 = input.LA(1);

                    if ( (LA15_0==KW_LessThanSign) ) {
                        alt15=1;
                    }
                    switch (alt15) {
                        case 1 :
                            {
                            otherlv_24=(Token)match(input,KW_LessThanSign,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_24, grammarAccess.getTypeAccess().getLessThanSignKeyword_2_1_4_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getTypeAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_1_4_1_0());
                              							
                            }
                            pushFollow(FOLLOW_10);
                            lv_typeParameters_25_0=ruleJvmTypeParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getTypeRule());
                              								}
                              								add(
                              									current,
                              									"typeParameters",
                              									lv_typeParameters_25_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop14:
                            do {
                                int alt14=2;
                                int LA14_0 = input.LA(1);

                                if ( (LA14_0==KW_Comma) ) {
                                    alt14=1;
                                }


                                switch (alt14) {
                            	case 1 :
                            	    {
                            	    otherlv_26=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_26, grammarAccess.getTypeAccess().getCommaKeyword_2_1_4_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getTypeAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_1_4_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_10);
                            	    lv_typeParameters_27_0=ruleJvmTypeParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getTypeRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"typeParameters",
                            	      										lv_typeParameters_27_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop14;
                                }
                            } while (true);

                            otherlv_28=(Token)match(input,KW_GreaterThanSign,FOLLOW_18); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_28, grammarAccess.getTypeAccess().getGreaterThanSignKeyword_2_1_4_3());
                              					
                            }

                            }
                            break;

                    }
                    int alt17=2;
                    int LA17_0 = input.LA(1);

                    if ( (LA17_0==KW_Extends) ) {
                        alt17=1;
                    }
                    switch (alt17) {
                        case 1 :
                            {
                            otherlv_29=(Token)match(input,KW_Extends,FOLLOW_13); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_29, grammarAccess.getTypeAccess().getExtendsKeyword_2_1_5_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getTypeAccess().getExtendsJvmSuperTypeReferenceParserRuleCall_2_1_5_1_0());
                              							
                            }
                            pushFollow(FOLLOW_14);
                            lv_extends_30_0=ruleJvmSuperTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getTypeRule());
                              								}
                              								add(
                              									current,
                              									"extends",
                              									lv_extends_30_0,
                              									"org.eclipse.xtend.core.Xtend.JvmSuperTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop16:
                            do {
                                int alt16=2;
                                int LA16_0 = input.LA(1);

                                if ( (LA16_0==KW_Comma) ) {
                                    alt16=1;
                                }


                                switch (alt16) {
                            	case 1 :
                            	    {
                            	    otherlv_31=(Token)match(input,KW_Comma,FOLLOW_13); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_31, grammarAccess.getTypeAccess().getCommaKeyword_2_1_5_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getTypeAccess().getExtendsJvmSuperTypeReferenceParserRuleCall_2_1_5_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_14);
                            	    lv_extends_32_0=ruleJvmSuperTypeReference();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getTypeRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"extends",
                            	      										lv_extends_32_0,
                            	      										"org.eclipse.xtend.core.Xtend.JvmSuperTypeReference");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop16;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_33=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_15); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_33, grammarAccess.getTypeAccess().getLeftCurlyBracketKeyword_2_1_6());
                      				
                    }
                    loop18:
                    do {
                        int alt18=2;
                        int LA18_0 = input.LA(1);

                        if ( (LA18_0==KW_Package||LA18_0==KW_Class||(LA18_0>=KW_Interface && LA18_0<=KW_LeftParenthesis)||LA18_0==KW_EqualsSignGreaterThanSign||LA18_0==KW_Extension||LA18_0==KW_New||(LA18_0>=KW_Public && LA18_0<=KW_Create)||(LA18_0>=KW_AFTER && LA18_0<=KW_SEPARATOR)||LA18_0==KW_CommercialAt||LA18_0==RULE_ID) ) {
                            alt18=1;
                        }


                        switch (alt18) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getTypeAccess().getMembersMemberParserRuleCall_2_1_7_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_15);
                    	    lv_members_34_0=ruleMember();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getTypeRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"members",
                    	      								lv_members_34_0,
                    	      								"org.eclipse.xtend.core.Xtend.Member");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop18;
                        }
                    } while (true);

                    otherlv_35=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_35, grammarAccess.getTypeAccess().getRightCurlyBracketKeyword_2_1_8());
                      				
                    }

                    }


                    }
                    break;
                case 3 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getTypeAccess().getXtendEnumAnnotationInfoAction_2_2_0(),
                      							current);
                      					
                    }

                    }
                    loop19:
                    do {
                        int alt19=2;
                        int LA19_0 = input.LA(1);

                        if ( (LA19_0==KW_Package||(LA19_0>=KW_Public && LA19_0<=KW_Transient)) ) {
                            alt19=1;
                        }


                        switch (alt19) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getTypeAccess().getModifiersCommonModifierParserRuleCall_2_2_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_19);
                    	    lv_modifiers_37_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getTypeRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_37_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop19;
                        }
                    } while (true);

                    otherlv_38=(Token)match(input,KW_Enum,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_38, grammarAccess.getTypeAccess().getEnumKeyword_2_2_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getTypeAccess().getNameValidIDParserRuleCall_2_2_3_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_name_39_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getTypeRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_39_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    otherlv_40=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_21); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_40, grammarAccess.getTypeAccess().getLeftCurlyBracketKeyword_2_2_4());
                      				
                    }
                    int alt21=2;
                    int LA21_0 = input.LA(1);

                    if ( (LA21_0==KW_Annotation||LA21_0==KW_Create||(LA21_0>=KW_AFTER && LA21_0<=KW_SEPARATOR)||LA21_0==KW_CommercialAt||LA21_0==RULE_ID) ) {
                        alt21=1;
                    }
                    switch (alt21) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getTypeAccess().getMembersXtendEnumLiteralParserRuleCall_2_2_5_0_0());
                              							
                            }
                            pushFollow(FOLLOW_22);
                            lv_members_41_0=ruleXtendEnumLiteral();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getTypeRule());
                              								}
                              								add(
                              									current,
                              									"members",
                              									lv_members_41_0,
                              									"org.eclipse.xtend.core.Xtend.XtendEnumLiteral");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop20:
                            do {
                                int alt20=2;
                                int LA20_0 = input.LA(1);

                                if ( (LA20_0==KW_Comma) ) {
                                    alt20=1;
                                }


                                switch (alt20) {
                            	case 1 :
                            	    {
                            	    otherlv_42=(Token)match(input,KW_Comma,FOLLOW_23); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_42, grammarAccess.getTypeAccess().getCommaKeyword_2_2_5_1_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getTypeAccess().getMembersXtendEnumLiteralParserRuleCall_2_2_5_1_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_22);
                            	    lv_members_43_0=ruleXtendEnumLiteral();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getTypeRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"members",
                            	      										lv_members_43_0,
                            	      										"org.eclipse.xtend.core.Xtend.XtendEnumLiteral");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop20;
                                }
                            } while (true);


                            }
                            break;

                    }
                    int alt22=2;
                    int LA22_0 = input.LA(1);

                    if ( (LA22_0==KW_Semicolon) ) {
                        alt22=1;
                    }
                    switch (alt22) {
                        case 1 :
                            {
                            otherlv_44=(Token)match(input,KW_Semicolon,FOLLOW_24); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_44, grammarAccess.getTypeAccess().getSemicolonKeyword_2_2_6());
                              					
                            }

                            }
                            break;

                    }

                    otherlv_45=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_45, grammarAccess.getTypeAccess().getRightCurlyBracketKeyword_2_2_7());
                      				
                    }

                    }


                    }
                    break;
                case 4 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getTypeAccess().getXtendAnnotationTypeAnnotationInfoAction_2_3_0(),
                      							current);
                      					
                    }

                    }
                    loop23:
                    do {
                        int alt23=2;
                        int LA23_0 = input.LA(1);

                        if ( (LA23_0==KW_Package||(LA23_0>=KW_Public && LA23_0<=KW_Transient)) ) {
                            alt23=1;
                        }


                        switch (alt23) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getTypeAccess().getModifiersCommonModifierParserRuleCall_2_3_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_25);
                    	    lv_modifiers_47_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getTypeRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_47_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop23;
                        }
                    } while (true);

                    otherlv_48=(Token)match(input,KW_Annotation,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_48, grammarAccess.getTypeAccess().getAnnotationKeyword_2_3_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getTypeAccess().getNameValidIDParserRuleCall_2_3_3_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_name_49_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getTypeRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_49_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    otherlv_50=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_26); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_50, grammarAccess.getTypeAccess().getLeftCurlyBracketKeyword_2_3_4());
                      				
                    }
                    loop24:
                    do {
                        int alt24=2;
                        int LA24_0 = input.LA(1);

                        if ( (LA24_0==KW_Package||LA24_0==KW_Class||(LA24_0>=KW_Interface && LA24_0<=KW_LeftParenthesis)||LA24_0==KW_EqualsSignGreaterThanSign||(LA24_0>=KW_Public && LA24_0<=KW_Var)||LA24_0==KW_Create||(LA24_0>=KW_AFTER && LA24_0<=KW_SEPARATOR)||LA24_0==KW_CommercialAt||LA24_0==RULE_ID) ) {
                            alt24=1;
                        }


                        switch (alt24) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getTypeAccess().getMembersAnnotationFieldParserRuleCall_2_3_5_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_26);
                    	    lv_members_51_0=ruleAnnotationField();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getTypeRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"members",
                    	      								lv_members_51_0,
                    	      								"org.eclipse.xtend.core.Xtend.AnnotationField");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop24;
                        }
                    } while (true);

                    otherlv_52=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_52, grammarAccess.getTypeAccess().getRightCurlyBracketKeyword_2_3_6());
                      				
                    }

                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleJvmSuperTypeReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmSuperTypeReference = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmSuperTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmSuperTypeReference=ruleJvmSuperTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmSuperTypeReference; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmSuperTypeReference() throws RecognitionException {
        EObject current = null;

        EObject this_JvmParameterizedTypeReference_0 = null;

        EObject this_XFunctionSuperTypeRef_1 = null;



        	enterRule();

        try {
            {
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==KW_Annotation||LA26_0==KW_Create||(LA26_0>=KW_AFTER && LA26_0<=KW_SEPARATOR)||LA26_0==RULE_ID) ) {
                alt26=1;
            }
            else if ( (LA26_0==KW_LeftParenthesis||LA26_0==KW_EqualsSignGreaterThanSign) ) {
                alt26=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 26, 0, input);

                throw nvae;
            }
            switch (alt26) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getJvmSuperTypeReferenceAccess().getJvmParameterizedTypeReferenceParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_JvmParameterizedTypeReference_0=ruleJvmParameterizedTypeReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_JvmParameterizedTypeReference_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getJvmSuperTypeReferenceAccess().getXFunctionSuperTypeRefParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XFunctionSuperTypeRef_1=ruleXFunctionSuperTypeRef();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XFunctionSuperTypeRef_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXFunctionSuperTypeRef() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXFunctionSuperTypeRef = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXFunctionSuperTypeRefRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXFunctionSuperTypeRef=ruleXFunctionSuperTypeRef();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXFunctionSuperTypeRef; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXFunctionSuperTypeRef() throws RecognitionException {
        EObject current = null;

        Token lv_instanceContext_0_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        EObject lv_paramTypes_1_0 = null;

        EObject lv_paramTypes_3_0 = null;

        EObject lv_returnType_6_0 = null;



        	enterRule();

        try {
            {
            {
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==KW_LeftParenthesis) ) {
                alt29=1;
            }
            switch (alt29) {
                case 1 :
                    {
                    {
                    {
                    lv_instanceContext_0_0=(Token)match(input,KW_LeftParenthesis,FOLLOW_27); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_instanceContext_0_0, grammarAccess.getXFunctionSuperTypeRefAccess().getInstanceContextLeftParenthesisKeyword_0_0_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getXFunctionSuperTypeRefRule());
                      						}
                      						setWithLastConsumed(current, "instanceContext", true, "(");
                      					
                    }

                    }


                    }
                    int alt28=2;
                    int LA28_0 = input.LA(1);

                    if ( ((LA28_0>=KW_Annotation && LA28_0<=KW_LeftParenthesis)||LA28_0==KW_EqualsSignGreaterThanSign||LA28_0==KW_Create||(LA28_0>=KW_AFTER && LA28_0<=KW_SEPARATOR)||LA28_0==RULE_ID) ) {
                        alt28=1;
                    }
                    switch (alt28) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getXFunctionSuperTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_0_0());
                              						
                            }
                            pushFollow(FOLLOW_28);
                            lv_paramTypes_1_0=ruleJvmTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getXFunctionSuperTypeRefRule());
                              							}
                              							add(
                              								current,
                              								"paramTypes",
                              								lv_paramTypes_1_0,
                              								"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }
                            loop27:
                            do {
                                int alt27=2;
                                int LA27_0 = input.LA(1);

                                if ( (LA27_0==KW_Comma) ) {
                                    alt27=1;
                                }


                                switch (alt27) {
                            	case 1 :
                            	    {
                            	    otherlv_2=(Token)match(input,KW_Comma,FOLLOW_29); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      						newLeafNode(otherlv_2, grammarAccess.getXFunctionSuperTypeRefAccess().getCommaKeyword_0_1_1_0());
                            	      					
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      								newCompositeNode(grammarAccess.getXFunctionSuperTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_1_1_0());
                            	      							
                            	    }
                            	    pushFollow(FOLLOW_28);
                            	    lv_paramTypes_3_0=ruleJvmTypeReference();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      								if (current==null) {
                            	      									current = createModelElementForParent(grammarAccess.getXFunctionSuperTypeRefRule());
                            	      								}
                            	      								add(
                            	      									current,
                            	      									"paramTypes",
                            	      									lv_paramTypes_3_0,
                            	      									"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                            	      								afterParserOrEnumRuleCall();
                            	      							
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop27;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_4=(Token)match(input,KW_RightParenthesis,FOLLOW_30); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_4, grammarAccess.getXFunctionSuperTypeRefAccess().getRightParenthesisKeyword_0_2());
                      			
                    }

                    }
                    break;

            }

            otherlv_5=(Token)match(input,KW_EqualsSignGreaterThanSign,FOLLOW_29); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_5, grammarAccess.getXFunctionSuperTypeRefAccess().getEqualsSignGreaterThanSignKeyword_1());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXFunctionSuperTypeRefAccess().getReturnTypeJvmTypeReferenceParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_returnType_6_0=ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXFunctionSuperTypeRefRule());
              					}
              					set(
              						current,
              						"returnType",
              						lv_returnType_6_0,
              						"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleAnnotationField() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAnnotationField = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getAnnotationFieldRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleAnnotationField=ruleAnnotationField();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleAnnotationField; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleAnnotationField() throws RecognitionException {
        EObject current = null;

        Token otherlv_12=null;
        Token otherlv_14=null;
        Token otherlv_17=null;
        Token otherlv_19=null;
        Token otherlv_21=null;
        Token otherlv_23=null;
        Token otherlv_24=null;
        Token otherlv_26=null;
        Token otherlv_28=null;
        Token otherlv_30=null;
        Token otherlv_32=null;
        Token otherlv_35=null;
        Token otherlv_37=null;
        Token otherlv_39=null;
        Token otherlv_41=null;
        Token otherlv_42=null;
        Token otherlv_44=null;
        Token otherlv_46=null;
        Token otherlv_48=null;
        Token otherlv_51=null;
        Token otherlv_53=null;
        Token otherlv_55=null;
        Token otherlv_57=null;
        Token otherlv_58=null;
        Token otherlv_61=null;
        Token otherlv_63=null;
        Token otherlv_65=null;
        EObject lv_annotations_1_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_3_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_4_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_5_0 = null;

        EObject lv_type_6_0 = null;

        AntlrDatatypeRuleToken lv_name_7_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_9_0 = null;

        EObject lv_type_10_0 = null;

        AntlrDatatypeRuleToken lv_name_11_0 = null;

        EObject lv_initialValue_13_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_16_0 = null;

        AntlrDatatypeRuleToken lv_name_18_0 = null;

        EObject lv_typeParameters_20_0 = null;

        EObject lv_typeParameters_22_0 = null;

        EObject lv_extends_25_0 = null;

        EObject lv_implements_27_0 = null;

        EObject lv_implements_29_0 = null;

        EObject lv_members_31_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_34_0 = null;

        AntlrDatatypeRuleToken lv_name_36_0 = null;

        EObject lv_typeParameters_38_0 = null;

        EObject lv_typeParameters_40_0 = null;

        EObject lv_extends_43_0 = null;

        EObject lv_extends_45_0 = null;

        EObject lv_members_47_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_50_0 = null;

        AntlrDatatypeRuleToken lv_name_52_0 = null;

        EObject lv_members_54_0 = null;

        EObject lv_members_56_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_60_0 = null;

        AntlrDatatypeRuleToken lv_name_62_0 = null;

        EObject lv_members_64_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getAnnotationFieldAccess().getXtendMemberAction_0(),
              					current);
              			
            }

            }
            loop30:
            do {
                int alt30=2;
                int LA30_0 = input.LA(1);

                if ( (LA30_0==KW_CommercialAt) ) {
                    alt30=1;
                }


                switch (alt30) {
            	case 1 :
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getAnnotationFieldAccess().getAnnotationsXAnnotationParserRuleCall_1_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_31);
            	    lv_annotations_1_0=ruleXAnnotation();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
            	      					}
            	      					add(
            	      						current,
            	      						"annotations",
            	      						lv_annotations_1_0,
            	      						"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotation");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop30;
                }
            } while (true);
            int alt57=5;
            alt57 = dfa57.predict(input);
            switch (alt57) {
                case 1 :
                    {
                    {
                    int alt35=2;
                    alt35 = dfa35.predict(input);
                    switch (alt35) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								current = forceCreateModelElementAndSet(
                              									grammarAccess.getAnnotationFieldAccess().getXtendFieldAnnotationInfoAction_2_0_0_0_0(),
                              									current);
                              							
                            }

                            }
                            loop31:
                            do {
                                int alt31=2;
                                int LA31_0 = input.LA(1);

                                if ( (LA31_0==KW_Package||(LA31_0>=KW_Public && LA31_0<=KW_Transient)) ) {
                                    alt31=1;
                                }


                                switch (alt31) {
                            	case 1 :
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getModifiersCommonModifierParserRuleCall_2_0_0_0_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_32);
                            	    lv_modifiers_3_0=ruleCommonModifier();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"modifiers",
                            	      										lv_modifiers_3_0,
                            	      										"org.eclipse.xtend.core.Xtend.CommonModifier");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop31;
                                }
                            } while (true);
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getModifiersFieldModifierParserRuleCall_2_0_0_0_2_0());
                              								
                            }
                            pushFollow(FOLLOW_29);
                            lv_modifiers_4_0=ruleFieldModifier();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              									}
                              									add(
                              										current,
                              										"modifiers",
                              										lv_modifiers_4_0,
                              										"org.eclipse.xtend.core.Xtend.FieldModifier");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }
                            loop32:
                            do {
                                int alt32=2;
                                int LA32_0 = input.LA(1);

                                if ( (LA32_0==KW_Package||(LA32_0>=KW_Public && LA32_0<=KW_Transient)) ) {
                                    alt32=1;
                                }


                                switch (alt32) {
                            	case 1 :
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getModifiersCommonModifierParserRuleCall_2_0_0_0_3_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_29);
                            	    lv_modifiers_5_0=ruleCommonModifier();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"modifiers",
                            	      										lv_modifiers_5_0,
                            	      										"org.eclipse.xtend.core.Xtend.CommonModifier");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop32;
                                }
                            } while (true);
                            int alt33=2;
                            alt33 = dfa33.predict(input);
                            switch (alt33) {
                                case 1 :
                                    {
                                    {
                                    if ( state.backtracking==0 ) {

                                      									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_0_0_4_0());
                                      								
                                    }
                                    pushFollow(FOLLOW_3);
                                    lv_type_6_0=ruleJvmTypeReference();

                                    state._fsp--;
                                    if (state.failed) return current;
                                    if ( state.backtracking==0 ) {

                                      									if (current==null) {
                                      										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                                      									}
                                      									set(
                                      										current,
                                      										"type",
                                      										lv_type_6_0,
                                      										"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                                      									afterParserOrEnumRuleCall();
                                      								
                                    }

                                    }


                                    }
                                    break;

                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getNameValidIDParserRuleCall_2_0_0_0_5_0());
                              								
                            }
                            pushFollow(FOLLOW_33);
                            lv_name_7_0=ruleValidID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              									}
                              									set(
                              										current,
                              										"name",
                              										lv_name_7_0,
                              										"org.eclipse.xtend.core.Xtend.ValidID");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								current = forceCreateModelElementAndSet(
                              									grammarAccess.getAnnotationFieldAccess().getXtendFieldAnnotationInfoAction_2_0_0_1_0(),
                              									current);
                              							
                            }

                            }
                            loop34:
                            do {
                                int alt34=2;
                                int LA34_0 = input.LA(1);

                                if ( (LA34_0==KW_Package||(LA34_0>=KW_Public && LA34_0<=KW_Transient)) ) {
                                    alt34=1;
                                }


                                switch (alt34) {
                            	case 1 :
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getModifiersCommonModifierParserRuleCall_2_0_0_1_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_29);
                            	    lv_modifiers_9_0=ruleCommonModifier();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"modifiers",
                            	      										lv_modifiers_9_0,
                            	      										"org.eclipse.xtend.core.Xtend.CommonModifier");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop34;
                                }
                            } while (true);
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_0_1_2_0());
                              								
                            }
                            pushFollow(FOLLOW_3);
                            lv_type_10_0=ruleJvmTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              									}
                              									set(
                              										current,
                              										"type",
                              										lv_type_10_0,
                              										"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getNameValidIDParserRuleCall_2_0_0_1_3_0());
                              								
                            }
                            pushFollow(FOLLOW_33);
                            lv_name_11_0=ruleValidID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              									}
                              									set(
                              										current,
                              										"name",
                              										lv_name_11_0,
                              										"org.eclipse.xtend.core.Xtend.ValidID");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }


                            }


                            }
                            break;

                    }
                    int alt36=2;
                    int LA36_0 = input.LA(1);

                    if ( (LA36_0==KW_EqualsSign) ) {
                        alt36=1;
                    }
                    switch (alt36) {
                        case 1 :
                            {
                            otherlv_12=(Token)match(input,KW_EqualsSign,FOLLOW_34); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_12, grammarAccess.getAnnotationFieldAccess().getEqualsSignKeyword_2_0_1_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getAnnotationFieldAccess().getInitialValueXAnnotationElementValueParserRuleCall_2_0_1_1_0());
                              							
                            }
                            pushFollow(FOLLOW_35);
                            lv_initialValue_13_0=ruleXAnnotationElementValue();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              								}
                              								set(
                              									current,
                              									"initialValue",
                              									lv_initialValue_13_0,
                              									"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotationElementValue");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }


                            }
                            break;

                    }
                    int alt37=2;
                    int LA37_0 = input.LA(1);

                    if ( (LA37_0==KW_Semicolon) ) {
                        alt37=1;
                    }
                    switch (alt37) {
                        case 1 :
                            {
                            otherlv_14=(Token)match(input,KW_Semicolon,FOLLOW_2); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_14, grammarAccess.getAnnotationFieldAccess().getSemicolonKeyword_2_0_2());
                              					
                            }

                            }
                            break;

                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getAnnotationFieldAccess().getXtendClassAnnotationInfoAction_2_1_0(),
                      							current);
                      					
                    }

                    }
                    loop38:
                    do {
                        int alt38=2;
                        int LA38_0 = input.LA(1);

                        if ( (LA38_0==KW_Package||(LA38_0>=KW_Public && LA38_0<=KW_Transient)) ) {
                            alt38=1;
                        }


                        switch (alt38) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getModifiersCommonModifierParserRuleCall_2_1_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_8);
                    	    lv_modifiers_16_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_16_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop38;
                        }
                    } while (true);

                    otherlv_17=(Token)match(input,KW_Class,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_17, grammarAccess.getAnnotationFieldAccess().getClassKeyword_2_1_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getNameValidIDParserRuleCall_2_1_3_0());
                      						
                    }
                    pushFollow(FOLLOW_9);
                    lv_name_18_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_18_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    int alt40=2;
                    int LA40_0 = input.LA(1);

                    if ( (LA40_0==KW_LessThanSign) ) {
                        alt40=1;
                    }
                    switch (alt40) {
                        case 1 :
                            {
                            otherlv_19=(Token)match(input,KW_LessThanSign,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_19, grammarAccess.getAnnotationFieldAccess().getLessThanSignKeyword_2_1_4_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getAnnotationFieldAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_1_4_1_0());
                              							
                            }
                            pushFollow(FOLLOW_10);
                            lv_typeParameters_20_0=ruleJvmTypeParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              								}
                              								add(
                              									current,
                              									"typeParameters",
                              									lv_typeParameters_20_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop39:
                            do {
                                int alt39=2;
                                int LA39_0 = input.LA(1);

                                if ( (LA39_0==KW_Comma) ) {
                                    alt39=1;
                                }


                                switch (alt39) {
                            	case 1 :
                            	    {
                            	    otherlv_21=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_21, grammarAccess.getAnnotationFieldAccess().getCommaKeyword_2_1_4_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_1_4_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_10);
                            	    lv_typeParameters_22_0=ruleJvmTypeParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"typeParameters",
                            	      										lv_typeParameters_22_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop39;
                                }
                            } while (true);

                            otherlv_23=(Token)match(input,KW_GreaterThanSign,FOLLOW_11); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_23, grammarAccess.getAnnotationFieldAccess().getGreaterThanSignKeyword_2_1_4_3());
                              					
                            }

                            }
                            break;

                    }
                    int alt41=2;
                    int LA41_0 = input.LA(1);

                    if ( (LA41_0==KW_Extends) ) {
                        alt41=1;
                    }
                    switch (alt41) {
                        case 1 :
                            {
                            otherlv_24=(Token)match(input,KW_Extends,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_24, grammarAccess.getAnnotationFieldAccess().getExtendsKeyword_2_1_5_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getAnnotationFieldAccess().getExtendsJvmParameterizedTypeReferenceParserRuleCall_2_1_5_1_0());
                              							
                            }
                            pushFollow(FOLLOW_12);
                            lv_extends_25_0=ruleJvmParameterizedTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              								}
                              								set(
                              									current,
                              									"extends",
                              									lv_extends_25_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }


                            }
                            break;

                    }
                    int alt43=2;
                    int LA43_0 = input.LA(1);

                    if ( (LA43_0==KW_Implements) ) {
                        alt43=1;
                    }
                    switch (alt43) {
                        case 1 :
                            {
                            otherlv_26=(Token)match(input,KW_Implements,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_26, grammarAccess.getAnnotationFieldAccess().getImplementsKeyword_2_1_6_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getAnnotationFieldAccess().getImplementsJvmParameterizedTypeReferenceParserRuleCall_2_1_6_1_0());
                              							
                            }
                            pushFollow(FOLLOW_14);
                            lv_implements_27_0=ruleJvmParameterizedTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              								}
                              								add(
                              									current,
                              									"implements",
                              									lv_implements_27_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop42:
                            do {
                                int alt42=2;
                                int LA42_0 = input.LA(1);

                                if ( (LA42_0==KW_Comma) ) {
                                    alt42=1;
                                }


                                switch (alt42) {
                            	case 1 :
                            	    {
                            	    otherlv_28=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_28, grammarAccess.getAnnotationFieldAccess().getCommaKeyword_2_1_6_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getImplementsJvmParameterizedTypeReferenceParserRuleCall_2_1_6_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_14);
                            	    lv_implements_29_0=ruleJvmParameterizedTypeReference();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"implements",
                            	      										lv_implements_29_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop42;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_30=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_15); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_30, grammarAccess.getAnnotationFieldAccess().getLeftCurlyBracketKeyword_2_1_7());
                      				
                    }
                    loop44:
                    do {
                        int alt44=2;
                        int LA44_0 = input.LA(1);

                        if ( (LA44_0==KW_Package||LA44_0==KW_Class||(LA44_0>=KW_Interface && LA44_0<=KW_LeftParenthesis)||LA44_0==KW_EqualsSignGreaterThanSign||LA44_0==KW_Extension||LA44_0==KW_New||(LA44_0>=KW_Public && LA44_0<=KW_Create)||(LA44_0>=KW_AFTER && LA44_0<=KW_SEPARATOR)||LA44_0==KW_CommercialAt||LA44_0==RULE_ID) ) {
                            alt44=1;
                        }


                        switch (alt44) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getMembersMemberParserRuleCall_2_1_8_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_15);
                    	    lv_members_31_0=ruleMember();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"members",
                    	      								lv_members_31_0,
                    	      								"org.eclipse.xtend.core.Xtend.Member");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop44;
                        }
                    } while (true);

                    otherlv_32=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_32, grammarAccess.getAnnotationFieldAccess().getRightCurlyBracketKeyword_2_1_9());
                      				
                    }

                    }


                    }
                    break;
                case 3 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getAnnotationFieldAccess().getXtendInterfaceAnnotationInfoAction_2_2_0(),
                      							current);
                      					
                    }

                    }
                    loop45:
                    do {
                        int alt45=2;
                        int LA45_0 = input.LA(1);

                        if ( (LA45_0==KW_Package||(LA45_0>=KW_Public && LA45_0<=KW_Transient)) ) {
                            alt45=1;
                        }


                        switch (alt45) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getModifiersCommonModifierParserRuleCall_2_2_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_16);
                    	    lv_modifiers_34_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_34_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop45;
                        }
                    } while (true);

                    otherlv_35=(Token)match(input,KW_Interface,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_35, grammarAccess.getAnnotationFieldAccess().getInterfaceKeyword_2_2_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getNameValidIDParserRuleCall_2_2_3_0());
                      						
                    }
                    pushFollow(FOLLOW_17);
                    lv_name_36_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_36_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    int alt47=2;
                    int LA47_0 = input.LA(1);

                    if ( (LA47_0==KW_LessThanSign) ) {
                        alt47=1;
                    }
                    switch (alt47) {
                        case 1 :
                            {
                            otherlv_37=(Token)match(input,KW_LessThanSign,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_37, grammarAccess.getAnnotationFieldAccess().getLessThanSignKeyword_2_2_4_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getAnnotationFieldAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_2_4_1_0());
                              							
                            }
                            pushFollow(FOLLOW_10);
                            lv_typeParameters_38_0=ruleJvmTypeParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              								}
                              								add(
                              									current,
                              									"typeParameters",
                              									lv_typeParameters_38_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop46:
                            do {
                                int alt46=2;
                                int LA46_0 = input.LA(1);

                                if ( (LA46_0==KW_Comma) ) {
                                    alt46=1;
                                }


                                switch (alt46) {
                            	case 1 :
                            	    {
                            	    otherlv_39=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_39, grammarAccess.getAnnotationFieldAccess().getCommaKeyword_2_2_4_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_2_4_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_10);
                            	    lv_typeParameters_40_0=ruleJvmTypeParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"typeParameters",
                            	      										lv_typeParameters_40_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop46;
                                }
                            } while (true);

                            otherlv_41=(Token)match(input,KW_GreaterThanSign,FOLLOW_18); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_41, grammarAccess.getAnnotationFieldAccess().getGreaterThanSignKeyword_2_2_4_3());
                              					
                            }

                            }
                            break;

                    }
                    int alt49=2;
                    int LA49_0 = input.LA(1);

                    if ( (LA49_0==KW_Extends) ) {
                        alt49=1;
                    }
                    switch (alt49) {
                        case 1 :
                            {
                            otherlv_42=(Token)match(input,KW_Extends,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_42, grammarAccess.getAnnotationFieldAccess().getExtendsKeyword_2_2_5_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getAnnotationFieldAccess().getExtendsJvmParameterizedTypeReferenceParserRuleCall_2_2_5_1_0());
                              							
                            }
                            pushFollow(FOLLOW_14);
                            lv_extends_43_0=ruleJvmParameterizedTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              								}
                              								add(
                              									current,
                              									"extends",
                              									lv_extends_43_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop48:
                            do {
                                int alt48=2;
                                int LA48_0 = input.LA(1);

                                if ( (LA48_0==KW_Comma) ) {
                                    alt48=1;
                                }


                                switch (alt48) {
                            	case 1 :
                            	    {
                            	    otherlv_44=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_44, grammarAccess.getAnnotationFieldAccess().getCommaKeyword_2_2_5_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getExtendsJvmParameterizedTypeReferenceParserRuleCall_2_2_5_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_14);
                            	    lv_extends_45_0=ruleJvmParameterizedTypeReference();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"extends",
                            	      										lv_extends_45_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop48;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_46=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_15); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_46, grammarAccess.getAnnotationFieldAccess().getLeftCurlyBracketKeyword_2_2_6());
                      				
                    }
                    loop50:
                    do {
                        int alt50=2;
                        int LA50_0 = input.LA(1);

                        if ( (LA50_0==KW_Package||LA50_0==KW_Class||(LA50_0>=KW_Interface && LA50_0<=KW_LeftParenthesis)||LA50_0==KW_EqualsSignGreaterThanSign||LA50_0==KW_Extension||LA50_0==KW_New||(LA50_0>=KW_Public && LA50_0<=KW_Create)||(LA50_0>=KW_AFTER && LA50_0<=KW_SEPARATOR)||LA50_0==KW_CommercialAt||LA50_0==RULE_ID) ) {
                            alt50=1;
                        }


                        switch (alt50) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getMembersMemberParserRuleCall_2_2_7_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_15);
                    	    lv_members_47_0=ruleMember();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"members",
                    	      								lv_members_47_0,
                    	      								"org.eclipse.xtend.core.Xtend.Member");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop50;
                        }
                    } while (true);

                    otherlv_48=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_48, grammarAccess.getAnnotationFieldAccess().getRightCurlyBracketKeyword_2_2_8());
                      				
                    }

                    }


                    }
                    break;
                case 4 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getAnnotationFieldAccess().getXtendEnumAnnotationInfoAction_2_3_0(),
                      							current);
                      					
                    }

                    }
                    loop51:
                    do {
                        int alt51=2;
                        int LA51_0 = input.LA(1);

                        if ( (LA51_0==KW_Package||(LA51_0>=KW_Public && LA51_0<=KW_Transient)) ) {
                            alt51=1;
                        }


                        switch (alt51) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getModifiersCommonModifierParserRuleCall_2_3_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_19);
                    	    lv_modifiers_50_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_50_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop51;
                        }
                    } while (true);

                    otherlv_51=(Token)match(input,KW_Enum,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_51, grammarAccess.getAnnotationFieldAccess().getEnumKeyword_2_3_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getNameValidIDParserRuleCall_2_3_3_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_name_52_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_52_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    otherlv_53=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_21); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_53, grammarAccess.getAnnotationFieldAccess().getLeftCurlyBracketKeyword_2_3_4());
                      				
                    }
                    int alt53=2;
                    int LA53_0 = input.LA(1);

                    if ( (LA53_0==KW_Annotation||LA53_0==KW_Create||(LA53_0>=KW_AFTER && LA53_0<=KW_SEPARATOR)||LA53_0==KW_CommercialAt||LA53_0==RULE_ID) ) {
                        alt53=1;
                    }
                    switch (alt53) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getAnnotationFieldAccess().getMembersXtendEnumLiteralParserRuleCall_2_3_5_0_0());
                              							
                            }
                            pushFollow(FOLLOW_22);
                            lv_members_54_0=ruleXtendEnumLiteral();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                              								}
                              								add(
                              									current,
                              									"members",
                              									lv_members_54_0,
                              									"org.eclipse.xtend.core.Xtend.XtendEnumLiteral");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop52:
                            do {
                                int alt52=2;
                                int LA52_0 = input.LA(1);

                                if ( (LA52_0==KW_Comma) ) {
                                    alt52=1;
                                }


                                switch (alt52) {
                            	case 1 :
                            	    {
                            	    otherlv_55=(Token)match(input,KW_Comma,FOLLOW_23); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_55, grammarAccess.getAnnotationFieldAccess().getCommaKeyword_2_3_5_1_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getAnnotationFieldAccess().getMembersXtendEnumLiteralParserRuleCall_2_3_5_1_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_22);
                            	    lv_members_56_0=ruleXtendEnumLiteral();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"members",
                            	      										lv_members_56_0,
                            	      										"org.eclipse.xtend.core.Xtend.XtendEnumLiteral");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop52;
                                }
                            } while (true);


                            }
                            break;

                    }
                    int alt54=2;
                    int LA54_0 = input.LA(1);

                    if ( (LA54_0==KW_Semicolon) ) {
                        alt54=1;
                    }
                    switch (alt54) {
                        case 1 :
                            {
                            otherlv_57=(Token)match(input,KW_Semicolon,FOLLOW_24); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_57, grammarAccess.getAnnotationFieldAccess().getSemicolonKeyword_2_3_6());
                              					
                            }

                            }
                            break;

                    }

                    otherlv_58=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_58, grammarAccess.getAnnotationFieldAccess().getRightCurlyBracketKeyword_2_3_7());
                      				
                    }

                    }


                    }
                    break;
                case 5 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getAnnotationFieldAccess().getXtendAnnotationTypeAnnotationInfoAction_2_4_0(),
                      							current);
                      					
                    }

                    }
                    loop55:
                    do {
                        int alt55=2;
                        int LA55_0 = input.LA(1);

                        if ( (LA55_0==KW_Package||(LA55_0>=KW_Public && LA55_0<=KW_Transient)) ) {
                            alt55=1;
                        }


                        switch (alt55) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getModifiersCommonModifierParserRuleCall_2_4_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_25);
                    	    lv_modifiers_60_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_60_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop55;
                        }
                    } while (true);

                    otherlv_61=(Token)match(input,KW_Annotation,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_61, grammarAccess.getAnnotationFieldAccess().getAnnotationKeyword_2_4_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getNameValidIDParserRuleCall_2_4_3_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_name_62_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_62_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    otherlv_63=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_26); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_63, grammarAccess.getAnnotationFieldAccess().getLeftCurlyBracketKeyword_2_4_4());
                      				
                    }
                    loop56:
                    do {
                        int alt56=2;
                        int LA56_0 = input.LA(1);

                        if ( (LA56_0==KW_Package||LA56_0==KW_Class||(LA56_0>=KW_Interface && LA56_0<=KW_LeftParenthesis)||LA56_0==KW_EqualsSignGreaterThanSign||(LA56_0>=KW_Public && LA56_0<=KW_Var)||LA56_0==KW_Create||(LA56_0>=KW_AFTER && LA56_0<=KW_SEPARATOR)||LA56_0==KW_CommercialAt||LA56_0==RULE_ID) ) {
                            alt56=1;
                        }


                        switch (alt56) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getAnnotationFieldAccess().getMembersAnnotationFieldParserRuleCall_2_4_5_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_26);
                    	    lv_members_64_0=ruleAnnotationField();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getAnnotationFieldRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"members",
                    	      								lv_members_64_0,
                    	      								"org.eclipse.xtend.core.Xtend.AnnotationField");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop56;
                        }
                    } while (true);

                    otherlv_65=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_65, grammarAccess.getAnnotationFieldAccess().getRightCurlyBracketKeyword_2_4_6());
                      				
                    }

                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleMember() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMember = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getMemberRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleMember=ruleMember();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleMember; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleMember() throws RecognitionException {
        EObject current = null;

        Token lv_modifiers_8_0=null;
        Token lv_modifiers_15_0=null;
        Token otherlv_21=null;
        Token otherlv_23=null;
        Token otherlv_29=null;
        Token otherlv_31=null;
        Token otherlv_33=null;
        Token otherlv_37=null;
        Token otherlv_40=null;
        Token otherlv_43=null;
        Token otherlv_46=null;
        Token otherlv_48=null;
        Token otherlv_50=null;
        Token otherlv_52=null;
        Token otherlv_53=null;
        Token otherlv_55=null;
        Token otherlv_59=null;
        Token otherlv_62=null;
        Token otherlv_63=null;
        Token otherlv_65=null;
        Token otherlv_67=null;
        Token otherlv_68=null;
        Token otherlv_70=null;
        Token otherlv_72=null;
        Token otherlv_73=null;
        Token otherlv_75=null;
        Token otherlv_80=null;
        Token otherlv_82=null;
        Token otherlv_84=null;
        Token otherlv_86=null;
        Token otherlv_87=null;
        Token otherlv_89=null;
        Token otherlv_91=null;
        Token otherlv_93=null;
        Token otherlv_95=null;
        Token otherlv_98=null;
        Token otherlv_100=null;
        Token otherlv_102=null;
        Token otherlv_104=null;
        Token otherlv_105=null;
        Token otherlv_107=null;
        Token otherlv_109=null;
        Token otherlv_111=null;
        Token otherlv_114=null;
        Token otherlv_116=null;
        Token otherlv_118=null;
        Token otherlv_120=null;
        Token otherlv_121=null;
        Token otherlv_124=null;
        Token otherlv_126=null;
        Token otherlv_128=null;
        EObject lv_annotations_1_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_3_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_4_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_5_0 = null;

        EObject lv_type_6_0 = null;

        AntlrDatatypeRuleToken lv_name_7_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_9_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_10_0 = null;

        EObject lv_type_11_0 = null;

        AntlrDatatypeRuleToken lv_name_12_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_13_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_14_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_16_0 = null;

        EObject lv_type_17_0 = null;

        AntlrDatatypeRuleToken lv_name_18_0 = null;

        EObject lv_type_19_0 = null;

        AntlrDatatypeRuleToken lv_name_20_0 = null;

        EObject lv_initialValue_22_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_25_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_26_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_27_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_28_0 = null;

        EObject lv_typeParameters_30_0 = null;

        EObject lv_typeParameters_32_0 = null;

        EObject lv_returnType_34_0 = null;

        EObject lv_createExtensionInfo_35_0 = null;

        AntlrDatatypeRuleToken lv_name_36_0 = null;

        EObject lv_returnType_38_0 = null;

        AntlrDatatypeRuleToken lv_name_39_0 = null;

        EObject lv_returnType_41_0 = null;

        AntlrDatatypeRuleToken lv_name_42_0 = null;

        EObject lv_createExtensionInfo_44_0 = null;

        AntlrDatatypeRuleToken lv_name_45_0 = null;

        AntlrDatatypeRuleToken lv_name_47_0 = null;

        EObject lv_parameters_49_0 = null;

        EObject lv_parameters_51_0 = null;

        EObject lv_exceptions_54_0 = null;

        EObject lv_exceptions_56_0 = null;

        EObject lv_expression_57_0 = null;

        EObject lv_expression_58_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_61_0 = null;

        EObject lv_typeParameters_64_0 = null;

        EObject lv_typeParameters_66_0 = null;

        EObject lv_parameters_69_0 = null;

        EObject lv_parameters_71_0 = null;

        EObject lv_exceptions_74_0 = null;

        EObject lv_exceptions_76_0 = null;

        EObject lv_expression_77_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_79_0 = null;

        AntlrDatatypeRuleToken lv_name_81_0 = null;

        EObject lv_typeParameters_83_0 = null;

        EObject lv_typeParameters_85_0 = null;

        EObject lv_extends_88_0 = null;

        EObject lv_implements_90_0 = null;

        EObject lv_implements_92_0 = null;

        EObject lv_members_94_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_97_0 = null;

        AntlrDatatypeRuleToken lv_name_99_0 = null;

        EObject lv_typeParameters_101_0 = null;

        EObject lv_typeParameters_103_0 = null;

        EObject lv_extends_106_0 = null;

        EObject lv_extends_108_0 = null;

        EObject lv_members_110_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_113_0 = null;

        AntlrDatatypeRuleToken lv_name_115_0 = null;

        EObject lv_members_117_0 = null;

        EObject lv_members_119_0 = null;

        AntlrDatatypeRuleToken lv_modifiers_123_0 = null;

        AntlrDatatypeRuleToken lv_name_125_0 = null;

        EObject lv_members_127_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getMemberAccess().getXtendMemberAction_0(),
              					current);
              			
            }

            }
            loop58:
            do {
                int alt58=2;
                int LA58_0 = input.LA(1);

                if ( (LA58_0==KW_CommercialAt) ) {
                    alt58=1;
                }


                switch (alt58) {
            	case 1 :
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getMemberAccess().getAnnotationsXAnnotationParserRuleCall_1_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_36);
            	    lv_annotations_1_0=ruleXAnnotation();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getMemberRule());
            	      					}
            	      					add(
            	      						current,
            	      						"annotations",
            	      						lv_annotations_1_0,
            	      						"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotation");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop58;
                }
            } while (true);
            int alt106=7;
            alt106 = dfa106.predict(input);
            switch (alt106) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getMemberAccess().getXtendFieldAnnotationInfoAction_2_0_0(),
                      							current);
                      					
                    }

                    }
                    loop59:
                    do {
                        int alt59=2;
                        int LA59_0 = input.LA(1);

                        if ( (LA59_0==KW_Package||(LA59_0>=KW_Public && LA59_0<=KW_Transient)) ) {
                            alt59=1;
                        }


                        switch (alt59) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_0_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_29);
                    	    lv_modifiers_3_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_3_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop59;
                        }
                    } while (true);
                    int alt67=4;
                    alt67 = dfa67.predict(input);
                    switch (alt67) {
                        case 1 :
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getMemberAccess().getModifiersFieldModifierParserRuleCall_2_0_2_0_0_0());
                              								
                            }
                            pushFollow(FOLLOW_29);
                            lv_modifiers_4_0=ruleFieldModifier();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getMemberRule());
                              									}
                              									add(
                              										current,
                              										"modifiers",
                              										lv_modifiers_4_0,
                              										"org.eclipse.xtend.core.Xtend.FieldModifier");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }
                            loop60:
                            do {
                                int alt60=2;
                                int LA60_0 = input.LA(1);

                                if ( (LA60_0==KW_Package||(LA60_0>=KW_Public && LA60_0<=KW_Transient)) ) {
                                    alt60=1;
                                }


                                switch (alt60) {
                            	case 1 :
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_0_2_0_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_29);
                            	    lv_modifiers_5_0=ruleCommonModifier();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"modifiers",
                            	      										lv_modifiers_5_0,
                            	      										"org.eclipse.xtend.core.Xtend.CommonModifier");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop60;
                                }
                            } while (true);
                            int alt61=2;
                            alt61 = dfa61.predict(input);
                            switch (alt61) {
                                case 1 :
                                    {
                                    {
                                    if ( state.backtracking==0 ) {

                                      									newCompositeNode(grammarAccess.getMemberAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_2_0_2_0());
                                      								
                                    }
                                    pushFollow(FOLLOW_3);
                                    lv_type_6_0=ruleJvmTypeReference();

                                    state._fsp--;
                                    if (state.failed) return current;
                                    if ( state.backtracking==0 ) {

                                      									if (current==null) {
                                      										current = createModelElementForParent(grammarAccess.getMemberRule());
                                      									}
                                      									set(
                                      										current,
                                      										"type",
                                      										lv_type_6_0,
                                      										"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                                      									afterParserOrEnumRuleCall();
                                      								
                                    }

                                    }


                                    }
                                    break;

                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getMemberAccess().getNameValidIDParserRuleCall_2_0_2_0_3_0());
                              								
                            }
                            pushFollow(FOLLOW_33);
                            lv_name_7_0=ruleValidID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getMemberRule());
                              									}
                              									set(
                              										current,
                              										"name",
                              										lv_name_7_0,
                              										"org.eclipse.xtend.core.Xtend.ValidID");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            {
                            {
                            {
                            lv_modifiers_8_0=(Token)match(input,KW_Extension,FOLLOW_29); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									newLeafNode(lv_modifiers_8_0, grammarAccess.getMemberAccess().getModifiersExtensionKeyword_2_0_2_1_0_0());
                              								
                            }
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElement(grammarAccess.getMemberRule());
                              									}
                              									addWithLastConsumed(current, "modifiers", lv_modifiers_8_0, "extension");
                              								
                            }

                            }


                            }
                            loop62:
                            do {
                                int alt62=3;
                                int LA62_0 = input.LA(1);

                                if ( ((LA62_0>=KW_Val && LA62_0<=KW_Var)) ) {
                                    alt62=1;
                                }
                                else if ( (LA62_0==KW_Package||(LA62_0>=KW_Public && LA62_0<=KW_Transient)) ) {
                                    alt62=2;
                                }


                                switch (alt62) {
                            	case 1 :
                            	    {
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      										newCompositeNode(grammarAccess.getMemberAccess().getModifiersFieldModifierParserRuleCall_2_0_2_1_1_0_0());
                            	      									
                            	    }
                            	    pushFollow(FOLLOW_29);
                            	    lv_modifiers_9_0=ruleFieldModifier();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      										if (current==null) {
                            	      											current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      										}
                            	      										add(
                            	      											current,
                            	      											"modifiers",
                            	      											lv_modifiers_9_0,
                            	      											"org.eclipse.xtend.core.Xtend.FieldModifier");
                            	      										afterParserOrEnumRuleCall();
                            	      									
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;
                            	case 2 :
                            	    {
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      										newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_0_2_1_1_1_0());
                            	      									
                            	    }
                            	    pushFollow(FOLLOW_29);
                            	    lv_modifiers_10_0=ruleCommonModifier();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      										if (current==null) {
                            	      											current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      										}
                            	      										add(
                            	      											current,
                            	      											"modifiers",
                            	      											lv_modifiers_10_0,
                            	      											"org.eclipse.xtend.core.Xtend.CommonModifier");
                            	      										afterParserOrEnumRuleCall();
                            	      									
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop62;
                                }
                            } while (true);
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getMemberAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_2_1_2_0());
                              								
                            }
                            pushFollow(FOLLOW_37);
                            lv_type_11_0=ruleJvmTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getMemberRule());
                              									}
                              									set(
                              										current,
                              										"type",
                              										lv_type_11_0,
                              										"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }
                            int alt63=2;
                            alt63 = dfa63.predict(input);
                            switch (alt63) {
                                case 1 :
                                    {
                                    {
                                    if ( state.backtracking==0 ) {

                                      									newCompositeNode(grammarAccess.getMemberAccess().getNameValidIDParserRuleCall_2_0_2_1_3_0());
                                      								
                                    }
                                    pushFollow(FOLLOW_33);
                                    lv_name_12_0=ruleValidID();

                                    state._fsp--;
                                    if (state.failed) return current;
                                    if ( state.backtracking==0 ) {

                                      									if (current==null) {
                                      										current = createModelElementForParent(grammarAccess.getMemberRule());
                                      									}
                                      									set(
                                      										current,
                                      										"name",
                                      										lv_name_12_0,
                                      										"org.eclipse.xtend.core.Xtend.ValidID");
                                      									afterParserOrEnumRuleCall();
                                      								
                                    }

                                    }


                                    }
                                    break;

                            }


                            }


                            }
                            break;
                        case 3 :
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getMemberAccess().getModifiersFieldModifierParserRuleCall_2_0_2_2_0_0());
                              								
                            }
                            pushFollow(FOLLOW_38);
                            lv_modifiers_13_0=ruleFieldModifier();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getMemberRule());
                              									}
                              									add(
                              										current,
                              										"modifiers",
                              										lv_modifiers_13_0,
                              										"org.eclipse.xtend.core.Xtend.FieldModifier");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }
                            loop64:
                            do {
                                int alt64=2;
                                int LA64_0 = input.LA(1);

                                if ( (LA64_0==KW_Package||(LA64_0>=KW_Public && LA64_0<=KW_Transient)) ) {
                                    alt64=1;
                                }


                                switch (alt64) {
                            	case 1 :
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_0_2_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_38);
                            	    lv_modifiers_14_0=ruleCommonModifier();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"modifiers",
                            	      										lv_modifiers_14_0,
                            	      										"org.eclipse.xtend.core.Xtend.CommonModifier");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop64;
                                }
                            } while (true);
                            {
                            {
                            lv_modifiers_15_0=(Token)match(input,KW_Extension,FOLLOW_29); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									newLeafNode(lv_modifiers_15_0, grammarAccess.getMemberAccess().getModifiersExtensionKeyword_2_0_2_2_2_0());
                              								
                            }
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElement(grammarAccess.getMemberRule());
                              									}
                              									addWithLastConsumed(current, "modifiers", lv_modifiers_15_0, "extension");
                              								
                            }

                            }


                            }
                            loop65:
                            do {
                                int alt65=2;
                                int LA65_0 = input.LA(1);

                                if ( (LA65_0==KW_Package||(LA65_0>=KW_Public && LA65_0<=KW_Transient)) ) {
                                    alt65=1;
                                }


                                switch (alt65) {
                            	case 1 :
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_0_2_2_3_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_29);
                            	    lv_modifiers_16_0=ruleCommonModifier();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"modifiers",
                            	      										lv_modifiers_16_0,
                            	      										"org.eclipse.xtend.core.Xtend.CommonModifier");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop65;
                                }
                            } while (true);
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getMemberAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_2_2_4_0());
                              								
                            }
                            pushFollow(FOLLOW_37);
                            lv_type_17_0=ruleJvmTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getMemberRule());
                              									}
                              									set(
                              										current,
                              										"type",
                              										lv_type_17_0,
                              										"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }
                            int alt66=2;
                            alt66 = dfa66.predict(input);
                            switch (alt66) {
                                case 1 :
                                    {
                                    {
                                    if ( state.backtracking==0 ) {

                                      									newCompositeNode(grammarAccess.getMemberAccess().getNameValidIDParserRuleCall_2_0_2_2_5_0());
                                      								
                                    }
                                    pushFollow(FOLLOW_33);
                                    lv_name_18_0=ruleValidID();

                                    state._fsp--;
                                    if (state.failed) return current;
                                    if ( state.backtracking==0 ) {

                                      									if (current==null) {
                                      										current = createModelElementForParent(grammarAccess.getMemberRule());
                                      									}
                                      									set(
                                      										current,
                                      										"name",
                                      										lv_name_18_0,
                                      										"org.eclipse.xtend.core.Xtend.ValidID");
                                      									afterParserOrEnumRuleCall();
                                      								
                                    }

                                    }


                                    }
                                    break;

                            }


                            }


                            }
                            break;
                        case 4 :
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getMemberAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_2_3_0_0());
                              								
                            }
                            pushFollow(FOLLOW_3);
                            lv_type_19_0=ruleJvmTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getMemberRule());
                              									}
                              									set(
                              										current,
                              										"type",
                              										lv_type_19_0,
                              										"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getMemberAccess().getNameValidIDParserRuleCall_2_0_2_3_1_0());
                              								
                            }
                            pushFollow(FOLLOW_33);
                            lv_name_20_0=ruleValidID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getMemberRule());
                              									}
                              									set(
                              										current,
                              										"name",
                              										lv_name_20_0,
                              										"org.eclipse.xtend.core.Xtend.ValidID");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }


                            }


                            }
                            break;

                    }
                    int alt68=2;
                    int LA68_0 = input.LA(1);

                    if ( (LA68_0==KW_EqualsSign) ) {
                        alt68=1;
                    }
                    switch (alt68) {
                        case 1 :
                            {
                            otherlv_21=(Token)match(input,KW_EqualsSign,FOLLOW_34); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_21, grammarAccess.getMemberAccess().getEqualsSignKeyword_2_0_3_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getInitialValueXExpressionParserRuleCall_2_0_3_1_0());
                              							
                            }
                            pushFollow(FOLLOW_35);
                            lv_initialValue_22_0=ruleXExpression();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								set(
                              									current,
                              									"initialValue",
                              									lv_initialValue_22_0,
                              									"org.eclipse.xtext.xbase.Xbase.XExpression");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }


                            }
                            break;

                    }
                    int alt69=2;
                    int LA69_0 = input.LA(1);

                    if ( (LA69_0==KW_Semicolon) ) {
                        alt69=1;
                    }
                    switch (alt69) {
                        case 1 :
                            {
                            otherlv_23=(Token)match(input,KW_Semicolon,FOLLOW_2); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_23, grammarAccess.getMemberAccess().getSemicolonKeyword_2_0_4());
                              					
                            }

                            }
                            break;

                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getMemberAccess().getXtendFunctionAnnotationInfoAction_2_1_0(),
                      							current);
                      					
                    }

                    }
                    loop70:
                    do {
                        int alt70=2;
                        int LA70_0 = input.LA(1);

                        if ( (LA70_0==KW_Package||(LA70_0>=KW_Public && LA70_0<=KW_Transient)) ) {
                            alt70=1;
                        }


                        switch (alt70) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_1_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_39);
                    	    lv_modifiers_25_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_25_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop70;
                        }
                    } while (true);
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMemberAccess().getModifiersMethodModifierParserRuleCall_2_1_2_0());
                      						
                    }
                    pushFollow(FOLLOW_40);
                    lv_modifiers_26_0=ruleMethodModifier();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getMemberRule());
                      							}
                      							add(
                      								current,
                      								"modifiers",
                      								lv_modifiers_26_0,
                      								"org.eclipse.xtend.core.Xtend.MethodModifier");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    loop71:
                    do {
                        int alt71=3;
                        int LA71_0 = input.LA(1);

                        if ( (LA71_0==KW_Package||(LA71_0>=KW_Public && LA71_0<=KW_Transient)) ) {
                            alt71=1;
                        }
                        else if ( ((LA71_0>=KW_Def && LA71_0<=KW_Override)) ) {
                            alt71=2;
                        }


                        switch (alt71) {
                    	case 1 :
                    	    {
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      								newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_1_3_0_0());
                    	      							
                    	    }
                    	    pushFollow(FOLLOW_40);
                    	    lv_modifiers_27_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      								if (current==null) {
                    	      									current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      								}
                    	      								add(
                    	      									current,
                    	      									"modifiers",
                    	      									lv_modifiers_27_0,
                    	      									"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      								afterParserOrEnumRuleCall();
                    	      							
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;
                    	case 2 :
                    	    {
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      								newCompositeNode(grammarAccess.getMemberAccess().getModifiersMethodModifierParserRuleCall_2_1_3_1_0());
                    	      							
                    	    }
                    	    pushFollow(FOLLOW_40);
                    	    lv_modifiers_28_0=ruleMethodModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      								if (current==null) {
                    	      									current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      								}
                    	      								add(
                    	      									current,
                    	      									"modifiers",
                    	      									lv_modifiers_28_0,
                    	      									"org.eclipse.xtend.core.Xtend.MethodModifier");
                    	      								afterParserOrEnumRuleCall();
                    	      							
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop71;
                        }
                    } while (true);
                    int alt73=2;
                    int LA73_0 = input.LA(1);

                    if ( (LA73_0==KW_LessThanSign) ) {
                        int LA73_1 = input.LA(2);

                        if ( (LA73_1==KW_Annotation||LA73_1==KW_Create||(LA73_1>=KW_AFTER && LA73_1<=KW_SEPARATOR)||LA73_1==RULE_ID) ) {
                            alt73=1;
                        }
                    }
                    switch (alt73) {
                        case 1 :
                            {
                            otherlv_29=(Token)match(input,KW_LessThanSign,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_29, grammarAccess.getMemberAccess().getLessThanSignKeyword_2_1_4_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_1_4_1_0());
                              							
                            }
                            pushFollow(FOLLOW_10);
                            lv_typeParameters_30_0=ruleJvmTypeParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"typeParameters",
                              									lv_typeParameters_30_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop72:
                            do {
                                int alt72=2;
                                int LA72_0 = input.LA(1);

                                if ( (LA72_0==KW_Comma) ) {
                                    alt72=1;
                                }


                                switch (alt72) {
                            	case 1 :
                            	    {
                            	    otherlv_31=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_31, grammarAccess.getMemberAccess().getCommaKeyword_2_1_4_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_1_4_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_10);
                            	    lv_typeParameters_32_0=ruleJvmTypeParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"typeParameters",
                            	      										lv_typeParameters_32_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop72;
                                }
                            } while (true);

                            otherlv_33=(Token)match(input,KW_GreaterThanSign,FOLLOW_40); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_33, grammarAccess.getMemberAccess().getGreaterThanSignKeyword_2_1_4_3());
                              					
                            }

                            }
                            break;

                    }
                    int alt74=5;
                    alt74 = dfa74.predict(input);
                    switch (alt74) {
                        case 1 :
                            {
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              										newCompositeNode(grammarAccess.getMemberAccess().getReturnTypeJvmTypeReferenceParserRuleCall_2_1_5_0_0_0_0());
                              									
                            }
                            pushFollow(FOLLOW_41);
                            lv_returnType_34_0=ruleJvmTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElementForParent(grammarAccess.getMemberRule());
                              										}
                              										set(
                              											current,
                              											"returnType",
                              											lv_returnType_34_0,
                              											"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                              										afterParserOrEnumRuleCall();
                              									
                            }

                            }


                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              										newCompositeNode(grammarAccess.getMemberAccess().getCreateExtensionInfoCreateExtensionInfoParserRuleCall_2_1_5_0_0_1_0());
                              									
                            }
                            pushFollow(FOLLOW_3);
                            lv_createExtensionInfo_35_0=ruleCreateExtensionInfo();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElementForParent(grammarAccess.getMemberRule());
                              										}
                              										set(
                              											current,
                              											"createExtensionInfo",
                              											lv_createExtensionInfo_35_0,
                              											"org.eclipse.xtend.core.Xtend.CreateExtensionInfo");
                              										afterParserOrEnumRuleCall();
                              									
                            }

                            }


                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              										newCompositeNode(grammarAccess.getMemberAccess().getNameValidIDParserRuleCall_2_1_5_0_0_2_0());
                              									
                            }
                            pushFollow(FOLLOW_42);
                            lv_name_36_0=ruleValidID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElementForParent(grammarAccess.getMemberRule());
                              										}
                              										set(
                              											current,
                              											"name",
                              											lv_name_36_0,
                              											"org.eclipse.xtend.core.Xtend.ValidID");
                              										afterParserOrEnumRuleCall();
                              									
                            }

                            }


                            }

                            otherlv_37=(Token)match(input,KW_LeftParenthesis,FOLLOW_43); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								newLeafNode(otherlv_37, grammarAccess.getMemberAccess().getLeftParenthesisKeyword_2_1_5_0_0_3());
                              							
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              										newCompositeNode(grammarAccess.getMemberAccess().getReturnTypeTypeReferenceWithTypeArgsParserRuleCall_2_1_5_1_0_0_0());
                              									
                            }
                            pushFollow(FOLLOW_40);
                            lv_returnType_38_0=ruleTypeReferenceWithTypeArgs();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElementForParent(grammarAccess.getMemberRule());
                              										}
                              										set(
                              											current,
                              											"returnType",
                              											lv_returnType_38_0,
                              											"org.eclipse.xtend.core.Xtend.TypeReferenceWithTypeArgs");
                              										afterParserOrEnumRuleCall();
                              									
                            }

                            }


                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              										newCompositeNode(grammarAccess.getMemberAccess().getNameFunctionIDParserRuleCall_2_1_5_1_0_1_0());
                              									
                            }
                            pushFollow(FOLLOW_42);
                            lv_name_39_0=ruleFunctionID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElementForParent(grammarAccess.getMemberRule());
                              										}
                              										set(
                              											current,
                              											"name",
                              											lv_name_39_0,
                              											"org.eclipse.xtend.core.Xtend.FunctionID");
                              										afterParserOrEnumRuleCall();
                              									
                            }

                            }


                            }

                            otherlv_40=(Token)match(input,KW_LeftParenthesis,FOLLOW_43); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								newLeafNode(otherlv_40, grammarAccess.getMemberAccess().getLeftParenthesisKeyword_2_1_5_1_0_2());
                              							
                            }

                            }


                            }


                            }
                            break;
                        case 3 :
                            {
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              										newCompositeNode(grammarAccess.getMemberAccess().getReturnTypeTypeReferenceNoTypeArgsParserRuleCall_2_1_5_2_0_0_0());
                              									
                            }
                            pushFollow(FOLLOW_40);
                            lv_returnType_41_0=ruleTypeReferenceNoTypeArgs();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElementForParent(grammarAccess.getMemberRule());
                              										}
                              										set(
                              											current,
                              											"returnType",
                              											lv_returnType_41_0,
                              											"org.eclipse.xtend.core.Xtend.TypeReferenceNoTypeArgs");
                              										afterParserOrEnumRuleCall();
                              									
                            }

                            }


                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              										newCompositeNode(grammarAccess.getMemberAccess().getNameFunctionIDParserRuleCall_2_1_5_2_0_1_0());
                              									
                            }
                            pushFollow(FOLLOW_42);
                            lv_name_42_0=ruleFunctionID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElementForParent(grammarAccess.getMemberRule());
                              										}
                              										set(
                              											current,
                              											"name",
                              											lv_name_42_0,
                              											"org.eclipse.xtend.core.Xtend.FunctionID");
                              										afterParserOrEnumRuleCall();
                              									
                            }

                            }


                            }

                            otherlv_43=(Token)match(input,KW_LeftParenthesis,FOLLOW_43); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								newLeafNode(otherlv_43, grammarAccess.getMemberAccess().getLeftParenthesisKeyword_2_1_5_2_0_2());
                              							
                            }

                            }


                            }


                            }
                            break;
                        case 4 :
                            {
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              										newCompositeNode(grammarAccess.getMemberAccess().getCreateExtensionInfoCreateExtensionInfoParserRuleCall_2_1_5_3_0_0_0());
                              									
                            }
                            pushFollow(FOLLOW_3);
                            lv_createExtensionInfo_44_0=ruleCreateExtensionInfo();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElementForParent(grammarAccess.getMemberRule());
                              										}
                              										set(
                              											current,
                              											"createExtensionInfo",
                              											lv_createExtensionInfo_44_0,
                              											"org.eclipse.xtend.core.Xtend.CreateExtensionInfo");
                              										afterParserOrEnumRuleCall();
                              									
                            }

                            }


                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              										newCompositeNode(grammarAccess.getMemberAccess().getNameValidIDParserRuleCall_2_1_5_3_0_1_0());
                              									
                            }
                            pushFollow(FOLLOW_42);
                            lv_name_45_0=ruleValidID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElementForParent(grammarAccess.getMemberRule());
                              										}
                              										set(
                              											current,
                              											"name",
                              											lv_name_45_0,
                              											"org.eclipse.xtend.core.Xtend.ValidID");
                              										afterParserOrEnumRuleCall();
                              									
                            }

                            }


                            }

                            otherlv_46=(Token)match(input,KW_LeftParenthesis,FOLLOW_43); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								newLeafNode(otherlv_46, grammarAccess.getMemberAccess().getLeftParenthesisKeyword_2_1_5_3_0_2());
                              							
                            }

                            }


                            }


                            }
                            break;
                        case 5 :
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getMemberAccess().getNameFunctionIDParserRuleCall_2_1_5_4_0_0());
                              								
                            }
                            pushFollow(FOLLOW_42);
                            lv_name_47_0=ruleFunctionID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getMemberRule());
                              									}
                              									set(
                              										current,
                              										"name",
                              										lv_name_47_0,
                              										"org.eclipse.xtend.core.Xtend.FunctionID");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }

                            otherlv_48=(Token)match(input,KW_LeftParenthesis,FOLLOW_43); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							newLeafNode(otherlv_48, grammarAccess.getMemberAccess().getLeftParenthesisKeyword_2_1_5_4_1());
                              						
                            }

                            }


                            }
                            break;

                    }
                    int alt76=2;
                    int LA76_0 = input.LA(1);

                    if ( ((LA76_0>=KW_Annotation && LA76_0<=KW_LeftParenthesis)||LA76_0==KW_EqualsSignGreaterThanSign||LA76_0==KW_Extension||LA76_0==KW_Create||(LA76_0>=KW_AFTER && LA76_0<=KW_SEPARATOR)||LA76_0==KW_CommercialAt||LA76_0==RULE_ID) ) {
                        alt76=1;
                    }
                    switch (alt76) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getParametersParameterParserRuleCall_2_1_6_0_0());
                              							
                            }
                            pushFollow(FOLLOW_28);
                            lv_parameters_49_0=ruleParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"parameters",
                              									lv_parameters_49_0,
                              									"org.eclipse.xtend.core.Xtend.Parameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop75:
                            do {
                                int alt75=2;
                                int LA75_0 = input.LA(1);

                                if ( (LA75_0==KW_Comma) ) {
                                    alt75=1;
                                }


                                switch (alt75) {
                            	case 1 :
                            	    {
                            	    otherlv_50=(Token)match(input,KW_Comma,FOLLOW_44); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_50, grammarAccess.getMemberAccess().getCommaKeyword_2_1_6_1_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getParametersParameterParserRuleCall_2_1_6_1_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_28);
                            	    lv_parameters_51_0=ruleParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"parameters",
                            	      										lv_parameters_51_0,
                            	      										"org.eclipse.xtend.core.Xtend.Parameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop75;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_52=(Token)match(input,KW_RightParenthesis,FOLLOW_45); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_52, grammarAccess.getMemberAccess().getRightParenthesisKeyword_2_1_7());
                      				
                    }
                    int alt78=2;
                    int LA78_0 = input.LA(1);

                    if ( (LA78_0==KW_Throws) ) {
                        alt78=1;
                    }
                    switch (alt78) {
                        case 1 :
                            {
                            otherlv_53=(Token)match(input,KW_Throws,FOLLOW_29); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_53, grammarAccess.getMemberAccess().getThrowsKeyword_2_1_8_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getExceptionsJvmTypeReferenceParserRuleCall_2_1_8_1_0());
                              							
                            }
                            pushFollow(FOLLOW_46);
                            lv_exceptions_54_0=ruleJvmTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"exceptions",
                              									lv_exceptions_54_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop77:
                            do {
                                int alt77=2;
                                int LA77_0 = input.LA(1);

                                if ( (LA77_0==KW_Comma) ) {
                                    alt77=1;
                                }


                                switch (alt77) {
                            	case 1 :
                            	    {
                            	    otherlv_55=(Token)match(input,KW_Comma,FOLLOW_29); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_55, grammarAccess.getMemberAccess().getCommaKeyword_2_1_8_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getExceptionsJvmTypeReferenceParserRuleCall_2_1_8_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_46);
                            	    lv_exceptions_56_0=ruleJvmTypeReference();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"exceptions",
                            	      										lv_exceptions_56_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop77;
                                }
                            } while (true);


                            }
                            break;

                    }
                    int alt79=4;
                    switch ( input.LA(1) ) {
                        case KW_LeftCurlyBracket:
                            {
                            alt79=1;
                            }
                            break;
                        case RULE_RICH_TEXT:
                        case RULE_RICH_TEXT_START:
                            {
                            alt79=2;
                            }
                            break;
                        case KW_Semicolon:
                            {
                            alt79=3;
                            }
                            break;
                    }

                    switch (alt79) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getExpressionXBlockExpressionParserRuleCall_2_1_9_0_0());
                              							
                            }
                            pushFollow(FOLLOW_2);
                            lv_expression_57_0=ruleXBlockExpression();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								set(
                              									current,
                              									"expression",
                              									lv_expression_57_0,
                              									"org.eclipse.xtext.xbase.Xbase.XBlockExpression");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getExpressionRichStringParserRuleCall_2_1_9_1_0());
                              							
                            }
                            pushFollow(FOLLOW_2);
                            lv_expression_58_0=ruleRichString();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								set(
                              									current,
                              									"expression",
                              									lv_expression_58_0,
                              									"org.eclipse.xtend.core.Xtend.RichString");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }


                            }
                            break;
                        case 3 :
                            {
                            otherlv_59=(Token)match(input,KW_Semicolon,FOLLOW_2); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_59, grammarAccess.getMemberAccess().getSemicolonKeyword_2_1_9_2());
                              					
                            }

                            }
                            break;

                    }


                    }


                    }
                    break;
                case 3 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getMemberAccess().getXtendConstructorAnnotationInfoAction_2_2_0(),
                      							current);
                      					
                    }

                    }
                    loop80:
                    do {
                        int alt80=2;
                        int LA80_0 = input.LA(1);

                        if ( (LA80_0==KW_Package||(LA80_0>=KW_Public && LA80_0<=KW_Transient)) ) {
                            alt80=1;
                        }


                        switch (alt80) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_2_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_47);
                    	    lv_modifiers_61_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_61_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop80;
                        }
                    } while (true);

                    otherlv_62=(Token)match(input,KW_New,FOLLOW_48); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_62, grammarAccess.getMemberAccess().getNewKeyword_2_2_2());
                      				
                    }
                    int alt82=2;
                    int LA82_0 = input.LA(1);

                    if ( (LA82_0==KW_LessThanSign) ) {
                        alt82=1;
                    }
                    switch (alt82) {
                        case 1 :
                            {
                            otherlv_63=(Token)match(input,KW_LessThanSign,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_63, grammarAccess.getMemberAccess().getLessThanSignKeyword_2_2_3_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_2_3_1_0());
                              							
                            }
                            pushFollow(FOLLOW_10);
                            lv_typeParameters_64_0=ruleJvmTypeParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"typeParameters",
                              									lv_typeParameters_64_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop81:
                            do {
                                int alt81=2;
                                int LA81_0 = input.LA(1);

                                if ( (LA81_0==KW_Comma) ) {
                                    alt81=1;
                                }


                                switch (alt81) {
                            	case 1 :
                            	    {
                            	    otherlv_65=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_65, grammarAccess.getMemberAccess().getCommaKeyword_2_2_3_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_2_3_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_10);
                            	    lv_typeParameters_66_0=ruleJvmTypeParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"typeParameters",
                            	      										lv_typeParameters_66_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop81;
                                }
                            } while (true);

                            otherlv_67=(Token)match(input,KW_GreaterThanSign,FOLLOW_42); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_67, grammarAccess.getMemberAccess().getGreaterThanSignKeyword_2_2_3_3());
                              					
                            }

                            }
                            break;

                    }

                    otherlv_68=(Token)match(input,KW_LeftParenthesis,FOLLOW_43); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_68, grammarAccess.getMemberAccess().getLeftParenthesisKeyword_2_2_4());
                      				
                    }
                    int alt84=2;
                    int LA84_0 = input.LA(1);

                    if ( ((LA84_0>=KW_Annotation && LA84_0<=KW_LeftParenthesis)||LA84_0==KW_EqualsSignGreaterThanSign||LA84_0==KW_Extension||LA84_0==KW_Create||(LA84_0>=KW_AFTER && LA84_0<=KW_SEPARATOR)||LA84_0==KW_CommercialAt||LA84_0==RULE_ID) ) {
                        alt84=1;
                    }
                    switch (alt84) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getParametersParameterParserRuleCall_2_2_5_0_0());
                              							
                            }
                            pushFollow(FOLLOW_28);
                            lv_parameters_69_0=ruleParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"parameters",
                              									lv_parameters_69_0,
                              									"org.eclipse.xtend.core.Xtend.Parameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop83:
                            do {
                                int alt83=2;
                                int LA83_0 = input.LA(1);

                                if ( (LA83_0==KW_Comma) ) {
                                    alt83=1;
                                }


                                switch (alt83) {
                            	case 1 :
                            	    {
                            	    otherlv_70=(Token)match(input,KW_Comma,FOLLOW_44); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_70, grammarAccess.getMemberAccess().getCommaKeyword_2_2_5_1_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getParametersParameterParserRuleCall_2_2_5_1_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_28);
                            	    lv_parameters_71_0=ruleParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"parameters",
                            	      										lv_parameters_71_0,
                            	      										"org.eclipse.xtend.core.Xtend.Parameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop83;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_72=(Token)match(input,KW_RightParenthesis,FOLLOW_49); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_72, grammarAccess.getMemberAccess().getRightParenthesisKeyword_2_2_6());
                      				
                    }
                    int alt86=2;
                    int LA86_0 = input.LA(1);

                    if ( (LA86_0==KW_Throws) ) {
                        alt86=1;
                    }
                    switch (alt86) {
                        case 1 :
                            {
                            otherlv_73=(Token)match(input,KW_Throws,FOLLOW_29); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_73, grammarAccess.getMemberAccess().getThrowsKeyword_2_2_7_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getExceptionsJvmTypeReferenceParserRuleCall_2_2_7_1_0());
                              							
                            }
                            pushFollow(FOLLOW_14);
                            lv_exceptions_74_0=ruleJvmTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"exceptions",
                              									lv_exceptions_74_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop85:
                            do {
                                int alt85=2;
                                int LA85_0 = input.LA(1);

                                if ( (LA85_0==KW_Comma) ) {
                                    alt85=1;
                                }


                                switch (alt85) {
                            	case 1 :
                            	    {
                            	    otherlv_75=(Token)match(input,KW_Comma,FOLLOW_29); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_75, grammarAccess.getMemberAccess().getCommaKeyword_2_2_7_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getExceptionsJvmTypeReferenceParserRuleCall_2_2_7_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_14);
                            	    lv_exceptions_76_0=ruleJvmTypeReference();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"exceptions",
                            	      										lv_exceptions_76_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop85;
                                }
                            } while (true);


                            }
                            break;

                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMemberAccess().getExpressionXBlockExpressionParserRuleCall_2_2_8_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    lv_expression_77_0=ruleXBlockExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getMemberRule());
                      							}
                      							set(
                      								current,
                      								"expression",
                      								lv_expression_77_0,
                      								"org.eclipse.xtext.xbase.Xbase.XBlockExpression");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;
                case 4 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getMemberAccess().getXtendClassAnnotationInfoAction_2_3_0(),
                      							current);
                      					
                    }

                    }
                    loop87:
                    do {
                        int alt87=2;
                        int LA87_0 = input.LA(1);

                        if ( (LA87_0==KW_Package||(LA87_0>=KW_Public && LA87_0<=KW_Transient)) ) {
                            alt87=1;
                        }


                        switch (alt87) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_3_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_8);
                    	    lv_modifiers_79_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_79_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop87;
                        }
                    } while (true);

                    otherlv_80=(Token)match(input,KW_Class,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_80, grammarAccess.getMemberAccess().getClassKeyword_2_3_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMemberAccess().getNameValidIDParserRuleCall_2_3_3_0());
                      						
                    }
                    pushFollow(FOLLOW_9);
                    lv_name_81_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getMemberRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_81_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    int alt89=2;
                    int LA89_0 = input.LA(1);

                    if ( (LA89_0==KW_LessThanSign) ) {
                        alt89=1;
                    }
                    switch (alt89) {
                        case 1 :
                            {
                            otherlv_82=(Token)match(input,KW_LessThanSign,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_82, grammarAccess.getMemberAccess().getLessThanSignKeyword_2_3_4_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_3_4_1_0());
                              							
                            }
                            pushFollow(FOLLOW_10);
                            lv_typeParameters_83_0=ruleJvmTypeParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"typeParameters",
                              									lv_typeParameters_83_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop88:
                            do {
                                int alt88=2;
                                int LA88_0 = input.LA(1);

                                if ( (LA88_0==KW_Comma) ) {
                                    alt88=1;
                                }


                                switch (alt88) {
                            	case 1 :
                            	    {
                            	    otherlv_84=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_84, grammarAccess.getMemberAccess().getCommaKeyword_2_3_4_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_3_4_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_10);
                            	    lv_typeParameters_85_0=ruleJvmTypeParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"typeParameters",
                            	      										lv_typeParameters_85_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop88;
                                }
                            } while (true);

                            otherlv_86=(Token)match(input,KW_GreaterThanSign,FOLLOW_11); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_86, grammarAccess.getMemberAccess().getGreaterThanSignKeyword_2_3_4_3());
                              					
                            }

                            }
                            break;

                    }
                    int alt90=2;
                    int LA90_0 = input.LA(1);

                    if ( (LA90_0==KW_Extends) ) {
                        alt90=1;
                    }
                    switch (alt90) {
                        case 1 :
                            {
                            otherlv_87=(Token)match(input,KW_Extends,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_87, grammarAccess.getMemberAccess().getExtendsKeyword_2_3_5_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getExtendsJvmParameterizedTypeReferenceParserRuleCall_2_3_5_1_0());
                              							
                            }
                            pushFollow(FOLLOW_12);
                            lv_extends_88_0=ruleJvmParameterizedTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								set(
                              									current,
                              									"extends",
                              									lv_extends_88_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }


                            }
                            break;

                    }
                    int alt92=2;
                    int LA92_0 = input.LA(1);

                    if ( (LA92_0==KW_Implements) ) {
                        alt92=1;
                    }
                    switch (alt92) {
                        case 1 :
                            {
                            otherlv_89=(Token)match(input,KW_Implements,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_89, grammarAccess.getMemberAccess().getImplementsKeyword_2_3_6_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getImplementsJvmParameterizedTypeReferenceParserRuleCall_2_3_6_1_0());
                              							
                            }
                            pushFollow(FOLLOW_14);
                            lv_implements_90_0=ruleJvmParameterizedTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"implements",
                              									lv_implements_90_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop91:
                            do {
                                int alt91=2;
                                int LA91_0 = input.LA(1);

                                if ( (LA91_0==KW_Comma) ) {
                                    alt91=1;
                                }


                                switch (alt91) {
                            	case 1 :
                            	    {
                            	    otherlv_91=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_91, grammarAccess.getMemberAccess().getCommaKeyword_2_3_6_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getImplementsJvmParameterizedTypeReferenceParserRuleCall_2_3_6_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_14);
                            	    lv_implements_92_0=ruleJvmParameterizedTypeReference();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"implements",
                            	      										lv_implements_92_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop91;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_93=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_15); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_93, grammarAccess.getMemberAccess().getLeftCurlyBracketKeyword_2_3_7());
                      				
                    }
                    loop93:
                    do {
                        int alt93=2;
                        int LA93_0 = input.LA(1);

                        if ( (LA93_0==KW_Package||LA93_0==KW_Class||(LA93_0>=KW_Interface && LA93_0<=KW_LeftParenthesis)||LA93_0==KW_EqualsSignGreaterThanSign||LA93_0==KW_Extension||LA93_0==KW_New||(LA93_0>=KW_Public && LA93_0<=KW_Create)||(LA93_0>=KW_AFTER && LA93_0<=KW_SEPARATOR)||LA93_0==KW_CommercialAt||LA93_0==RULE_ID) ) {
                            alt93=1;
                        }


                        switch (alt93) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getMemberAccess().getMembersMemberParserRuleCall_2_3_8_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_15);
                    	    lv_members_94_0=ruleMember();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"members",
                    	      								lv_members_94_0,
                    	      								"org.eclipse.xtend.core.Xtend.Member");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop93;
                        }
                    } while (true);

                    otherlv_95=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_95, grammarAccess.getMemberAccess().getRightCurlyBracketKeyword_2_3_9());
                      				
                    }

                    }


                    }
                    break;
                case 5 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getMemberAccess().getXtendInterfaceAnnotationInfoAction_2_4_0(),
                      							current);
                      					
                    }

                    }
                    loop94:
                    do {
                        int alt94=2;
                        int LA94_0 = input.LA(1);

                        if ( (LA94_0==KW_Package||(LA94_0>=KW_Public && LA94_0<=KW_Transient)) ) {
                            alt94=1;
                        }


                        switch (alt94) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_4_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_16);
                    	    lv_modifiers_97_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_97_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop94;
                        }
                    } while (true);

                    otherlv_98=(Token)match(input,KW_Interface,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_98, grammarAccess.getMemberAccess().getInterfaceKeyword_2_4_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMemberAccess().getNameValidIDParserRuleCall_2_4_3_0());
                      						
                    }
                    pushFollow(FOLLOW_17);
                    lv_name_99_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getMemberRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_99_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    int alt96=2;
                    int LA96_0 = input.LA(1);

                    if ( (LA96_0==KW_LessThanSign) ) {
                        alt96=1;
                    }
                    switch (alt96) {
                        case 1 :
                            {
                            otherlv_100=(Token)match(input,KW_LessThanSign,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_100, grammarAccess.getMemberAccess().getLessThanSignKeyword_2_4_4_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_4_4_1_0());
                              							
                            }
                            pushFollow(FOLLOW_10);
                            lv_typeParameters_101_0=ruleJvmTypeParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"typeParameters",
                              									lv_typeParameters_101_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop95:
                            do {
                                int alt95=2;
                                int LA95_0 = input.LA(1);

                                if ( (LA95_0==KW_Comma) ) {
                                    alt95=1;
                                }


                                switch (alt95) {
                            	case 1 :
                            	    {
                            	    otherlv_102=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_102, grammarAccess.getMemberAccess().getCommaKeyword_2_4_4_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getTypeParametersJvmTypeParameterParserRuleCall_2_4_4_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_10);
                            	    lv_typeParameters_103_0=ruleJvmTypeParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"typeParameters",
                            	      										lv_typeParameters_103_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmTypeParameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop95;
                                }
                            } while (true);

                            otherlv_104=(Token)match(input,KW_GreaterThanSign,FOLLOW_18); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_104, grammarAccess.getMemberAccess().getGreaterThanSignKeyword_2_4_4_3());
                              					
                            }

                            }
                            break;

                    }
                    int alt98=2;
                    int LA98_0 = input.LA(1);

                    if ( (LA98_0==KW_Extends) ) {
                        alt98=1;
                    }
                    switch (alt98) {
                        case 1 :
                            {
                            otherlv_105=(Token)match(input,KW_Extends,FOLLOW_3); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_105, grammarAccess.getMemberAccess().getExtendsKeyword_2_4_5_0());
                              					
                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getExtendsJvmParameterizedTypeReferenceParserRuleCall_2_4_5_1_0());
                              							
                            }
                            pushFollow(FOLLOW_14);
                            lv_extends_106_0=ruleJvmParameterizedTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"extends",
                              									lv_extends_106_0,
                              									"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop97:
                            do {
                                int alt97=2;
                                int LA97_0 = input.LA(1);

                                if ( (LA97_0==KW_Comma) ) {
                                    alt97=1;
                                }


                                switch (alt97) {
                            	case 1 :
                            	    {
                            	    otherlv_107=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_107, grammarAccess.getMemberAccess().getCommaKeyword_2_4_5_2_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getExtendsJvmParameterizedTypeReferenceParserRuleCall_2_4_5_2_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_14);
                            	    lv_extends_108_0=ruleJvmParameterizedTypeReference();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"extends",
                            	      										lv_extends_108_0,
                            	      										"org.eclipse.xtext.xbase.Xtype.JvmParameterizedTypeReference");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop97;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_109=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_15); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_109, grammarAccess.getMemberAccess().getLeftCurlyBracketKeyword_2_4_6());
                      				
                    }
                    loop99:
                    do {
                        int alt99=2;
                        int LA99_0 = input.LA(1);

                        if ( (LA99_0==KW_Package||LA99_0==KW_Class||(LA99_0>=KW_Interface && LA99_0<=KW_LeftParenthesis)||LA99_0==KW_EqualsSignGreaterThanSign||LA99_0==KW_Extension||LA99_0==KW_New||(LA99_0>=KW_Public && LA99_0<=KW_Create)||(LA99_0>=KW_AFTER && LA99_0<=KW_SEPARATOR)||LA99_0==KW_CommercialAt||LA99_0==RULE_ID) ) {
                            alt99=1;
                        }


                        switch (alt99) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getMemberAccess().getMembersMemberParserRuleCall_2_4_7_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_15);
                    	    lv_members_110_0=ruleMember();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"members",
                    	      								lv_members_110_0,
                    	      								"org.eclipse.xtend.core.Xtend.Member");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop99;
                        }
                    } while (true);

                    otherlv_111=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_111, grammarAccess.getMemberAccess().getRightCurlyBracketKeyword_2_4_8());
                      				
                    }

                    }


                    }
                    break;
                case 6 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getMemberAccess().getXtendEnumAnnotationInfoAction_2_5_0(),
                      							current);
                      					
                    }

                    }
                    loop100:
                    do {
                        int alt100=2;
                        int LA100_0 = input.LA(1);

                        if ( (LA100_0==KW_Package||(LA100_0>=KW_Public && LA100_0<=KW_Transient)) ) {
                            alt100=1;
                        }


                        switch (alt100) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_5_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_19);
                    	    lv_modifiers_113_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_113_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop100;
                        }
                    } while (true);

                    otherlv_114=(Token)match(input,KW_Enum,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_114, grammarAccess.getMemberAccess().getEnumKeyword_2_5_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMemberAccess().getNameValidIDParserRuleCall_2_5_3_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_name_115_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getMemberRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_115_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    otherlv_116=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_21); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_116, grammarAccess.getMemberAccess().getLeftCurlyBracketKeyword_2_5_4());
                      				
                    }
                    int alt102=2;
                    int LA102_0 = input.LA(1);

                    if ( (LA102_0==KW_Annotation||LA102_0==KW_Create||(LA102_0>=KW_AFTER && LA102_0<=KW_SEPARATOR)||LA102_0==KW_CommercialAt||LA102_0==RULE_ID) ) {
                        alt102=1;
                    }
                    switch (alt102) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getMemberAccess().getMembersXtendEnumLiteralParserRuleCall_2_5_5_0_0());
                              							
                            }
                            pushFollow(FOLLOW_22);
                            lv_members_117_0=ruleXtendEnumLiteral();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getMemberRule());
                              								}
                              								add(
                              									current,
                              									"members",
                              									lv_members_117_0,
                              									"org.eclipse.xtend.core.Xtend.XtendEnumLiteral");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop101:
                            do {
                                int alt101=2;
                                int LA101_0 = input.LA(1);

                                if ( (LA101_0==KW_Comma) ) {
                                    alt101=1;
                                }


                                switch (alt101) {
                            	case 1 :
                            	    {
                            	    otherlv_118=(Token)match(input,KW_Comma,FOLLOW_23); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_118, grammarAccess.getMemberAccess().getCommaKeyword_2_5_5_1_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getMemberAccess().getMembersXtendEnumLiteralParserRuleCall_2_5_5_1_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_22);
                            	    lv_members_119_0=ruleXtendEnumLiteral();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getMemberRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"members",
                            	      										lv_members_119_0,
                            	      										"org.eclipse.xtend.core.Xtend.XtendEnumLiteral");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop101;
                                }
                            } while (true);


                            }
                            break;

                    }
                    int alt103=2;
                    int LA103_0 = input.LA(1);

                    if ( (LA103_0==KW_Semicolon) ) {
                        alt103=1;
                    }
                    switch (alt103) {
                        case 1 :
                            {
                            otherlv_120=(Token)match(input,KW_Semicolon,FOLLOW_24); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_120, grammarAccess.getMemberAccess().getSemicolonKeyword_2_5_6());
                              					
                            }

                            }
                            break;

                    }

                    otherlv_121=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_121, grammarAccess.getMemberAccess().getRightCurlyBracketKeyword_2_5_7());
                      				
                    }

                    }


                    }
                    break;
                case 7 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getMemberAccess().getXtendAnnotationTypeAnnotationInfoAction_2_6_0(),
                      							current);
                      					
                    }

                    }
                    loop104:
                    do {
                        int alt104=2;
                        int LA104_0 = input.LA(1);

                        if ( (LA104_0==KW_Package||(LA104_0>=KW_Public && LA104_0<=KW_Transient)) ) {
                            alt104=1;
                        }


                        switch (alt104) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getMemberAccess().getModifiersCommonModifierParserRuleCall_2_6_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_25);
                    	    lv_modifiers_123_0=ruleCommonModifier();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"modifiers",
                    	      								lv_modifiers_123_0,
                    	      								"org.eclipse.xtend.core.Xtend.CommonModifier");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop104;
                        }
                    } while (true);

                    otherlv_124=(Token)match(input,KW_Annotation,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_124, grammarAccess.getMemberAccess().getAnnotationKeyword_2_6_2());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMemberAccess().getNameValidIDParserRuleCall_2_6_3_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_name_125_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getMemberRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_125_0,
                      								"org.eclipse.xtend.core.Xtend.ValidID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    otherlv_126=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_26); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_126, grammarAccess.getMemberAccess().getLeftCurlyBracketKeyword_2_6_4());
                      				
                    }
                    loop105:
                    do {
                        int alt105=2;
                        int LA105_0 = input.LA(1);

                        if ( (LA105_0==KW_Package||LA105_0==KW_Class||(LA105_0>=KW_Interface && LA105_0<=KW_LeftParenthesis)||LA105_0==KW_EqualsSignGreaterThanSign||(LA105_0>=KW_Public && LA105_0<=KW_Var)||LA105_0==KW_Create||(LA105_0>=KW_AFTER && LA105_0<=KW_SEPARATOR)||LA105_0==KW_CommercialAt||LA105_0==RULE_ID) ) {
                            alt105=1;
                        }


                        switch (alt105) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getMemberAccess().getMembersAnnotationFieldParserRuleCall_2_6_5_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_26);
                    	    lv_members_127_0=ruleAnnotationField();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getMemberRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"members",
                    	      								lv_members_127_0,
                    	      								"org.eclipse.xtend.core.Xtend.AnnotationField");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop105;
                        }
                    } while (true);

                    otherlv_128=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_128, grammarAccess.getMemberAccess().getRightCurlyBracketKeyword_2_6_6());
                      				
                    }

                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleTypeReferenceNoTypeArgs() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTypeReferenceNoTypeArgs = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getTypeReferenceNoTypeArgsRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleTypeReferenceNoTypeArgs=ruleTypeReferenceNoTypeArgs();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleTypeReferenceNoTypeArgs; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleTypeReferenceNoTypeArgs() throws RecognitionException {
        EObject current = null;


        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				if (current==null) {
              					current = createModelElement(grammarAccess.getTypeReferenceNoTypeArgsRule());
              				}
              			
            }
            if ( state.backtracking==0 ) {

              				newCompositeNode(grammarAccess.getTypeReferenceNoTypeArgsAccess().getTypeJvmTypeCrossReference_0());
              			
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              				afterParserOrEnumRuleCall();
              			
            }

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleTypeReferenceWithTypeArgs() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTypeReferenceWithTypeArgs = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getTypeReferenceWithTypeArgsRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleTypeReferenceWithTypeArgs=ruleTypeReferenceWithTypeArgs();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleTypeReferenceWithTypeArgs; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleTypeReferenceWithTypeArgs() throws RecognitionException {
        EObject current = null;

        EObject this_ParameterizedTypeReferenceWithTypeArgs_0 = null;

        EObject this_TypeReferenceNoTypeArgs_3 = null;

        EObject this_XFunctionTypeRef_6 = null;



        	enterRule();

        try {
            {
            int alt109=3;
            alt109 = dfa109.predict(input);
            switch (alt109) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getTypeReferenceWithTypeArgsAccess().getParameterizedTypeReferenceWithTypeArgsParserRuleCall_0_0());
                      			
                    }
                    pushFollow(FOLLOW_50);
                    this_ParameterizedTypeReferenceWithTypeArgs_0=ruleParameterizedTypeReferenceWithTypeArgs();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_ParameterizedTypeReferenceWithTypeArgs_0;
                      				afterParserOrEnumRuleCall();
                      			
                    }
                    loop107:
                    do {
                        int alt107=2;
                        int LA107_0 = input.LA(1);

                        if ( (LA107_0==KW_LeftSquareBracket) && (synpred5_InternalXtend())) {
                            alt107=1;
                        }


                        switch (alt107) {
                    	case 1 :
                    	    {
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							current = forceCreateModelElementAndSet(
                    	      								grammarAccess.getTypeReferenceWithTypeArgsAccess().getJvmGenericArrayTypeReferenceComponentTypeAction_0_1_0_0(),
                    	      								current);
                    	      						
                    	    }

                    	    }

                    	    if ( state.backtracking==0 ) {

                    	      						newCompositeNode(grammarAccess.getTypeReferenceWithTypeArgsAccess().getArrayBracketsParserRuleCall_0_1_0_1());
                    	      					
                    	    }
                    	    pushFollow(FOLLOW_50);
                    	    ruleArrayBrackets();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      						afterParserOrEnumRuleCall();
                    	      					
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop107;
                        }
                    } while (true);


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getTypeReferenceWithTypeArgsAccess().getTypeReferenceNoTypeArgsParserRuleCall_1_0());
                      			
                    }
                    pushFollow(FOLLOW_51);
                    this_TypeReferenceNoTypeArgs_3=ruleTypeReferenceNoTypeArgs();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_TypeReferenceNoTypeArgs_3;
                      				afterParserOrEnumRuleCall();
                      			
                    }
                    int cnt108=0;
                    loop108:
                    do {
                        int alt108=2;
                        int LA108_0 = input.LA(1);

                        if ( (LA108_0==KW_LeftSquareBracket) && (synpred6_InternalXtend())) {
                            alt108=1;
                        }


                        switch (alt108) {
                    	case 1 :
                    	    {
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							current = forceCreateModelElementAndSet(
                    	      								grammarAccess.getTypeReferenceWithTypeArgsAccess().getJvmGenericArrayTypeReferenceComponentTypeAction_1_1_0_0(),
                    	      								current);
                    	      						
                    	    }

                    	    }

                    	    if ( state.backtracking==0 ) {

                    	      						newCompositeNode(grammarAccess.getTypeReferenceWithTypeArgsAccess().getArrayBracketsParserRuleCall_1_1_0_1());
                    	      					
                    	    }
                    	    pushFollow(FOLLOW_50);
                    	    ruleArrayBrackets();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      						afterParserOrEnumRuleCall();
                    	      					
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt108 >= 1 ) break loop108;
                    	    if (state.backtracking>0) {state.failed=true; return current;}
                                EarlyExitException eee =
                                    new EarlyExitException(108, input);
                                throw eee;
                        }
                        cnt108++;
                    } while (true);


                    }


                    }
                    break;
                case 3 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getTypeReferenceWithTypeArgsAccess().getXFunctionTypeRefParserRuleCall_2());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XFunctionTypeRef_6=ruleXFunctionTypeRef();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XFunctionTypeRef_6;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleParameterizedTypeReferenceWithTypeArgs() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleParameterizedTypeReferenceWithTypeArgs = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getParameterizedTypeReferenceWithTypeArgsRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleParameterizedTypeReferenceWithTypeArgs=ruleParameterizedTypeReferenceWithTypeArgs();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleParameterizedTypeReferenceWithTypeArgs; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleParameterizedTypeReferenceWithTypeArgs() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        Token otherlv_11=null;
        Token otherlv_13=null;
        EObject lv_arguments_2_0 = null;

        EObject lv_arguments_4_0 = null;

        EObject lv_arguments_10_0 = null;

        EObject lv_arguments_12_0 = null;



        	enterRule();

        try {
            {
            {
            {
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getParameterizedTypeReferenceWithTypeArgsRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getTypeJvmTypeCrossReference_0_0());
              				
            }
            pushFollow(FOLLOW_52);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            {
            otherlv_1=(Token)match(input,KW_LessThanSign,FOLLOW_53); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              				newLeafNode(otherlv_1, grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getLessThanSignKeyword_1_0());
              			
            }
            {
            {
            if ( state.backtracking==0 ) {

              						newCompositeNode(grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0());
              					
            }
            pushFollow(FOLLOW_10);
            lv_arguments_2_0=ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              						if (current==null) {
              							current = createModelElementForParent(grammarAccess.getParameterizedTypeReferenceWithTypeArgsRule());
              						}
              						add(
              							current,
              							"arguments",
              							lv_arguments_2_0,
              							"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
              						afterParserOrEnumRuleCall();
              					
            }

            }


            }
            loop110:
            do {
                int alt110=2;
                int LA110_0 = input.LA(1);

                if ( (LA110_0==KW_Comma) ) {
                    alt110=1;
                }


                switch (alt110) {
            	case 1 :
            	    {
            	    otherlv_3=(Token)match(input,KW_Comma,FOLLOW_53); if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					newLeafNode(otherlv_3, grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getCommaKeyword_1_2_0());
            	      				
            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							newCompositeNode(grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0());
            	      						
            	    }
            	    pushFollow(FOLLOW_10);
            	    lv_arguments_4_0=ruleJvmArgumentTypeReference();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      							if (current==null) {
            	      								current = createModelElementForParent(grammarAccess.getParameterizedTypeReferenceWithTypeArgsRule());
            	      							}
            	      							add(
            	      								current,
            	      								"arguments",
            	      								lv_arguments_4_0,
            	      								"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
            	      							afterParserOrEnumRuleCall();
            	      						
            	    }

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop110;
                }
            } while (true);

            otherlv_5=(Token)match(input,KW_GreaterThanSign,FOLLOW_54); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              				newLeafNode(otherlv_5, grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getGreaterThanSignKeyword_1_3());
              			
            }
            loop113:
            do {
                int alt113=2;
                int LA113_0 = input.LA(1);

                if ( (LA113_0==KW_FullStop) && (synpred7_InternalXtend())) {
                    alt113=1;
                }


                switch (alt113) {
            	case 1 :
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								current = forceCreateModelElementAndSet(
            	      									grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getJvmInnerTypeReferenceOuterAction_1_4_0_0_0(),
            	      									current);
            	      							
            	    }

            	    }

            	    otherlv_7=(Token)match(input,KW_FullStop,FOLLOW_3); if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      							newLeafNode(otherlv_7, grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getFullStopKeyword_1_4_0_0_1());
            	      						
            	    }

            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							if (current==null) {
            	      								current = createModelElement(grammarAccess.getParameterizedTypeReferenceWithTypeArgsRule());
            	      							}
            	      						
            	    }
            	    if ( state.backtracking==0 ) {

            	      							newCompositeNode(grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getTypeJvmTypeCrossReference_1_4_1_0());
            	      						
            	    }
            	    pushFollow(FOLLOW_55);
            	    ruleValidID();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      							afterParserOrEnumRuleCall();
            	      						
            	    }

            	    }


            	    }
            	    int alt112=2;
            	    alt112 = dfa112.predict(input);
            	    switch (alt112) {
            	        case 1 :
            	            {
            	            {
            	            otherlv_9=(Token)match(input,KW_LessThanSign,FOLLOW_53); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              							newLeafNode(otherlv_9, grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getLessThanSignKeyword_1_4_2_0());
            	              						
            	            }

            	            }
            	            {
            	            {
            	            if ( state.backtracking==0 ) {

            	              								newCompositeNode(grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_1_0());
            	              							
            	            }
            	            pushFollow(FOLLOW_10);
            	            lv_arguments_10_0=ruleJvmArgumentTypeReference();

            	            state._fsp--;
            	            if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              								if (current==null) {
            	              									current = createModelElementForParent(grammarAccess.getParameterizedTypeReferenceWithTypeArgsRule());
            	              								}
            	              								add(
            	              									current,
            	              									"arguments",
            	              									lv_arguments_10_0,
            	              									"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
            	              								afterParserOrEnumRuleCall();
            	              							
            	            }

            	            }


            	            }
            	            loop111:
            	            do {
            	                int alt111=2;
            	                int LA111_0 = input.LA(1);

            	                if ( (LA111_0==KW_Comma) ) {
            	                    alt111=1;
            	                }


            	                switch (alt111) {
            	            	case 1 :
            	            	    {
            	            	    otherlv_11=(Token)match(input,KW_Comma,FOLLOW_53); if (state.failed) return current;
            	            	    if ( state.backtracking==0 ) {

            	            	      							newLeafNode(otherlv_11, grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getCommaKeyword_1_4_2_2_0());
            	            	      						
            	            	    }
            	            	    {
            	            	    {
            	            	    if ( state.backtracking==0 ) {

            	            	      									newCompositeNode(grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_2_1_0());
            	            	      								
            	            	    }
            	            	    pushFollow(FOLLOW_10);
            	            	    lv_arguments_12_0=ruleJvmArgumentTypeReference();

            	            	    state._fsp--;
            	            	    if (state.failed) return current;
            	            	    if ( state.backtracking==0 ) {

            	            	      									if (current==null) {
            	            	      										current = createModelElementForParent(grammarAccess.getParameterizedTypeReferenceWithTypeArgsRule());
            	            	      									}
            	            	      									add(
            	            	      										current,
            	            	      										"arguments",
            	            	      										lv_arguments_12_0,
            	            	      										"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
            	            	      									afterParserOrEnumRuleCall();
            	            	      								
            	            	    }

            	            	    }


            	            	    }


            	            	    }
            	            	    break;

            	            	default :
            	            	    break loop111;
            	                }
            	            } while (true);

            	            otherlv_13=(Token)match(input,KW_GreaterThanSign,FOLLOW_54); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              						newLeafNode(otherlv_13, grammarAccess.getParameterizedTypeReferenceWithTypeArgsAccess().getGreaterThanSignKeyword_1_4_2_3());
            	              					
            	            }

            	            }
            	            break;

            	    }


            	    }
            	    break;

            	default :
            	    break loop113;
                }
            } while (true);


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleFunctionID() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleFunctionID = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getFunctionIDRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleFunctionID=ruleFunctionID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleFunctionID.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleFunctionID() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        AntlrDatatypeRuleToken this_ValidID_0 = null;

        AntlrDatatypeRuleToken this_Operators_1 = null;



        	enterRule();

        try {
            {
            int alt114=2;
            int LA114_0 = input.LA(1);

            if ( (LA114_0==KW_Annotation||LA114_0==KW_Create||(LA114_0>=KW_AFTER && LA114_0<=KW_SEPARATOR)||LA114_0==RULE_ID) ) {
                alt114=1;
            }
            else if ( (LA114_0==KW_LessThanSign||LA114_0==KW_GreaterThanSign||LA114_0==KW_EqualsSignGreaterThanSign||(LA114_0>=KW_PlusSignEqualsSign && LA114_0<=KW_ExclamationMarkEqualsSignEqualsSign)||(LA114_0>=KW_HyphenMinusGreaterThanSign && LA114_0<=KW_ExclamationMark)||(LA114_0>=KW_PlusSignPlusSign && LA114_0<=KW_HyphenMinusHyphenMinus)) ) {
                alt114=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 114, 0, input);

                throw nvae;
            }
            switch (alt114) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getFunctionIDAccess().getValidIDParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_ValidID_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_ValidID_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getFunctionIDAccess().getOperatorsParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_Operators_1=ruleOperators();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_Operators_1);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOperators() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOperators = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOperatorsRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOperators=ruleOperators();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOperators.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOperators() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        AntlrDatatypeRuleToken this_OpMultiAssign_0 = null;

        AntlrDatatypeRuleToken this_OpOr_1 = null;

        AntlrDatatypeRuleToken this_OpAnd_2 = null;

        AntlrDatatypeRuleToken this_OpEquality_3 = null;

        AntlrDatatypeRuleToken this_OpCompare_4 = null;

        AntlrDatatypeRuleToken this_OpOther_5 = null;

        AntlrDatatypeRuleToken this_OpMulti_6 = null;

        AntlrDatatypeRuleToken this_OpUnary_7 = null;

        AntlrDatatypeRuleToken this_OpPostfix_8 = null;



        	enterRule();

        try {
            {
            int alt115=9;
            alt115 = dfa115.predict(input);
            switch (alt115) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getOperatorsAccess().getOpMultiAssignParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_OpMultiAssign_0=ruleOpMultiAssign();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_OpMultiAssign_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getOperatorsAccess().getOpOrParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_OpOr_1=ruleOpOr();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_OpOr_1);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getOperatorsAccess().getOpAndParserRuleCall_2());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_OpAnd_2=ruleOpAnd();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_OpAnd_2);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 4 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getOperatorsAccess().getOpEqualityParserRuleCall_3());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_OpEquality_3=ruleOpEquality();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_OpEquality_3);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 5 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getOperatorsAccess().getOpCompareParserRuleCall_4());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_OpCompare_4=ruleOpCompare();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_OpCompare_4);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 6 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getOperatorsAccess().getOpOtherParserRuleCall_5());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_OpOther_5=ruleOpOther();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_OpOther_5);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 7 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getOperatorsAccess().getOpMultiParserRuleCall_6());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_OpMulti_6=ruleOpMulti();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_OpMulti_6);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 8 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getOperatorsAccess().getOpUnaryParserRuleCall_7());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_OpUnary_7=ruleOpUnary();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_OpUnary_7);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 9 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getOperatorsAccess().getOpPostfixParserRuleCall_8());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_OpPostfix_8=ruleOpPostfix();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_OpPostfix_8);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXtendEnumLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXtendEnumLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXtendEnumLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXtendEnumLiteral=ruleXtendEnumLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXtendEnumLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXtendEnumLiteral() throws RecognitionException {
        EObject current = null;

        EObject lv_annotations_0_0 = null;

        AntlrDatatypeRuleToken lv_name_1_0 = null;



        	enterRule();

        try {
            {
            {
            loop116:
            do {
                int alt116=2;
                int LA116_0 = input.LA(1);

                if ( (LA116_0==KW_CommercialAt) ) {
                    alt116=1;
                }


                switch (alt116) {
            	case 1 :
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getXtendEnumLiteralAccess().getAnnotationsXAnnotationParserRuleCall_0_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_23);
            	    lv_annotations_0_0=ruleXAnnotation();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getXtendEnumLiteralRule());
            	      					}
            	      					add(
            	      						current,
            	      						"annotations",
            	      						lv_annotations_0_0,
            	      						"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotation");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop116;
                }
            } while (true);
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXtendEnumLiteralAccess().getNameValidIDParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_name_1_0=ruleValidID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXtendEnumLiteralRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_1_0,
              						"org.eclipse.xtend.core.Xtend.ValidID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleCommonModifier() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleCommonModifier = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getCommonModifierRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleCommonModifier=ruleCommonModifier();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleCommonModifier.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleCommonModifier() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt117=13;
            switch ( input.LA(1) ) {
            case KW_Public:
                {
                alt117=1;
                }
                break;
            case KW_Private:
                {
                alt117=2;
                }
                break;
            case KW_Protected:
                {
                alt117=3;
                }
                break;
            case KW_Package:
                {
                alt117=4;
                }
                break;
            case KW_Abstract:
                {
                alt117=5;
                }
                break;
            case KW_Static:
                {
                alt117=6;
                }
                break;
            case KW_Dispatch:
                {
                alt117=7;
                }
                break;
            case KW_Final:
                {
                alt117=8;
                }
                break;
            case KW_Strictfp:
                {
                alt117=9;
                }
                break;
            case KW_Native:
                {
                alt117=10;
                }
                break;
            case KW_Volatile:
                {
                alt117=11;
                }
                break;
            case KW_Synchronized:
                {
                alt117=12;
                }
                break;
            case KW_Transient:
                {
                alt117=13;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 117, 0, input);

                throw nvae;
            }

            switch (alt117) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_Public,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getPublicKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_Private,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getPrivateKeyword_1());
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    kw=(Token)match(input,KW_Protected,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getProtectedKeyword_2());
                      		
                    }

                    }
                    break;
                case 4 :
                    {
                    kw=(Token)match(input,KW_Package,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getPackageKeyword_3());
                      		
                    }

                    }
                    break;
                case 5 :
                    {
                    kw=(Token)match(input,KW_Abstract,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getAbstractKeyword_4());
                      		
                    }

                    }
                    break;
                case 6 :
                    {
                    kw=(Token)match(input,KW_Static,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getStaticKeyword_5());
                      		
                    }

                    }
                    break;
                case 7 :
                    {
                    kw=(Token)match(input,KW_Dispatch,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getDispatchKeyword_6());
                      		
                    }

                    }
                    break;
                case 8 :
                    {
                    kw=(Token)match(input,KW_Final,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getFinalKeyword_7());
                      		
                    }

                    }
                    break;
                case 9 :
                    {
                    kw=(Token)match(input,KW_Strictfp,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getStrictfpKeyword_8());
                      		
                    }

                    }
                    break;
                case 10 :
                    {
                    kw=(Token)match(input,KW_Native,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getNativeKeyword_9());
                      		
                    }

                    }
                    break;
                case 11 :
                    {
                    kw=(Token)match(input,KW_Volatile,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getVolatileKeyword_10());
                      		
                    }

                    }
                    break;
                case 12 :
                    {
                    kw=(Token)match(input,KW_Synchronized,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getSynchronizedKeyword_11());
                      		
                    }

                    }
                    break;
                case 13 :
                    {
                    kw=(Token)match(input,KW_Transient,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getCommonModifierAccess().getTransientKeyword_12());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleFieldModifier() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleFieldModifier = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getFieldModifierRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleFieldModifier=ruleFieldModifier();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleFieldModifier.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleFieldModifier() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt118=2;
            int LA118_0 = input.LA(1);

            if ( (LA118_0==KW_Val) ) {
                alt118=1;
            }
            else if ( (LA118_0==KW_Var) ) {
                alt118=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 118, 0, input);

                throw nvae;
            }
            switch (alt118) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_Val,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getFieldModifierAccess().getValKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_Var,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getFieldModifierAccess().getVarKeyword_1());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleMethodModifier() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleMethodModifier = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getMethodModifierRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleMethodModifier=ruleMethodModifier();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleMethodModifier.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleMethodModifier() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt119=2;
            int LA119_0 = input.LA(1);

            if ( (LA119_0==KW_Def) ) {
                alt119=1;
            }
            else if ( (LA119_0==KW_Override) ) {
                alt119=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 119, 0, input);

                throw nvae;
            }
            switch (alt119) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_Def,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getMethodModifierAccess().getDefKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_Override,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getMethodModifierAccess().getOverrideKeyword_1());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleCreateExtensionInfo() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleCreateExtensionInfo = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getCreateExtensionInfoRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleCreateExtensionInfo=ruleCreateExtensionInfo();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleCreateExtensionInfo; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleCreateExtensionInfo() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;

        EObject lv_createExpression_3_0 = null;



        	enterRule();

        try {
            {
            {
            otherlv_0=(Token)match(input,KW_Create,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getCreateExtensionInfoAccess().getCreateKeyword_0());
              		
            }
            int alt120=2;
            switch ( input.LA(1) ) {
                case RULE_ID:
                    {
                    int LA120_1 = input.LA(2);

                    if ( (LA120_1==KW_Colon) ) {
                        alt120=1;
                    }
                    }
                    break;
                case KW_Create:
                    {
                    int LA120_2 = input.LA(2);

                    if ( (LA120_2==KW_Colon) ) {
                        alt120=1;
                    }
                    }
                    break;
                case KW_Annotation:
                    {
                    int LA120_3 = input.LA(2);

                    if ( (LA120_3==KW_Colon) ) {
                        alt120=1;
                    }
                    }
                    break;
                case KW_AFTER:
                    {
                    int LA120_4 = input.LA(2);

                    if ( (LA120_4==KW_Colon) ) {
                        alt120=1;
                    }
                    }
                    break;
                case KW_BEFORE:
                    {
                    int LA120_5 = input.LA(2);

                    if ( (LA120_5==KW_Colon) ) {
                        alt120=1;
                    }
                    }
                    break;
                case KW_SEPARATOR:
                    {
                    int LA120_6 = input.LA(2);

                    if ( (LA120_6==KW_Colon) ) {
                        alt120=1;
                    }
                    }
                    break;
            }

            switch (alt120) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getCreateExtensionInfoAccess().getNameValidIDParserRuleCall_1_0_0());
                      					
                    }
                    pushFollow(FOLLOW_56);
                    lv_name_1_0=ruleValidID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getCreateExtensionInfoRule());
                      						}
                      						set(
                      							current,
                      							"name",
                      							lv_name_1_0,
                      							"org.eclipse.xtend.core.Xtend.ValidID");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }

                    otherlv_2=(Token)match(input,KW_Colon,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_2, grammarAccess.getCreateExtensionInfoAccess().getColonKeyword_1_1());
                      			
                    }

                    }
                    break;

            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getCreateExtensionInfoAccess().getCreateExpressionXExpressionParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_createExpression_3_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getCreateExtensionInfoRule());
              					}
              					set(
              						current,
              						"createExpression",
              						lv_createExpression_3_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleValidID() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleValidID = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getValidIDRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleValidID=ruleValidID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleValidID.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleValidID() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_ID_0=null;
        Token kw=null;


        	enterRule();

        try {
            {
            int alt121=6;
            switch ( input.LA(1) ) {
            case RULE_ID:
                {
                alt121=1;
                }
                break;
            case KW_Create:
                {
                alt121=2;
                }
                break;
            case KW_Annotation:
                {
                alt121=3;
                }
                break;
            case KW_AFTER:
                {
                alt121=4;
                }
                break;
            case KW_BEFORE:
                {
                alt121=5;
                }
                break;
            case KW_SEPARATOR:
                {
                alt121=6;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 121, 0, input);

                throw nvae;
            }

            switch (alt121) {
                case 1 :
                    {
                    this_ID_0=(Token)match(input,RULE_ID,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_ID_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_ID_0, grammarAccess.getValidIDAccess().getIDTerminalRuleCall_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_Create,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getValidIDAccess().getCreateKeyword_1());
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    kw=(Token)match(input,KW_Annotation,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getValidIDAccess().getAnnotationKeyword_2());
                      		
                    }

                    }
                    break;
                case 4 :
                    {
                    kw=(Token)match(input,KW_AFTER,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getValidIDAccess().getAFTERKeyword_3());
                      		
                    }

                    }
                    break;
                case 5 :
                    {
                    kw=(Token)match(input,KW_BEFORE,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getValidIDAccess().getBEFOREKeyword_4());
                      		
                    }

                    }
                    break;
                case 6 :
                    {
                    kw=(Token)match(input,KW_SEPARATOR,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getValidIDAccess().getSEPARATORKeyword_5());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleFeatureCallID() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleFeatureCallID = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getFeatureCallIDRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleFeatureCallID=ruleFeatureCallID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleFeatureCallID.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleFeatureCallID() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_InnerVarID_0 = null;



        	enterRule();

        try {
            {
            int alt122=2;
            int LA122_0 = input.LA(1);

            if ( (LA122_0==KW_Package||LA122_0==KW_Class||(LA122_0>=KW_Extends && LA122_0<=KW_Implements)||(LA122_0>=KW_Interface && LA122_0<=KW_Annotation)||LA122_0==KW_Throws||(LA122_0>=KW_Public && LA122_0<=KW_Transient)||(LA122_0>=KW_Def && LA122_0<=KW_Create)||(LA122_0>=KW_AFTER && LA122_0<=KW_Import)||LA122_0==RULE_ID) ) {
                alt122=1;
            }
            else if ( (LA122_0==KW_Extension) ) {
                alt122=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 122, 0, input);

                throw nvae;
            }
            switch (alt122) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getFeatureCallIDAccess().getInnerVarIDParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_InnerVarID_0=ruleInnerVarID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_InnerVarID_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_Extension,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getFeatureCallIDAccess().getExtensionKeyword_1());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleInnerVarID() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleInnerVarID = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getInnerVarIDRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleInnerVarID=ruleInnerVarID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleInnerVarID.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleInnerVarID() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_ID_0=null;
        Token kw=null;


        	enterRule();

        try {
            {
            int alt123=28;
            switch ( input.LA(1) ) {
            case RULE_ID:
                {
                alt123=1;
                }
                break;
            case KW_Abstract:
                {
                alt123=2;
                }
                break;
            case KW_Annotation:
                {
                alt123=3;
                }
                break;
            case KW_Class:
                {
                alt123=4;
                }
                break;
            case KW_Create:
                {
                alt123=5;
                }
                break;
            case KW_Def:
                {
                alt123=6;
                }
                break;
            case KW_Dispatch:
                {
                alt123=7;
                }
                break;
            case KW_Enum:
                {
                alt123=8;
                }
                break;
            case KW_Extends:
                {
                alt123=9;
                }
                break;
            case KW_Final:
                {
                alt123=10;
                }
                break;
            case KW_Implements:
                {
                alt123=11;
                }
                break;
            case KW_Import:
                {
                alt123=12;
                }
                break;
            case KW_Interface:
                {
                alt123=13;
                }
                break;
            case KW_Override:
                {
                alt123=14;
                }
                break;
            case KW_Package:
                {
                alt123=15;
                }
                break;
            case KW_Public:
                {
                alt123=16;
                }
                break;
            case KW_Private:
                {
                alt123=17;
                }
                break;
            case KW_Protected:
                {
                alt123=18;
                }
                break;
            case KW_Static:
                {
                alt123=19;
                }
                break;
            case KW_Throws:
                {
                alt123=20;
                }
                break;
            case KW_Strictfp:
                {
                alt123=21;
                }
                break;
            case KW_Native:
                {
                alt123=22;
                }
                break;
            case KW_Volatile:
                {
                alt123=23;
                }
                break;
            case KW_Synchronized:
                {
                alt123=24;
                }
                break;
            case KW_Transient:
                {
                alt123=25;
                }
                break;
            case KW_AFTER:
                {
                alt123=26;
                }
                break;
            case KW_BEFORE:
                {
                alt123=27;
                }
                break;
            case KW_SEPARATOR:
                {
                alt123=28;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 123, 0, input);

                throw nvae;
            }

            switch (alt123) {
                case 1 :
                    {
                    this_ID_0=(Token)match(input,RULE_ID,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_ID_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_ID_0, grammarAccess.getInnerVarIDAccess().getIDTerminalRuleCall_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_Abstract,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getAbstractKeyword_1());
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    kw=(Token)match(input,KW_Annotation,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getAnnotationKeyword_2());
                      		
                    }

                    }
                    break;
                case 4 :
                    {
                    kw=(Token)match(input,KW_Class,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getClassKeyword_3());
                      		
                    }

                    }
                    break;
                case 5 :
                    {
                    kw=(Token)match(input,KW_Create,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getCreateKeyword_4());
                      		
                    }

                    }
                    break;
                case 6 :
                    {
                    kw=(Token)match(input,KW_Def,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getDefKeyword_5());
                      		
                    }

                    }
                    break;
                case 7 :
                    {
                    kw=(Token)match(input,KW_Dispatch,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getDispatchKeyword_6());
                      		
                    }

                    }
                    break;
                case 8 :
                    {
                    kw=(Token)match(input,KW_Enum,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getEnumKeyword_7());
                      		
                    }

                    }
                    break;
                case 9 :
                    {
                    kw=(Token)match(input,KW_Extends,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getExtendsKeyword_8());
                      		
                    }

                    }
                    break;
                case 10 :
                    {
                    kw=(Token)match(input,KW_Final,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getFinalKeyword_9());
                      		
                    }

                    }
                    break;
                case 11 :
                    {
                    kw=(Token)match(input,KW_Implements,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getImplementsKeyword_10());
                      		
                    }

                    }
                    break;
                case 12 :
                    {
                    kw=(Token)match(input,KW_Import,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getImportKeyword_11());
                      		
                    }

                    }
                    break;
                case 13 :
                    {
                    kw=(Token)match(input,KW_Interface,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getInterfaceKeyword_12());
                      		
                    }

                    }
                    break;
                case 14 :
                    {
                    kw=(Token)match(input,KW_Override,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getOverrideKeyword_13());
                      		
                    }

                    }
                    break;
                case 15 :
                    {
                    kw=(Token)match(input,KW_Package,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getPackageKeyword_14());
                      		
                    }

                    }
                    break;
                case 16 :
                    {
                    kw=(Token)match(input,KW_Public,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getPublicKeyword_15());
                      		
                    }

                    }
                    break;
                case 17 :
                    {
                    kw=(Token)match(input,KW_Private,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getPrivateKeyword_16());
                      		
                    }

                    }
                    break;
                case 18 :
                    {
                    kw=(Token)match(input,KW_Protected,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getProtectedKeyword_17());
                      		
                    }

                    }
                    break;
                case 19 :
                    {
                    kw=(Token)match(input,KW_Static,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getStaticKeyword_18());
                      		
                    }

                    }
                    break;
                case 20 :
                    {
                    kw=(Token)match(input,KW_Throws,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getThrowsKeyword_19());
                      		
                    }

                    }
                    break;
                case 21 :
                    {
                    kw=(Token)match(input,KW_Strictfp,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getStrictfpKeyword_20());
                      		
                    }

                    }
                    break;
                case 22 :
                    {
                    kw=(Token)match(input,KW_Native,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getNativeKeyword_21());
                      		
                    }

                    }
                    break;
                case 23 :
                    {
                    kw=(Token)match(input,KW_Volatile,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getVolatileKeyword_22());
                      		
                    }

                    }
                    break;
                case 24 :
                    {
                    kw=(Token)match(input,KW_Synchronized,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getSynchronizedKeyword_23());
                      		
                    }

                    }
                    break;
                case 25 :
                    {
                    kw=(Token)match(input,KW_Transient,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getTransientKeyword_24());
                      		
                    }

                    }
                    break;
                case 26 :
                    {
                    kw=(Token)match(input,KW_AFTER,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getAFTERKeyword_25());
                      		
                    }

                    }
                    break;
                case 27 :
                    {
                    kw=(Token)match(input,KW_BEFORE,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getBEFOREKeyword_26());
                      		
                    }

                    }
                    break;
                case 28 :
                    {
                    kw=(Token)match(input,KW_SEPARATOR,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getInnerVarIDAccess().getSEPARATORKeyword_27());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleParameter() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleParameter = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getParameterRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleParameter=ruleParameter();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleParameter; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleParameter() throws RecognitionException {
        EObject current = null;

        Token lv_extension_1_0=null;
        Token lv_varArg_4_0=null;
        EObject lv_annotations_0_0 = null;

        EObject lv_annotations_2_0 = null;

        EObject lv_parameterType_3_0 = null;

        AntlrDatatypeRuleToken lv_name_5_0 = null;



        	enterRule();

        try {
            {
            {
            loop124:
            do {
                int alt124=2;
                int LA124_0 = input.LA(1);

                if ( (LA124_0==KW_CommercialAt) ) {
                    alt124=1;
                }


                switch (alt124) {
            	case 1 :
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getParameterAccess().getAnnotationsXAnnotationParserRuleCall_0_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_44);
            	    lv_annotations_0_0=ruleXAnnotation();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getParameterRule());
            	      					}
            	      					add(
            	      						current,
            	      						"annotations",
            	      						lv_annotations_0_0,
            	      						"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotation");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop124;
                }
            } while (true);
            int alt126=2;
            int LA126_0 = input.LA(1);

            if ( (LA126_0==KW_Extension) ) {
                alt126=1;
            }
            switch (alt126) {
                case 1 :
                    {
                    {
                    {
                    lv_extension_1_0=(Token)match(input,KW_Extension,FOLLOW_44); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_extension_1_0, grammarAccess.getParameterAccess().getExtensionExtensionKeyword_1_0_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getParameterRule());
                      						}
                      						setWithLastConsumed(current, "extension", true, "extension");
                      					
                    }

                    }


                    }
                    loop125:
                    do {
                        int alt125=2;
                        int LA125_0 = input.LA(1);

                        if ( (LA125_0==KW_CommercialAt) ) {
                            alt125=1;
                        }


                        switch (alt125) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      						newCompositeNode(grammarAccess.getParameterAccess().getAnnotationsXAnnotationParserRuleCall_1_1_0());
                    	      					
                    	    }
                    	    pushFollow(FOLLOW_44);
                    	    lv_annotations_2_0=ruleXAnnotation();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      						if (current==null) {
                    	      							current = createModelElementForParent(grammarAccess.getParameterRule());
                    	      						}
                    	      						add(
                    	      							current,
                    	      							"annotations",
                    	      							lv_annotations_2_0,
                    	      							"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotation");
                    	      						afterParserOrEnumRuleCall();
                    	      					
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop125;
                        }
                    } while (true);


                    }
                    break;

            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_57);
            lv_parameterType_3_0=ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getParameterRule());
              					}
              					set(
              						current,
              						"parameterType",
              						lv_parameterType_3_0,
              						"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            int alt127=2;
            int LA127_0 = input.LA(1);

            if ( (LA127_0==KW_FullStopFullStopFullStop) ) {
                alt127=1;
            }
            switch (alt127) {
                case 1 :
                    {
                    {
                    lv_varArg_4_0=(Token)match(input,KW_FullStopFullStopFullStop,FOLLOW_3); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(lv_varArg_4_0, grammarAccess.getParameterAccess().getVarArgFullStopFullStopFullStopKeyword_3_0());
                      				
                    }
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElement(grammarAccess.getParameterRule());
                      					}
                      					setWithLastConsumed(current, "varArg", true, "...");
                      				
                    }

                    }


                    }
                    break;

            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getParameterAccess().getNameValidIDParserRuleCall_4_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_name_5_0=ruleValidID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getParameterRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_5_0,
              						"org.eclipse.xtend.core.Xtend.ValidID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXVariableDeclaration() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXVariableDeclaration = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXVariableDeclarationRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXVariableDeclaration=ruleXVariableDeclaration();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXVariableDeclaration; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXVariableDeclaration() throws RecognitionException {
        EObject current = null;

        Token lv_writeable_1_0=null;
        Token otherlv_2=null;
        Token lv_extension_3_0=null;
        Token lv_extension_4_0=null;
        Token lv_writeable_5_0=null;
        Token otherlv_6=null;
        Token otherlv_10=null;
        EObject lv_type_7_0 = null;

        AntlrDatatypeRuleToken lv_name_8_0 = null;

        AntlrDatatypeRuleToken lv_name_9_0 = null;

        EObject lv_right_11_0 = null;



        	enterRule();

        try {
            {
            {
            {
            {
            {
            if ( state.backtracking==0 ) {

              						current = forceCreateModelElement(
              							grammarAccess.getXVariableDeclarationAccess().getXtendVariableDeclarationAction_0_0_0(),
              							current);
              					
            }

            }
            int alt131=2;
            int LA131_0 = input.LA(1);

            if ( ((LA131_0>=KW_Val && LA131_0<=KW_Var)) ) {
                alt131=1;
            }
            else if ( (LA131_0==KW_Extension) ) {
                alt131=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 131, 0, input);

                throw nvae;
            }
            switch (alt131) {
                case 1 :
                    {
                    {
                    int alt128=2;
                    int LA128_0 = input.LA(1);

                    if ( (LA128_0==KW_Var) ) {
                        alt128=1;
                    }
                    else if ( (LA128_0==KW_Val) ) {
                        alt128=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 128, 0, input);

                        throw nvae;
                    }
                    switch (alt128) {
                        case 1 :
                            {
                            {
                            {
                            lv_writeable_1_0=(Token)match(input,KW_Var,FOLLOW_58); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										newLeafNode(lv_writeable_1_0, grammarAccess.getXVariableDeclarationAccess().getWriteableVarKeyword_0_0_1_0_0_0_0());
                              									
                            }
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElement(grammarAccess.getXVariableDeclarationRule());
                              										}
                              										setWithLastConsumed(current, "writeable", true, "var");
                              									
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            otherlv_2=(Token)match(input,KW_Val,FOLLOW_58); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								newLeafNode(otherlv_2, grammarAccess.getXVariableDeclarationAccess().getValKeyword_0_0_1_0_0_1());
                              							
                            }

                            }
                            break;

                    }
                    int alt129=2;
                    int LA129_0 = input.LA(1);

                    if ( (LA129_0==KW_Extension) ) {
                        alt129=1;
                    }
                    switch (alt129) {
                        case 1 :
                            {
                            {
                            lv_extension_3_0=(Token)match(input,KW_Extension,FOLLOW_58); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									newLeafNode(lv_extension_3_0, grammarAccess.getXVariableDeclarationAccess().getExtensionExtensionKeyword_0_0_1_0_1_0());
                              								
                            }
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElement(grammarAccess.getXVariableDeclarationRule());
                              									}
                              									setWithLastConsumed(current, "extension", true, "extension");
                              								
                            }

                            }


                            }
                            break;

                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    {
                    lv_extension_4_0=(Token)match(input,KW_Extension,FOLLOW_59); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      									newLeafNode(lv_extension_4_0, grammarAccess.getXVariableDeclarationAccess().getExtensionExtensionKeyword_0_0_1_1_0_0());
                      								
                    }
                    if ( state.backtracking==0 ) {

                      									if (current==null) {
                      										current = createModelElement(grammarAccess.getXVariableDeclarationRule());
                      									}
                      									setWithLastConsumed(current, "extension", true, "extension");
                      								
                    }

                    }


                    }
                    int alt130=2;
                    int LA130_0 = input.LA(1);

                    if ( (LA130_0==KW_Var) ) {
                        alt130=1;
                    }
                    else if ( (LA130_0==KW_Val) ) {
                        alt130=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 130, 0, input);

                        throw nvae;
                    }
                    switch (alt130) {
                        case 1 :
                            {
                            {
                            {
                            lv_writeable_5_0=(Token)match(input,KW_Var,FOLLOW_58); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              										newLeafNode(lv_writeable_5_0, grammarAccess.getXVariableDeclarationAccess().getWriteableVarKeyword_0_0_1_1_1_0_0());
                              									
                            }
                            if ( state.backtracking==0 ) {

                              										if (current==null) {
                              											current = createModelElement(grammarAccess.getXVariableDeclarationRule());
                              										}
                              										setWithLastConsumed(current, "writeable", true, "var");
                              									
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            otherlv_6=(Token)match(input,KW_Val,FOLLOW_58); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								newLeafNode(otherlv_6, grammarAccess.getXVariableDeclarationAccess().getValKeyword_0_0_1_1_1_1());
                              							
                            }

                            }
                            break;

                    }


                    }


                    }
                    break;

            }


            }


            }
            int alt132=2;
            alt132 = dfa132.predict(input);
            switch (alt132) {
                case 1 :
                    {
                    {
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      								newCompositeNode(grammarAccess.getXVariableDeclarationAccess().getTypeJvmTypeReferenceParserRuleCall_1_0_0_0_0());
                      							
                    }
                    pushFollow(FOLLOW_60);
                    lv_type_7_0=ruleJvmTypeReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      								if (current==null) {
                      									current = createModelElementForParent(grammarAccess.getXVariableDeclarationRule());
                      								}
                      								set(
                      									current,
                      									"type",
                      									lv_type_7_0,
                      									"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                      								afterParserOrEnumRuleCall();
                      							
                    }

                    }


                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      								newCompositeNode(grammarAccess.getXVariableDeclarationAccess().getNameInnerVarIDParserRuleCall_1_0_0_1_0());
                      							
                    }
                    pushFollow(FOLLOW_61);
                    lv_name_8_0=ruleInnerVarID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      								if (current==null) {
                      									current = createModelElementForParent(grammarAccess.getXVariableDeclarationRule());
                      								}
                      								set(
                      									current,
                      									"name",
                      									lv_name_8_0,
                      									"org.eclipse.xtend.core.Xtend.InnerVarID");
                      								afterParserOrEnumRuleCall();
                      							
                    }

                    }


                    }


                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXVariableDeclarationAccess().getNameInnerVarIDParserRuleCall_1_1_0());
                      					
                    }
                    pushFollow(FOLLOW_61);
                    lv_name_9_0=ruleInnerVarID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXVariableDeclarationRule());
                      						}
                      						set(
                      							current,
                      							"name",
                      							lv_name_9_0,
                      							"org.eclipse.xtend.core.Xtend.InnerVarID");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }
            int alt133=2;
            int LA133_0 = input.LA(1);

            if ( (LA133_0==KW_EqualsSign) ) {
                alt133=1;
            }
            switch (alt133) {
                case 1 :
                    {
                    otherlv_10=(Token)match(input,KW_EqualsSign,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_10, grammarAccess.getXVariableDeclarationAccess().getEqualsSignKeyword_2_0());
                      			
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXVariableDeclarationAccess().getRightXExpressionParserRuleCall_2_1_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_right_11_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXVariableDeclarationRule());
                      						}
                      						set(
                      							current,
                      							"right",
                      							lv_right_11_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpression");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXConstructorCall() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXConstructorCall = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXConstructorCallRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXConstructorCall=ruleXConstructorCall();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXConstructorCall; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXConstructorCall() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject this_XbaseConstructorCall_0 = null;

        EObject lv_members_3_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXConstructorCallAccess().getXbaseConstructorCallParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_62);
            this_XbaseConstructorCall_0=ruleXbaseConstructorCall();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XbaseConstructorCall_0;
              			afterParserOrEnumRuleCall();
              		
            }
            int alt135=2;
            alt135 = dfa135.predict(input);
            switch (alt135) {
                case 1 :
                    {
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							current = forceCreateModelElementAndSet(
                      								grammarAccess.getXConstructorCallAccess().getAnonymousClassConstructorCallAction_1_0_0_0(),
                      								current);
                      						
                    }

                    }

                    otherlv_2=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_15); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(otherlv_2, grammarAccess.getXConstructorCallAccess().getLeftCurlyBracketKeyword_1_0_0_1());
                      					
                    }

                    }


                    }
                    loop134:
                    do {
                        int alt134=2;
                        int LA134_0 = input.LA(1);

                        if ( (LA134_0==KW_Package||LA134_0==KW_Class||(LA134_0>=KW_Interface && LA134_0<=KW_LeftParenthesis)||LA134_0==KW_EqualsSignGreaterThanSign||LA134_0==KW_Extension||LA134_0==KW_New||(LA134_0>=KW_Public && LA134_0<=KW_Create)||(LA134_0>=KW_AFTER && LA134_0<=KW_SEPARATOR)||LA134_0==KW_CommercialAt||LA134_0==RULE_ID) ) {
                            alt134=1;
                        }


                        switch (alt134) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      						newCompositeNode(grammarAccess.getXConstructorCallAccess().getMembersMemberParserRuleCall_1_1_0());
                    	      					
                    	    }
                    	    pushFollow(FOLLOW_15);
                    	    lv_members_3_0=ruleMember();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      						if (current==null) {
                    	      							current = createModelElementForParent(grammarAccess.getXConstructorCallRule());
                    	      						}
                    	      						add(
                    	      							current,
                    	      							"members",
                    	      							lv_members_3_0,
                    	      							"org.eclipse.xtend.core.Xtend.Member");
                    	      						afterParserOrEnumRuleCall();
                    	      					
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop134;
                        }
                    } while (true);

                    otherlv_4=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_4, grammarAccess.getXConstructorCallAccess().getRightCurlyBracketKeyword_1_2());
                      			
                    }

                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXbaseConstructorCall() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXbaseConstructorCall = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXbaseConstructorCallRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXbaseConstructorCall=ruleXbaseConstructorCall();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXbaseConstructorCall; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXbaseConstructorCall() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        Token lv_explicitConstructorCall_8_0=null;
        Token otherlv_11=null;
        Token otherlv_13=null;
        EObject lv_typeArguments_4_0 = null;

        EObject lv_typeArguments_6_0 = null;

        EObject lv_arguments_9_0 = null;

        EObject lv_arguments_10_0 = null;

        EObject lv_arguments_12_0 = null;

        EObject lv_arguments_14_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXbaseConstructorCallAccess().getXConstructorCallAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_New,FOLLOW_3); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXbaseConstructorCallAccess().getNewKeyword_1());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getXbaseConstructorCallRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXbaseConstructorCallAccess().getConstructorJvmConstructorCrossReference_2_0());
              				
            }
            pushFollow(FOLLOW_63);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            int alt137=2;
            alt137 = dfa137.predict(input);
            switch (alt137) {
                case 1 :
                    {
                    {
                    otherlv_3=(Token)match(input,KW_LessThanSign,FOLLOW_53); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_3, grammarAccess.getXbaseConstructorCallAccess().getLessThanSignKeyword_3_0());
                      				
                    }

                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXbaseConstructorCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_3_1_0());
                      					
                    }
                    pushFollow(FOLLOW_10);
                    lv_typeArguments_4_0=ruleJvmArgumentTypeReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXbaseConstructorCallRule());
                      						}
                      						add(
                      							current,
                      							"typeArguments",
                      							lv_typeArguments_4_0,
                      							"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }
                    loop136:
                    do {
                        int alt136=2;
                        int LA136_0 = input.LA(1);

                        if ( (LA136_0==KW_Comma) ) {
                            alt136=1;
                        }


                        switch (alt136) {
                    	case 1 :
                    	    {
                    	    otherlv_5=(Token)match(input,KW_Comma,FOLLOW_53); if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      					newLeafNode(otherlv_5, grammarAccess.getXbaseConstructorCallAccess().getCommaKeyword_3_2_0());
                    	      				
                    	    }
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getXbaseConstructorCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_3_2_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_10);
                    	    lv_typeArguments_6_0=ruleJvmArgumentTypeReference();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getXbaseConstructorCallRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"typeArguments",
                    	      								lv_typeArguments_6_0,
                    	      								"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop136;
                        }
                    } while (true);

                    otherlv_7=(Token)match(input,KW_GreaterThanSign,FOLLOW_64); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_7, grammarAccess.getXbaseConstructorCallAccess().getGreaterThanSignKeyword_3_3());
                      			
                    }

                    }
                    break;

            }
            int alt140=2;
            alt140 = dfa140.predict(input);
            switch (alt140) {
                case 1 :
                    {
                    {
                    {
                    lv_explicitConstructorCall_8_0=(Token)match(input,KW_LeftParenthesis,FOLLOW_65); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_explicitConstructorCall_8_0, grammarAccess.getXbaseConstructorCallAccess().getExplicitConstructorCallLeftParenthesisKeyword_4_0_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getXbaseConstructorCallRule());
                      						}
                      						setWithLastConsumed(current, "explicitConstructorCall", true, "(");
                      					
                    }

                    }


                    }
                    int alt139=3;
                    alt139 = dfa139.predict(input);
                    switch (alt139) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getXbaseConstructorCallAccess().getArgumentsXShortClosureParserRuleCall_4_1_0_0());
                              						
                            }
                            pushFollow(FOLLOW_66);
                            lv_arguments_9_0=ruleXShortClosure();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getXbaseConstructorCallRule());
                              							}
                              							add(
                              								current,
                              								"arguments",
                              								lv_arguments_9_0,
                              								"org.eclipse.xtext.xbase.Xbase.XShortClosure");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getXbaseConstructorCallAccess().getArgumentsXExpressionParserRuleCall_4_1_1_0_0());
                              							
                            }
                            pushFollow(FOLLOW_28);
                            lv_arguments_10_0=ruleXExpression();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getXbaseConstructorCallRule());
                              								}
                              								add(
                              									current,
                              									"arguments",
                              									lv_arguments_10_0,
                              									"org.eclipse.xtext.xbase.Xbase.XExpression");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop138:
                            do {
                                int alt138=2;
                                int LA138_0 = input.LA(1);

                                if ( (LA138_0==KW_Comma) ) {
                                    alt138=1;
                                }


                                switch (alt138) {
                            	case 1 :
                            	    {
                            	    otherlv_11=(Token)match(input,KW_Comma,FOLLOW_34); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_11, grammarAccess.getXbaseConstructorCallAccess().getCommaKeyword_4_1_1_1_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getXbaseConstructorCallAccess().getArgumentsXExpressionParserRuleCall_4_1_1_1_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_28);
                            	    lv_arguments_12_0=ruleXExpression();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getXbaseConstructorCallRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"arguments",
                            	      										lv_arguments_12_0,
                            	      										"org.eclipse.xtext.xbase.Xbase.XExpression");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop138;
                                }
                            } while (true);


                            }


                            }
                            break;

                    }

                    otherlv_13=(Token)match(input,KW_RightParenthesis,FOLLOW_50); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_13, grammarAccess.getXbaseConstructorCallAccess().getRightParenthesisKeyword_4_2());
                      			
                    }

                    }
                    break;

            }
            int alt141=2;
            alt141 = dfa141.predict(input);
            switch (alt141) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getXbaseConstructorCallAccess().getArgumentsXClosureParserRuleCall_5_0());
                      				
                    }
                    pushFollow(FOLLOW_2);
                    lv_arguments_14_0=ruleXClosure();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getXbaseConstructorCallRule());
                      					}
                      					add(
                      						current,
                      						"arguments",
                      						lv_arguments_14_0,
                      						"org.eclipse.xtext.xbase.Xbase.XClosure");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleJvmFormalParameter() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmFormalParameter = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmFormalParameterRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmFormalParameter=ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmFormalParameter; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmFormalParameter() throws RecognitionException {
        EObject current = null;

        Token lv_extension_0_0=null;
        EObject lv_parameterType_1_0 = null;

        AntlrDatatypeRuleToken lv_name_2_0 = null;



        	enterRule();

        try {
            {
            {
            int alt142=2;
            int LA142_0 = input.LA(1);

            if ( (LA142_0==KW_Extension) ) {
                alt142=1;
            }
            switch (alt142) {
                case 1 :
                    {
                    {
                    lv_extension_0_0=(Token)match(input,KW_Extension,FOLLOW_58); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(lv_extension_0_0, grammarAccess.getJvmFormalParameterAccess().getExtensionExtensionKeyword_0_0());
                      				
                    }
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElement(grammarAccess.getJvmFormalParameterRule());
                      					}
                      					setWithLastConsumed(current, "extension", true, "extension");
                      				
                    }

                    }


                    }
                    break;

            }
            int alt143=2;
            switch ( input.LA(1) ) {
                case RULE_ID:
                    {
                    int LA143_1 = input.LA(2);

                    if ( (LA143_1==KW_Package||(LA143_1>=KW_Class && LA143_1<=KW_LessThanSign)||(LA143_1>=KW_Extends && LA143_1<=KW_Implements)||(LA143_1>=KW_Interface && LA143_1<=KW_Annotation)||LA143_1==KW_Throws||(LA143_1>=KW_FullStop && LA143_1<=KW_Transient)||(LA143_1>=KW_Def && LA143_1<=KW_Create)||(LA143_1>=KW_AFTER && LA143_1<=KW_Import)||LA143_1==KW_LeftSquareBracket||LA143_1==RULE_ID) ) {
                        alt143=1;
                    }
                    }
                    break;
                case KW_Create:
                    {
                    int LA143_2 = input.LA(2);

                    if ( (LA143_2==KW_Package||(LA143_2>=KW_Class && LA143_2<=KW_LessThanSign)||(LA143_2>=KW_Extends && LA143_2<=KW_Implements)||(LA143_2>=KW_Interface && LA143_2<=KW_Annotation)||LA143_2==KW_Throws||(LA143_2>=KW_FullStop && LA143_2<=KW_Transient)||(LA143_2>=KW_Def && LA143_2<=KW_Create)||(LA143_2>=KW_AFTER && LA143_2<=KW_Import)||LA143_2==KW_LeftSquareBracket||LA143_2==RULE_ID) ) {
                        alt143=1;
                    }
                    }
                    break;
                case KW_Annotation:
                    {
                    int LA143_3 = input.LA(2);

                    if ( (LA143_3==KW_Package||(LA143_3>=KW_Class && LA143_3<=KW_LessThanSign)||(LA143_3>=KW_Extends && LA143_3<=KW_Implements)||(LA143_3>=KW_Interface && LA143_3<=KW_Annotation)||LA143_3==KW_Throws||(LA143_3>=KW_FullStop && LA143_3<=KW_Transient)||(LA143_3>=KW_Def && LA143_3<=KW_Create)||(LA143_3>=KW_AFTER && LA143_3<=KW_Import)||LA143_3==KW_LeftSquareBracket||LA143_3==RULE_ID) ) {
                        alt143=1;
                    }
                    }
                    break;
                case KW_AFTER:
                    {
                    int LA143_4 = input.LA(2);

                    if ( (LA143_4==KW_Package||(LA143_4>=KW_Class && LA143_4<=KW_LessThanSign)||(LA143_4>=KW_Extends && LA143_4<=KW_Implements)||(LA143_4>=KW_Interface && LA143_4<=KW_Annotation)||LA143_4==KW_Throws||(LA143_4>=KW_FullStop && LA143_4<=KW_Transient)||(LA143_4>=KW_Def && LA143_4<=KW_Create)||(LA143_4>=KW_AFTER && LA143_4<=KW_Import)||LA143_4==KW_LeftSquareBracket||LA143_4==RULE_ID) ) {
                        alt143=1;
                    }
                    }
                    break;
                case KW_BEFORE:
                    {
                    int LA143_5 = input.LA(2);

                    if ( (LA143_5==KW_Package||(LA143_5>=KW_Class && LA143_5<=KW_LessThanSign)||(LA143_5>=KW_Extends && LA143_5<=KW_Implements)||(LA143_5>=KW_Interface && LA143_5<=KW_Annotation)||LA143_5==KW_Throws||(LA143_5>=KW_FullStop && LA143_5<=KW_Transient)||(LA143_5>=KW_Def && LA143_5<=KW_Create)||(LA143_5>=KW_AFTER && LA143_5<=KW_Import)||LA143_5==KW_LeftSquareBracket||LA143_5==RULE_ID) ) {
                        alt143=1;
                    }
                    }
                    break;
                case KW_SEPARATOR:
                    {
                    int LA143_6 = input.LA(2);

                    if ( (LA143_6==KW_Package||(LA143_6>=KW_Class && LA143_6<=KW_LessThanSign)||(LA143_6>=KW_Extends && LA143_6<=KW_Implements)||(LA143_6>=KW_Interface && LA143_6<=KW_Annotation)||LA143_6==KW_Throws||(LA143_6>=KW_FullStop && LA143_6<=KW_Transient)||(LA143_6>=KW_Def && LA143_6<=KW_Create)||(LA143_6>=KW_AFTER && LA143_6<=KW_Import)||LA143_6==KW_LeftSquareBracket||LA143_6==RULE_ID) ) {
                        alt143=1;
                    }
                    }
                    break;
                case KW_LeftParenthesis:
                case KW_EqualsSignGreaterThanSign:
                    {
                    alt143=1;
                    }
                    break;
            }

            switch (alt143) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getJvmFormalParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_1_0());
                      				
                    }
                    pushFollow(FOLLOW_60);
                    lv_parameterType_1_0=ruleJvmTypeReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getJvmFormalParameterRule());
                      					}
                      					set(
                      						current,
                      						"parameterType",
                      						lv_parameterType_1_0,
                      						"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getJvmFormalParameterAccess().getNameInnerVarIDParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_name_2_0=ruleInnerVarID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getJvmFormalParameterRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_2_0,
              						"org.eclipse.xtend.core.Xtend.InnerVarID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleFullJvmFormalParameter() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFullJvmFormalParameter = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getFullJvmFormalParameterRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleFullJvmFormalParameter=ruleFullJvmFormalParameter();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleFullJvmFormalParameter; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleFullJvmFormalParameter() throws RecognitionException {
        EObject current = null;

        Token lv_extension_0_0=null;
        EObject lv_parameterType_1_0 = null;

        AntlrDatatypeRuleToken lv_name_2_0 = null;



        	enterRule();

        try {
            {
            {
            int alt144=2;
            int LA144_0 = input.LA(1);

            if ( (LA144_0==KW_Extension) ) {
                alt144=1;
            }
            switch (alt144) {
                case 1 :
                    {
                    {
                    lv_extension_0_0=(Token)match(input,KW_Extension,FOLLOW_29); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(lv_extension_0_0, grammarAccess.getFullJvmFormalParameterAccess().getExtensionExtensionKeyword_0_0());
                      				
                    }
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElement(grammarAccess.getFullJvmFormalParameterRule());
                      					}
                      					setWithLastConsumed(current, "extension", true, "extension");
                      				
                    }

                    }


                    }
                    break;

            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getFullJvmFormalParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_60);
            lv_parameterType_1_0=ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getFullJvmFormalParameterRule());
              					}
              					set(
              						current,
              						"parameterType",
              						lv_parameterType_1_0,
              						"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getFullJvmFormalParameterAccess().getNameInnerVarIDParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_name_2_0=ruleInnerVarID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getFullJvmFormalParameterRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_2_0,
              						"org.eclipse.xtend.core.Xtend.InnerVarID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXStringLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXStringLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXStringLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXStringLiteral=ruleXStringLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXStringLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXStringLiteral() throws RecognitionException {
        EObject current = null;

        EObject this_SimpleStringLiteral_0 = null;

        EObject this_RichString_1 = null;



        	enterRule();

        try {
            {
            int alt145=2;
            int LA145_0 = input.LA(1);

            if ( (LA145_0==RULE_STRING) ) {
                alt145=1;
            }
            else if ( ((LA145_0>=RULE_RICH_TEXT && LA145_0<=RULE_RICH_TEXT_START)) ) {
                alt145=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 145, 0, input);

                throw nvae;
            }
            switch (alt145) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXStringLiteralAccess().getSimpleStringLiteralParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_SimpleStringLiteral_0=ruleSimpleStringLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_SimpleStringLiteral_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXStringLiteralAccess().getRichStringParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_RichString_1=ruleRichString();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_RichString_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXSwitchExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXSwitchExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXSwitchExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXSwitchExpression=ruleXSwitchExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXSwitchExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXSwitchExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        Token otherlv_8=null;
        Token otherlv_10=null;
        Token otherlv_12=null;
        Token otherlv_13=null;
        Token otherlv_15=null;
        EObject lv_declaredParam_3_0 = null;

        EObject lv_switch_5_0 = null;

        EObject lv_declaredParam_7_0 = null;

        EObject lv_switch_9_0 = null;

        EObject lv_cases_11_0 = null;

        EObject lv_default_14_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXSwitchExpressionAccess().getXSwitchExpressionAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_Switch,FOLLOW_67); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXSwitchExpressionAccess().getSwitchKeyword_1());
              		
            }
            int alt147=2;
            alt147 = dfa147.predict(input);
            switch (alt147) {
                case 1 :
                    {
                    {
                    {
                    {
                    otherlv_2=(Token)match(input,KW_LeftParenthesis,FOLLOW_58); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							newLeafNode(otherlv_2, grammarAccess.getXSwitchExpressionAccess().getLeftParenthesisKeyword_2_0_0_0_0());
                      						
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      									newCompositeNode(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_0_0_0_1_0());
                      								
                    }
                    pushFollow(FOLLOW_56);
                    lv_declaredParam_3_0=ruleJvmFormalParameter();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      									if (current==null) {
                      										current = createModelElementForParent(grammarAccess.getXSwitchExpressionRule());
                      									}
                      									set(
                      										current,
                      										"declaredParam",
                      										lv_declaredParam_3_0,
                      										"org.eclipse.xtend.core.Xtend.JvmFormalParameter");
                      									afterParserOrEnumRuleCall();
                      								
                    }

                    }


                    }

                    otherlv_4=(Token)match(input,KW_Colon,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							newLeafNode(otherlv_4, grammarAccess.getXSwitchExpressionAccess().getColonKeyword_2_0_0_0_2());
                      						
                    }

                    }


                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getXSwitchExpressionAccess().getSwitchXExpressionParserRuleCall_2_0_1_0());
                      						
                    }
                    pushFollow(FOLLOW_66);
                    lv_switch_5_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getXSwitchExpressionRule());
                      							}
                      							set(
                      								current,
                      								"switch",
                      								lv_switch_5_0,
                      								"org.eclipse.xtext.xbase.Xbase.XExpression");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    otherlv_6=(Token)match(input,KW_RightParenthesis,FOLLOW_20); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_6, grammarAccess.getXSwitchExpressionAccess().getRightParenthesisKeyword_2_0_2());
                      				
                    }

                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    int alt146=2;
                    alt146 = dfa146.predict(input);
                    switch (alt146) {
                        case 1 :
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_1_0_0_0_0());
                              								
                            }
                            pushFollow(FOLLOW_56);
                            lv_declaredParam_7_0=ruleJvmFormalParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElementForParent(grammarAccess.getXSwitchExpressionRule());
                              									}
                              									set(
                              										current,
                              										"declaredParam",
                              										lv_declaredParam_7_0,
                              										"org.eclipse.xtend.core.Xtend.JvmFormalParameter");
                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }

                            otherlv_8=(Token)match(input,KW_Colon,FOLLOW_67); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							newLeafNode(otherlv_8, grammarAccess.getXSwitchExpressionAccess().getColonKeyword_2_1_0_0_1());
                              						
                            }

                            }


                            }
                            break;

                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getXSwitchExpressionAccess().getSwitchXExpressionOrSimpleConstructorCallParserRuleCall_2_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_switch_9_0=ruleXExpressionOrSimpleConstructorCall();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getXSwitchExpressionRule());
                      							}
                      							set(
                      								current,
                      								"switch",
                      								lv_switch_9_0,
                      								"org.eclipse.xtend.core.Xtend.XExpressionOrSimpleConstructorCall");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }

            otherlv_10=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_68); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_10, grammarAccess.getXSwitchExpressionAccess().getLeftCurlyBracketKeyword_3());
              		
            }
            loop148:
            do {
                int alt148=2;
                int LA148_0 = input.LA(1);

                if ( (LA148_0==KW_Comma||(LA148_0>=KW_Annotation && LA148_0<=KW_LeftParenthesis)||LA148_0==KW_EqualsSignGreaterThanSign||(LA148_0>=KW_Create && LA148_0<=KW_SEPARATOR)||LA148_0==KW_Case||LA148_0==RULE_ID) ) {
                    alt148=1;
                }


                switch (alt148) {
            	case 1 :
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getXSwitchExpressionAccess().getCasesXCasePartParserRuleCall_4_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_68);
            	    lv_cases_11_0=ruleXCasePart();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getXSwitchExpressionRule());
            	      					}
            	      					add(
            	      						current,
            	      						"cases",
            	      						lv_cases_11_0,
            	      						"org.eclipse.xtext.xbase.Xbase.XCasePart");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop148;
                }
            } while (true);
            int alt149=2;
            int LA149_0 = input.LA(1);

            if ( (LA149_0==KW_Default) ) {
                alt149=1;
            }
            switch (alt149) {
                case 1 :
                    {
                    otherlv_12=(Token)match(input,KW_Default,FOLLOW_56); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_12, grammarAccess.getXSwitchExpressionAccess().getDefaultKeyword_5_0());
                      			
                    }
                    otherlv_13=(Token)match(input,KW_Colon,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_13, grammarAccess.getXSwitchExpressionAccess().getColonKeyword_5_1());
                      			
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXSwitchExpressionAccess().getDefaultXExpressionParserRuleCall_5_2_0());
                      					
                    }
                    pushFollow(FOLLOW_24);
                    lv_default_14_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXSwitchExpressionRule());
                      						}
                      						set(
                      							current,
                      							"default",
                      							lv_default_14_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpression");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }

            otherlv_15=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_15, grammarAccess.getXSwitchExpressionAccess().getRightCurlyBracketKeyword_6());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXExpressionOrSimpleConstructorCall() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXExpressionOrSimpleConstructorCall = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXExpressionOrSimpleConstructorCallRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXExpressionOrSimpleConstructorCall=ruleXExpressionOrSimpleConstructorCall();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXExpressionOrSimpleConstructorCall; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXExpressionOrSimpleConstructorCall() throws RecognitionException {
        EObject current = null;

        EObject this_XbaseConstructorCall_0 = null;

        EObject this_XExpression_1 = null;



        	enterRule();

        try {
            {
            int alt150=2;
            alt150 = dfa150.predict(input);
            switch (alt150) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getXExpressionOrSimpleConstructorCallAccess().getXbaseConstructorCallParserRuleCall_0());
                      			
                    }
                    pushFollow(FOLLOW_2);
                    this_XbaseConstructorCall_0=ruleXbaseConstructorCall();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_XbaseConstructorCall_0;
                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }


                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXExpressionOrSimpleConstructorCallAccess().getXExpressionParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XExpression_1=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XExpression_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleSimpleStringLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSimpleStringLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getSimpleStringLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleSimpleStringLiteral=ruleSimpleStringLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleSimpleStringLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleSimpleStringLiteral() throws RecognitionException {
        EObject current = null;

        Token lv_value_1_0=null;


        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getSimpleStringLiteralAccess().getXStringLiteralAction_0(),
              					current);
              			
            }

            }
            {
            {
            lv_value_1_0=(Token)match(input,RULE_STRING,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(lv_value_1_0, grammarAccess.getSimpleStringLiteralAccess().getValueSTRINGTerminalRuleCall_1_0());
              				
            }
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getSimpleStringLiteralRule());
              					}
              					setWithLastConsumed(
              						current,
              						"value",
              						lv_value_1_0,
              						"org.eclipse.xtext.xbase.Xtype.STRING");
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleRichString() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRichString = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRichStringRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRichString=ruleRichString();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRichString; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleRichString() throws RecognitionException {
        EObject current = null;

        EObject lv_expressions_1_0 = null;

        EObject lv_expressions_2_0 = null;

        EObject lv_expressions_3_0 = null;

        EObject lv_expressions_4_0 = null;

        EObject lv_expressions_5_0 = null;

        EObject lv_expressions_6_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getRichStringAccess().getRichStringAction_0(),
              					current);
              			
            }

            }
            int alt154=2;
            int LA154_0 = input.LA(1);

            if ( (LA154_0==RULE_RICH_TEXT) ) {
                alt154=1;
            }
            else if ( (LA154_0==RULE_RICH_TEXT_START) ) {
                alt154=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 154, 0, input);

                throw nvae;
            }
            switch (alt154) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getRichStringAccess().getExpressionsRichStringLiteralParserRuleCall_1_0_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_expressions_1_0=ruleRichStringLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getRichStringRule());
                      						}
                      						add(
                      							current,
                      							"expressions",
                      							lv_expressions_1_0,
                      							"org.eclipse.xtend.core.Xtend.RichStringLiteral");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getRichStringAccess().getExpressionsRichStringLiteralStartParserRuleCall_1_1_0_0());
                      						
                    }
                    pushFollow(FOLLOW_69);
                    lv_expressions_2_0=ruleRichStringLiteralStart();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getRichStringRule());
                      							}
                      							add(
                      								current,
                      								"expressions",
                      								lv_expressions_2_0,
                      								"org.eclipse.xtend.core.Xtend.RichStringLiteralStart");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    int alt151=2;
                    int LA151_0 = input.LA(1);

                    if ( (LA151_0==KW_Package||(LA151_0>=KW_Class && LA151_0<=KW_LessThanSign)||(LA151_0>=KW_Extends && LA151_0<=KW_LeftCurlyBracket)||(LA151_0>=KW_Interface && LA151_0<=KW_LeftParenthesis)||(LA151_0>=KW_Extension && LA151_0<=KW_New)||(LA151_0>=KW_Public && LA151_0<=KW_Create)||(LA151_0>=KW_AFTER && LA151_0<=KW_Import)||LA151_0==KW_Switch||LA151_0==KW_FOR||LA151_0==KW_IF||(LA151_0>=KW_NumberSign && LA151_0<=KW_LeftSquareBracket)||(LA151_0>=KW_PlusSign && LA151_0<=KW_HyphenMinus)||LA151_0==KW_ExclamationMark||LA151_0==KW_If||(LA151_0>=KW_For && LA151_0<=KW_Try)||(LA151_0>=RULE_ID && LA151_0<=RULE_RICH_TEXT_START)||(LA151_0>=RULE_HEX && LA151_0<=RULE_DECIMAL)) ) {
                        alt151=1;
                    }
                    switch (alt151) {
                        case 1 :
                            {
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getRichStringAccess().getExpressionsRichStringPartParserRuleCall_1_1_1_0());
                              						
                            }
                            pushFollow(FOLLOW_69);
                            lv_expressions_3_0=ruleRichStringPart();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getRichStringRule());
                              							}
                              							add(
                              								current,
                              								"expressions",
                              								lv_expressions_3_0,
                              								"org.eclipse.xtend.core.Xtend.RichStringPart");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }
                            break;

                    }
                    loop153:
                    do {
                        int alt153=2;
                        int LA153_0 = input.LA(1);

                        if ( ((LA153_0>=RULE_RICH_TEXT_INBETWEEN && LA153_0<=RULE_COMMENT_RICH_TEXT_INBETWEEN)) ) {
                            alt153=1;
                        }


                        switch (alt153) {
                    	case 1 :
                    	    {
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      								newCompositeNode(grammarAccess.getRichStringAccess().getExpressionsRichStringLiteralInbetweenParserRuleCall_1_1_2_0_0());
                    	      							
                    	    }
                    	    pushFollow(FOLLOW_69);
                    	    lv_expressions_4_0=ruleRichStringLiteralInbetween();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      								if (current==null) {
                    	      									current = createModelElementForParent(grammarAccess.getRichStringRule());
                    	      								}
                    	      								add(
                    	      									current,
                    	      									"expressions",
                    	      									lv_expressions_4_0,
                    	      									"org.eclipse.xtend.core.Xtend.RichStringLiteralInbetween");
                    	      								afterParserOrEnumRuleCall();
                    	      							
                    	    }

                    	    }


                    	    }
                    	    int alt152=2;
                    	    int LA152_0 = input.LA(1);

                    	    if ( (LA152_0==KW_Package||(LA152_0>=KW_Class && LA152_0<=KW_LessThanSign)||(LA152_0>=KW_Extends && LA152_0<=KW_LeftCurlyBracket)||(LA152_0>=KW_Interface && LA152_0<=KW_LeftParenthesis)||(LA152_0>=KW_Extension && LA152_0<=KW_New)||(LA152_0>=KW_Public && LA152_0<=KW_Create)||(LA152_0>=KW_AFTER && LA152_0<=KW_Import)||LA152_0==KW_Switch||LA152_0==KW_FOR||LA152_0==KW_IF||(LA152_0>=KW_NumberSign && LA152_0<=KW_LeftSquareBracket)||(LA152_0>=KW_PlusSign && LA152_0<=KW_HyphenMinus)||LA152_0==KW_ExclamationMark||LA152_0==KW_If||(LA152_0>=KW_For && LA152_0<=KW_Try)||(LA152_0>=RULE_ID && LA152_0<=RULE_RICH_TEXT_START)||(LA152_0>=RULE_HEX && LA152_0<=RULE_DECIMAL)) ) {
                    	        alt152=1;
                    	    }
                    	    switch (alt152) {
                    	        case 1 :
                    	            {
                    	            {
                    	            if ( state.backtracking==0 ) {

                    	              								newCompositeNode(grammarAccess.getRichStringAccess().getExpressionsRichStringPartParserRuleCall_1_1_2_1_0());
                    	              							
                    	            }
                    	            pushFollow(FOLLOW_69);
                    	            lv_expressions_5_0=ruleRichStringPart();

                    	            state._fsp--;
                    	            if (state.failed) return current;
                    	            if ( state.backtracking==0 ) {

                    	              								if (current==null) {
                    	              									current = createModelElementForParent(grammarAccess.getRichStringRule());
                    	              								}
                    	              								add(
                    	              									current,
                    	              									"expressions",
                    	              									lv_expressions_5_0,
                    	              									"org.eclipse.xtend.core.Xtend.RichStringPart");
                    	              								afterParserOrEnumRuleCall();
                    	              							
                    	            }

                    	            }


                    	            }
                    	            break;

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop153;
                        }
                    } while (true);
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getRichStringAccess().getExpressionsRichStringLiteralEndParserRuleCall_1_1_3_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    lv_expressions_6_0=ruleRichStringLiteralEnd();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getRichStringRule());
                      							}
                      							add(
                      								current,
                      								"expressions",
                      								lv_expressions_6_0,
                      								"org.eclipse.xtend.core.Xtend.RichStringLiteralEnd");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleRichStringLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRichStringLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRichStringLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRichStringLiteral=ruleRichStringLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRichStringLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleRichStringLiteral() throws RecognitionException {
        EObject current = null;

        Token lv_value_1_0=null;


        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getRichStringLiteralAccess().getRichStringLiteralAction_0(),
              					current);
              			
            }

            }
            {
            {
            lv_value_1_0=(Token)match(input,RULE_RICH_TEXT,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(lv_value_1_0, grammarAccess.getRichStringLiteralAccess().getValueRICH_TEXTTerminalRuleCall_1_0());
              				
            }
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getRichStringLiteralRule());
              					}
              					setWithLastConsumed(
              						current,
              						"value",
              						lv_value_1_0,
              						"org.eclipse.xtend.core.Xtend.RICH_TEXT");
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleRichStringLiteralStart() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRichStringLiteralStart = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRichStringLiteralStartRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRichStringLiteralStart=ruleRichStringLiteralStart();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRichStringLiteralStart; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleRichStringLiteralStart() throws RecognitionException {
        EObject current = null;

        Token lv_value_1_0=null;


        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getRichStringLiteralStartAccess().getRichStringLiteralAction_0(),
              					current);
              			
            }

            }
            {
            {
            lv_value_1_0=(Token)match(input,RULE_RICH_TEXT_START,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(lv_value_1_0, grammarAccess.getRichStringLiteralStartAccess().getValueRICH_TEXT_STARTTerminalRuleCall_1_0());
              				
            }
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getRichStringLiteralStartRule());
              					}
              					setWithLastConsumed(
              						current,
              						"value",
              						lv_value_1_0,
              						"org.eclipse.xtend.core.Xtend.RICH_TEXT_START");
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleRichStringLiteralInbetween() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRichStringLiteralInbetween = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRichStringLiteralInbetweenRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRichStringLiteralInbetween=ruleRichStringLiteralInbetween();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRichStringLiteralInbetween; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleRichStringLiteralInbetween() throws RecognitionException {
        EObject current = null;

        Token lv_value_1_0=null;
        Token lv_value_2_0=null;


        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getRichStringLiteralInbetweenAccess().getRichStringLiteralAction_0(),
              					current);
              			
            }

            }
            int alt155=2;
            int LA155_0 = input.LA(1);

            if ( (LA155_0==RULE_RICH_TEXT_INBETWEEN) ) {
                alt155=1;
            }
            else if ( (LA155_0==RULE_COMMENT_RICH_TEXT_INBETWEEN) ) {
                alt155=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 155, 0, input);

                throw nvae;
            }
            switch (alt155) {
                case 1 :
                    {
                    {
                    {
                    lv_value_1_0=(Token)match(input,RULE_RICH_TEXT_INBETWEEN,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_value_1_0, grammarAccess.getRichStringLiteralInbetweenAccess().getValueRICH_TEXT_INBETWEENTerminalRuleCall_1_0_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getRichStringLiteralInbetweenRule());
                      						}
                      						setWithLastConsumed(
                      							current,
                      							"value",
                      							lv_value_1_0,
                      							"org.eclipse.xtend.core.Xtend.RICH_TEXT_INBETWEEN");
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    lv_value_2_0=(Token)match(input,RULE_COMMENT_RICH_TEXT_INBETWEEN,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_value_2_0, grammarAccess.getRichStringLiteralInbetweenAccess().getValueCOMMENT_RICH_TEXT_INBETWEENTerminalRuleCall_1_1_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getRichStringLiteralInbetweenRule());
                      						}
                      						setWithLastConsumed(
                      							current,
                      							"value",
                      							lv_value_2_0,
                      							"org.eclipse.xtend.core.Xtend.COMMENT_RICH_TEXT_INBETWEEN");
                      					
                    }

                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleRichStringLiteralEnd() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRichStringLiteralEnd = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRichStringLiteralEndRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRichStringLiteralEnd=ruleRichStringLiteralEnd();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRichStringLiteralEnd; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleRichStringLiteralEnd() throws RecognitionException {
        EObject current = null;

        Token lv_value_1_0=null;
        Token lv_value_2_0=null;


        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getRichStringLiteralEndAccess().getRichStringLiteralAction_0(),
              					current);
              			
            }

            }
            int alt156=2;
            int LA156_0 = input.LA(1);

            if ( (LA156_0==RULE_RICH_TEXT_END) ) {
                alt156=1;
            }
            else if ( (LA156_0==RULE_COMMENT_RICH_TEXT_END) ) {
                alt156=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 156, 0, input);

                throw nvae;
            }
            switch (alt156) {
                case 1 :
                    {
                    {
                    {
                    lv_value_1_0=(Token)match(input,RULE_RICH_TEXT_END,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_value_1_0, grammarAccess.getRichStringLiteralEndAccess().getValueRICH_TEXT_ENDTerminalRuleCall_1_0_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getRichStringLiteralEndRule());
                      						}
                      						setWithLastConsumed(
                      							current,
                      							"value",
                      							lv_value_1_0,
                      							"org.eclipse.xtend.core.Xtend.RICH_TEXT_END");
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    lv_value_2_0=(Token)match(input,RULE_COMMENT_RICH_TEXT_END,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_value_2_0, grammarAccess.getRichStringLiteralEndAccess().getValueCOMMENT_RICH_TEXT_ENDTerminalRuleCall_1_1_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getRichStringLiteralEndRule());
                      						}
                      						setWithLastConsumed(
                      							current,
                      							"value",
                      							lv_value_2_0,
                      							"org.eclipse.xtend.core.Xtend.COMMENT_RICH_TEXT_END");
                      					
                    }

                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleInternalRichString() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleInternalRichString = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getInternalRichStringRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleInternalRichString=ruleInternalRichString();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleInternalRichString; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleInternalRichString() throws RecognitionException {
        EObject current = null;

        EObject lv_expressions_1_0 = null;

        EObject lv_expressions_2_0 = null;

        EObject lv_expressions_3_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getInternalRichStringAccess().getRichStringAction_0(),
              					current);
              			
            }

            }
            {
            {
            {
            if ( state.backtracking==0 ) {

              						newCompositeNode(grammarAccess.getInternalRichStringAccess().getExpressionsRichStringLiteralInbetweenParserRuleCall_1_0_0());
              					
            }
            pushFollow(FOLLOW_70);
            lv_expressions_1_0=ruleRichStringLiteralInbetween();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              						if (current==null) {
              							current = createModelElementForParent(grammarAccess.getInternalRichStringRule());
              						}
              						add(
              							current,
              							"expressions",
              							lv_expressions_1_0,
              							"org.eclipse.xtend.core.Xtend.RichStringLiteralInbetween");
              						afterParserOrEnumRuleCall();
              					
            }

            }


            }
            loop158:
            do {
                int alt158=2;
                int LA158_0 = input.LA(1);

                if ( (LA158_0==KW_Package||(LA158_0>=KW_Class && LA158_0<=KW_LessThanSign)||(LA158_0>=KW_Extends && LA158_0<=KW_LeftCurlyBracket)||(LA158_0>=KW_Interface && LA158_0<=KW_LeftParenthesis)||(LA158_0>=KW_Extension && LA158_0<=KW_New)||(LA158_0>=KW_Public && LA158_0<=KW_Create)||(LA158_0>=KW_AFTER && LA158_0<=KW_Import)||LA158_0==KW_Switch||LA158_0==KW_FOR||LA158_0==KW_IF||(LA158_0>=KW_NumberSign && LA158_0<=KW_LeftSquareBracket)||(LA158_0>=KW_PlusSign && LA158_0<=KW_HyphenMinus)||LA158_0==KW_ExclamationMark||LA158_0==KW_If||(LA158_0>=KW_For && LA158_0<=KW_Try)||(LA158_0>=RULE_ID && LA158_0<=RULE_COMMENT_RICH_TEXT_INBETWEEN)||(LA158_0>=RULE_HEX && LA158_0<=RULE_DECIMAL)) ) {
                    alt158=1;
                }


                switch (alt158) {
            	case 1 :
            	    {
            	    int alt157=2;
            	    int LA157_0 = input.LA(1);

            	    if ( (LA157_0==KW_Package||(LA157_0>=KW_Class && LA157_0<=KW_LessThanSign)||(LA157_0>=KW_Extends && LA157_0<=KW_LeftCurlyBracket)||(LA157_0>=KW_Interface && LA157_0<=KW_LeftParenthesis)||(LA157_0>=KW_Extension && LA157_0<=KW_New)||(LA157_0>=KW_Public && LA157_0<=KW_Create)||(LA157_0>=KW_AFTER && LA157_0<=KW_Import)||LA157_0==KW_Switch||LA157_0==KW_FOR||LA157_0==KW_IF||(LA157_0>=KW_NumberSign && LA157_0<=KW_LeftSquareBracket)||(LA157_0>=KW_PlusSign && LA157_0<=KW_HyphenMinus)||LA157_0==KW_ExclamationMark||LA157_0==KW_If||(LA157_0>=KW_For && LA157_0<=KW_Try)||(LA157_0>=RULE_ID && LA157_0<=RULE_RICH_TEXT_START)||(LA157_0>=RULE_HEX && LA157_0<=RULE_DECIMAL)) ) {
            	        alt157=1;
            	    }
            	    switch (alt157) {
            	        case 1 :
            	            {
            	            {
            	            if ( state.backtracking==0 ) {

            	              							newCompositeNode(grammarAccess.getInternalRichStringAccess().getExpressionsRichStringPartParserRuleCall_1_1_0_0());
            	              						
            	            }
            	            pushFollow(FOLLOW_71);
            	            lv_expressions_2_0=ruleRichStringPart();

            	            state._fsp--;
            	            if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              							if (current==null) {
            	              								current = createModelElementForParent(grammarAccess.getInternalRichStringRule());
            	              							}
            	              							add(
            	              								current,
            	              								"expressions",
            	              								lv_expressions_2_0,
            	              								"org.eclipse.xtend.core.Xtend.RichStringPart");
            	              							afterParserOrEnumRuleCall();
            	              						
            	            }

            	            }


            	            }
            	            break;

            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							newCompositeNode(grammarAccess.getInternalRichStringAccess().getExpressionsRichStringLiteralInbetweenParserRuleCall_1_1_1_0());
            	      						
            	    }
            	    pushFollow(FOLLOW_70);
            	    lv_expressions_3_0=ruleRichStringLiteralInbetween();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      							if (current==null) {
            	      								current = createModelElementForParent(grammarAccess.getInternalRichStringRule());
            	      							}
            	      							add(
            	      								current,
            	      								"expressions",
            	      								lv_expressions_3_0,
            	      								"org.eclipse.xtend.core.Xtend.RichStringLiteralInbetween");
            	      							afterParserOrEnumRuleCall();
            	      						
            	    }

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop158;
                }
            } while (true);


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleRichStringPart() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRichStringPart = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRichStringPartRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRichStringPart=ruleRichStringPart();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRichStringPart; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleRichStringPart() throws RecognitionException {
        EObject current = null;

        EObject this_XExpressionOrVarDeclaration_0 = null;

        EObject this_RichStringForLoop_1 = null;

        EObject this_RichStringIf_2 = null;



        	enterRule();

        try {
            {
            int alt159=3;
            switch ( input.LA(1) ) {
            case KW_Package:
            case KW_Class:
            case KW_LessThanSign:
            case KW_Extends:
            case KW_Implements:
            case KW_LeftCurlyBracket:
            case KW_Interface:
            case KW_Enum:
            case KW_Annotation:
            case KW_LeftParenthesis:
            case KW_Extension:
            case KW_Throws:
            case KW_New:
            case KW_Public:
            case KW_Private:
            case KW_Protected:
            case KW_Abstract:
            case KW_Static:
            case KW_Dispatch:
            case KW_Final:
            case KW_Strictfp:
            case KW_Native:
            case KW_Volatile:
            case KW_Synchronized:
            case KW_Transient:
            case KW_Val:
            case KW_Var:
            case KW_Def:
            case KW_Override:
            case KW_Create:
            case KW_AFTER:
            case KW_BEFORE:
            case KW_SEPARATOR:
            case KW_Import:
            case KW_Switch:
            case KW_NumberSign:
            case KW_LeftSquareBracket:
            case KW_PlusSign:
            case KW_HyphenMinus:
            case KW_ExclamationMark:
            case KW_If:
            case KW_For:
            case KW_While:
            case KW_Do:
            case KW_Super:
            case KW_False:
            case KW_True:
            case KW_Null:
            case KW_Typeof:
            case KW_Throw:
            case KW_Return:
            case KW_Try:
            case RULE_ID:
            case RULE_STRING:
            case RULE_RICH_TEXT:
            case RULE_RICH_TEXT_START:
            case RULE_HEX:
            case RULE_INT:
            case RULE_DECIMAL:
                {
                alt159=1;
                }
                break;
            case KW_FOR:
                {
                alt159=2;
                }
                break;
            case KW_IF:
                {
                alt159=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 159, 0, input);

                throw nvae;
            }

            switch (alt159) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getRichStringPartAccess().getXExpressionOrVarDeclarationParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XExpressionOrVarDeclaration_0=ruleXExpressionOrVarDeclaration();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XExpressionOrVarDeclaration_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getRichStringPartAccess().getRichStringForLoopParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_RichStringForLoop_1=ruleRichStringForLoop();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_RichStringForLoop_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getRichStringPartAccess().getRichStringIfParserRuleCall_2());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_RichStringIf_2=ruleRichStringIf();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_RichStringIf_2;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleRichStringForLoop() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRichStringForLoop = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRichStringForLoopRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRichStringForLoop=ruleRichStringForLoop();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRichStringForLoop; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleRichStringForLoop() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        Token otherlv_12=null;
        EObject lv_declaredParam_2_0 = null;

        EObject lv_forExpression_4_0 = null;

        EObject lv_before_6_0 = null;

        EObject lv_separator_8_0 = null;

        EObject lv_after_10_0 = null;

        EObject lv_eachExpression_11_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getRichStringForLoopAccess().getRichStringForLoopAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_FOR,FOLLOW_58); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getRichStringForLoopAccess().getFORKeyword_1());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRichStringForLoopAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_56);
            lv_declaredParam_2_0=ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRichStringForLoopRule());
              					}
              					set(
              						current,
              						"declaredParam",
              						lv_declaredParam_2_0,
              						"org.eclipse.xtend.core.Xtend.JvmFormalParameter");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_3=(Token)match(input,KW_Colon,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_3, grammarAccess.getRichStringForLoopAccess().getColonKeyword_3());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRichStringForLoopAccess().getForExpressionXExpressionParserRuleCall_4_0());
              				
            }
            pushFollow(FOLLOW_72);
            lv_forExpression_4_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRichStringForLoopRule());
              					}
              					set(
              						current,
              						"forExpression",
              						lv_forExpression_4_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            int alt160=2;
            int LA160_0 = input.LA(1);

            if ( (LA160_0==KW_BEFORE) ) {
                alt160=1;
            }
            switch (alt160) {
                case 1 :
                    {
                    otherlv_5=(Token)match(input,KW_BEFORE,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_5, grammarAccess.getRichStringForLoopAccess().getBEFOREKeyword_5_0());
                      			
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getRichStringForLoopAccess().getBeforeXExpressionParserRuleCall_5_1_0());
                      					
                    }
                    pushFollow(FOLLOW_72);
                    lv_before_6_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getRichStringForLoopRule());
                      						}
                      						set(
                      							current,
                      							"before",
                      							lv_before_6_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpression");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }
            int alt161=2;
            int LA161_0 = input.LA(1);

            if ( (LA161_0==KW_SEPARATOR) ) {
                alt161=1;
            }
            switch (alt161) {
                case 1 :
                    {
                    otherlv_7=(Token)match(input,KW_SEPARATOR,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_7, grammarAccess.getRichStringForLoopAccess().getSEPARATORKeyword_6_0());
                      			
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getRichStringForLoopAccess().getSeparatorXExpressionParserRuleCall_6_1_0());
                      					
                    }
                    pushFollow(FOLLOW_72);
                    lv_separator_8_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getRichStringForLoopRule());
                      						}
                      						set(
                      							current,
                      							"separator",
                      							lv_separator_8_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpression");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }
            int alt162=2;
            int LA162_0 = input.LA(1);

            if ( (LA162_0==KW_AFTER) ) {
                alt162=1;
            }
            switch (alt162) {
                case 1 :
                    {
                    otherlv_9=(Token)match(input,KW_AFTER,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_9, grammarAccess.getRichStringForLoopAccess().getAFTERKeyword_7_0());
                      			
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getRichStringForLoopAccess().getAfterXExpressionParserRuleCall_7_1_0());
                      					
                    }
                    pushFollow(FOLLOW_72);
                    lv_after_10_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getRichStringForLoopRule());
                      						}
                      						set(
                      							current,
                      							"after",
                      							lv_after_10_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpression");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRichStringForLoopAccess().getEachExpressionInternalRichStringParserRuleCall_8_0());
              				
            }
            pushFollow(FOLLOW_73);
            lv_eachExpression_11_0=ruleInternalRichString();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRichStringForLoopRule());
              					}
              					set(
              						current,
              						"eachExpression",
              						lv_eachExpression_11_0,
              						"org.eclipse.xtend.core.Xtend.InternalRichString");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_12=(Token)match(input,KW_ENDFOR,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_12, grammarAccess.getRichStringForLoopAccess().getENDFORKeyword_9());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleRichStringIf() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRichStringIf = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRichStringIfRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRichStringIf=ruleRichStringIf();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRichStringIf; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleRichStringIf() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        EObject lv_if_2_0 = null;

        EObject lv_then_3_0 = null;

        EObject lv_elseIfs_4_0 = null;

        EObject lv_else_6_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getRichStringIfAccess().getRichStringIfAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_IF,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getRichStringIfAccess().getIFKeyword_1());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRichStringIfAccess().getIfXExpressionParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_72);
            lv_if_2_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRichStringIfRule());
              					}
              					set(
              						current,
              						"if",
              						lv_if_2_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRichStringIfAccess().getThenInternalRichStringParserRuleCall_3_0());
              				
            }
            pushFollow(FOLLOW_74);
            lv_then_3_0=ruleInternalRichString();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRichStringIfRule());
              					}
              					set(
              						current,
              						"then",
              						lv_then_3_0,
              						"org.eclipse.xtend.core.Xtend.InternalRichString");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            loop163:
            do {
                int alt163=2;
                int LA163_0 = input.LA(1);

                if ( (LA163_0==KW_ELSEIF) ) {
                    alt163=1;
                }


                switch (alt163) {
            	case 1 :
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getRichStringIfAccess().getElseIfsRichStringElseIfParserRuleCall_4_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_74);
            	    lv_elseIfs_4_0=ruleRichStringElseIf();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getRichStringIfRule());
            	      					}
            	      					add(
            	      						current,
            	      						"elseIfs",
            	      						lv_elseIfs_4_0,
            	      						"org.eclipse.xtend.core.Xtend.RichStringElseIf");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop163;
                }
            } while (true);
            int alt164=2;
            int LA164_0 = input.LA(1);

            if ( (LA164_0==KW_ELSE) ) {
                alt164=1;
            }
            switch (alt164) {
                case 1 :
                    {
                    otherlv_5=(Token)match(input,KW_ELSE,FOLLOW_72); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_5, grammarAccess.getRichStringIfAccess().getELSEKeyword_5_0());
                      			
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getRichStringIfAccess().getElseInternalRichStringParserRuleCall_5_1_0());
                      					
                    }
                    pushFollow(FOLLOW_75);
                    lv_else_6_0=ruleInternalRichString();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getRichStringIfRule());
                      						}
                      						set(
                      							current,
                      							"else",
                      							lv_else_6_0,
                      							"org.eclipse.xtend.core.Xtend.InternalRichString");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }

            otherlv_7=(Token)match(input,KW_ENDIF,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_7, grammarAccess.getRichStringIfAccess().getENDIFKeyword_6());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleRichStringElseIf() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRichStringElseIf = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRichStringElseIfRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRichStringElseIf=ruleRichStringElseIf();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRichStringElseIf; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleRichStringElseIf() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_if_1_0 = null;

        EObject lv_then_2_0 = null;



        	enterRule();

        try {
            {
            {
            otherlv_0=(Token)match(input,KW_ELSEIF,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getRichStringElseIfAccess().getELSEIFKeyword_0());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRichStringElseIfAccess().getIfXExpressionParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_72);
            lv_if_1_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRichStringElseIfRule());
              					}
              					set(
              						current,
              						"if",
              						lv_if_1_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRichStringElseIfAccess().getThenInternalRichStringParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_then_2_0=ruleInternalRichString();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRichStringElseIfRule());
              					}
              					set(
              						current,
              						"then",
              						lv_then_2_0,
              						"org.eclipse.xtend.core.Xtend.InternalRichString");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXAnnotation() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXAnnotation = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXAnnotationRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXAnnotation=ruleXAnnotation();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXAnnotation; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXAnnotation() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_8=null;
        EObject lv_elementValuePairs_4_0 = null;

        EObject lv_elementValuePairs_6_0 = null;

        EObject lv_value_7_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXAnnotationAccess().getXAnnotationAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_CommercialAt,FOLLOW_3); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXAnnotationAccess().getCommercialAtKeyword_1());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getXAnnotationRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXAnnotationAccess().getAnnotationTypeJvmAnnotationTypeCrossReference_2_0());
              				
            }
            pushFollow(FOLLOW_76);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            int alt167=2;
            alt167 = dfa167.predict(input);
            switch (alt167) {
                case 1 :
                    {
                    {
                    otherlv_3=(Token)match(input,KW_LeftParenthesis,FOLLOW_77); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_3, grammarAccess.getXAnnotationAccess().getLeftParenthesisKeyword_3_0());
                      				
                    }

                    }
                    int alt166=3;
                    alt166 = dfa166.predict(input);
                    switch (alt166) {
                        case 1 :
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getXAnnotationAccess().getElementValuePairsXAnnotationElementValuePairParserRuleCall_3_1_0_0_0());
                              							
                            }
                            pushFollow(FOLLOW_28);
                            lv_elementValuePairs_4_0=ruleXAnnotationElementValuePair();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getXAnnotationRule());
                              								}
                              								add(
                              									current,
                              									"elementValuePairs",
                              									lv_elementValuePairs_4_0,
                              									"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotationElementValuePair");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop165:
                            do {
                                int alt165=2;
                                int LA165_0 = input.LA(1);

                                if ( (LA165_0==KW_Comma) ) {
                                    alt165=1;
                                }


                                switch (alt165) {
                            	case 1 :
                            	    {
                            	    otherlv_5=(Token)match(input,KW_Comma,FOLLOW_3); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_5, grammarAccess.getXAnnotationAccess().getCommaKeyword_3_1_0_1_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getXAnnotationAccess().getElementValuePairsXAnnotationElementValuePairParserRuleCall_3_1_0_1_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_28);
                            	    lv_elementValuePairs_6_0=ruleXAnnotationElementValuePair();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getXAnnotationRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"elementValuePairs",
                            	      										lv_elementValuePairs_6_0,
                            	      										"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotationElementValuePair");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop165;
                                }
                            } while (true);


                            }


                            }
                            break;
                        case 2 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getXAnnotationAccess().getValueXAnnotationElementValueOrCommaListParserRuleCall_3_1_1_0());
                              						
                            }
                            pushFollow(FOLLOW_66);
                            lv_value_7_0=ruleXAnnotationElementValueOrCommaList();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getXAnnotationRule());
                              							}
                              							set(
                              								current,
                              								"value",
                              								lv_value_7_0,
                              								"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotationElementValueOrCommaList");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }


                            }
                            break;

                    }

                    otherlv_8=(Token)match(input,KW_RightParenthesis,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_8, grammarAccess.getXAnnotationAccess().getRightParenthesisKeyword_3_2());
                      			
                    }

                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXAnnotationElementValuePair() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXAnnotationElementValuePair = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXAnnotationElementValuePairRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXAnnotationElementValuePair=ruleXAnnotationElementValuePair();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXAnnotationElementValuePair; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXAnnotationElementValuePair() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_value_2_0 = null;



        	enterRule();

        try {
            {
            {
            {
            {
            {
            {
            if ( state.backtracking==0 ) {

              							if (current==null) {
              								current = createModelElement(grammarAccess.getXAnnotationElementValuePairRule());
              							}
              						
            }
            if ( state.backtracking==0 ) {

              							newCompositeNode(grammarAccess.getXAnnotationElementValuePairAccess().getElementJvmOperationCrossReference_0_0_0_0());
              						
            }
            pushFollow(FOLLOW_78);
            ruleValidID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              							afterParserOrEnumRuleCall();
              						
            }

            }


            }

            otherlv_1=(Token)match(input,KW_EqualsSign,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(otherlv_1, grammarAccess.getXAnnotationElementValuePairAccess().getEqualsSignKeyword_0_0_1());
              				
            }

            }


            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXAnnotationElementValuePairAccess().getValueXAnnotationElementValueParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_value_2_0=ruleXAnnotationElementValue();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXAnnotationElementValuePairRule());
              					}
              					set(
              						current,
              						"value",
              						lv_value_2_0,
              						"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotationElementValue");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXAnnotationElementValueOrCommaList() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXAnnotationElementValueOrCommaList = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXAnnotationElementValueOrCommaListRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXAnnotationElementValueOrCommaList=ruleXAnnotationElementValueOrCommaList();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXAnnotationElementValueOrCommaList; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXAnnotationElementValueOrCommaList() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        Token otherlv_9=null;
        EObject lv_elements_3_0 = null;

        EObject lv_elements_5_0 = null;

        EObject this_XAnnotationOrExpression_7 = null;

        EObject lv_elements_10_0 = null;



        	enterRule();

        try {
            {
            int alt172=2;
            alt172 = dfa172.predict(input);
            switch (alt172) {
                case 1 :
                    {
                    {
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							current = forceCreateModelElement(
                      								grammarAccess.getXAnnotationElementValueOrCommaListAccess().getXListLiteralAction_0_0_0_0(),
                      								current);
                      						
                    }

                    }

                    otherlv_1=(Token)match(input,KW_NumberSign,FOLLOW_51); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(otherlv_1, grammarAccess.getXAnnotationElementValueOrCommaListAccess().getNumberSignKeyword_0_0_0_1());
                      					
                    }
                    otherlv_2=(Token)match(input,KW_LeftSquareBracket,FOLLOW_79); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(otherlv_2, grammarAccess.getXAnnotationElementValueOrCommaListAccess().getLeftSquareBracketKeyword_0_0_0_2());
                      					
                    }

                    }


                    }
                    int alt169=2;
                    int LA169_0 = input.LA(1);

                    if ( (LA169_0==KW_Package||(LA169_0>=KW_Class && LA169_0<=KW_LessThanSign)||(LA169_0>=KW_Extends && LA169_0<=KW_LeftCurlyBracket)||(LA169_0>=KW_Interface && LA169_0<=KW_LeftParenthesis)||(LA169_0>=KW_Extension && LA169_0<=KW_New)||(LA169_0>=KW_Public && LA169_0<=KW_Transient)||(LA169_0>=KW_Def && LA169_0<=KW_Create)||(LA169_0>=KW_AFTER && LA169_0<=KW_Import)||LA169_0==KW_Switch||(LA169_0>=KW_CommercialAt && LA169_0<=KW_LeftSquareBracket)||(LA169_0>=KW_PlusSign && LA169_0<=KW_HyphenMinus)||LA169_0==KW_ExclamationMark||LA169_0==KW_If||(LA169_0>=KW_For && LA169_0<=KW_Try)||(LA169_0>=RULE_ID && LA169_0<=RULE_RICH_TEXT_START)||(LA169_0>=RULE_HEX && LA169_0<=RULE_DECIMAL)) ) {
                        alt169=1;
                    }
                    switch (alt169) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_0_0());
                              						
                            }
                            pushFollow(FOLLOW_80);
                            lv_elements_3_0=ruleXAnnotationOrExpression();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getXAnnotationElementValueOrCommaListRule());
                              							}
                              							add(
                              								current,
                              								"elements",
                              								lv_elements_3_0,
                              								"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotationOrExpression");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }
                            loop168:
                            do {
                                int alt168=2;
                                int LA168_0 = input.LA(1);

                                if ( (LA168_0==KW_Comma) ) {
                                    alt168=1;
                                }


                                switch (alt168) {
                            	case 1 :
                            	    {
                            	    otherlv_4=(Token)match(input,KW_Comma,FOLLOW_34); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      						newLeafNode(otherlv_4, grammarAccess.getXAnnotationElementValueOrCommaListAccess().getCommaKeyword_0_1_1_0());
                            	      					
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      								newCompositeNode(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_1_1_0());
                            	      							
                            	    }
                            	    pushFollow(FOLLOW_80);
                            	    lv_elements_5_0=ruleXAnnotationOrExpression();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      								if (current==null) {
                            	      									current = createModelElementForParent(grammarAccess.getXAnnotationElementValueOrCommaListRule());
                            	      								}
                            	      								add(
                            	      									current,
                            	      									"elements",
                            	      									lv_elements_5_0,
                            	      									"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotationOrExpression");
                            	      								afterParserOrEnumRuleCall();
                            	      							
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop168;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_6=(Token)match(input,KW_RightSquareBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_6, grammarAccess.getXAnnotationElementValueOrCommaListAccess().getRightSquareBracketKeyword_0_2());
                      			
                    }

                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getXAnnotationOrExpressionParserRuleCall_1_0());
                      			
                    }
                    pushFollow(FOLLOW_81);
                    this_XAnnotationOrExpression_7=ruleXAnnotationOrExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_XAnnotationOrExpression_7;
                      				afterParserOrEnumRuleCall();
                      			
                    }
                    int alt171=2;
                    int LA171_0 = input.LA(1);

                    if ( (LA171_0==KW_Comma) ) {
                        alt171=1;
                    }
                    switch (alt171) {
                        case 1 :
                            {
                            {
                            if ( state.backtracking==0 ) {

                              						current = forceCreateModelElementAndAdd(
                              							grammarAccess.getXAnnotationElementValueOrCommaListAccess().getXListLiteralElementsAction_1_1_0(),
                              							current);
                              					
                            }

                            }
                            int cnt170=0;
                            loop170:
                            do {
                                int alt170=2;
                                int LA170_0 = input.LA(1);

                                if ( (LA170_0==KW_Comma) ) {
                                    alt170=1;
                                }


                                switch (alt170) {
                            	case 1 :
                            	    {
                            	    otherlv_9=(Token)match(input,KW_Comma,FOLLOW_34); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      						newLeafNode(otherlv_9, grammarAccess.getXAnnotationElementValueOrCommaListAccess().getCommaKeyword_1_1_1_0());
                            	      					
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      								newCompositeNode(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsXAnnotationOrExpressionParserRuleCall_1_1_1_1_0());
                            	      							
                            	    }
                            	    pushFollow(FOLLOW_81);
                            	    lv_elements_10_0=ruleXAnnotationOrExpression();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      								if (current==null) {
                            	      									current = createModelElementForParent(grammarAccess.getXAnnotationElementValueOrCommaListRule());
                            	      								}
                            	      								add(
                            	      									current,
                            	      									"elements",
                            	      									lv_elements_10_0,
                            	      									"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotationOrExpression");
                            	      								afterParserOrEnumRuleCall();
                            	      							
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    if ( cnt170 >= 1 ) break loop170;
                            	    if (state.backtracking>0) {state.failed=true; return current;}
                                        EarlyExitException eee =
                                            new EarlyExitException(170, input);
                                        throw eee;
                                }
                                cnt170++;
                            } while (true);


                            }
                            break;

                    }


                    }


                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXAnnotationElementValue() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXAnnotationElementValue = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXAnnotationElementValueRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXAnnotationElementValue=ruleXAnnotationElementValue();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXAnnotationElementValue; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXAnnotationElementValue() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_elements_3_0 = null;

        EObject lv_elements_5_0 = null;

        EObject this_XAnnotationOrExpression_7 = null;



        	enterRule();

        try {
            {
            int alt175=2;
            alt175 = dfa175.predict(input);
            switch (alt175) {
                case 1 :
                    {
                    {
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							current = forceCreateModelElement(
                      								grammarAccess.getXAnnotationElementValueAccess().getXListLiteralAction_0_0_0_0(),
                      								current);
                      						
                    }

                    }

                    otherlv_1=(Token)match(input,KW_NumberSign,FOLLOW_51); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(otherlv_1, grammarAccess.getXAnnotationElementValueAccess().getNumberSignKeyword_0_0_0_1());
                      					
                    }
                    otherlv_2=(Token)match(input,KW_LeftSquareBracket,FOLLOW_79); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(otherlv_2, grammarAccess.getXAnnotationElementValueAccess().getLeftSquareBracketKeyword_0_0_0_2());
                      					
                    }

                    }


                    }
                    int alt174=2;
                    int LA174_0 = input.LA(1);

                    if ( (LA174_0==KW_Package||(LA174_0>=KW_Class && LA174_0<=KW_LessThanSign)||(LA174_0>=KW_Extends && LA174_0<=KW_LeftCurlyBracket)||(LA174_0>=KW_Interface && LA174_0<=KW_LeftParenthesis)||(LA174_0>=KW_Extension && LA174_0<=KW_New)||(LA174_0>=KW_Public && LA174_0<=KW_Transient)||(LA174_0>=KW_Def && LA174_0<=KW_Create)||(LA174_0>=KW_AFTER && LA174_0<=KW_Import)||LA174_0==KW_Switch||(LA174_0>=KW_CommercialAt && LA174_0<=KW_LeftSquareBracket)||(LA174_0>=KW_PlusSign && LA174_0<=KW_HyphenMinus)||LA174_0==KW_ExclamationMark||LA174_0==KW_If||(LA174_0>=KW_For && LA174_0<=KW_Try)||(LA174_0>=RULE_ID && LA174_0<=RULE_RICH_TEXT_START)||(LA174_0>=RULE_HEX && LA174_0<=RULE_DECIMAL)) ) {
                        alt174=1;
                    }
                    switch (alt174) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getXAnnotationElementValueAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_0_0());
                              						
                            }
                            pushFollow(FOLLOW_80);
                            lv_elements_3_0=ruleXAnnotationOrExpression();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getXAnnotationElementValueRule());
                              							}
                              							add(
                              								current,
                              								"elements",
                              								lv_elements_3_0,
                              								"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotationOrExpression");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }
                            loop173:
                            do {
                                int alt173=2;
                                int LA173_0 = input.LA(1);

                                if ( (LA173_0==KW_Comma) ) {
                                    alt173=1;
                                }


                                switch (alt173) {
                            	case 1 :
                            	    {
                            	    otherlv_4=(Token)match(input,KW_Comma,FOLLOW_34); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      						newLeafNode(otherlv_4, grammarAccess.getXAnnotationElementValueAccess().getCommaKeyword_0_1_1_0());
                            	      					
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      								newCompositeNode(grammarAccess.getXAnnotationElementValueAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_1_1_0());
                            	      							
                            	    }
                            	    pushFollow(FOLLOW_80);
                            	    lv_elements_5_0=ruleXAnnotationOrExpression();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      								if (current==null) {
                            	      									current = createModelElementForParent(grammarAccess.getXAnnotationElementValueRule());
                            	      								}
                            	      								add(
                            	      									current,
                            	      									"elements",
                            	      									lv_elements_5_0,
                            	      									"org.eclipse.xtext.xbase.annotations.XbaseWithAnnotations.XAnnotationOrExpression");
                            	      								afterParserOrEnumRuleCall();
                            	      							
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop173;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_6=(Token)match(input,KW_RightSquareBracket,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_6, grammarAccess.getXAnnotationElementValueAccess().getRightSquareBracketKeyword_0_2());
                      			
                    }

                    }


                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXAnnotationElementValueAccess().getXAnnotationOrExpressionParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XAnnotationOrExpression_7=ruleXAnnotationOrExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XAnnotationOrExpression_7;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXAnnotationOrExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXAnnotationOrExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXAnnotationOrExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXAnnotationOrExpression=ruleXAnnotationOrExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXAnnotationOrExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXAnnotationOrExpression() throws RecognitionException {
        EObject current = null;

        EObject this_XAnnotation_0 = null;

        EObject this_XExpression_1 = null;



        	enterRule();

        try {
            {
            int alt176=2;
            int LA176_0 = input.LA(1);

            if ( (LA176_0==KW_CommercialAt) ) {
                alt176=1;
            }
            else if ( (LA176_0==KW_Package||(LA176_0>=KW_Class && LA176_0<=KW_LessThanSign)||(LA176_0>=KW_Extends && LA176_0<=KW_LeftCurlyBracket)||(LA176_0>=KW_Interface && LA176_0<=KW_LeftParenthesis)||(LA176_0>=KW_Extension && LA176_0<=KW_New)||(LA176_0>=KW_Public && LA176_0<=KW_Transient)||(LA176_0>=KW_Def && LA176_0<=KW_Create)||(LA176_0>=KW_AFTER && LA176_0<=KW_Import)||LA176_0==KW_Switch||(LA176_0>=KW_NumberSign && LA176_0<=KW_LeftSquareBracket)||(LA176_0>=KW_PlusSign && LA176_0<=KW_HyphenMinus)||LA176_0==KW_ExclamationMark||LA176_0==KW_If||(LA176_0>=KW_For && LA176_0<=KW_Try)||(LA176_0>=RULE_ID && LA176_0<=RULE_RICH_TEXT_START)||(LA176_0>=RULE_HEX && LA176_0<=RULE_DECIMAL)) ) {
                alt176=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 176, 0, input);

                throw nvae;
            }
            switch (alt176) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXAnnotationOrExpressionAccess().getXAnnotationParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XAnnotation_0=ruleXAnnotation();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XAnnotation_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXAnnotationOrExpressionAccess().getXExpressionParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XExpression_1=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XExpression_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXExpression=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXExpression() throws RecognitionException {
        EObject current = null;

        EObject this_XAssignment_0 = null;



        	enterRule();

        try {
            {
            if ( state.backtracking==0 ) {

              		newCompositeNode(grammarAccess.getXExpressionAccess().getXAssignmentParserRuleCall());
              	
            }
            pushFollow(FOLLOW_2);
            this_XAssignment_0=ruleXAssignment();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              		current = this_XAssignment_0;
              		afterParserOrEnumRuleCall();
              	
            }

            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXAssignment() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXAssignment = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXAssignmentRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXAssignment=ruleXAssignment();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXAssignment; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXAssignment() throws RecognitionException {
        EObject current = null;

        EObject lv_value_3_0 = null;

        EObject this_XOrExpression_4 = null;

        EObject lv_rightOperand_7_0 = null;



        	enterRule();

        try {
            {
            int alt178=2;
            alt178 = dfa178.predict(input);
            switch (alt178) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      					current = forceCreateModelElement(
                      						grammarAccess.getXAssignmentAccess().getXAssignmentAction_0_0(),
                      						current);
                      				
                    }

                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getXAssignmentRule());
                      						}
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementCrossReference_0_1_0());
                      					
                    }
                    pushFollow(FOLLOW_78);
                    ruleFeatureCallID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }

                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getXAssignmentAccess().getOpSingleAssignParserRuleCall_0_2());
                      			
                    }
                    pushFollow(FOLLOW_34);
                    ruleOpSingleAssign();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				afterParserOrEnumRuleCall();
                      			
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXAssignmentAccess().getValueXAssignmentParserRuleCall_0_3_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_value_3_0=ruleXAssignment();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXAssignmentRule());
                      						}
                      						set(
                      							current,
                      							"value",
                      							lv_value_3_0,
                      							"org.eclipse.xtext.xbase.Xbase.XAssignment");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getXAssignmentAccess().getXOrExpressionParserRuleCall_1_0());
                      			
                    }
                    pushFollow(FOLLOW_82);
                    this_XOrExpression_4=ruleXOrExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_XOrExpression_4;
                      				afterParserOrEnumRuleCall();
                      			
                    }
                    int alt177=2;
                    alt177 = dfa177.predict(input);
                    switch (alt177) {
                        case 1 :
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								current = forceCreateModelElementAndSet(
                              									grammarAccess.getXAssignmentAccess().getXBinaryOperationLeftOperandAction_1_1_0_0_0(),
                              									current);
                              							
                            }

                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              									if (current==null) {
                              										current = createModelElement(grammarAccess.getXAssignmentRule());
                              									}
                              								
                            }
                            if ( state.backtracking==0 ) {

                              									newCompositeNode(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_0_0_1_0());
                              								
                            }
                            pushFollow(FOLLOW_34);
                            ruleOpMultiAssign();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              									afterParserOrEnumRuleCall();
                              								
                            }

                            }


                            }


                            }


                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getXAssignmentAccess().getRightOperandXAssignmentParserRuleCall_1_1_1_0());
                              						
                            }
                            pushFollow(FOLLOW_2);
                            lv_rightOperand_7_0=ruleXAssignment();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getXAssignmentRule());
                              							}
                              							set(
                              								current,
                              								"rightOperand",
                              								lv_rightOperand_7_0,
                              								"org.eclipse.xtext.xbase.Xbase.XAssignment");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }


                            }
                            break;

                    }


                    }


                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpSingleAssign() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpSingleAssign = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpSingleAssignRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpSingleAssign=ruleOpSingleAssign();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpSingleAssign.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpSingleAssign() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            kw=(Token)match(input,KW_EqualsSign,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              		current.merge(kw);
              		newLeafNode(kw, grammarAccess.getOpSingleAssignAccess().getEqualsSignKeyword());
              	
            }

            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpMultiAssign() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpMultiAssign = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpMultiAssignRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpMultiAssign=ruleOpMultiAssign();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpMultiAssign.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpMultiAssign() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt180=7;
            switch ( input.LA(1) ) {
            case KW_PlusSignEqualsSign:
                {
                alt180=1;
                }
                break;
            case KW_HyphenMinusEqualsSign:
                {
                alt180=2;
                }
                break;
            case KW_AsteriskEqualsSign:
                {
                alt180=3;
                }
                break;
            case KW_SolidusEqualsSign:
                {
                alt180=4;
                }
                break;
            case KW_PercentSignEqualsSign:
                {
                alt180=5;
                }
                break;
            case KW_LessThanSign:
                {
                alt180=6;
                }
                break;
            case KW_GreaterThanSign:
                {
                alt180=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 180, 0, input);

                throw nvae;
            }

            switch (alt180) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_PlusSignEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getPlusSignEqualsSignKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_HyphenMinusEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getHyphenMinusEqualsSignKeyword_1());
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    kw=(Token)match(input,KW_AsteriskEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getAsteriskEqualsSignKeyword_2());
                      		
                    }

                    }
                    break;
                case 4 :
                    {
                    kw=(Token)match(input,KW_SolidusEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getSolidusEqualsSignKeyword_3());
                      		
                    }

                    }
                    break;
                case 5 :
                    {
                    kw=(Token)match(input,KW_PercentSignEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getPercentSignEqualsSignKeyword_4());
                      		
                    }

                    }
                    break;
                case 6 :
                    {
                    {
                    kw=(Token)match(input,KW_LessThanSign,FOLLOW_52); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getLessThanSignKeyword_5_0());
                      			
                    }
                    kw=(Token)match(input,KW_LessThanSign,FOLLOW_78); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getLessThanSignKeyword_5_1());
                      			
                    }
                    kw=(Token)match(input,KW_EqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getEqualsSignKeyword_5_2());
                      			
                    }

                    }


                    }
                    break;
                case 7 :
                    {
                    {
                    kw=(Token)match(input,KW_GreaterThanSign,FOLLOW_83); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getGreaterThanSignKeyword_6_0());
                      			
                    }
                    int alt179=2;
                    int LA179_0 = input.LA(1);

                    if ( (LA179_0==KW_GreaterThanSign) ) {
                        alt179=1;
                    }
                    switch (alt179) {
                        case 1 :
                            {
                            kw=(Token)match(input,KW_GreaterThanSign,FOLLOW_84); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					current.merge(kw);
                              					newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getGreaterThanSignKeyword_6_1());
                              				
                            }

                            }
                            break;

                    }

                    kw=(Token)match(input,KW_GreaterThanSignEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpMultiAssignAccess().getGreaterThanSignEqualsSignKeyword_6_2());
                      			
                    }

                    }


                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXOrExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXOrExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXOrExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXOrExpression=ruleXOrExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXOrExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXOrExpression() throws RecognitionException {
        EObject current = null;

        EObject this_XAndExpression_0 = null;

        EObject lv_rightOperand_3_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXOrExpressionAccess().getXAndExpressionParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_85);
            this_XAndExpression_0=ruleXAndExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XAndExpression_0;
              			afterParserOrEnumRuleCall();
              		
            }
            loop181:
            do {
                int alt181=2;
                int LA181_0 = input.LA(1);

                if ( (LA181_0==KW_VerticalLineVerticalLine) ) {
                    int LA181_2 = input.LA(2);

                    if ( (synpred26_InternalXtend()) ) {
                        alt181=1;
                    }


                }


                switch (alt181) {
            	case 1 :
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							current = forceCreateModelElementAndSet(
            	      								grammarAccess.getXOrExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0(),
            	      								current);
            	      						
            	    }

            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								if (current==null) {
            	      									current = createModelElement(grammarAccess.getXOrExpressionRule());
            	      								}
            	      							
            	    }
            	    if ( state.backtracking==0 ) {

            	      								newCompositeNode(grammarAccess.getXOrExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0());
            	      							
            	    }
            	    pushFollow(FOLLOW_34);
            	    ruleOpOr();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      								afterParserOrEnumRuleCall();
            	      							
            	    }

            	    }


            	    }


            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      						newCompositeNode(grammarAccess.getXOrExpressionAccess().getRightOperandXAndExpressionParserRuleCall_1_1_0());
            	      					
            	    }
            	    pushFollow(FOLLOW_85);
            	    lv_rightOperand_3_0=ruleXAndExpression();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						if (current==null) {
            	      							current = createModelElementForParent(grammarAccess.getXOrExpressionRule());
            	      						}
            	      						set(
            	      							current,
            	      							"rightOperand",
            	      							lv_rightOperand_3_0,
            	      							"org.eclipse.xtext.xbase.Xbase.XAndExpression");
            	      						afterParserOrEnumRuleCall();
            	      					
            	    }

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop181;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpOr() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpOr = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpOrRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpOr=ruleOpOr();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpOr.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpOr() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            kw=(Token)match(input,KW_VerticalLineVerticalLine,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              		current.merge(kw);
              		newLeafNode(kw, grammarAccess.getOpOrAccess().getVerticalLineVerticalLineKeyword());
              	
            }

            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXAndExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXAndExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXAndExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXAndExpression=ruleXAndExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXAndExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXAndExpression() throws RecognitionException {
        EObject current = null;

        EObject this_XEqualityExpression_0 = null;

        EObject lv_rightOperand_3_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXAndExpressionAccess().getXEqualityExpressionParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_86);
            this_XEqualityExpression_0=ruleXEqualityExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XEqualityExpression_0;
              			afterParserOrEnumRuleCall();
              		
            }
            loop182:
            do {
                int alt182=2;
                int LA182_0 = input.LA(1);

                if ( (LA182_0==KW_AmpersandAmpersand) ) {
                    int LA182_2 = input.LA(2);

                    if ( (synpred27_InternalXtend()) ) {
                        alt182=1;
                    }


                }


                switch (alt182) {
            	case 1 :
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							current = forceCreateModelElementAndSet(
            	      								grammarAccess.getXAndExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0(),
            	      								current);
            	      						
            	    }

            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								if (current==null) {
            	      									current = createModelElement(grammarAccess.getXAndExpressionRule());
            	      								}
            	      							
            	    }
            	    if ( state.backtracking==0 ) {

            	      								newCompositeNode(grammarAccess.getXAndExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0());
            	      							
            	    }
            	    pushFollow(FOLLOW_34);
            	    ruleOpAnd();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      								afterParserOrEnumRuleCall();
            	      							
            	    }

            	    }


            	    }


            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      						newCompositeNode(grammarAccess.getXAndExpressionAccess().getRightOperandXEqualityExpressionParserRuleCall_1_1_0());
            	      					
            	    }
            	    pushFollow(FOLLOW_86);
            	    lv_rightOperand_3_0=ruleXEqualityExpression();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						if (current==null) {
            	      							current = createModelElementForParent(grammarAccess.getXAndExpressionRule());
            	      						}
            	      						set(
            	      							current,
            	      							"rightOperand",
            	      							lv_rightOperand_3_0,
            	      							"org.eclipse.xtext.xbase.Xbase.XEqualityExpression");
            	      						afterParserOrEnumRuleCall();
            	      					
            	    }

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop182;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpAnd() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpAnd = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpAndRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpAnd=ruleOpAnd();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpAnd.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpAnd() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            kw=(Token)match(input,KW_AmpersandAmpersand,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              		current.merge(kw);
              		newLeafNode(kw, grammarAccess.getOpAndAccess().getAmpersandAmpersandKeyword());
              	
            }

            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXEqualityExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXEqualityExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXEqualityExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXEqualityExpression=ruleXEqualityExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXEqualityExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXEqualityExpression() throws RecognitionException {
        EObject current = null;

        EObject this_XRelationalExpression_0 = null;

        EObject lv_rightOperand_3_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXEqualityExpressionAccess().getXRelationalExpressionParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_87);
            this_XRelationalExpression_0=ruleXRelationalExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XRelationalExpression_0;
              			afterParserOrEnumRuleCall();
              		
            }
            loop183:
            do {
                int alt183=2;
                switch ( input.LA(1) ) {
                case KW_EqualsSignEqualsSign:
                    {
                    int LA183_2 = input.LA(2);

                    if ( (synpred28_InternalXtend()) ) {
                        alt183=1;
                    }


                    }
                    break;
                case KW_ExclamationMarkEqualsSign:
                    {
                    int LA183_3 = input.LA(2);

                    if ( (synpred28_InternalXtend()) ) {
                        alt183=1;
                    }


                    }
                    break;
                case KW_EqualsSignEqualsSignEqualsSign:
                    {
                    int LA183_4 = input.LA(2);

                    if ( (synpred28_InternalXtend()) ) {
                        alt183=1;
                    }


                    }
                    break;
                case KW_ExclamationMarkEqualsSignEqualsSign:
                    {
                    int LA183_5 = input.LA(2);

                    if ( (synpred28_InternalXtend()) ) {
                        alt183=1;
                    }


                    }
                    break;

                }

                switch (alt183) {
            	case 1 :
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							current = forceCreateModelElementAndSet(
            	      								grammarAccess.getXEqualityExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0(),
            	      								current);
            	      						
            	    }

            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								if (current==null) {
            	      									current = createModelElement(grammarAccess.getXEqualityExpressionRule());
            	      								}
            	      							
            	    }
            	    if ( state.backtracking==0 ) {

            	      								newCompositeNode(grammarAccess.getXEqualityExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0());
            	      							
            	    }
            	    pushFollow(FOLLOW_34);
            	    ruleOpEquality();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      								afterParserOrEnumRuleCall();
            	      							
            	    }

            	    }


            	    }


            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      						newCompositeNode(grammarAccess.getXEqualityExpressionAccess().getRightOperandXRelationalExpressionParserRuleCall_1_1_0());
            	      					
            	    }
            	    pushFollow(FOLLOW_87);
            	    lv_rightOperand_3_0=ruleXRelationalExpression();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						if (current==null) {
            	      							current = createModelElementForParent(grammarAccess.getXEqualityExpressionRule());
            	      						}
            	      						set(
            	      							current,
            	      							"rightOperand",
            	      							lv_rightOperand_3_0,
            	      							"org.eclipse.xtext.xbase.Xbase.XRelationalExpression");
            	      						afterParserOrEnumRuleCall();
            	      					
            	    }

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop183;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpEquality() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpEquality = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpEqualityRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpEquality=ruleOpEquality();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpEquality.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpEquality() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt184=4;
            switch ( input.LA(1) ) {
            case KW_EqualsSignEqualsSign:
                {
                alt184=1;
                }
                break;
            case KW_ExclamationMarkEqualsSign:
                {
                alt184=2;
                }
                break;
            case KW_EqualsSignEqualsSignEqualsSign:
                {
                alt184=3;
                }
                break;
            case KW_ExclamationMarkEqualsSignEqualsSign:
                {
                alt184=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 184, 0, input);

                throw nvae;
            }

            switch (alt184) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_EqualsSignEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpEqualityAccess().getEqualsSignEqualsSignKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_ExclamationMarkEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpEqualityAccess().getExclamationMarkEqualsSignKeyword_1());
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    kw=(Token)match(input,KW_EqualsSignEqualsSignEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpEqualityAccess().getEqualsSignEqualsSignEqualsSignKeyword_2());
                      		
                    }

                    }
                    break;
                case 4 :
                    {
                    kw=(Token)match(input,KW_ExclamationMarkEqualsSignEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpEqualityAccess().getExclamationMarkEqualsSignEqualsSignKeyword_3());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXRelationalExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXRelationalExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXRelationalExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXRelationalExpression=ruleXRelationalExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXRelationalExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXRelationalExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        EObject this_XOtherOperatorExpression_0 = null;

        EObject lv_type_3_0 = null;

        EObject lv_rightOperand_6_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXRelationalExpressionAccess().getXOtherOperatorExpressionParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_88);
            this_XOtherOperatorExpression_0=ruleXOtherOperatorExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XOtherOperatorExpression_0;
              			afterParserOrEnumRuleCall();
              		
            }
            loop185:
            do {
                int alt185=3;
                switch ( input.LA(1) ) {
                case KW_LessThanSign:
                    {
                    int LA185_2 = input.LA(2);

                    if ( (synpred30_InternalXtend()) ) {
                        alt185=2;
                    }


                    }
                    break;
                case KW_GreaterThanSign:
                    {
                    int LA185_3 = input.LA(2);

                    if ( (synpred30_InternalXtend()) ) {
                        alt185=2;
                    }


                    }
                    break;
                case KW_Instanceof:
                    {
                    int LA185_4 = input.LA(2);

                    if ( (synpred29_InternalXtend()) ) {
                        alt185=1;
                    }


                    }
                    break;
                case KW_GreaterThanSignEqualsSign:
                    {
                    int LA185_5 = input.LA(2);

                    if ( (synpred30_InternalXtend()) ) {
                        alt185=2;
                    }


                    }
                    break;

                }

                switch (alt185) {
            	case 1 :
            	    {
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								current = forceCreateModelElementAndSet(
            	      									grammarAccess.getXRelationalExpressionAccess().getXInstanceOfExpressionExpressionAction_1_0_0_0_0(),
            	      									current);
            	      							
            	    }

            	    }

            	    otherlv_2=(Token)match(input,KW_Instanceof,FOLLOW_29); if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      							newLeafNode(otherlv_2, grammarAccess.getXRelationalExpressionAccess().getInstanceofKeyword_1_0_0_0_1());
            	      						
            	    }

            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							newCompositeNode(grammarAccess.getXRelationalExpressionAccess().getTypeJvmTypeReferenceParserRuleCall_1_0_1_0());
            	      						
            	    }
            	    pushFollow(FOLLOW_88);
            	    lv_type_3_0=ruleJvmTypeReference();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      							if (current==null) {
            	      								current = createModelElementForParent(grammarAccess.getXRelationalExpressionRule());
            	      							}
            	      							set(
            	      								current,
            	      								"type",
            	      								lv_type_3_0,
            	      								"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
            	      							afterParserOrEnumRuleCall();
            	      						
            	    }

            	    }


            	    }


            	    }


            	    }
            	    break;
            	case 2 :
            	    {
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								current = forceCreateModelElementAndSet(
            	      									grammarAccess.getXRelationalExpressionAccess().getXBinaryOperationLeftOperandAction_1_1_0_0_0(),
            	      									current);
            	      							
            	    }

            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      									if (current==null) {
            	      										current = createModelElement(grammarAccess.getXRelationalExpressionRule());
            	      									}
            	      								
            	    }
            	    if ( state.backtracking==0 ) {

            	      									newCompositeNode(grammarAccess.getXRelationalExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_0_0_1_0());
            	      								
            	    }
            	    pushFollow(FOLLOW_34);
            	    ruleOpCompare();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      									afterParserOrEnumRuleCall();
            	      								
            	    }

            	    }


            	    }


            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							newCompositeNode(grammarAccess.getXRelationalExpressionAccess().getRightOperandXOtherOperatorExpressionParserRuleCall_1_1_1_0());
            	      						
            	    }
            	    pushFollow(FOLLOW_88);
            	    lv_rightOperand_6_0=ruleXOtherOperatorExpression();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      							if (current==null) {
            	      								current = createModelElementForParent(grammarAccess.getXRelationalExpressionRule());
            	      							}
            	      							set(
            	      								current,
            	      								"rightOperand",
            	      								lv_rightOperand_6_0,
            	      								"org.eclipse.xtext.xbase.Xbase.XOtherOperatorExpression");
            	      							afterParserOrEnumRuleCall();
            	      						
            	    }

            	    }


            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop185;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpCompare() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpCompare = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpCompareRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpCompare=ruleOpCompare();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpCompare.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpCompare() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt186=4;
            switch ( input.LA(1) ) {
            case KW_GreaterThanSignEqualsSign:
                {
                alt186=1;
                }
                break;
            case KW_LessThanSign:
                {
                int LA186_2 = input.LA(2);

                if ( (LA186_2==EOF||LA186_2==KW_Package||(LA186_2>=KW_Class && LA186_2<=KW_LessThanSign)||(LA186_2>=KW_Extends && LA186_2<=KW_LeftCurlyBracket)||(LA186_2>=KW_Interface && LA186_2<=KW_LeftParenthesis)||(LA186_2>=KW_Extension && LA186_2<=KW_New)||(LA186_2>=KW_Public && LA186_2<=KW_Transient)||(LA186_2>=KW_Def && LA186_2<=KW_Create)||(LA186_2>=KW_AFTER && LA186_2<=KW_Import)||LA186_2==KW_Switch||(LA186_2>=KW_NumberSign && LA186_2<=KW_LeftSquareBracket)||(LA186_2>=KW_PlusSign && LA186_2<=KW_HyphenMinus)||LA186_2==KW_ExclamationMark||LA186_2==KW_If||(LA186_2>=KW_For && LA186_2<=KW_Try)||(LA186_2>=RULE_ID && LA186_2<=RULE_RICH_TEXT_START)||(LA186_2>=RULE_HEX && LA186_2<=RULE_DECIMAL)) ) {
                    alt186=4;
                }
                else if ( (LA186_2==KW_EqualsSign) ) {
                    alt186=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 186, 2, input);

                    throw nvae;
                }
                }
                break;
            case KW_GreaterThanSign:
                {
                alt186=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 186, 0, input);

                throw nvae;
            }

            switch (alt186) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_GreaterThanSignEqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpCompareAccess().getGreaterThanSignEqualsSignKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    {
                    kw=(Token)match(input,KW_LessThanSign,FOLLOW_78); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpCompareAccess().getLessThanSignKeyword_1_0());
                      			
                    }
                    kw=(Token)match(input,KW_EqualsSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpCompareAccess().getEqualsSignKeyword_1_1());
                      			
                    }

                    }


                    }
                    break;
                case 3 :
                    {
                    kw=(Token)match(input,KW_GreaterThanSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpCompareAccess().getGreaterThanSignKeyword_2());
                      		
                    }

                    }
                    break;
                case 4 :
                    {
                    kw=(Token)match(input,KW_LessThanSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpCompareAccess().getLessThanSignKeyword_3());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXOtherOperatorExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXOtherOperatorExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXOtherOperatorExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXOtherOperatorExpression=ruleXOtherOperatorExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXOtherOperatorExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXOtherOperatorExpression() throws RecognitionException {
        EObject current = null;

        EObject this_XAdditiveExpression_0 = null;

        EObject lv_rightOperand_3_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXOtherOperatorExpressionAccess().getXAdditiveExpressionParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_89);
            this_XAdditiveExpression_0=ruleXAdditiveExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XAdditiveExpression_0;
              			afterParserOrEnumRuleCall();
              		
            }
            loop187:
            do {
                int alt187=2;
                alt187 = dfa187.predict(input);
                switch (alt187) {
            	case 1 :
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							current = forceCreateModelElementAndSet(
            	      								grammarAccess.getXOtherOperatorExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0(),
            	      								current);
            	      						
            	    }

            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								if (current==null) {
            	      									current = createModelElement(grammarAccess.getXOtherOperatorExpressionRule());
            	      								}
            	      							
            	    }
            	    if ( state.backtracking==0 ) {

            	      								newCompositeNode(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0());
            	      							
            	    }
            	    pushFollow(FOLLOW_34);
            	    ruleOpOther();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      								afterParserOrEnumRuleCall();
            	      							
            	    }

            	    }


            	    }


            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      						newCompositeNode(grammarAccess.getXOtherOperatorExpressionAccess().getRightOperandXAdditiveExpressionParserRuleCall_1_1_0());
            	      					
            	    }
            	    pushFollow(FOLLOW_89);
            	    lv_rightOperand_3_0=ruleXAdditiveExpression();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						if (current==null) {
            	      							current = createModelElementForParent(grammarAccess.getXOtherOperatorExpressionRule());
            	      						}
            	      						set(
            	      							current,
            	      							"rightOperand",
            	      							lv_rightOperand_3_0,
            	      							"org.eclipse.xtext.xbase.Xbase.XAdditiveExpression");
            	      						afterParserOrEnumRuleCall();
            	      					
            	    }

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop187;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpOther() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpOther = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpOtherRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpOther=ruleOpOther();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpOther.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpOther() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt190=9;
            alt190 = dfa190.predict(input);
            switch (alt190) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_HyphenMinusGreaterThanSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpOtherAccess().getHyphenMinusGreaterThanSignKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_FullStopFullStopLessThanSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpOtherAccess().getFullStopFullStopLessThanSignKeyword_1());
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    {
                    kw=(Token)match(input,KW_GreaterThanSign,FOLLOW_90); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_2_0());
                      			
                    }
                    kw=(Token)match(input,KW_FullStopFullStop,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpOtherAccess().getFullStopFullStopKeyword_2_1());
                      			
                    }

                    }


                    }
                    break;
                case 4 :
                    {
                    kw=(Token)match(input,KW_FullStopFullStop,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpOtherAccess().getFullStopFullStopKeyword_3());
                      		
                    }

                    }
                    break;
                case 5 :
                    {
                    kw=(Token)match(input,KW_EqualsSignGreaterThanSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpOtherAccess().getEqualsSignGreaterThanSignKeyword_4());
                      		
                    }

                    }
                    break;
                case 6 :
                    {
                    {
                    kw=(Token)match(input,KW_GreaterThanSign,FOLLOW_91); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_0());
                      			
                    }
                    int alt188=2;
                    int LA188_0 = input.LA(1);

                    if ( (LA188_0==KW_GreaterThanSign) ) {
                        int LA188_1 = input.LA(2);

                        if ( (LA188_1==EOF||LA188_1==KW_Package||(LA188_1>=KW_Class && LA188_1<=KW_LessThanSign)||(LA188_1>=KW_Extends && LA188_1<=KW_LeftCurlyBracket)||(LA188_1>=KW_Interface && LA188_1<=KW_LeftParenthesis)||(LA188_1>=KW_Extension && LA188_1<=KW_New)||(LA188_1>=KW_Public && LA188_1<=KW_Transient)||(LA188_1>=KW_Def && LA188_1<=KW_Create)||(LA188_1>=KW_AFTER && LA188_1<=KW_Import)||LA188_1==KW_Switch||(LA188_1>=KW_NumberSign && LA188_1<=KW_LeftSquareBracket)||(LA188_1>=KW_PlusSign && LA188_1<=KW_HyphenMinus)||LA188_1==KW_ExclamationMark||LA188_1==KW_If||(LA188_1>=KW_For && LA188_1<=KW_Try)||(LA188_1>=RULE_ID && LA188_1<=RULE_RICH_TEXT_START)||(LA188_1>=RULE_HEX && LA188_1<=RULE_DECIMAL)) ) {
                            alt188=2;
                        }
                        else if ( (LA188_1==KW_GreaterThanSign) && (synpred32_InternalXtend())) {
                            alt188=1;
                        }
                        else {
                            if (state.backtracking>0) {state.failed=true; return current;}
                            NoViableAltException nvae =
                                new NoViableAltException("", 188, 1, input);

                            throw nvae;
                        }
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 188, 0, input);

                        throw nvae;
                    }
                    switch (alt188) {
                        case 1 :
                            {
                            {
                            {
                            kw=(Token)match(input,KW_GreaterThanSign,FOLLOW_91); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							current.merge(kw);
                              							newLeafNode(kw, grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_0_0_0());
                              						
                            }
                            kw=(Token)match(input,KW_GreaterThanSign,FOLLOW_2); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							current.merge(kw);
                              							newLeafNode(kw, grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_0_0_1());
                              						
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            kw=(Token)match(input,KW_GreaterThanSign,FOLLOW_2); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					current.merge(kw);
                              					newLeafNode(kw, grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_1());
                              				
                            }

                            }
                            break;

                    }


                    }


                    }
                    break;
                case 7 :
                    {
                    {
                    kw=(Token)match(input,KW_LessThanSign,FOLLOW_92); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_0());
                      			
                    }
                    int alt189=3;
                    int LA189_0 = input.LA(1);

                    if ( (LA189_0==KW_LessThanSign) ) {
                        int LA189_1 = input.LA(2);

                        if ( (synpred33_InternalXtend()) ) {
                            alt189=1;
                        }
                        else if ( (true) ) {
                            alt189=2;
                        }
                        else {
                            if (state.backtracking>0) {state.failed=true; return current;}
                            NoViableAltException nvae =
                                new NoViableAltException("", 189, 1, input);

                            throw nvae;
                        }
                    }
                    else if ( (LA189_0==KW_EqualsSignGreaterThanSign) ) {
                        alt189=3;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 189, 0, input);

                        throw nvae;
                    }
                    switch (alt189) {
                        case 1 :
                            {
                            {
                            {
                            kw=(Token)match(input,KW_LessThanSign,FOLLOW_52); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							current.merge(kw);
                              							newLeafNode(kw, grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_0_0_0());
                              						
                            }
                            kw=(Token)match(input,KW_LessThanSign,FOLLOW_2); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							current.merge(kw);
                              							newLeafNode(kw, grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_0_0_1());
                              						
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            kw=(Token)match(input,KW_LessThanSign,FOLLOW_2); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					current.merge(kw);
                              					newLeafNode(kw, grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_1());
                              				
                            }

                            }
                            break;
                        case 3 :
                            {
                            kw=(Token)match(input,KW_EqualsSignGreaterThanSign,FOLLOW_2); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					current.merge(kw);
                              					newLeafNode(kw, grammarAccess.getOpOtherAccess().getEqualsSignGreaterThanSignKeyword_6_1_2());
                              				
                            }

                            }
                            break;

                    }


                    }


                    }
                    break;
                case 8 :
                    {
                    kw=(Token)match(input,KW_LessThanSignGreaterThanSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpOtherAccess().getLessThanSignGreaterThanSignKeyword_7());
                      		
                    }

                    }
                    break;
                case 9 :
                    {
                    kw=(Token)match(input,KW_QuestionMarkColon,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpOtherAccess().getQuestionMarkColonKeyword_8());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXAdditiveExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXAdditiveExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXAdditiveExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXAdditiveExpression=ruleXAdditiveExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXAdditiveExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXAdditiveExpression() throws RecognitionException {
        EObject current = null;

        EObject this_XMultiplicativeExpression_0 = null;

        EObject lv_rightOperand_3_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXAdditiveExpressionAccess().getXMultiplicativeExpressionParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_93);
            this_XMultiplicativeExpression_0=ruleXMultiplicativeExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XMultiplicativeExpression_0;
              			afterParserOrEnumRuleCall();
              		
            }
            loop191:
            do {
                int alt191=2;
                int LA191_0 = input.LA(1);

                if ( (LA191_0==KW_HyphenMinus) ) {
                    int LA191_2 = input.LA(2);

                    if ( (synpred34_InternalXtend()) ) {
                        alt191=1;
                    }


                }
                else if ( (LA191_0==KW_PlusSign) ) {
                    int LA191_3 = input.LA(2);

                    if ( (synpred34_InternalXtend()) ) {
                        alt191=1;
                    }


                }


                switch (alt191) {
            	case 1 :
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							current = forceCreateModelElementAndSet(
            	      								grammarAccess.getXAdditiveExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0(),
            	      								current);
            	      						
            	    }

            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								if (current==null) {
            	      									current = createModelElement(grammarAccess.getXAdditiveExpressionRule());
            	      								}
            	      							
            	    }
            	    if ( state.backtracking==0 ) {

            	      								newCompositeNode(grammarAccess.getXAdditiveExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0());
            	      							
            	    }
            	    pushFollow(FOLLOW_34);
            	    ruleOpAdd();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      								afterParserOrEnumRuleCall();
            	      							
            	    }

            	    }


            	    }


            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      						newCompositeNode(grammarAccess.getXAdditiveExpressionAccess().getRightOperandXMultiplicativeExpressionParserRuleCall_1_1_0());
            	      					
            	    }
            	    pushFollow(FOLLOW_93);
            	    lv_rightOperand_3_0=ruleXMultiplicativeExpression();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						if (current==null) {
            	      							current = createModelElementForParent(grammarAccess.getXAdditiveExpressionRule());
            	      						}
            	      						set(
            	      							current,
            	      							"rightOperand",
            	      							lv_rightOperand_3_0,
            	      							"org.eclipse.xtext.xbase.Xbase.XMultiplicativeExpression");
            	      						afterParserOrEnumRuleCall();
            	      					
            	    }

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop191;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpAdd() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpAdd = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpAddRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpAdd=ruleOpAdd();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpAdd.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpAdd() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt192=2;
            int LA192_0 = input.LA(1);

            if ( (LA192_0==KW_PlusSign) ) {
                alt192=1;
            }
            else if ( (LA192_0==KW_HyphenMinus) ) {
                alt192=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 192, 0, input);

                throw nvae;
            }
            switch (alt192) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_PlusSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpAddAccess().getPlusSignKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_HyphenMinus,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpAddAccess().getHyphenMinusKeyword_1());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXMultiplicativeExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXMultiplicativeExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXMultiplicativeExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXMultiplicativeExpression=ruleXMultiplicativeExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXMultiplicativeExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXMultiplicativeExpression() throws RecognitionException {
        EObject current = null;

        EObject this_XUnaryOperation_0 = null;

        EObject lv_rightOperand_3_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXMultiplicativeExpressionAccess().getXUnaryOperationParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_94);
            this_XUnaryOperation_0=ruleXUnaryOperation();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XUnaryOperation_0;
              			afterParserOrEnumRuleCall();
              		
            }
            loop193:
            do {
                int alt193=2;
                switch ( input.LA(1) ) {
                case KW_Asterisk:
                    {
                    int LA193_2 = input.LA(2);

                    if ( (synpred35_InternalXtend()) ) {
                        alt193=1;
                    }


                    }
                    break;
                case KW_AsteriskAsterisk:
                    {
                    int LA193_3 = input.LA(2);

                    if ( (synpred35_InternalXtend()) ) {
                        alt193=1;
                    }


                    }
                    break;
                case KW_Solidus:
                    {
                    int LA193_4 = input.LA(2);

                    if ( (synpred35_InternalXtend()) ) {
                        alt193=1;
                    }


                    }
                    break;
                case KW_PercentSign:
                    {
                    int LA193_5 = input.LA(2);

                    if ( (synpred35_InternalXtend()) ) {
                        alt193=1;
                    }


                    }
                    break;

                }

                switch (alt193) {
            	case 1 :
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							current = forceCreateModelElementAndSet(
            	      								grammarAccess.getXMultiplicativeExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0(),
            	      								current);
            	      						
            	    }

            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								if (current==null) {
            	      									current = createModelElement(grammarAccess.getXMultiplicativeExpressionRule());
            	      								}
            	      							
            	    }
            	    if ( state.backtracking==0 ) {

            	      								newCompositeNode(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0());
            	      							
            	    }
            	    pushFollow(FOLLOW_34);
            	    ruleOpMulti();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      								afterParserOrEnumRuleCall();
            	      							
            	    }

            	    }


            	    }


            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      						newCompositeNode(grammarAccess.getXMultiplicativeExpressionAccess().getRightOperandXUnaryOperationParserRuleCall_1_1_0());
            	      					
            	    }
            	    pushFollow(FOLLOW_94);
            	    lv_rightOperand_3_0=ruleXUnaryOperation();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						if (current==null) {
            	      							current = createModelElementForParent(grammarAccess.getXMultiplicativeExpressionRule());
            	      						}
            	      						set(
            	      							current,
            	      							"rightOperand",
            	      							lv_rightOperand_3_0,
            	      							"org.eclipse.xtext.xbase.Xbase.XUnaryOperation");
            	      						afterParserOrEnumRuleCall();
            	      					
            	    }

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop193;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpMulti() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpMulti = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpMultiRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpMulti=ruleOpMulti();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpMulti.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpMulti() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt194=4;
            switch ( input.LA(1) ) {
            case KW_Asterisk:
                {
                alt194=1;
                }
                break;
            case KW_AsteriskAsterisk:
                {
                alt194=2;
                }
                break;
            case KW_Solidus:
                {
                alt194=3;
                }
                break;
            case KW_PercentSign:
                {
                alt194=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 194, 0, input);

                throw nvae;
            }

            switch (alt194) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_Asterisk,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpMultiAccess().getAsteriskKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_AsteriskAsterisk,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpMultiAccess().getAsteriskAsteriskKeyword_1());
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    kw=(Token)match(input,KW_Solidus,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpMultiAccess().getSolidusKeyword_2());
                      		
                    }

                    }
                    break;
                case 4 :
                    {
                    kw=(Token)match(input,KW_PercentSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpMultiAccess().getPercentSignKeyword_3());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXUnaryOperation() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXUnaryOperation = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXUnaryOperationRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXUnaryOperation=ruleXUnaryOperation();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXUnaryOperation; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXUnaryOperation() throws RecognitionException {
        EObject current = null;

        EObject lv_operand_2_0 = null;

        EObject this_XCastedExpression_3 = null;



        	enterRule();

        try {
            {
            int alt195=2;
            int LA195_0 = input.LA(1);

            if ( ((LA195_0>=KW_PlusSign && LA195_0<=KW_HyphenMinus)||LA195_0==KW_ExclamationMark) ) {
                alt195=1;
            }
            else if ( (LA195_0==KW_Package||(LA195_0>=KW_Class && LA195_0<=KW_LessThanSign)||(LA195_0>=KW_Extends && LA195_0<=KW_LeftCurlyBracket)||(LA195_0>=KW_Interface && LA195_0<=KW_LeftParenthesis)||(LA195_0>=KW_Extension && LA195_0<=KW_New)||(LA195_0>=KW_Public && LA195_0<=KW_Transient)||(LA195_0>=KW_Def && LA195_0<=KW_Create)||(LA195_0>=KW_AFTER && LA195_0<=KW_Import)||LA195_0==KW_Switch||(LA195_0>=KW_NumberSign && LA195_0<=KW_LeftSquareBracket)||LA195_0==KW_If||(LA195_0>=KW_For && LA195_0<=KW_Try)||(LA195_0>=RULE_ID && LA195_0<=RULE_RICH_TEXT_START)||(LA195_0>=RULE_HEX && LA195_0<=RULE_DECIMAL)) ) {
                alt195=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 195, 0, input);

                throw nvae;
            }
            switch (alt195) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      					current = forceCreateModelElement(
                      						grammarAccess.getXUnaryOperationAccess().getXUnaryOperationAction_0_0(),
                      						current);
                      				
                    }

                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getXUnaryOperationRule());
                      						}
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXUnaryOperationAccess().getFeatureJvmIdentifiableElementCrossReference_0_1_0());
                      					
                    }
                    pushFollow(FOLLOW_34);
                    ruleOpUnary();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXUnaryOperationAccess().getOperandXUnaryOperationParserRuleCall_0_2_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_operand_2_0=ruleXUnaryOperation();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXUnaryOperationRule());
                      						}
                      						set(
                      							current,
                      							"operand",
                      							lv_operand_2_0,
                      							"org.eclipse.xtext.xbase.Xbase.XUnaryOperation");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXUnaryOperationAccess().getXCastedExpressionParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XCastedExpression_3=ruleXCastedExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XCastedExpression_3;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpUnary() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpUnary = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpUnaryRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpUnary=ruleOpUnary();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpUnary.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpUnary() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt196=3;
            switch ( input.LA(1) ) {
            case KW_ExclamationMark:
                {
                alt196=1;
                }
                break;
            case KW_HyphenMinus:
                {
                alt196=2;
                }
                break;
            case KW_PlusSign:
                {
                alt196=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 196, 0, input);

                throw nvae;
            }

            switch (alt196) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_ExclamationMark,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpUnaryAccess().getExclamationMarkKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_HyphenMinus,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpUnaryAccess().getHyphenMinusKeyword_1());
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    kw=(Token)match(input,KW_PlusSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpUnaryAccess().getPlusSignKeyword_2());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXCastedExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXCastedExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXCastedExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXCastedExpression=ruleXCastedExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXCastedExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXCastedExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        EObject this_XPostfixOperation_0 = null;

        EObject lv_type_3_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXCastedExpressionAccess().getXPostfixOperationParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_95);
            this_XPostfixOperation_0=ruleXPostfixOperation();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XPostfixOperation_0;
              			afterParserOrEnumRuleCall();
              		
            }
            loop197:
            do {
                int alt197=2;
                int LA197_0 = input.LA(1);

                if ( (LA197_0==KW_As) ) {
                    int LA197_2 = input.LA(2);

                    if ( (synpred36_InternalXtend()) ) {
                        alt197=1;
                    }


                }


                switch (alt197) {
            	case 1 :
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							current = forceCreateModelElementAndSet(
            	      								grammarAccess.getXCastedExpressionAccess().getXCastedExpressionTargetAction_1_0_0_0(),
            	      								current);
            	      						
            	    }

            	    }

            	    otherlv_2=(Token)match(input,KW_As,FOLLOW_29); if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						newLeafNode(otherlv_2, grammarAccess.getXCastedExpressionAccess().getAsKeyword_1_0_0_1());
            	      					
            	    }

            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      						newCompositeNode(grammarAccess.getXCastedExpressionAccess().getTypeJvmTypeReferenceParserRuleCall_1_1_0());
            	      					
            	    }
            	    pushFollow(FOLLOW_95);
            	    lv_type_3_0=ruleJvmTypeReference();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						if (current==null) {
            	      							current = createModelElementForParent(grammarAccess.getXCastedExpressionRule());
            	      						}
            	      						set(
            	      							current,
            	      							"type",
            	      							lv_type_3_0,
            	      							"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
            	      						afterParserOrEnumRuleCall();
            	      					
            	    }

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop197;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXPostfixOperation() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXPostfixOperation = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXPostfixOperationRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXPostfixOperation=ruleXPostfixOperation();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXPostfixOperation; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXPostfixOperation() throws RecognitionException {
        EObject current = null;

        EObject this_XMemberFeatureCall_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXPostfixOperationAccess().getXMemberFeatureCallParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_96);
            this_XMemberFeatureCall_0=ruleXMemberFeatureCall();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XMemberFeatureCall_0;
              			afterParserOrEnumRuleCall();
              		
            }
            int alt198=2;
            int LA198_0 = input.LA(1);

            if ( (LA198_0==KW_PlusSignPlusSign) ) {
                int LA198_1 = input.LA(2);

                if ( (synpred37_InternalXtend()) ) {
                    alt198=1;
                }
            }
            else if ( (LA198_0==KW_HyphenMinusHyphenMinus) ) {
                int LA198_2 = input.LA(2);

                if ( (synpred37_InternalXtend()) ) {
                    alt198=1;
                }
            }
            switch (alt198) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						current = forceCreateModelElementAndSet(
                      							grammarAccess.getXPostfixOperationAccess().getXPostfixOperationOperandAction_1_0_0(),
                      							current);
                      					
                    }

                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getXPostfixOperationRule());
                      							}
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getXPostfixOperationAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_1_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    ruleOpPostfix();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleOpPostfix() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleOpPostfix = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getOpPostfixRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleOpPostfix=ruleOpPostfix();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleOpPostfix.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleOpPostfix() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            int alt199=2;
            int LA199_0 = input.LA(1);

            if ( (LA199_0==KW_PlusSignPlusSign) ) {
                alt199=1;
            }
            else if ( (LA199_0==KW_HyphenMinusHyphenMinus) ) {
                alt199=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 199, 0, input);

                throw nvae;
            }
            switch (alt199) {
                case 1 :
                    {
                    kw=(Token)match(input,KW_PlusSignPlusSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpPostfixAccess().getPlusSignPlusSignKeyword_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_HyphenMinusHyphenMinus,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getOpPostfixAccess().getHyphenMinusHyphenMinusKeyword_1());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXMemberFeatureCall() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXMemberFeatureCall = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXMemberFeatureCallRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXMemberFeatureCall=ruleXMemberFeatureCall();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXMemberFeatureCall; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXMemberFeatureCall() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token lv_explicitStatic_3_0=null;
        Token otherlv_8=null;
        Token lv_nullSafe_9_0=null;
        Token lv_explicitStatic_10_0=null;
        Token otherlv_11=null;
        Token otherlv_13=null;
        Token otherlv_15=null;
        Token lv_explicitOperationCall_17_0=null;
        Token otherlv_20=null;
        Token otherlv_22=null;
        EObject this_XPrimaryExpression_0 = null;

        EObject lv_value_6_0 = null;

        EObject lv_typeArguments_12_0 = null;

        EObject lv_typeArguments_14_0 = null;

        EObject lv_memberCallArguments_18_0 = null;

        EObject lv_memberCallArguments_19_0 = null;

        EObject lv_memberCallArguments_21_0 = null;

        EObject lv_memberCallArguments_23_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getXPrimaryExpressionParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_97);
            this_XPrimaryExpression_0=ruleXPrimaryExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XPrimaryExpression_0;
              			afterParserOrEnumRuleCall();
              		
            }
            loop208:
            do {
                int alt208=3;
                switch ( input.LA(1) ) {
                case KW_FullStop:
                    {
                    int LA208_2 = input.LA(2);

                    if ( (synpred38_InternalXtend()) ) {
                        alt208=1;
                    }
                    else if ( (synpred39_InternalXtend()) ) {
                        alt208=2;
                    }


                    }
                    break;
                case KW_ColonColon:
                    {
                    int LA208_3 = input.LA(2);

                    if ( (synpred38_InternalXtend()) ) {
                        alt208=1;
                    }
                    else if ( (synpred39_InternalXtend()) ) {
                        alt208=2;
                    }


                    }
                    break;
                case KW_QuestionMarkFullStop:
                    {
                    int LA208_4 = input.LA(2);

                    if ( (synpred39_InternalXtend()) ) {
                        alt208=2;
                    }


                    }
                    break;

                }

                switch (alt208) {
            	case 1 :
            	    {
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								current = forceCreateModelElementAndSet(
            	      									grammarAccess.getXMemberFeatureCallAccess().getXAssignmentAssignableAction_1_0_0_0_0(),
            	      									current);
            	      							
            	    }

            	    }
            	    int alt200=2;
            	    int LA200_0 = input.LA(1);

            	    if ( (LA200_0==KW_FullStop) ) {
            	        alt200=1;
            	    }
            	    else if ( (LA200_0==KW_ColonColon) ) {
            	        alt200=2;
            	    }
            	    else {
            	        if (state.backtracking>0) {state.failed=true; return current;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 200, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt200) {
            	        case 1 :
            	            {
            	            otherlv_2=(Token)match(input,KW_FullStop,FOLLOW_98); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              								newLeafNode(otherlv_2, grammarAccess.getXMemberFeatureCallAccess().getFullStopKeyword_1_0_0_0_1_0());
            	              							
            	            }

            	            }
            	            break;
            	        case 2 :
            	            {
            	            {
            	            {
            	            lv_explicitStatic_3_0=(Token)match(input,KW_ColonColon,FOLLOW_98); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              										newLeafNode(lv_explicitStatic_3_0, grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_0_0_0_1_1_0());
            	              									
            	            }
            	            if ( state.backtracking==0 ) {

            	              										if (current==null) {
            	              											current = createModelElement(grammarAccess.getXMemberFeatureCallRule());
            	              										}
            	              										setWithLastConsumed(current, "explicitStatic", true, "::");
            	              									
            	            }

            	            }


            	            }


            	            }
            	            break;

            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      									if (current==null) {
            	      										current = createModelElement(grammarAccess.getXMemberFeatureCallRule());
            	      									}
            	      								
            	    }
            	    if ( state.backtracking==0 ) {

            	      									newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_0_2_0());
            	      								
            	    }
            	    pushFollow(FOLLOW_78);
            	    ruleFeatureCallID();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      									afterParserOrEnumRuleCall();
            	      								
            	    }

            	    }


            	    }

            	    if ( state.backtracking==0 ) {

            	      							newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getOpSingleAssignParserRuleCall_1_0_0_0_3());
            	      						
            	    }
            	    pushFollow(FOLLOW_34);
            	    ruleOpSingleAssign();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      							afterParserOrEnumRuleCall();
            	      						
            	    }

            	    }


            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getValueXAssignmentParserRuleCall_1_0_1_0());
            	      						
            	    }
            	    pushFollow(FOLLOW_97);
            	    lv_value_6_0=ruleXAssignment();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      							if (current==null) {
            	      								current = createModelElementForParent(grammarAccess.getXMemberFeatureCallRule());
            	      							}
            	      							set(
            	      								current,
            	      								"value",
            	      								lv_value_6_0,
            	      								"org.eclipse.xtext.xbase.Xbase.XAssignment");
            	      							afterParserOrEnumRuleCall();
            	      						
            	    }

            	    }


            	    }


            	    }


            	    }
            	    break;
            	case 2 :
            	    {
            	    {
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      								current = forceCreateModelElementAndSet(
            	      									grammarAccess.getXMemberFeatureCallAccess().getXMemberFeatureCallMemberCallTargetAction_1_1_0_0_0(),
            	      									current);
            	      							
            	    }

            	    }
            	    int alt201=3;
            	    switch ( input.LA(1) ) {
            	    case KW_FullStop:
            	        {
            	        alt201=1;
            	        }
            	        break;
            	    case KW_QuestionMarkFullStop:
            	        {
            	        alt201=2;
            	        }
            	        break;
            	    case KW_ColonColon:
            	        {
            	        alt201=3;
            	        }
            	        break;
            	    default:
            	        if (state.backtracking>0) {state.failed=true; return current;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 201, 0, input);

            	        throw nvae;
            	    }

            	    switch (alt201) {
            	        case 1 :
            	            {
            	            otherlv_8=(Token)match(input,KW_FullStop,FOLLOW_99); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              								newLeafNode(otherlv_8, grammarAccess.getXMemberFeatureCallAccess().getFullStopKeyword_1_1_0_0_1_0());
            	              							
            	            }

            	            }
            	            break;
            	        case 2 :
            	            {
            	            {
            	            {
            	            lv_nullSafe_9_0=(Token)match(input,KW_QuestionMarkFullStop,FOLLOW_99); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              										newLeafNode(lv_nullSafe_9_0, grammarAccess.getXMemberFeatureCallAccess().getNullSafeQuestionMarkFullStopKeyword_1_1_0_0_1_1_0());
            	              									
            	            }
            	            if ( state.backtracking==0 ) {

            	              										if (current==null) {
            	              											current = createModelElement(grammarAccess.getXMemberFeatureCallRule());
            	              										}
            	              										setWithLastConsumed(current, "nullSafe", true, "?.");
            	              									
            	            }

            	            }


            	            }


            	            }
            	            break;
            	        case 3 :
            	            {
            	            {
            	            {
            	            lv_explicitStatic_10_0=(Token)match(input,KW_ColonColon,FOLLOW_99); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              										newLeafNode(lv_explicitStatic_10_0, grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_1_0_0_1_2_0());
            	              									
            	            }
            	            if ( state.backtracking==0 ) {

            	              										if (current==null) {
            	              											current = createModelElement(grammarAccess.getXMemberFeatureCallRule());
            	              										}
            	              										setWithLastConsumed(current, "explicitStatic", true, "::");
            	              									
            	            }

            	            }


            	            }


            	            }
            	            break;

            	    }


            	    }


            	    }
            	    int alt203=2;
            	    int LA203_0 = input.LA(1);

            	    if ( (LA203_0==KW_LessThanSign) ) {
            	        alt203=1;
            	    }
            	    switch (alt203) {
            	        case 1 :
            	            {
            	            otherlv_11=(Token)match(input,KW_LessThanSign,FOLLOW_53); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              						newLeafNode(otherlv_11, grammarAccess.getXMemberFeatureCallAccess().getLessThanSignKeyword_1_1_1_0());
            	              					
            	            }
            	            {
            	            {
            	            if ( state.backtracking==0 ) {

            	              								newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_1_1_0());
            	              							
            	            }
            	            pushFollow(FOLLOW_10);
            	            lv_typeArguments_12_0=ruleJvmArgumentTypeReference();

            	            state._fsp--;
            	            if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              								if (current==null) {
            	              									current = createModelElementForParent(grammarAccess.getXMemberFeatureCallRule());
            	              								}
            	              								add(
            	              									current,
            	              									"typeArguments",
            	              									lv_typeArguments_12_0,
            	              									"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
            	              								afterParserOrEnumRuleCall();
            	              							
            	            }

            	            }


            	            }
            	            loop202:
            	            do {
            	                int alt202=2;
            	                int LA202_0 = input.LA(1);

            	                if ( (LA202_0==KW_Comma) ) {
            	                    alt202=1;
            	                }


            	                switch (alt202) {
            	            	case 1 :
            	            	    {
            	            	    otherlv_13=(Token)match(input,KW_Comma,FOLLOW_53); if (state.failed) return current;
            	            	    if ( state.backtracking==0 ) {

            	            	      							newLeafNode(otherlv_13, grammarAccess.getXMemberFeatureCallAccess().getCommaKeyword_1_1_1_2_0());
            	            	      						
            	            	    }
            	            	    {
            	            	    {
            	            	    if ( state.backtracking==0 ) {

            	            	      									newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_1_2_1_0());
            	            	      								
            	            	    }
            	            	    pushFollow(FOLLOW_10);
            	            	    lv_typeArguments_14_0=ruleJvmArgumentTypeReference();

            	            	    state._fsp--;
            	            	    if (state.failed) return current;
            	            	    if ( state.backtracking==0 ) {

            	            	      									if (current==null) {
            	            	      										current = createModelElementForParent(grammarAccess.getXMemberFeatureCallRule());
            	            	      									}
            	            	      									add(
            	            	      										current,
            	            	      										"typeArguments",
            	            	      										lv_typeArguments_14_0,
            	            	      										"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
            	            	      									afterParserOrEnumRuleCall();
            	            	      								
            	            	    }

            	            	    }


            	            	    }


            	            	    }
            	            	    break;

            	            	default :
            	            	    break loop202;
            	                }
            	            } while (true);

            	            otherlv_15=(Token)match(input,KW_GreaterThanSign,FOLLOW_99); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              						newLeafNode(otherlv_15, grammarAccess.getXMemberFeatureCallAccess().getGreaterThanSignKeyword_1_1_1_3());
            	              					
            	            }

            	            }
            	            break;

            	    }
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      							if (current==null) {
            	      								current = createModelElement(grammarAccess.getXMemberFeatureCallRule());
            	      							}
            	      						
            	    }
            	    if ( state.backtracking==0 ) {

            	      							newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_2_0());
            	      						
            	    }
            	    pushFollow(FOLLOW_100);
            	    ruleIdOrSuper();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      							afterParserOrEnumRuleCall();
            	      						
            	    }

            	    }


            	    }
            	    int alt206=2;
            	    alt206 = dfa206.predict(input);
            	    switch (alt206) {
            	        case 1 :
            	            {
            	            {
            	            {
            	            lv_explicitOperationCall_17_0=(Token)match(input,KW_LeftParenthesis,FOLLOW_65); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              								newLeafNode(lv_explicitOperationCall_17_0, grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_1_1_3_0_0());
            	              							
            	            }
            	            if ( state.backtracking==0 ) {

            	              								if (current==null) {
            	              									current = createModelElement(grammarAccess.getXMemberFeatureCallRule());
            	              								}
            	              								setWithLastConsumed(current, "explicitOperationCall", true, "(");
            	              							
            	            }

            	            }


            	            }
            	            int alt205=3;
            	            alt205 = dfa205.predict(input);
            	            switch (alt205) {
            	                case 1 :
            	                    {
            	                    {
            	                    {
            	                    if ( state.backtracking==0 ) {

            	                      									newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXShortClosureParserRuleCall_1_1_3_1_0_0());
            	                      								
            	                    }
            	                    pushFollow(FOLLOW_66);
            	                    lv_memberCallArguments_18_0=ruleXShortClosure();

            	                    state._fsp--;
            	                    if (state.failed) return current;
            	                    if ( state.backtracking==0 ) {

            	                      									if (current==null) {
            	                      										current = createModelElementForParent(grammarAccess.getXMemberFeatureCallRule());
            	                      									}
            	                      									add(
            	                      										current,
            	                      										"memberCallArguments",
            	                      										lv_memberCallArguments_18_0,
            	                      										"org.eclipse.xtext.xbase.Xbase.XShortClosure");
            	                      									afterParserOrEnumRuleCall();
            	                      								
            	                    }

            	                    }


            	                    }


            	                    }
            	                    break;
            	                case 2 :
            	                    {
            	                    {
            	                    {
            	                    {
            	                    if ( state.backtracking==0 ) {

            	                      										newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXExpressionParserRuleCall_1_1_3_1_1_0_0());
            	                      									
            	                    }
            	                    pushFollow(FOLLOW_28);
            	                    lv_memberCallArguments_19_0=ruleXExpression();

            	                    state._fsp--;
            	                    if (state.failed) return current;
            	                    if ( state.backtracking==0 ) {

            	                      										if (current==null) {
            	                      											current = createModelElementForParent(grammarAccess.getXMemberFeatureCallRule());
            	                      										}
            	                      										add(
            	                      											current,
            	                      											"memberCallArguments",
            	                      											lv_memberCallArguments_19_0,
            	                      											"org.eclipse.xtext.xbase.Xbase.XExpression");
            	                      										afterParserOrEnumRuleCall();
            	                      									
            	                    }

            	                    }


            	                    }
            	                    loop204:
            	                    do {
            	                        int alt204=2;
            	                        int LA204_0 = input.LA(1);

            	                        if ( (LA204_0==KW_Comma) ) {
            	                            alt204=1;
            	                        }


            	                        switch (alt204) {
            	                    	case 1 :
            	                    	    {
            	                    	    otherlv_20=(Token)match(input,KW_Comma,FOLLOW_34); if (state.failed) return current;
            	                    	    if ( state.backtracking==0 ) {

            	                    	      									newLeafNode(otherlv_20, grammarAccess.getXMemberFeatureCallAccess().getCommaKeyword_1_1_3_1_1_1_0());
            	                    	      								
            	                    	    }
            	                    	    {
            	                    	    {
            	                    	    if ( state.backtracking==0 ) {

            	                    	      											newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXExpressionParserRuleCall_1_1_3_1_1_1_1_0());
            	                    	      										
            	                    	    }
            	                    	    pushFollow(FOLLOW_28);
            	                    	    lv_memberCallArguments_21_0=ruleXExpression();

            	                    	    state._fsp--;
            	                    	    if (state.failed) return current;
            	                    	    if ( state.backtracking==0 ) {

            	                    	      											if (current==null) {
            	                    	      												current = createModelElementForParent(grammarAccess.getXMemberFeatureCallRule());
            	                    	      											}
            	                    	      											add(
            	                    	      												current,
            	                    	      												"memberCallArguments",
            	                    	      												lv_memberCallArguments_21_0,
            	                    	      												"org.eclipse.xtext.xbase.Xbase.XExpression");
            	                    	      											afterParserOrEnumRuleCall();
            	                    	      										
            	                    	    }

            	                    	    }


            	                    	    }


            	                    	    }
            	                    	    break;

            	                    	default :
            	                    	    break loop204;
            	                        }
            	                    } while (true);


            	                    }


            	                    }
            	                    break;

            	            }

            	            otherlv_22=(Token)match(input,KW_RightParenthesis,FOLLOW_101); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              						newLeafNode(otherlv_22, grammarAccess.getXMemberFeatureCallAccess().getRightParenthesisKeyword_1_1_3_2());
            	              					
            	            }

            	            }
            	            break;

            	    }
            	    int alt207=2;
            	    alt207 = dfa207.predict(input);
            	    switch (alt207) {
            	        case 1 :
            	            {
            	            {
            	            if ( state.backtracking==0 ) {

            	              							newCompositeNode(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXClosureParserRuleCall_1_1_4_0());
            	              						
            	            }
            	            pushFollow(FOLLOW_97);
            	            lv_memberCallArguments_23_0=ruleXClosure();

            	            state._fsp--;
            	            if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              							if (current==null) {
            	              								current = createModelElementForParent(grammarAccess.getXMemberFeatureCallRule());
            	              							}
            	              							add(
            	              								current,
            	              								"memberCallArguments",
            	              								lv_memberCallArguments_23_0,
            	              								"org.eclipse.xtext.xbase.Xbase.XClosure");
            	              							afterParserOrEnumRuleCall();
            	              						
            	            }

            	            }


            	            }
            	            break;

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop208;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXPrimaryExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXPrimaryExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXPrimaryExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXPrimaryExpression=ruleXPrimaryExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXPrimaryExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXPrimaryExpression() throws RecognitionException {
        EObject current = null;

        EObject this_XConstructorCall_0 = null;

        EObject this_XBlockExpression_1 = null;

        EObject this_XSwitchExpression_2 = null;

        EObject this_XSynchronizedExpression_3 = null;

        EObject this_XFeatureCall_4 = null;

        EObject this_XLiteral_5 = null;

        EObject this_XIfExpression_6 = null;

        EObject this_XForLoopExpression_7 = null;

        EObject this_XBasicForLoopExpression_8 = null;

        EObject this_XWhileExpression_9 = null;

        EObject this_XDoWhileExpression_10 = null;

        EObject this_XThrowExpression_11 = null;

        EObject this_XReturnExpression_12 = null;

        EObject this_XTryCatchFinallyExpression_13 = null;

        EObject this_XParenthesizedExpression_14 = null;



        	enterRule();

        try {
            {
            int alt209=15;
            alt209 = dfa209.predict(input);
            switch (alt209) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXConstructorCallParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XConstructorCall_0=ruleXConstructorCall();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XConstructorCall_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXBlockExpressionParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XBlockExpression_1=ruleXBlockExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XBlockExpression_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 3 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXSwitchExpressionParserRuleCall_2());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XSwitchExpression_2=ruleXSwitchExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XSwitchExpression_2;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 4 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXSynchronizedExpressionParserRuleCall_3());
                      			
                    }
                    pushFollow(FOLLOW_2);
                    this_XSynchronizedExpression_3=ruleXSynchronizedExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_XSynchronizedExpression_3;
                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }


                    }
                    break;
                case 5 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXFeatureCallParserRuleCall_4());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XFeatureCall_4=ruleXFeatureCall();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XFeatureCall_4;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 6 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXLiteralParserRuleCall_5());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XLiteral_5=ruleXLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XLiteral_5;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 7 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXIfExpressionParserRuleCall_6());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XIfExpression_6=ruleXIfExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XIfExpression_6;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 8 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXForLoopExpressionParserRuleCall_7());
                      			
                    }
                    pushFollow(FOLLOW_2);
                    this_XForLoopExpression_7=ruleXForLoopExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_XForLoopExpression_7;
                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }


                    }
                    break;
                case 9 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXBasicForLoopExpressionParserRuleCall_8());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XBasicForLoopExpression_8=ruleXBasicForLoopExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XBasicForLoopExpression_8;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 10 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXWhileExpressionParserRuleCall_9());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XWhileExpression_9=ruleXWhileExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XWhileExpression_9;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 11 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXDoWhileExpressionParserRuleCall_10());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XDoWhileExpression_10=ruleXDoWhileExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XDoWhileExpression_10;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 12 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXThrowExpressionParserRuleCall_11());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XThrowExpression_11=ruleXThrowExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XThrowExpression_11;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 13 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXReturnExpressionParserRuleCall_12());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XReturnExpression_12=ruleXReturnExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XReturnExpression_12;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 14 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXTryCatchFinallyExpressionParserRuleCall_13());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XTryCatchFinallyExpression_13=ruleXTryCatchFinallyExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XTryCatchFinallyExpression_13;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 15 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXPrimaryExpressionAccess().getXParenthesizedExpressionParserRuleCall_14());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XParenthesizedExpression_14=ruleXParenthesizedExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XParenthesizedExpression_14;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXLiteral=ruleXLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXLiteral() throws RecognitionException {
        EObject current = null;

        EObject this_XCollectionLiteral_0 = null;

        EObject this_XClosure_1 = null;

        EObject this_XBooleanLiteral_2 = null;

        EObject this_XNumberLiteral_3 = null;

        EObject this_XNullLiteral_4 = null;

        EObject this_XStringLiteral_5 = null;

        EObject this_XTypeLiteral_6 = null;



        	enterRule();

        try {
            {
            int alt210=7;
            int LA210_0 = input.LA(1);

            if ( (LA210_0==KW_NumberSign) ) {
                alt210=1;
            }
            else if ( (LA210_0==KW_LeftSquareBracket) && (synpred45_InternalXtend())) {
                alt210=2;
            }
            else if ( ((LA210_0>=KW_False && LA210_0<=KW_True)) ) {
                alt210=3;
            }
            else if ( ((LA210_0>=RULE_HEX && LA210_0<=RULE_DECIMAL)) ) {
                alt210=4;
            }
            else if ( (LA210_0==KW_Null) ) {
                alt210=5;
            }
            else if ( ((LA210_0>=RULE_STRING && LA210_0<=RULE_RICH_TEXT_START)) ) {
                alt210=6;
            }
            else if ( (LA210_0==KW_Typeof) ) {
                alt210=7;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 210, 0, input);

                throw nvae;
            }
            switch (alt210) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXLiteralAccess().getXCollectionLiteralParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XCollectionLiteral_0=ruleXCollectionLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XCollectionLiteral_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getXLiteralAccess().getXClosureParserRuleCall_1());
                      			
                    }
                    pushFollow(FOLLOW_2);
                    this_XClosure_1=ruleXClosure();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_XClosure_1;
                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }


                    }
                    break;
                case 3 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXLiteralAccess().getXBooleanLiteralParserRuleCall_2());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XBooleanLiteral_2=ruleXBooleanLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XBooleanLiteral_2;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 4 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXLiteralAccess().getXNumberLiteralParserRuleCall_3());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XNumberLiteral_3=ruleXNumberLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XNumberLiteral_3;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 5 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXLiteralAccess().getXNullLiteralParserRuleCall_4());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XNullLiteral_4=ruleXNullLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XNullLiteral_4;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 6 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXLiteralAccess().getXStringLiteralParserRuleCall_5());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XStringLiteral_5=ruleXStringLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XStringLiteral_5;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 7 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXLiteralAccess().getXTypeLiteralParserRuleCall_6());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XTypeLiteral_6=ruleXTypeLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XTypeLiteral_6;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXCollectionLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXCollectionLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXCollectionLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXCollectionLiteral=ruleXCollectionLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXCollectionLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXCollectionLiteral() throws RecognitionException {
        EObject current = null;

        EObject this_XSetLiteral_0 = null;

        EObject this_XListLiteral_1 = null;



        	enterRule();

        try {
            {
            int alt211=2;
            int LA211_0 = input.LA(1);

            if ( (LA211_0==KW_NumberSign) ) {
                int LA211_1 = input.LA(2);

                if ( (LA211_1==KW_LeftCurlyBracket) ) {
                    alt211=1;
                }
                else if ( (LA211_1==KW_LeftSquareBracket) ) {
                    alt211=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 211, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 211, 0, input);

                throw nvae;
            }
            switch (alt211) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXCollectionLiteralAccess().getXSetLiteralParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XSetLiteral_0=ruleXSetLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XSetLiteral_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXCollectionLiteralAccess().getXListLiteralParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XListLiteral_1=ruleXListLiteral();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XListLiteral_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXSetLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXSetLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXSetLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXSetLiteral=ruleXSetLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXSetLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXSetLiteral() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_elements_3_0 = null;

        EObject lv_elements_5_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXSetLiteralAccess().getXSetLiteralAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_NumberSign,FOLLOW_20); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXSetLiteralAccess().getNumberSignKeyword_1());
              		
            }
            otherlv_2=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_102); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getXSetLiteralAccess().getLeftCurlyBracketKeyword_2());
              		
            }
            int alt213=2;
            int LA213_0 = input.LA(1);

            if ( (LA213_0==KW_Package||(LA213_0>=KW_Class && LA213_0<=KW_LessThanSign)||(LA213_0>=KW_Extends && LA213_0<=KW_LeftCurlyBracket)||(LA213_0>=KW_Interface && LA213_0<=KW_LeftParenthesis)||(LA213_0>=KW_Extension && LA213_0<=KW_New)||(LA213_0>=KW_Public && LA213_0<=KW_Transient)||(LA213_0>=KW_Def && LA213_0<=KW_Create)||(LA213_0>=KW_AFTER && LA213_0<=KW_Import)||LA213_0==KW_Switch||(LA213_0>=KW_NumberSign && LA213_0<=KW_LeftSquareBracket)||(LA213_0>=KW_PlusSign && LA213_0<=KW_HyphenMinus)||LA213_0==KW_ExclamationMark||LA213_0==KW_If||(LA213_0>=KW_For && LA213_0<=KW_Try)||(LA213_0>=RULE_ID && LA213_0<=RULE_RICH_TEXT_START)||(LA213_0>=RULE_HEX && LA213_0<=RULE_DECIMAL)) ) {
                alt213=1;
            }
            switch (alt213) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXSetLiteralAccess().getElementsXExpressionParserRuleCall_3_0_0());
                      					
                    }
                    pushFollow(FOLLOW_103);
                    lv_elements_3_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXSetLiteralRule());
                      						}
                      						add(
                      							current,
                      							"elements",
                      							lv_elements_3_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpression");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }
                    loop212:
                    do {
                        int alt212=2;
                        int LA212_0 = input.LA(1);

                        if ( (LA212_0==KW_Comma) ) {
                            alt212=1;
                        }


                        switch (alt212) {
                    	case 1 :
                    	    {
                    	    otherlv_4=(Token)match(input,KW_Comma,FOLLOW_34); if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      					newLeafNode(otherlv_4, grammarAccess.getXSetLiteralAccess().getCommaKeyword_3_1_0());
                    	      				
                    	    }
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getXSetLiteralAccess().getElementsXExpressionParserRuleCall_3_1_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_103);
                    	    lv_elements_5_0=ruleXExpression();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getXSetLiteralRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"elements",
                    	      								lv_elements_5_0,
                    	      								"org.eclipse.xtext.xbase.Xbase.XExpression");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop212;
                        }
                    } while (true);


                    }
                    break;

            }

            otherlv_6=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_6, grammarAccess.getXSetLiteralAccess().getRightCurlyBracketKeyword_4());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXListLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXListLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXListLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXListLiteral=ruleXListLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXListLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXListLiteral() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_elements_3_0 = null;

        EObject lv_elements_5_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXListLiteralAccess().getXListLiteralAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_NumberSign,FOLLOW_51); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXListLiteralAccess().getNumberSignKeyword_1());
              		
            }
            otherlv_2=(Token)match(input,KW_LeftSquareBracket,FOLLOW_79); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getXListLiteralAccess().getLeftSquareBracketKeyword_2());
              		
            }
            int alt215=2;
            int LA215_0 = input.LA(1);

            if ( (LA215_0==KW_Package||(LA215_0>=KW_Class && LA215_0<=KW_LessThanSign)||(LA215_0>=KW_Extends && LA215_0<=KW_LeftCurlyBracket)||(LA215_0>=KW_Interface && LA215_0<=KW_LeftParenthesis)||(LA215_0>=KW_Extension && LA215_0<=KW_New)||(LA215_0>=KW_Public && LA215_0<=KW_Transient)||(LA215_0>=KW_Def && LA215_0<=KW_Create)||(LA215_0>=KW_AFTER && LA215_0<=KW_Import)||LA215_0==KW_Switch||(LA215_0>=KW_NumberSign && LA215_0<=KW_LeftSquareBracket)||(LA215_0>=KW_PlusSign && LA215_0<=KW_HyphenMinus)||LA215_0==KW_ExclamationMark||LA215_0==KW_If||(LA215_0>=KW_For && LA215_0<=KW_Try)||(LA215_0>=RULE_ID && LA215_0<=RULE_RICH_TEXT_START)||(LA215_0>=RULE_HEX && LA215_0<=RULE_DECIMAL)) ) {
                alt215=1;
            }
            switch (alt215) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXListLiteralAccess().getElementsXExpressionParserRuleCall_3_0_0());
                      					
                    }
                    pushFollow(FOLLOW_80);
                    lv_elements_3_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXListLiteralRule());
                      						}
                      						add(
                      							current,
                      							"elements",
                      							lv_elements_3_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpression");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }
                    loop214:
                    do {
                        int alt214=2;
                        int LA214_0 = input.LA(1);

                        if ( (LA214_0==KW_Comma) ) {
                            alt214=1;
                        }


                        switch (alt214) {
                    	case 1 :
                    	    {
                    	    otherlv_4=(Token)match(input,KW_Comma,FOLLOW_34); if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      					newLeafNode(otherlv_4, grammarAccess.getXListLiteralAccess().getCommaKeyword_3_1_0());
                    	      				
                    	    }
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getXListLiteralAccess().getElementsXExpressionParserRuleCall_3_1_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_80);
                    	    lv_elements_5_0=ruleXExpression();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getXListLiteralRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"elements",
                    	      								lv_elements_5_0,
                    	      								"org.eclipse.xtext.xbase.Xbase.XExpression");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop214;
                        }
                    } while (true);


                    }
                    break;

            }

            otherlv_6=(Token)match(input,KW_RightSquareBracket,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_6, grammarAccess.getXListLiteralAccess().getRightSquareBracketKeyword_4());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXClosure() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXClosure = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXClosureRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXClosure=ruleXClosure();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXClosure; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXClosure() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token lv_explicitSyntax_5_0=null;
        Token otherlv_7=null;
        EObject lv_declaredFormalParameters_2_0 = null;

        EObject lv_declaredFormalParameters_4_0 = null;

        EObject lv_expression_6_0 = null;



        	enterRule();

        try {
            {
            {
            {
            {
            {
            if ( state.backtracking==0 ) {

              						current = forceCreateModelElement(
              							grammarAccess.getXClosureAccess().getXClosureAction_0_0_0(),
              							current);
              					
            }

            }

            otherlv_1=(Token)match(input,KW_LeftSquareBracket,FOLLOW_104); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(otherlv_1, grammarAccess.getXClosureAccess().getLeftSquareBracketKeyword_0_0_1());
              				
            }

            }


            }
            int alt218=2;
            alt218 = dfa218.predict(input);
            switch (alt218) {
                case 1 :
                    {
                    {
                    int alt217=2;
                    int LA217_0 = input.LA(1);

                    if ( (LA217_0==KW_Package||LA217_0==KW_Class||(LA217_0>=KW_Extends && LA217_0<=KW_Implements)||(LA217_0>=KW_Interface && LA217_0<=KW_LeftParenthesis)||LA217_0==KW_EqualsSignGreaterThanSign||(LA217_0>=KW_Extension && LA217_0<=KW_Throws)||(LA217_0>=KW_Public && LA217_0<=KW_Transient)||(LA217_0>=KW_Def && LA217_0<=KW_Create)||(LA217_0>=KW_AFTER && LA217_0<=KW_Import)||LA217_0==RULE_ID) ) {
                        alt217=1;
                    }
                    switch (alt217) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getXClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_1_0_0_0_0());
                              							
                            }
                            pushFollow(FOLLOW_105);
                            lv_declaredFormalParameters_2_0=ruleJvmFormalParameter();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getXClosureRule());
                              								}
                              								add(
                              									current,
                              									"declaredFormalParameters",
                              									lv_declaredFormalParameters_2_0,
                              									"org.eclipse.xtend.core.Xtend.JvmFormalParameter");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop216:
                            do {
                                int alt216=2;
                                int LA216_0 = input.LA(1);

                                if ( (LA216_0==KW_Comma) ) {
                                    alt216=1;
                                }


                                switch (alt216) {
                            	case 1 :
                            	    {
                            	    otherlv_3=(Token)match(input,KW_Comma,FOLLOW_58); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_3, grammarAccess.getXClosureAccess().getCommaKeyword_1_0_0_1_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getXClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_1_0_0_1_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_105);
                            	    lv_declaredFormalParameters_4_0=ruleJvmFormalParameter();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getXClosureRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"declaredFormalParameters",
                            	      										lv_declaredFormalParameters_4_0,
                            	      										"org.eclipse.xtend.core.Xtend.JvmFormalParameter");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop216;
                                }
                            } while (true);


                            }
                            break;

                    }
                    {
                    {
                    lv_explicitSyntax_5_0=(Token)match(input,KW_VerticalLine,FOLLOW_106); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							newLeafNode(lv_explicitSyntax_5_0, grammarAccess.getXClosureAccess().getExplicitSyntaxVerticalLineKeyword_1_0_1_0());
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getXClosureRule());
                      							}
                      							setWithLastConsumed(current, "explicitSyntax", true, "|");
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXClosureAccess().getExpressionXExpressionInClosureParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_107);
            lv_expression_6_0=ruleXExpressionInClosure();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXClosureRule());
              					}
              					set(
              						current,
              						"expression",
              						lv_expression_6_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpressionInClosure");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_7=(Token)match(input,KW_RightSquareBracket,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_7, grammarAccess.getXClosureAccess().getRightSquareBracketKeyword_3());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXExpressionInClosure() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXExpressionInClosure = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXExpressionInClosureRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXExpressionInClosure=ruleXExpressionInClosure();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXExpressionInClosure; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXExpressionInClosure() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        EObject lv_expressions_1_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXExpressionInClosureAccess().getXBlockExpressionAction_0(),
              					current);
              			
            }

            }
            loop220:
            do {
                int alt220=2;
                int LA220_0 = input.LA(1);

                if ( (LA220_0==KW_Package||(LA220_0>=KW_Class && LA220_0<=KW_LessThanSign)||(LA220_0>=KW_Extends && LA220_0<=KW_LeftCurlyBracket)||(LA220_0>=KW_Interface && LA220_0<=KW_LeftParenthesis)||(LA220_0>=KW_Extension && LA220_0<=KW_New)||(LA220_0>=KW_Public && LA220_0<=KW_Create)||(LA220_0>=KW_AFTER && LA220_0<=KW_Import)||LA220_0==KW_Switch||(LA220_0>=KW_NumberSign && LA220_0<=KW_LeftSquareBracket)||(LA220_0>=KW_PlusSign && LA220_0<=KW_HyphenMinus)||LA220_0==KW_ExclamationMark||LA220_0==KW_If||(LA220_0>=KW_For && LA220_0<=KW_Try)||(LA220_0>=RULE_ID && LA220_0<=RULE_RICH_TEXT_START)||(LA220_0>=RULE_HEX && LA220_0<=RULE_DECIMAL)) ) {
                    alt220=1;
                }


                switch (alt220) {
            	case 1 :
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      						newCompositeNode(grammarAccess.getXExpressionInClosureAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_1_0_0());
            	      					
            	    }
            	    pushFollow(FOLLOW_108);
            	    lv_expressions_1_0=ruleXExpressionOrVarDeclaration();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						if (current==null) {
            	      							current = createModelElementForParent(grammarAccess.getXExpressionInClosureRule());
            	      						}
            	      						add(
            	      							current,
            	      							"expressions",
            	      							lv_expressions_1_0,
            	      							"org.eclipse.xtext.xbase.Xbase.XExpressionOrVarDeclaration");
            	      						afterParserOrEnumRuleCall();
            	      					
            	    }

            	    }


            	    }
            	    int alt219=2;
            	    int LA219_0 = input.LA(1);

            	    if ( (LA219_0==KW_Semicolon) ) {
            	        alt219=1;
            	    }
            	    switch (alt219) {
            	        case 1 :
            	            {
            	            otherlv_2=(Token)match(input,KW_Semicolon,FOLLOW_109); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              					newLeafNode(otherlv_2, grammarAccess.getXExpressionInClosureAccess().getSemicolonKeyword_1_1());
            	              				
            	            }

            	            }
            	            break;

            	    }


            	    }
            	    break;

            	default :
            	    break loop220;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXShortClosure() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXShortClosure = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXShortClosureRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXShortClosure=ruleXShortClosure();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXShortClosure; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXShortClosure() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token lv_explicitSyntax_4_0=null;
        EObject lv_declaredFormalParameters_1_0 = null;

        EObject lv_declaredFormalParameters_3_0 = null;

        EObject lv_expression_5_0 = null;



        	enterRule();

        try {
            {
            {
            {
            {
            {
            if ( state.backtracking==0 ) {

              						current = forceCreateModelElement(
              							grammarAccess.getXShortClosureAccess().getXClosureAction_0_0_0(),
              							current);
              					
            }

            }
            int alt222=2;
            int LA222_0 = input.LA(1);

            if ( (LA222_0==KW_Package||LA222_0==KW_Class||(LA222_0>=KW_Extends && LA222_0<=KW_Implements)||(LA222_0>=KW_Interface && LA222_0<=KW_LeftParenthesis)||LA222_0==KW_EqualsSignGreaterThanSign||(LA222_0>=KW_Extension && LA222_0<=KW_Throws)||(LA222_0>=KW_Public && LA222_0<=KW_Transient)||(LA222_0>=KW_Def && LA222_0<=KW_Create)||(LA222_0>=KW_AFTER && LA222_0<=KW_Import)||LA222_0==RULE_ID) ) {
                alt222=1;
            }
            switch (alt222) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      								newCompositeNode(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_0_0_1_0_0());
                      							
                    }
                    pushFollow(FOLLOW_105);
                    lv_declaredFormalParameters_1_0=ruleJvmFormalParameter();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      								if (current==null) {
                      									current = createModelElementForParent(grammarAccess.getXShortClosureRule());
                      								}
                      								add(
                      									current,
                      									"declaredFormalParameters",
                      									lv_declaredFormalParameters_1_0,
                      									"org.eclipse.xtend.core.Xtend.JvmFormalParameter");
                      								afterParserOrEnumRuleCall();
                      							
                    }

                    }


                    }
                    loop221:
                    do {
                        int alt221=2;
                        int LA221_0 = input.LA(1);

                        if ( (LA221_0==KW_Comma) ) {
                            alt221=1;
                        }


                        switch (alt221) {
                    	case 1 :
                    	    {
                    	    otherlv_2=(Token)match(input,KW_Comma,FOLLOW_58); if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							newLeafNode(otherlv_2, grammarAccess.getXShortClosureAccess().getCommaKeyword_0_0_1_1_0());
                    	      						
                    	    }
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      									newCompositeNode(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_0_0_1_1_1_0());
                    	      								
                    	    }
                    	    pushFollow(FOLLOW_105);
                    	    lv_declaredFormalParameters_3_0=ruleJvmFormalParameter();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      									if (current==null) {
                    	      										current = createModelElementForParent(grammarAccess.getXShortClosureRule());
                    	      									}
                    	      									add(
                    	      										current,
                    	      										"declaredFormalParameters",
                    	      										lv_declaredFormalParameters_3_0,
                    	      										"org.eclipse.xtend.core.Xtend.JvmFormalParameter");
                    	      									afterParserOrEnumRuleCall();
                    	      								
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop221;
                        }
                    } while (true);


                    }
                    break;

            }
            {
            {
            lv_explicitSyntax_4_0=(Token)match(input,KW_VerticalLine,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              							newLeafNode(lv_explicitSyntax_4_0, grammarAccess.getXShortClosureAccess().getExplicitSyntaxVerticalLineKeyword_0_0_2_0());
              						
            }
            if ( state.backtracking==0 ) {

              							if (current==null) {
              								current = createModelElement(grammarAccess.getXShortClosureRule());
              							}
              							setWithLastConsumed(current, "explicitSyntax", true, "|");
              						
            }

            }


            }


            }


            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXShortClosureAccess().getExpressionXExpressionParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_expression_5_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXShortClosureRule());
              					}
              					set(
              						current,
              						"expression",
              						lv_expression_5_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXParenthesizedExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXParenthesizedExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXParenthesizedExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXParenthesizedExpression=ruleXParenthesizedExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXParenthesizedExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXParenthesizedExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        EObject this_XExpression_1 = null;



        	enterRule();

        try {
            {
            {
            otherlv_0=(Token)match(input,KW_LeftParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getXParenthesizedExpressionAccess().getLeftParenthesisKeyword_0());
              		
            }
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getXParenthesizedExpressionAccess().getXExpressionParserRuleCall_1());
              		
            }
            pushFollow(FOLLOW_66);
            this_XExpression_1=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_XExpression_1;
              			afterParserOrEnumRuleCall();
              		
            }
            otherlv_2=(Token)match(input,KW_RightParenthesis,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getXParenthesizedExpressionAccess().getRightParenthesisKeyword_2());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXIfExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXIfExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXIfExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXIfExpression=ruleXIfExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXIfExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXIfExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_if_3_0 = null;

        EObject lv_then_5_0 = null;

        EObject lv_else_7_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXIfExpressionAccess().getXIfExpressionAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_If,FOLLOW_42); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXIfExpressionAccess().getIfKeyword_1());
              		
            }
            otherlv_2=(Token)match(input,KW_LeftParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getXIfExpressionAccess().getLeftParenthesisKeyword_2());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXIfExpressionAccess().getIfXExpressionParserRuleCall_3_0());
              				
            }
            pushFollow(FOLLOW_66);
            lv_if_3_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXIfExpressionRule());
              					}
              					set(
              						current,
              						"if",
              						lv_if_3_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_4=(Token)match(input,KW_RightParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_4, grammarAccess.getXIfExpressionAccess().getRightParenthesisKeyword_4());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXIfExpressionAccess().getThenXExpressionParserRuleCall_5_0());
              				
            }
            pushFollow(FOLLOW_110);
            lv_then_5_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXIfExpressionRule());
              					}
              					set(
              						current,
              						"then",
              						lv_then_5_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            int alt223=2;
            int LA223_0 = input.LA(1);

            if ( (LA223_0==KW_Else) ) {
                int LA223_1 = input.LA(2);

                if ( (synpred49_InternalXtend()) ) {
                    alt223=1;
                }
            }
            switch (alt223) {
                case 1 :
                    {
                    {
                    otherlv_6=(Token)match(input,KW_Else,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_6, grammarAccess.getXIfExpressionAccess().getElseKeyword_6_0());
                      				
                    }

                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXIfExpressionAccess().getElseXExpressionParserRuleCall_6_1_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_else_7_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXIfExpressionRule());
                      						}
                      						set(
                      							current,
                      							"else",
                      							lv_else_7_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpression");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXCasePart() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXCasePart = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXCasePartRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXCasePart=ruleXCasePart();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXCasePart; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXCasePart() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_4=null;
        Token lv_fallThrough_6_0=null;
        EObject lv_typeGuard_1_0 = null;

        EObject lv_case_3_0 = null;

        EObject lv_then_5_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXCasePartAccess().getXCasePartAction_0(),
              					current);
              			
            }

            }
            int alt224=2;
            int LA224_0 = input.LA(1);

            if ( ((LA224_0>=KW_Annotation && LA224_0<=KW_LeftParenthesis)||LA224_0==KW_EqualsSignGreaterThanSign||LA224_0==KW_Create||(LA224_0>=KW_AFTER && LA224_0<=KW_SEPARATOR)||LA224_0==RULE_ID) ) {
                alt224=1;
            }
            switch (alt224) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getXCasePartAccess().getTypeGuardJvmTypeReferenceParserRuleCall_1_0());
                      				
                    }
                    pushFollow(FOLLOW_111);
                    lv_typeGuard_1_0=ruleJvmTypeReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getXCasePartRule());
                      					}
                      					set(
                      						current,
                      						"typeGuard",
                      						lv_typeGuard_1_0,
                      						"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }
            int alt225=2;
            int LA225_0 = input.LA(1);

            if ( (LA225_0==KW_Case) ) {
                alt225=1;
            }
            switch (alt225) {
                case 1 :
                    {
                    otherlv_2=(Token)match(input,KW_Case,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_2, grammarAccess.getXCasePartAccess().getCaseKeyword_2_0());
                      			
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXCasePartAccess().getCaseXExpressionParserRuleCall_2_1_0());
                      					
                    }
                    pushFollow(FOLLOW_112);
                    lv_case_3_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXCasePartRule());
                      						}
                      						set(
                      							current,
                      							"case",
                      							lv_case_3_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpression");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }
            int alt226=2;
            int LA226_0 = input.LA(1);

            if ( (LA226_0==KW_Colon) ) {
                alt226=1;
            }
            else if ( (LA226_0==KW_Comma) ) {
                alt226=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 226, 0, input);

                throw nvae;
            }
            switch (alt226) {
                case 1 :
                    {
                    {
                    otherlv_4=(Token)match(input,KW_Colon,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_4, grammarAccess.getXCasePartAccess().getColonKeyword_3_0_0());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getXCasePartAccess().getThenXExpressionParserRuleCall_3_0_1_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    lv_then_5_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getXCasePartRule());
                      							}
                      							set(
                      								current,
                      								"then",
                      								lv_then_5_0,
                      								"org.eclipse.xtext.xbase.Xbase.XExpression");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    lv_fallThrough_6_0=(Token)match(input,KW_Comma,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_fallThrough_6_0, grammarAccess.getXCasePartAccess().getFallThroughCommaKeyword_3_1_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getXCasePartRule());
                      						}
                      						setWithLastConsumed(current, "fallThrough", true, ",");
                      					
                    }

                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXForLoopExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXForLoopExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXForLoopExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXForLoopExpression=ruleXForLoopExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXForLoopExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXForLoopExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_declaredParam_3_0 = null;

        EObject lv_forExpression_5_0 = null;

        EObject lv_eachExpression_7_0 = null;



        	enterRule();

        try {
            {
            {
            {
            {
            {
            if ( state.backtracking==0 ) {

              						current = forceCreateModelElement(
              							grammarAccess.getXForLoopExpressionAccess().getXForLoopExpressionAction_0_0_0(),
              							current);
              					
            }

            }

            otherlv_1=(Token)match(input,KW_For,FOLLOW_42); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(otherlv_1, grammarAccess.getXForLoopExpressionAccess().getForKeyword_0_0_1());
              				
            }
            otherlv_2=(Token)match(input,KW_LeftParenthesis,FOLLOW_58); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(otherlv_2, grammarAccess.getXForLoopExpressionAccess().getLeftParenthesisKeyword_0_0_2());
              				
            }
            {
            {
            if ( state.backtracking==0 ) {

              							newCompositeNode(grammarAccess.getXForLoopExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_0_0_3_0());
              						
            }
            pushFollow(FOLLOW_56);
            lv_declaredParam_3_0=ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              							if (current==null) {
              								current = createModelElementForParent(grammarAccess.getXForLoopExpressionRule());
              							}
              							set(
              								current,
              								"declaredParam",
              								lv_declaredParam_3_0,
              								"org.eclipse.xtend.core.Xtend.JvmFormalParameter");
              							afterParserOrEnumRuleCall();
              						
            }

            }


            }

            otherlv_4=(Token)match(input,KW_Colon,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(otherlv_4, grammarAccess.getXForLoopExpressionAccess().getColonKeyword_0_0_4());
              				
            }

            }


            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXForLoopExpressionAccess().getForExpressionXExpressionParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_66);
            lv_forExpression_5_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXForLoopExpressionRule());
              					}
              					set(
              						current,
              						"forExpression",
              						lv_forExpression_5_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_6=(Token)match(input,KW_RightParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_6, grammarAccess.getXForLoopExpressionAccess().getRightParenthesisKeyword_2());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXForLoopExpressionAccess().getEachExpressionXExpressionParserRuleCall_3_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_eachExpression_7_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXForLoopExpressionRule());
              					}
              					set(
              						current,
              						"eachExpression",
              						lv_eachExpression_7_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXBasicForLoopExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXBasicForLoopExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXBasicForLoopExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXBasicForLoopExpression=ruleXBasicForLoopExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXBasicForLoopExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXBasicForLoopExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        Token otherlv_8=null;
        Token otherlv_10=null;
        Token otherlv_12=null;
        EObject lv_initExpressions_3_0 = null;

        EObject lv_initExpressions_5_0 = null;

        EObject lv_expression_7_0 = null;

        EObject lv_updateExpressions_9_0 = null;

        EObject lv_updateExpressions_11_0 = null;

        EObject lv_eachExpression_13_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXBasicForLoopExpressionAccess().getXBasicForLoopExpressionAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_For,FOLLOW_42); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXBasicForLoopExpressionAccess().getForKeyword_1());
              		
            }
            otherlv_2=(Token)match(input,KW_LeftParenthesis,FOLLOW_113); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getXBasicForLoopExpressionAccess().getLeftParenthesisKeyword_2());
              		
            }
            int alt228=2;
            int LA228_0 = input.LA(1);

            if ( (LA228_0==KW_Package||(LA228_0>=KW_Class && LA228_0<=KW_LessThanSign)||(LA228_0>=KW_Extends && LA228_0<=KW_LeftCurlyBracket)||(LA228_0>=KW_Interface && LA228_0<=KW_LeftParenthesis)||(LA228_0>=KW_Extension && LA228_0<=KW_New)||(LA228_0>=KW_Public && LA228_0<=KW_Create)||(LA228_0>=KW_AFTER && LA228_0<=KW_Import)||LA228_0==KW_Switch||(LA228_0>=KW_NumberSign && LA228_0<=KW_LeftSquareBracket)||(LA228_0>=KW_PlusSign && LA228_0<=KW_HyphenMinus)||LA228_0==KW_ExclamationMark||LA228_0==KW_If||(LA228_0>=KW_For && LA228_0<=KW_Try)||(LA228_0>=RULE_ID && LA228_0<=RULE_RICH_TEXT_START)||(LA228_0>=RULE_HEX && LA228_0<=RULE_DECIMAL)) ) {
                alt228=1;
            }
            switch (alt228) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsXExpressionOrVarDeclarationParserRuleCall_3_0_0());
                      					
                    }
                    pushFollow(FOLLOW_114);
                    lv_initExpressions_3_0=ruleXExpressionOrVarDeclaration();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXBasicForLoopExpressionRule());
                      						}
                      						add(
                      							current,
                      							"initExpressions",
                      							lv_initExpressions_3_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpressionOrVarDeclaration");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }
                    loop227:
                    do {
                        int alt227=2;
                        int LA227_0 = input.LA(1);

                        if ( (LA227_0==KW_Comma) ) {
                            alt227=1;
                        }


                        switch (alt227) {
                    	case 1 :
                    	    {
                    	    otherlv_4=(Token)match(input,KW_Comma,FOLLOW_115); if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      					newLeafNode(otherlv_4, grammarAccess.getXBasicForLoopExpressionAccess().getCommaKeyword_3_1_0());
                    	      				
                    	    }
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsXExpressionOrVarDeclarationParserRuleCall_3_1_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_114);
                    	    lv_initExpressions_5_0=ruleXExpressionOrVarDeclaration();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getXBasicForLoopExpressionRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"initExpressions",
                    	      								lv_initExpressions_5_0,
                    	      								"org.eclipse.xtext.xbase.Xbase.XExpressionOrVarDeclaration");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop227;
                        }
                    } while (true);


                    }
                    break;

            }

            otherlv_6=(Token)match(input,KW_Semicolon,FOLLOW_116); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_6, grammarAccess.getXBasicForLoopExpressionAccess().getSemicolonKeyword_4());
              		
            }
            int alt229=2;
            int LA229_0 = input.LA(1);

            if ( (LA229_0==KW_Package||(LA229_0>=KW_Class && LA229_0<=KW_LessThanSign)||(LA229_0>=KW_Extends && LA229_0<=KW_LeftCurlyBracket)||(LA229_0>=KW_Interface && LA229_0<=KW_LeftParenthesis)||(LA229_0>=KW_Extension && LA229_0<=KW_New)||(LA229_0>=KW_Public && LA229_0<=KW_Transient)||(LA229_0>=KW_Def && LA229_0<=KW_Create)||(LA229_0>=KW_AFTER && LA229_0<=KW_Import)||LA229_0==KW_Switch||(LA229_0>=KW_NumberSign && LA229_0<=KW_LeftSquareBracket)||(LA229_0>=KW_PlusSign && LA229_0<=KW_HyphenMinus)||LA229_0==KW_ExclamationMark||LA229_0==KW_If||(LA229_0>=KW_For && LA229_0<=KW_Try)||(LA229_0>=RULE_ID && LA229_0<=RULE_RICH_TEXT_START)||(LA229_0>=RULE_HEX && LA229_0<=RULE_DECIMAL)) ) {
                alt229=1;
            }
            switch (alt229) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getXBasicForLoopExpressionAccess().getExpressionXExpressionParserRuleCall_5_0());
                      				
                    }
                    pushFollow(FOLLOW_117);
                    lv_expression_7_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getXBasicForLoopExpressionRule());
                      					}
                      					set(
                      						current,
                      						"expression",
                      						lv_expression_7_0,
                      						"org.eclipse.xtext.xbase.Xbase.XExpression");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }

            otherlv_8=(Token)match(input,KW_Semicolon,FOLLOW_77); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_8, grammarAccess.getXBasicForLoopExpressionAccess().getSemicolonKeyword_6());
              		
            }
            int alt231=2;
            int LA231_0 = input.LA(1);

            if ( (LA231_0==KW_Package||(LA231_0>=KW_Class && LA231_0<=KW_LessThanSign)||(LA231_0>=KW_Extends && LA231_0<=KW_LeftCurlyBracket)||(LA231_0>=KW_Interface && LA231_0<=KW_LeftParenthesis)||(LA231_0>=KW_Extension && LA231_0<=KW_New)||(LA231_0>=KW_Public && LA231_0<=KW_Transient)||(LA231_0>=KW_Def && LA231_0<=KW_Create)||(LA231_0>=KW_AFTER && LA231_0<=KW_Import)||LA231_0==KW_Switch||(LA231_0>=KW_NumberSign && LA231_0<=KW_LeftSquareBracket)||(LA231_0>=KW_PlusSign && LA231_0<=KW_HyphenMinus)||LA231_0==KW_ExclamationMark||LA231_0==KW_If||(LA231_0>=KW_For && LA231_0<=KW_Try)||(LA231_0>=RULE_ID && LA231_0<=RULE_RICH_TEXT_START)||(LA231_0>=RULE_HEX && LA231_0<=RULE_DECIMAL)) ) {
                alt231=1;
            }
            switch (alt231) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsXExpressionParserRuleCall_7_0_0());
                      					
                    }
                    pushFollow(FOLLOW_28);
                    lv_updateExpressions_9_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXBasicForLoopExpressionRule());
                      						}
                      						add(
                      							current,
                      							"updateExpressions",
                      							lv_updateExpressions_9_0,
                      							"org.eclipse.xtext.xbase.Xbase.XExpression");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }
                    loop230:
                    do {
                        int alt230=2;
                        int LA230_0 = input.LA(1);

                        if ( (LA230_0==KW_Comma) ) {
                            alt230=1;
                        }


                        switch (alt230) {
                    	case 1 :
                    	    {
                    	    otherlv_10=(Token)match(input,KW_Comma,FOLLOW_34); if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      					newLeafNode(otherlv_10, grammarAccess.getXBasicForLoopExpressionAccess().getCommaKeyword_7_1_0());
                    	      				
                    	    }
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsXExpressionParserRuleCall_7_1_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_28);
                    	    lv_updateExpressions_11_0=ruleXExpression();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getXBasicForLoopExpressionRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"updateExpressions",
                    	      								lv_updateExpressions_11_0,
                    	      								"org.eclipse.xtext.xbase.Xbase.XExpression");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop230;
                        }
                    } while (true);


                    }
                    break;

            }

            otherlv_12=(Token)match(input,KW_RightParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_12, grammarAccess.getXBasicForLoopExpressionAccess().getRightParenthesisKeyword_8());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXBasicForLoopExpressionAccess().getEachExpressionXExpressionParserRuleCall_9_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_eachExpression_13_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXBasicForLoopExpressionRule());
              					}
              					set(
              						current,
              						"eachExpression",
              						lv_eachExpression_13_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXWhileExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXWhileExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXWhileExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXWhileExpression=ruleXWhileExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXWhileExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXWhileExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject lv_predicate_3_0 = null;

        EObject lv_body_5_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXWhileExpressionAccess().getXWhileExpressionAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_While,FOLLOW_42); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXWhileExpressionAccess().getWhileKeyword_1());
              		
            }
            otherlv_2=(Token)match(input,KW_LeftParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getXWhileExpressionAccess().getLeftParenthesisKeyword_2());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXWhileExpressionAccess().getPredicateXExpressionParserRuleCall_3_0());
              				
            }
            pushFollow(FOLLOW_66);
            lv_predicate_3_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXWhileExpressionRule());
              					}
              					set(
              						current,
              						"predicate",
              						lv_predicate_3_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_4=(Token)match(input,KW_RightParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_4, grammarAccess.getXWhileExpressionAccess().getRightParenthesisKeyword_4());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXWhileExpressionAccess().getBodyXExpressionParserRuleCall_5_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_body_5_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXWhileExpressionRule());
              					}
              					set(
              						current,
              						"body",
              						lv_body_5_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXDoWhileExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXDoWhileExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXDoWhileExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXDoWhileExpression=ruleXDoWhileExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXDoWhileExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXDoWhileExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_body_2_0 = null;

        EObject lv_predicate_5_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXDoWhileExpressionAccess().getXDoWhileExpressionAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_Do,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXDoWhileExpressionAccess().getDoKeyword_1());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXDoWhileExpressionAccess().getBodyXExpressionParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_118);
            lv_body_2_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXDoWhileExpressionRule());
              					}
              					set(
              						current,
              						"body",
              						lv_body_2_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_3=(Token)match(input,KW_While,FOLLOW_42); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_3, grammarAccess.getXDoWhileExpressionAccess().getWhileKeyword_3());
              		
            }
            otherlv_4=(Token)match(input,KW_LeftParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_4, grammarAccess.getXDoWhileExpressionAccess().getLeftParenthesisKeyword_4());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXDoWhileExpressionAccess().getPredicateXExpressionParserRuleCall_5_0());
              				
            }
            pushFollow(FOLLOW_66);
            lv_predicate_5_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXDoWhileExpressionRule());
              					}
              					set(
              						current,
              						"predicate",
              						lv_predicate_5_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_6=(Token)match(input,KW_RightParenthesis,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_6, grammarAccess.getXDoWhileExpressionAccess().getRightParenthesisKeyword_6());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXBlockExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXBlockExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXBlockExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXBlockExpression=ruleXBlockExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXBlockExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXBlockExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        EObject lv_expressions_2_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXBlockExpressionAccess().getXBlockExpressionAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_LeftCurlyBracket,FOLLOW_119); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXBlockExpressionAccess().getLeftCurlyBracketKeyword_1());
              		
            }
            loop233:
            do {
                int alt233=2;
                int LA233_0 = input.LA(1);

                if ( (LA233_0==KW_Package||(LA233_0>=KW_Class && LA233_0<=KW_LessThanSign)||(LA233_0>=KW_Extends && LA233_0<=KW_LeftCurlyBracket)||(LA233_0>=KW_Interface && LA233_0<=KW_LeftParenthesis)||(LA233_0>=KW_Extension && LA233_0<=KW_New)||(LA233_0>=KW_Public && LA233_0<=KW_Create)||(LA233_0>=KW_AFTER && LA233_0<=KW_Import)||LA233_0==KW_Switch||(LA233_0>=KW_NumberSign && LA233_0<=KW_LeftSquareBracket)||(LA233_0>=KW_PlusSign && LA233_0<=KW_HyphenMinus)||LA233_0==KW_ExclamationMark||LA233_0==KW_If||(LA233_0>=KW_For && LA233_0<=KW_Try)||(LA233_0>=RULE_ID && LA233_0<=RULE_RICH_TEXT_START)||(LA233_0>=RULE_HEX && LA233_0<=RULE_DECIMAL)) ) {
                    alt233=1;
                }


                switch (alt233) {
            	case 1 :
            	    {
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      						newCompositeNode(grammarAccess.getXBlockExpressionAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_2_0_0());
            	      					
            	    }
            	    pushFollow(FOLLOW_120);
            	    lv_expressions_2_0=ruleXExpressionOrVarDeclaration();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						if (current==null) {
            	      							current = createModelElementForParent(grammarAccess.getXBlockExpressionRule());
            	      						}
            	      						add(
            	      							current,
            	      							"expressions",
            	      							lv_expressions_2_0,
            	      							"org.eclipse.xtext.xbase.Xbase.XExpressionOrVarDeclaration");
            	      						afterParserOrEnumRuleCall();
            	      					
            	    }

            	    }


            	    }
            	    int alt232=2;
            	    int LA232_0 = input.LA(1);

            	    if ( (LA232_0==KW_Semicolon) ) {
            	        alt232=1;
            	    }
            	    switch (alt232) {
            	        case 1 :
            	            {
            	            otherlv_3=(Token)match(input,KW_Semicolon,FOLLOW_119); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              					newLeafNode(otherlv_3, grammarAccess.getXBlockExpressionAccess().getSemicolonKeyword_2_1());
            	              				
            	            }

            	            }
            	            break;

            	    }


            	    }
            	    break;

            	default :
            	    break loop233;
                }
            } while (true);

            otherlv_4=(Token)match(input,KW_RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_4, grammarAccess.getXBlockExpressionAccess().getRightCurlyBracketKeyword_3());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXExpressionOrVarDeclaration() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXExpressionOrVarDeclaration = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXExpressionOrVarDeclarationRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXExpressionOrVarDeclaration=ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXExpressionOrVarDeclaration; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXExpressionOrVarDeclaration() throws RecognitionException {
        EObject current = null;

        EObject this_XVariableDeclaration_0 = null;

        EObject this_XExpression_1 = null;



        	enterRule();

        try {
            {
            int alt234=2;
            int LA234_0 = input.LA(1);

            if ( (LA234_0==KW_Var) && (synpred51_InternalXtend())) {
                alt234=1;
            }
            else if ( (LA234_0==KW_Val) && (synpred51_InternalXtend())) {
                alt234=1;
            }
            else if ( (LA234_0==KW_Extension) ) {
                switch ( input.LA(2) ) {
                case KW_Var:
                    {
                    int LA234_5 = input.LA(3);

                    if ( (synpred51_InternalXtend()) ) {
                        alt234=1;
                    }
                    else if ( (true) ) {
                        alt234=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 234, 5, input);

                        throw nvae;
                    }
                    }
                    break;
                case KW_Val:
                    {
                    int LA234_6 = input.LA(3);

                    if ( (synpred51_InternalXtend()) ) {
                        alt234=1;
                    }
                    else if ( (true) ) {
                        alt234=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 234, 6, input);

                        throw nvae;
                    }
                    }
                    break;
                case EOF:
                case KW_Package:
                case KW_Semicolon:
                case KW_Class:
                case KW_LessThanSign:
                case KW_Comma:
                case KW_GreaterThanSign:
                case KW_Extends:
                case KW_Implements:
                case KW_LeftCurlyBracket:
                case KW_RightCurlyBracket:
                case KW_Interface:
                case KW_Enum:
                case KW_Annotation:
                case KW_LeftParenthesis:
                case KW_EqualsSignGreaterThanSign:
                case KW_EqualsSign:
                case KW_Extension:
                case KW_Throws:
                case KW_New:
                case KW_FullStop:
                case KW_Public:
                case KW_Private:
                case KW_Protected:
                case KW_Abstract:
                case KW_Static:
                case KW_Dispatch:
                case KW_Final:
                case KW_Strictfp:
                case KW_Native:
                case KW_Volatile:
                case KW_Synchronized:
                case KW_Transient:
                case KW_Def:
                case KW_Override:
                case KW_Create:
                case KW_AFTER:
                case KW_BEFORE:
                case KW_SEPARATOR:
                case KW_Import:
                case KW_Switch:
                case KW_NumberSign:
                case KW_LeftSquareBracket:
                case KW_RightSquareBracket:
                case KW_PlusSignEqualsSign:
                case KW_HyphenMinusEqualsSign:
                case KW_AsteriskEqualsSign:
                case KW_SolidusEqualsSign:
                case KW_PercentSignEqualsSign:
                case KW_GreaterThanSignEqualsSign:
                case KW_VerticalLineVerticalLine:
                case KW_AmpersandAmpersand:
                case KW_EqualsSignEqualsSign:
                case KW_ExclamationMarkEqualsSign:
                case KW_EqualsSignEqualsSignEqualsSign:
                case KW_ExclamationMarkEqualsSignEqualsSign:
                case KW_Instanceof:
                case KW_HyphenMinusGreaterThanSign:
                case KW_FullStopFullStopLessThanSign:
                case KW_FullStopFullStop:
                case KW_LessThanSignGreaterThanSign:
                case KW_QuestionMarkColon:
                case KW_PlusSign:
                case KW_HyphenMinus:
                case KW_Asterisk:
                case KW_AsteriskAsterisk:
                case KW_Solidus:
                case KW_PercentSign:
                case KW_ExclamationMark:
                case KW_As:
                case KW_PlusSignPlusSign:
                case KW_HyphenMinusHyphenMinus:
                case KW_ColonColon:
                case KW_QuestionMarkFullStop:
                case KW_If:
                case KW_For:
                case KW_While:
                case KW_Do:
                case KW_Super:
                case KW_False:
                case KW_True:
                case KW_Null:
                case KW_Typeof:
                case KW_Throw:
                case KW_Return:
                case KW_Try:
                case RULE_ID:
                case RULE_STRING:
                case RULE_RICH_TEXT:
                case RULE_RICH_TEXT_START:
                case RULE_RICH_TEXT_INBETWEEN:
                case RULE_COMMENT_RICH_TEXT_INBETWEEN:
                case RULE_RICH_TEXT_END:
                case RULE_COMMENT_RICH_TEXT_END:
                case RULE_HEX:
                case RULE_INT:
                case RULE_DECIMAL:
                    {
                    alt234=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 234, 3, input);

                    throw nvae;
                }

            }
            else if ( (LA234_0==KW_Package||(LA234_0>=KW_Class && LA234_0<=KW_LessThanSign)||(LA234_0>=KW_Extends && LA234_0<=KW_LeftCurlyBracket)||(LA234_0>=KW_Interface && LA234_0<=KW_LeftParenthesis)||(LA234_0>=KW_Throws && LA234_0<=KW_New)||(LA234_0>=KW_Public && LA234_0<=KW_Transient)||(LA234_0>=KW_Def && LA234_0<=KW_Create)||(LA234_0>=KW_AFTER && LA234_0<=KW_Import)||LA234_0==KW_Switch||(LA234_0>=KW_NumberSign && LA234_0<=KW_LeftSquareBracket)||(LA234_0>=KW_PlusSign && LA234_0<=KW_HyphenMinus)||LA234_0==KW_ExclamationMark||LA234_0==KW_If||(LA234_0>=KW_For && LA234_0<=KW_Try)||(LA234_0>=RULE_ID && LA234_0<=RULE_RICH_TEXT_START)||(LA234_0>=RULE_HEX && LA234_0<=RULE_DECIMAL)) ) {
                alt234=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 234, 0, input);

                throw nvae;
            }
            switch (alt234) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getXExpressionOrVarDeclarationAccess().getXVariableDeclarationParserRuleCall_0());
                      			
                    }
                    pushFollow(FOLLOW_2);
                    this_XVariableDeclaration_0=ruleXVariableDeclaration();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_XVariableDeclaration_0;
                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }


                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getXExpressionOrVarDeclarationAccess().getXExpressionParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XExpression_1=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XExpression_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXFeatureCall() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXFeatureCall = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXFeatureCallRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXFeatureCall=ruleXFeatureCall();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXFeatureCall; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXFeatureCall() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token lv_explicitOperationCall_7_0=null;
        Token otherlv_10=null;
        Token otherlv_12=null;
        EObject lv_typeArguments_2_0 = null;

        EObject lv_typeArguments_4_0 = null;

        EObject lv_featureCallArguments_8_0 = null;

        EObject lv_featureCallArguments_9_0 = null;

        EObject lv_featureCallArguments_11_0 = null;

        EObject lv_featureCallArguments_13_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXFeatureCallAccess().getXFeatureCallAction_0(),
              					current);
              			
            }

            }
            int alt236=2;
            int LA236_0 = input.LA(1);

            if ( (LA236_0==KW_LessThanSign) ) {
                alt236=1;
            }
            switch (alt236) {
                case 1 :
                    {
                    otherlv_1=(Token)match(input,KW_LessThanSign,FOLLOW_53); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_1, grammarAccess.getXFeatureCallAccess().getLessThanSignKeyword_1_0());
                      			
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0());
                      					
                    }
                    pushFollow(FOLLOW_10);
                    lv_typeArguments_2_0=ruleJvmArgumentTypeReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXFeatureCallRule());
                      						}
                      						add(
                      							current,
                      							"typeArguments",
                      							lv_typeArguments_2_0,
                      							"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }
                    loop235:
                    do {
                        int alt235=2;
                        int LA235_0 = input.LA(1);

                        if ( (LA235_0==KW_Comma) ) {
                            alt235=1;
                        }


                        switch (alt235) {
                    	case 1 :
                    	    {
                    	    otherlv_3=(Token)match(input,KW_Comma,FOLLOW_53); if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      					newLeafNode(otherlv_3, grammarAccess.getXFeatureCallAccess().getCommaKeyword_1_2_0());
                    	      				
                    	    }
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getXFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_10);
                    	    lv_typeArguments_4_0=ruleJvmArgumentTypeReference();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getXFeatureCallRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"typeArguments",
                    	      								lv_typeArguments_4_0,
                    	      								"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop235;
                        }
                    } while (true);

                    otherlv_5=(Token)match(input,KW_GreaterThanSign,FOLLOW_99); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_5, grammarAccess.getXFeatureCallAccess().getGreaterThanSignKeyword_1_3());
                      			
                    }

                    }
                    break;

            }
            {
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getXFeatureCallRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_2_0());
              				
            }
            pushFollow(FOLLOW_64);
            ruleIdOrSuper();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            int alt239=2;
            alt239 = dfa239.predict(input);
            switch (alt239) {
                case 1 :
                    {
                    {
                    {
                    lv_explicitOperationCall_7_0=(Token)match(input,KW_LeftParenthesis,FOLLOW_65); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_explicitOperationCall_7_0, grammarAccess.getXFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_3_0_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getXFeatureCallRule());
                      						}
                      						setWithLastConsumed(current, "explicitOperationCall", true, "(");
                      					
                    }

                    }


                    }
                    int alt238=3;
                    alt238 = dfa238.predict(input);
                    switch (alt238) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXShortClosureParserRuleCall_3_1_0_0());
                              						
                            }
                            pushFollow(FOLLOW_66);
                            lv_featureCallArguments_8_0=ruleXShortClosure();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getXFeatureCallRule());
                              							}
                              							add(
                              								current,
                              								"featureCallArguments",
                              								lv_featureCallArguments_8_0,
                              								"org.eclipse.xtext.xbase.Xbase.XShortClosure");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXExpressionParserRuleCall_3_1_1_0_0());
                              							
                            }
                            pushFollow(FOLLOW_28);
                            lv_featureCallArguments_9_0=ruleXExpression();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getXFeatureCallRule());
                              								}
                              								add(
                              									current,
                              									"featureCallArguments",
                              									lv_featureCallArguments_9_0,
                              									"org.eclipse.xtext.xbase.Xbase.XExpression");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }
                            loop237:
                            do {
                                int alt237=2;
                                int LA237_0 = input.LA(1);

                                if ( (LA237_0==KW_Comma) ) {
                                    alt237=1;
                                }


                                switch (alt237) {
                            	case 1 :
                            	    {
                            	    otherlv_10=(Token)match(input,KW_Comma,FOLLOW_34); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      							newLeafNode(otherlv_10, grammarAccess.getXFeatureCallAccess().getCommaKeyword_3_1_1_1_0());
                            	      						
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      									newCompositeNode(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXExpressionParserRuleCall_3_1_1_1_1_0());
                            	      								
                            	    }
                            	    pushFollow(FOLLOW_28);
                            	    lv_featureCallArguments_11_0=ruleXExpression();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      									if (current==null) {
                            	      										current = createModelElementForParent(grammarAccess.getXFeatureCallRule());
                            	      									}
                            	      									add(
                            	      										current,
                            	      										"featureCallArguments",
                            	      										lv_featureCallArguments_11_0,
                            	      										"org.eclipse.xtext.xbase.Xbase.XExpression");
                            	      									afterParserOrEnumRuleCall();
                            	      								
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop237;
                                }
                            } while (true);


                            }


                            }
                            break;

                    }

                    otherlv_12=(Token)match(input,KW_RightParenthesis,FOLLOW_50); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_12, grammarAccess.getXFeatureCallAccess().getRightParenthesisKeyword_3_2());
                      			
                    }

                    }
                    break;

            }
            int alt240=2;
            alt240 = dfa240.predict(input);
            switch (alt240) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXClosureParserRuleCall_4_0());
                      				
                    }
                    pushFollow(FOLLOW_2);
                    lv_featureCallArguments_13_0=ruleXClosure();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getXFeatureCallRule());
                      					}
                      					add(
                      						current,
                      						"featureCallArguments",
                      						lv_featureCallArguments_13_0,
                      						"org.eclipse.xtext.xbase.Xbase.XClosure");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleIdOrSuper() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleIdOrSuper = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getIdOrSuperRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleIdOrSuper=ruleIdOrSuper();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleIdOrSuper.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleIdOrSuper() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_FeatureCallID_0 = null;



        	enterRule();

        try {
            {
            int alt241=2;
            int LA241_0 = input.LA(1);

            if ( (LA241_0==KW_Package||LA241_0==KW_Class||(LA241_0>=KW_Extends && LA241_0<=KW_Implements)||(LA241_0>=KW_Interface && LA241_0<=KW_Annotation)||(LA241_0>=KW_Extension && LA241_0<=KW_Throws)||(LA241_0>=KW_Public && LA241_0<=KW_Transient)||(LA241_0>=KW_Def && LA241_0<=KW_Create)||(LA241_0>=KW_AFTER && LA241_0<=KW_Import)||LA241_0==RULE_ID) ) {
                alt241=1;
            }
            else if ( (LA241_0==KW_Super) ) {
                alt241=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 241, 0, input);

                throw nvae;
            }
            switch (alt241) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getIdOrSuperAccess().getFeatureCallIDParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_FeatureCallID_0=ruleFeatureCallID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_FeatureCallID_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    kw=(Token)match(input,KW_Super,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(kw);
                      			newLeafNode(kw, grammarAccess.getIdOrSuperAccess().getSuperKeyword_1());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXBooleanLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXBooleanLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXBooleanLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXBooleanLiteral=ruleXBooleanLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXBooleanLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXBooleanLiteral() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token lv_isTrue_2_0=null;


        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXBooleanLiteralAccess().getXBooleanLiteralAction_0(),
              					current);
              			
            }

            }
            int alt242=2;
            int LA242_0 = input.LA(1);

            if ( (LA242_0==KW_False) ) {
                alt242=1;
            }
            else if ( (LA242_0==KW_True) ) {
                alt242=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 242, 0, input);

                throw nvae;
            }
            switch (alt242) {
                case 1 :
                    {
                    otherlv_1=(Token)match(input,KW_False,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_1, grammarAccess.getXBooleanLiteralAccess().getFalseKeyword_1_0());
                      			
                    }

                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    lv_isTrue_2_0=(Token)match(input,KW_True,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_isTrue_2_0, grammarAccess.getXBooleanLiteralAccess().getIsTrueTrueKeyword_1_1_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getXBooleanLiteralRule());
                      						}
                      						setWithLastConsumed(current, "isTrue", true, "true");
                      					
                    }

                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXNullLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXNullLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXNullLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXNullLiteral=ruleXNullLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXNullLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXNullLiteral() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;


        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXNullLiteralAccess().getXNullLiteralAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_Null,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXNullLiteralAccess().getNullKeyword_1());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXNumberLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXNumberLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXNumberLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXNumberLiteral=ruleXNumberLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXNumberLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXNumberLiteral() throws RecognitionException {
        EObject current = null;

        AntlrDatatypeRuleToken lv_value_1_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXNumberLiteralAccess().getXNumberLiteralAction_0(),
              					current);
              			
            }

            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXNumberLiteralAccess().getValueNumberParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_value_1_0=ruleNumber();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXNumberLiteralRule());
              					}
              					set(
              						current,
              						"value",
              						lv_value_1_0,
              						"org.eclipse.xtext.xbase.Xbase.Number");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXTypeLiteral() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXTypeLiteral = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXTypeLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXTypeLiteral=ruleXTypeLiteral();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXTypeLiteral; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXTypeLiteral() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_5=null;
        AntlrDatatypeRuleToken lv_arrayDimensions_4_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXTypeLiteralAccess().getXTypeLiteralAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_Typeof,FOLLOW_42); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXTypeLiteralAccess().getTypeofKeyword_1());
              		
            }
            otherlv_2=(Token)match(input,KW_LeftParenthesis,FOLLOW_3); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getXTypeLiteralAccess().getLeftParenthesisKeyword_2());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getXTypeLiteralRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXTypeLiteralAccess().getTypeJvmTypeCrossReference_3_0());
              				
            }
            pushFollow(FOLLOW_121);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            loop243:
            do {
                int alt243=2;
                int LA243_0 = input.LA(1);

                if ( (LA243_0==KW_LeftSquareBracket) ) {
                    alt243=1;
                }


                switch (alt243) {
            	case 1 :
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getXTypeLiteralAccess().getArrayDimensionsArrayBracketsParserRuleCall_4_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_121);
            	    lv_arrayDimensions_4_0=ruleArrayBrackets();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getXTypeLiteralRule());
            	      					}
            	      					add(
            	      						current,
            	      						"arrayDimensions",
            	      						lv_arrayDimensions_4_0,
            	      						"org.eclipse.xtext.xbase.Xtype.ArrayBrackets");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop243;
                }
            } while (true);

            otherlv_5=(Token)match(input,KW_RightParenthesis,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_5, grammarAccess.getXTypeLiteralAccess().getRightParenthesisKeyword_5());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXThrowExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXThrowExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXThrowExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXThrowExpression=ruleXThrowExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXThrowExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXThrowExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_expression_2_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXThrowExpressionAccess().getXThrowExpressionAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_Throw,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXThrowExpressionAccess().getThrowKeyword_1());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXThrowExpressionAccess().getExpressionXExpressionParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_expression_2_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXThrowExpressionRule());
              					}
              					set(
              						current,
              						"expression",
              						lv_expression_2_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXReturnExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXReturnExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXReturnExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXReturnExpression=ruleXReturnExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXReturnExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXReturnExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_expression_2_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXReturnExpressionAccess().getXReturnExpressionAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_Return,FOLLOW_122); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXReturnExpressionAccess().getReturnKeyword_1());
              		
            }
            int alt244=2;
            alt244 = dfa244.predict(input);
            switch (alt244) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getXReturnExpressionAccess().getExpressionXExpressionParserRuleCall_2_0());
                      				
                    }
                    pushFollow(FOLLOW_2);
                    lv_expression_2_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getXReturnExpressionRule());
                      					}
                      					set(
                      						current,
                      						"expression",
                      						lv_expression_2_0,
                      						"org.eclipse.xtext.xbase.Xbase.XExpression");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXTryCatchFinallyExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXTryCatchFinallyExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXTryCatchFinallyExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXTryCatchFinallyExpression=ruleXTryCatchFinallyExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXTryCatchFinallyExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXTryCatchFinallyExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_expression_2_0 = null;

        EObject lv_catchClauses_3_0 = null;

        EObject lv_finallyExpression_5_0 = null;

        EObject lv_finallyExpression_7_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getXTryCatchFinallyExpressionAccess().getXTryCatchFinallyExpressionAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_Try,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXTryCatchFinallyExpressionAccess().getTryKeyword_1());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionXExpressionParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_123);
            lv_expression_2_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXTryCatchFinallyExpressionRule());
              					}
              					set(
              						current,
              						"expression",
              						lv_expression_2_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            int alt247=2;
            int LA247_0 = input.LA(1);

            if ( (LA247_0==KW_Catch) ) {
                alt247=1;
            }
            else if ( (LA247_0==KW_Finally) ) {
                alt247=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 247, 0, input);

                throw nvae;
            }
            switch (alt247) {
                case 1 :
                    {
                    {
                    int cnt245=0;
                    loop245:
                    do {
                        int alt245=2;
                        int LA245_0 = input.LA(1);

                        if ( (LA245_0==KW_Catch) ) {
                            int LA245_2 = input.LA(2);

                            if ( (synpred56_InternalXtend()) ) {
                                alt245=1;
                            }


                        }


                        switch (alt245) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesXCatchClauseParserRuleCall_3_0_0_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_124);
                    	    lv_catchClauses_3_0=ruleXCatchClause();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getXTryCatchFinallyExpressionRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"catchClauses",
                    	      								lv_catchClauses_3_0,
                    	      								"org.eclipse.xtext.xbase.Xbase.XCatchClause");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt245 >= 1 ) break loop245;
                    	    if (state.backtracking>0) {state.failed=true; return current;}
                                EarlyExitException eee =
                                    new EarlyExitException(245, input);
                                throw eee;
                        }
                        cnt245++;
                    } while (true);
                    int alt246=2;
                    int LA246_0 = input.LA(1);

                    if ( (LA246_0==KW_Finally) ) {
                        int LA246_1 = input.LA(2);

                        if ( (synpred57_InternalXtend()) ) {
                            alt246=1;
                        }
                    }
                    switch (alt246) {
                        case 1 :
                            {
                            {
                            otherlv_4=(Token)match(input,KW_Finally,FOLLOW_34); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							newLeafNode(otherlv_4, grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_3_0_1_0());
                              						
                            }

                            }
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_3_0_1_1_0());
                              							
                            }
                            pushFollow(FOLLOW_2);
                            lv_finallyExpression_5_0=ruleXExpression();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getXTryCatchFinallyExpressionRule());
                              								}
                              								set(
                              									current,
                              									"finallyExpression",
                              									lv_finallyExpression_5_0,
                              									"org.eclipse.xtext.xbase.Xbase.XExpression");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }


                            }
                            break;

                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    otherlv_6=(Token)match(input,KW_Finally,FOLLOW_34); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_6, grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_3_1_0());
                      				
                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_3_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    lv_finallyExpression_7_0=ruleXExpression();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getXTryCatchFinallyExpressionRule());
                      							}
                      							set(
                      								current,
                      								"finallyExpression",
                      								lv_finallyExpression_7_0,
                      								"org.eclipse.xtext.xbase.Xbase.XExpression");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXSynchronizedExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXSynchronizedExpression = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXSynchronizedExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXSynchronizedExpression=ruleXSynchronizedExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXSynchronizedExpression; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXSynchronizedExpression() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject lv_param_3_0 = null;

        EObject lv_expression_5_0 = null;



        	enterRule();

        try {
            {
            {
            {
            {
            {
            if ( state.backtracking==0 ) {

              						current = forceCreateModelElement(
              							grammarAccess.getXSynchronizedExpressionAccess().getXSynchronizedExpressionAction_0_0_0(),
              							current);
              					
            }

            }

            otherlv_1=(Token)match(input,KW_Synchronized,FOLLOW_42); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(otherlv_1, grammarAccess.getXSynchronizedExpressionAccess().getSynchronizedKeyword_0_0_1());
              				
            }
            otherlv_2=(Token)match(input,KW_LeftParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(otherlv_2, grammarAccess.getXSynchronizedExpressionAccess().getLeftParenthesisKeyword_0_0_2());
              				
            }

            }


            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXSynchronizedExpressionAccess().getParamXExpressionParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_66);
            lv_param_3_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXSynchronizedExpressionRule());
              					}
              					set(
              						current,
              						"param",
              						lv_param_3_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_4=(Token)match(input,KW_RightParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_4, grammarAccess.getXSynchronizedExpressionAccess().getRightParenthesisKeyword_2());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXSynchronizedExpressionAccess().getExpressionXExpressionParserRuleCall_3_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_expression_5_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXSynchronizedExpressionRule());
              					}
              					set(
              						current,
              						"expression",
              						lv_expression_5_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXCatchClause() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXCatchClause = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXCatchClauseRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXCatchClause=ruleXCatchClause();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXCatchClause; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXCatchClause() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_3=null;
        EObject lv_declaredParam_2_0 = null;

        EObject lv_expression_4_0 = null;



        	enterRule();

        try {
            {
            {
            {
            otherlv_0=(Token)match(input,KW_Catch,FOLLOW_42); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              				newLeafNode(otherlv_0, grammarAccess.getXCatchClauseAccess().getCatchKeyword_0());
              			
            }

            }

            otherlv_1=(Token)match(input,KW_LeftParenthesis,FOLLOW_29); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getXCatchClauseAccess().getLeftParenthesisKeyword_1());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXCatchClauseAccess().getDeclaredParamFullJvmFormalParameterParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_66);
            lv_declaredParam_2_0=ruleFullJvmFormalParameter();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXCatchClauseRule());
              					}
              					set(
              						current,
              						"declaredParam",
              						lv_declaredParam_2_0,
              						"org.eclipse.xtend.core.Xtend.FullJvmFormalParameter");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_3=(Token)match(input,KW_RightParenthesis,FOLLOW_34); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_3, grammarAccess.getXCatchClauseAccess().getRightParenthesisKeyword_3());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXCatchClauseAccess().getExpressionXExpressionParserRuleCall_4_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_expression_4_0=ruleXExpression();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXCatchClauseRule());
              					}
              					set(
              						current,
              						"expression",
              						lv_expression_4_0,
              						"org.eclipse.xtext.xbase.Xbase.XExpression");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleQualifiedName() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleQualifiedName = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getQualifiedNameRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleQualifiedName=ruleQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleQualifiedName.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleQualifiedName() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_ValidID_0 = null;

        AntlrDatatypeRuleToken this_ValidID_2 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getQualifiedNameAccess().getValidIDParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_54);
            this_ValidID_0=ruleValidID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current.merge(this_ValidID_0);
              		
            }
            if ( state.backtracking==0 ) {

              			afterParserOrEnumRuleCall();
              		
            }
            loop248:
            do {
                int alt248=2;
                alt248 = dfa248.predict(input);
                switch (alt248) {
            	case 1 :
            	    {
            	    {
            	    kw=(Token)match(input,KW_FullStop,FOLLOW_3); if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					current.merge(kw);
            	      					newLeafNode(kw, grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0());
            	      				
            	    }

            	    }

            	    if ( state.backtracking==0 ) {

            	      				newCompositeNode(grammarAccess.getQualifiedNameAccess().getValidIDParserRuleCall_1_1());
            	      			
            	    }
            	    pushFollow(FOLLOW_54);
            	    this_ValidID_2=ruleValidID();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      				current.merge(this_ValidID_2);
            	      			
            	    }
            	    if ( state.backtracking==0 ) {

            	      				afterParserOrEnumRuleCall();
            	      			
            	    }

            	    }
            	    break;

            	default :
            	    break loop248;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleNumber() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleNumber = null;



        	HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();

        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getNumberRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleNumber=ruleNumber();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleNumber.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {

            	myHiddenTokenState.restore();

        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleNumber() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_HEX_0=null;
        Token this_INT_1=null;
        Token this_DECIMAL_2=null;
        Token kw=null;
        Token this_INT_4=null;
        Token this_DECIMAL_5=null;


        	enterRule();
        	HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();

        try {
            {
            int alt252=2;
            int LA252_0 = input.LA(1);

            if ( (LA252_0==RULE_HEX) ) {
                alt252=1;
            }
            else if ( ((LA252_0>=RULE_INT && LA252_0<=RULE_DECIMAL)) ) {
                alt252=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 252, 0, input);

                throw nvae;
            }
            switch (alt252) {
                case 1 :
                    {
                    this_HEX_0=(Token)match(input,RULE_HEX,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_HEX_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_HEX_0, grammarAccess.getNumberAccess().getHEXTerminalRuleCall_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    {
                    int alt249=2;
                    int LA249_0 = input.LA(1);

                    if ( (LA249_0==RULE_INT) ) {
                        alt249=1;
                    }
                    else if ( (LA249_0==RULE_DECIMAL) ) {
                        alt249=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 249, 0, input);

                        throw nvae;
                    }
                    switch (alt249) {
                        case 1 :
                            {
                            this_INT_1=(Token)match(input,RULE_INT,FOLLOW_54); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					current.merge(this_INT_1);
                              				
                            }
                            if ( state.backtracking==0 ) {

                              					newLeafNode(this_INT_1, grammarAccess.getNumberAccess().getINTTerminalRuleCall_1_0_0());
                              				
                            }

                            }
                            break;
                        case 2 :
                            {
                            this_DECIMAL_2=(Token)match(input,RULE_DECIMAL,FOLLOW_54); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					current.merge(this_DECIMAL_2);
                              				
                            }
                            if ( state.backtracking==0 ) {

                              					newLeafNode(this_DECIMAL_2, grammarAccess.getNumberAccess().getDECIMALTerminalRuleCall_1_0_1());
                              				
                            }

                            }
                            break;

                    }
                    int alt251=2;
                    int LA251_0 = input.LA(1);

                    if ( (LA251_0==KW_FullStop) ) {
                        int LA251_1 = input.LA(2);

                        if ( ((LA251_1>=RULE_INT && LA251_1<=RULE_DECIMAL)) ) {
                            alt251=1;
                        }
                    }
                    switch (alt251) {
                        case 1 :
                            {
                            kw=(Token)match(input,KW_FullStop,FOLLOW_125); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              					current.merge(kw);
                              					newLeafNode(kw, grammarAccess.getNumberAccess().getFullStopKeyword_1_1_0());
                              				
                            }
                            int alt250=2;
                            int LA250_0 = input.LA(1);

                            if ( (LA250_0==RULE_INT) ) {
                                alt250=1;
                            }
                            else if ( (LA250_0==RULE_DECIMAL) ) {
                                alt250=2;
                            }
                            else {
                                if (state.backtracking>0) {state.failed=true; return current;}
                                NoViableAltException nvae =
                                    new NoViableAltException("", 250, 0, input);

                                throw nvae;
                            }
                            switch (alt250) {
                                case 1 :
                                    {
                                    this_INT_4=(Token)match(input,RULE_INT,FOLLOW_2); if (state.failed) return current;
                                    if ( state.backtracking==0 ) {

                                      						current.merge(this_INT_4);
                                      					
                                    }
                                    if ( state.backtracking==0 ) {

                                      						newLeafNode(this_INT_4, grammarAccess.getNumberAccess().getINTTerminalRuleCall_1_1_1_0());
                                      					
                                    }

                                    }
                                    break;
                                case 2 :
                                    {
                                    this_DECIMAL_5=(Token)match(input,RULE_DECIMAL,FOLLOW_2); if (state.failed) return current;
                                    if ( state.backtracking==0 ) {

                                      						current.merge(this_DECIMAL_5);
                                      					
                                    }
                                    if ( state.backtracking==0 ) {

                                      						newLeafNode(this_DECIMAL_5, grammarAccess.getNumberAccess().getDECIMALTerminalRuleCall_1_1_1_1());
                                      					
                                    }

                                    }
                                    break;

                            }


                            }
                            break;

                    }


                    }


                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {

            	myHiddenTokenState.restore();

        }
        return current;
    }
    public final EObject entryRuleJvmTypeReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmTypeReference = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmTypeReference=ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmTypeReference; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmTypeReference() throws RecognitionException {
        EObject current = null;

        EObject this_JvmParameterizedTypeReference_0 = null;

        EObject this_XFunctionTypeRef_3 = null;



        	enterRule();

        try {
            {
            int alt254=2;
            int LA254_0 = input.LA(1);

            if ( (LA254_0==KW_Annotation||LA254_0==KW_Create||(LA254_0>=KW_AFTER && LA254_0<=KW_SEPARATOR)||LA254_0==RULE_ID) ) {
                alt254=1;
            }
            else if ( (LA254_0==KW_LeftParenthesis||LA254_0==KW_EqualsSignGreaterThanSign) ) {
                alt254=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 254, 0, input);

                throw nvae;
            }
            switch (alt254) {
                case 1 :
                    {
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getJvmTypeReferenceAccess().getJvmParameterizedTypeReferenceParserRuleCall_0_0());
                      			
                    }
                    pushFollow(FOLLOW_50);
                    this_JvmParameterizedTypeReference_0=ruleJvmParameterizedTypeReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_JvmParameterizedTypeReference_0;
                      				afterParserOrEnumRuleCall();
                      			
                    }
                    loop253:
                    do {
                        int alt253=2;
                        int LA253_0 = input.LA(1);

                        if ( (LA253_0==KW_LeftSquareBracket) ) {
                            int LA253_2 = input.LA(2);

                            if ( (LA253_2==KW_RightSquareBracket) ) {
                                int LA253_3 = input.LA(3);

                                if ( (synpred61_InternalXtend()) ) {
                                    alt253=1;
                                }


                            }


                        }


                        switch (alt253) {
                    	case 1 :
                    	    {
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							current = forceCreateModelElementAndSet(
                    	      								grammarAccess.getJvmTypeReferenceAccess().getJvmGenericArrayTypeReferenceComponentTypeAction_0_1_0_0(),
                    	      								current);
                    	      						
                    	    }

                    	    }

                    	    if ( state.backtracking==0 ) {

                    	      						newCompositeNode(grammarAccess.getJvmTypeReferenceAccess().getArrayBracketsParserRuleCall_0_1_0_1());
                    	      					
                    	    }
                    	    pushFollow(FOLLOW_50);
                    	    ruleArrayBrackets();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      						afterParserOrEnumRuleCall();
                    	      					
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop253;
                        }
                    } while (true);


                    }


                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getJvmTypeReferenceAccess().getXFunctionTypeRefParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_XFunctionTypeRef_3=ruleXFunctionTypeRef();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_XFunctionTypeRef_3;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleArrayBrackets() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleArrayBrackets = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getArrayBracketsRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleArrayBrackets=ruleArrayBrackets();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleArrayBrackets.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleArrayBrackets() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;


        	enterRule();

        try {
            {
            {
            kw=(Token)match(input,KW_LeftSquareBracket,FOLLOW_107); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current.merge(kw);
              			newLeafNode(kw, grammarAccess.getArrayBracketsAccess().getLeftSquareBracketKeyword_0());
              		
            }
            kw=(Token)match(input,KW_RightSquareBracket,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current.merge(kw);
              			newLeafNode(kw, grammarAccess.getArrayBracketsAccess().getRightSquareBracketKeyword_1());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXFunctionTypeRef() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXFunctionTypeRef = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXFunctionTypeRefRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXFunctionTypeRef=ruleXFunctionTypeRef();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXFunctionTypeRef; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXFunctionTypeRef() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        EObject lv_paramTypes_1_0 = null;

        EObject lv_paramTypes_3_0 = null;

        EObject lv_returnType_6_0 = null;



        	enterRule();

        try {
            {
            {
            int alt257=2;
            int LA257_0 = input.LA(1);

            if ( (LA257_0==KW_LeftParenthesis) ) {
                alt257=1;
            }
            switch (alt257) {
                case 1 :
                    {
                    otherlv_0=(Token)match(input,KW_LeftParenthesis,FOLLOW_27); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_0, grammarAccess.getXFunctionTypeRefAccess().getLeftParenthesisKeyword_0_0());
                      			
                    }
                    int alt256=2;
                    int LA256_0 = input.LA(1);

                    if ( ((LA256_0>=KW_Annotation && LA256_0<=KW_LeftParenthesis)||LA256_0==KW_EqualsSignGreaterThanSign||LA256_0==KW_Create||(LA256_0>=KW_AFTER && LA256_0<=KW_SEPARATOR)||LA256_0==RULE_ID) ) {
                        alt256=1;
                    }
                    switch (alt256) {
                        case 1 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              							newCompositeNode(grammarAccess.getXFunctionTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_0_0());
                              						
                            }
                            pushFollow(FOLLOW_28);
                            lv_paramTypes_1_0=ruleJvmTypeReference();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElementForParent(grammarAccess.getXFunctionTypeRefRule());
                              							}
                              							add(
                              								current,
                              								"paramTypes",
                              								lv_paramTypes_1_0,
                              								"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                              							afterParserOrEnumRuleCall();
                              						
                            }

                            }


                            }
                            loop255:
                            do {
                                int alt255=2;
                                int LA255_0 = input.LA(1);

                                if ( (LA255_0==KW_Comma) ) {
                                    alt255=1;
                                }


                                switch (alt255) {
                            	case 1 :
                            	    {
                            	    otherlv_2=(Token)match(input,KW_Comma,FOLLOW_29); if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      						newLeafNode(otherlv_2, grammarAccess.getXFunctionTypeRefAccess().getCommaKeyword_0_1_1_0());
                            	      					
                            	    }
                            	    {
                            	    {
                            	    if ( state.backtracking==0 ) {

                            	      								newCompositeNode(grammarAccess.getXFunctionTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_1_1_0());
                            	      							
                            	    }
                            	    pushFollow(FOLLOW_28);
                            	    lv_paramTypes_3_0=ruleJvmTypeReference();

                            	    state._fsp--;
                            	    if (state.failed) return current;
                            	    if ( state.backtracking==0 ) {

                            	      								if (current==null) {
                            	      									current = createModelElementForParent(grammarAccess.getXFunctionTypeRefRule());
                            	      								}
                            	      								add(
                            	      									current,
                            	      									"paramTypes",
                            	      									lv_paramTypes_3_0,
                            	      									"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
                            	      								afterParserOrEnumRuleCall();
                            	      							
                            	    }

                            	    }


                            	    }


                            	    }
                            	    break;

                            	default :
                            	    break loop255;
                                }
                            } while (true);


                            }
                            break;

                    }

                    otherlv_4=(Token)match(input,KW_RightParenthesis,FOLLOW_30); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_4, grammarAccess.getXFunctionTypeRefAccess().getRightParenthesisKeyword_0_2());
                      			
                    }

                    }
                    break;

            }

            otherlv_5=(Token)match(input,KW_EqualsSignGreaterThanSign,FOLLOW_29); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_5, grammarAccess.getXFunctionTypeRefAccess().getEqualsSignGreaterThanSignKeyword_1());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getXFunctionTypeRefAccess().getReturnTypeJvmTypeReferenceParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_returnType_6_0=ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getXFunctionTypeRefRule());
              					}
              					set(
              						current,
              						"returnType",
              						lv_returnType_6_0,
              						"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleJvmParameterizedTypeReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmParameterizedTypeReference = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmParameterizedTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmParameterizedTypeReference=ruleJvmParameterizedTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmParameterizedTypeReference; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmParameterizedTypeReference() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        Token otherlv_11=null;
        Token otherlv_13=null;
        EObject lv_arguments_2_0 = null;

        EObject lv_arguments_4_0 = null;

        EObject lv_arguments_10_0 = null;

        EObject lv_arguments_12_0 = null;



        	enterRule();

        try {
            {
            {
            {
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getJvmParameterizedTypeReferenceRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeCrossReference_0_0());
              				
            }
            pushFollow(FOLLOW_126);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            int alt262=2;
            alt262 = dfa262.predict(input);
            switch (alt262) {
                case 1 :
                    {
                    {
                    otherlv_1=(Token)match(input,KW_LessThanSign,FOLLOW_53); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_1, grammarAccess.getJvmParameterizedTypeReferenceAccess().getLessThanSignKeyword_1_0());
                      				
                    }

                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0());
                      					
                    }
                    pushFollow(FOLLOW_10);
                    lv_arguments_2_0=ruleJvmArgumentTypeReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getJvmParameterizedTypeReferenceRule());
                      						}
                      						add(
                      							current,
                      							"arguments",
                      							lv_arguments_2_0,
                      							"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }
                    loop258:
                    do {
                        int alt258=2;
                        int LA258_0 = input.LA(1);

                        if ( (LA258_0==KW_Comma) ) {
                            alt258=1;
                        }


                        switch (alt258) {
                    	case 1 :
                    	    {
                    	    otherlv_3=(Token)match(input,KW_Comma,FOLLOW_53); if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      					newLeafNode(otherlv_3, grammarAccess.getJvmParameterizedTypeReferenceAccess().getCommaKeyword_1_2_0());
                    	      				
                    	    }
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_10);
                    	    lv_arguments_4_0=ruleJvmArgumentTypeReference();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getJvmParameterizedTypeReferenceRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"arguments",
                    	      								lv_arguments_4_0,
                    	      								"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop258;
                        }
                    } while (true);

                    otherlv_5=(Token)match(input,KW_GreaterThanSign,FOLLOW_54); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_5, grammarAccess.getJvmParameterizedTypeReferenceAccess().getGreaterThanSignKeyword_1_3());
                      			
                    }
                    loop261:
                    do {
                        int alt261=2;
                        alt261 = dfa261.predict(input);
                        switch (alt261) {
                    	case 1 :
                    	    {
                    	    {
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      								current = forceCreateModelElementAndSet(
                    	      									grammarAccess.getJvmParameterizedTypeReferenceAccess().getJvmInnerTypeReferenceOuterAction_1_4_0_0_0(),
                    	      									current);
                    	      							
                    	    }

                    	    }

                    	    otherlv_7=(Token)match(input,KW_FullStop,FOLLOW_3); if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							newLeafNode(otherlv_7, grammarAccess.getJvmParameterizedTypeReferenceAccess().getFullStopKeyword_1_4_0_0_1());
                    	      						
                    	    }

                    	    }


                    	    }
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElement(grammarAccess.getJvmParameterizedTypeReferenceRule());
                    	      							}
                    	      						
                    	    }
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeCrossReference_1_4_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_55);
                    	    ruleValidID();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    int alt260=2;
                    	    alt260 = dfa260.predict(input);
                    	    switch (alt260) {
                    	        case 1 :
                    	            {
                    	            {
                    	            otherlv_9=(Token)match(input,KW_LessThanSign,FOLLOW_53); if (state.failed) return current;
                    	            if ( state.backtracking==0 ) {

                    	              							newLeafNode(otherlv_9, grammarAccess.getJvmParameterizedTypeReferenceAccess().getLessThanSignKeyword_1_4_2_0());
                    	              						
                    	            }

                    	            }
                    	            {
                    	            {
                    	            if ( state.backtracking==0 ) {

                    	              								newCompositeNode(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_1_0());
                    	              							
                    	            }
                    	            pushFollow(FOLLOW_10);
                    	            lv_arguments_10_0=ruleJvmArgumentTypeReference();

                    	            state._fsp--;
                    	            if (state.failed) return current;
                    	            if ( state.backtracking==0 ) {

                    	              								if (current==null) {
                    	              									current = createModelElementForParent(grammarAccess.getJvmParameterizedTypeReferenceRule());
                    	              								}
                    	              								add(
                    	              									current,
                    	              									"arguments",
                    	              									lv_arguments_10_0,
                    	              									"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
                    	              								afterParserOrEnumRuleCall();
                    	              							
                    	            }

                    	            }


                    	            }
                    	            loop259:
                    	            do {
                    	                int alt259=2;
                    	                int LA259_0 = input.LA(1);

                    	                if ( (LA259_0==KW_Comma) ) {
                    	                    alt259=1;
                    	                }


                    	                switch (alt259) {
                    	            	case 1 :
                    	            	    {
                    	            	    otherlv_11=(Token)match(input,KW_Comma,FOLLOW_53); if (state.failed) return current;
                    	            	    if ( state.backtracking==0 ) {

                    	            	      							newLeafNode(otherlv_11, grammarAccess.getJvmParameterizedTypeReferenceAccess().getCommaKeyword_1_4_2_2_0());
                    	            	      						
                    	            	    }
                    	            	    {
                    	            	    {
                    	            	    if ( state.backtracking==0 ) {

                    	            	      									newCompositeNode(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_2_1_0());
                    	            	      								
                    	            	    }
                    	            	    pushFollow(FOLLOW_10);
                    	            	    lv_arguments_12_0=ruleJvmArgumentTypeReference();

                    	            	    state._fsp--;
                    	            	    if (state.failed) return current;
                    	            	    if ( state.backtracking==0 ) {

                    	            	      									if (current==null) {
                    	            	      										current = createModelElementForParent(grammarAccess.getJvmParameterizedTypeReferenceRule());
                    	            	      									}
                    	            	      									add(
                    	            	      										current,
                    	            	      										"arguments",
                    	            	      										lv_arguments_12_0,
                    	            	      										"org.eclipse.xtext.xbase.Xtype.JvmArgumentTypeReference");
                    	            	      									afterParserOrEnumRuleCall();
                    	            	      								
                    	            	    }

                    	            	    }


                    	            	    }


                    	            	    }
                    	            	    break;

                    	            	default :
                    	            	    break loop259;
                    	                }
                    	            } while (true);

                    	            otherlv_13=(Token)match(input,KW_GreaterThanSign,FOLLOW_54); if (state.failed) return current;
                    	            if ( state.backtracking==0 ) {

                    	              						newLeafNode(otherlv_13, grammarAccess.getJvmParameterizedTypeReferenceAccess().getGreaterThanSignKeyword_1_4_2_3());
                    	              					
                    	            }

                    	            }
                    	            break;

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop261;
                        }
                    } while (true);


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleJvmArgumentTypeReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmArgumentTypeReference = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmArgumentTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmArgumentTypeReference=ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmArgumentTypeReference; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmArgumentTypeReference() throws RecognitionException {
        EObject current = null;

        EObject this_JvmTypeReference_0 = null;

        EObject this_JvmWildcardTypeReference_1 = null;



        	enterRule();

        try {
            {
            int alt263=2;
            int LA263_0 = input.LA(1);

            if ( ((LA263_0>=KW_Annotation && LA263_0<=KW_LeftParenthesis)||LA263_0==KW_EqualsSignGreaterThanSign||LA263_0==KW_Create||(LA263_0>=KW_AFTER && LA263_0<=KW_SEPARATOR)||LA263_0==RULE_ID) ) {
                alt263=1;
            }
            else if ( (LA263_0==KW_QuestionMark) ) {
                alt263=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 263, 0, input);

                throw nvae;
            }
            switch (alt263) {
                case 1 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getJvmArgumentTypeReferenceAccess().getJvmTypeReferenceParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_JvmTypeReference_0=ruleJvmTypeReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_JvmTypeReference_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getJvmArgumentTypeReferenceAccess().getJvmWildcardTypeReferenceParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_JvmWildcardTypeReference_1=ruleJvmWildcardTypeReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_JvmWildcardTypeReference_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleJvmWildcardTypeReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmWildcardTypeReference = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmWildcardTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmWildcardTypeReference=ruleJvmWildcardTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmWildcardTypeReference; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmWildcardTypeReference() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_constraints_2_0 = null;

        EObject lv_constraints_3_0 = null;

        EObject lv_constraints_4_0 = null;

        EObject lv_constraints_5_0 = null;



        	enterRule();

        try {
            {
            {
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getJvmWildcardTypeReferenceAccess().getJvmWildcardTypeReferenceAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,KW_QuestionMark,FOLLOW_127); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getJvmWildcardTypeReferenceAccess().getQuestionMarkKeyword_1());
              		
            }
            int alt266=3;
            int LA266_0 = input.LA(1);

            if ( (LA266_0==KW_Extends) ) {
                alt266=1;
            }
            else if ( (LA266_0==KW_Super) ) {
                alt266=2;
            }
            switch (alt266) {
                case 1 :
                    {
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmUpperBoundParserRuleCall_2_0_0_0());
                      						
                    }
                    pushFollow(FOLLOW_128);
                    lv_constraints_2_0=ruleJvmUpperBound();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getJvmWildcardTypeReferenceRule());
                      							}
                      							add(
                      								current,
                      								"constraints",
                      								lv_constraints_2_0,
                      								"org.eclipse.xtext.xbase.Xtype.JvmUpperBound");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    loop264:
                    do {
                        int alt264=2;
                        int LA264_0 = input.LA(1);

                        if ( (LA264_0==KW_Ampersand) ) {
                            alt264=1;
                        }


                        switch (alt264) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmUpperBoundAndedParserRuleCall_2_0_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_128);
                    	    lv_constraints_3_0=ruleJvmUpperBoundAnded();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getJvmWildcardTypeReferenceRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"constraints",
                    	      								lv_constraints_3_0,
                    	      								"org.eclipse.xtext.xbase.Xtype.JvmUpperBoundAnded");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop264;
                        }
                    } while (true);


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmLowerBoundParserRuleCall_2_1_0_0());
                      						
                    }
                    pushFollow(FOLLOW_128);
                    lv_constraints_4_0=ruleJvmLowerBound();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getJvmWildcardTypeReferenceRule());
                      							}
                      							add(
                      								current,
                      								"constraints",
                      								lv_constraints_4_0,
                      								"org.eclipse.xtext.xbase.Xtype.JvmLowerBound");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    loop265:
                    do {
                        int alt265=2;
                        int LA265_0 = input.LA(1);

                        if ( (LA265_0==KW_Ampersand) ) {
                            alt265=1;
                        }


                        switch (alt265) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      							newCompositeNode(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmLowerBoundAndedParserRuleCall_2_1_1_0());
                    	      						
                    	    }
                    	    pushFollow(FOLLOW_128);
                    	    lv_constraints_5_0=ruleJvmLowerBoundAnded();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      							if (current==null) {
                    	      								current = createModelElementForParent(grammarAccess.getJvmWildcardTypeReferenceRule());
                    	      							}
                    	      							add(
                    	      								current,
                    	      								"constraints",
                    	      								lv_constraints_5_0,
                    	      								"org.eclipse.xtext.xbase.Xtype.JvmLowerBoundAnded");
                    	      							afterParserOrEnumRuleCall();
                    	      						
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop265;
                        }
                    } while (true);


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleJvmUpperBound() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmUpperBound = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmUpperBoundRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmUpperBound=ruleJvmUpperBound();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmUpperBound; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmUpperBound() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_typeReference_1_0 = null;



        	enterRule();

        try {
            {
            {
            otherlv_0=(Token)match(input,KW_Extends,FOLLOW_29); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getJvmUpperBoundAccess().getExtendsKeyword_0());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getJvmUpperBoundAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_typeReference_1_0=ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getJvmUpperBoundRule());
              					}
              					set(
              						current,
              						"typeReference",
              						lv_typeReference_1_0,
              						"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleJvmUpperBoundAnded() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmUpperBoundAnded = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmUpperBoundAndedRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmUpperBoundAnded=ruleJvmUpperBoundAnded();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmUpperBoundAnded; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmUpperBoundAnded() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_typeReference_1_0 = null;



        	enterRule();

        try {
            {
            {
            otherlv_0=(Token)match(input,KW_Ampersand,FOLLOW_29); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getJvmUpperBoundAndedAccess().getAmpersandKeyword_0());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getJvmUpperBoundAndedAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_typeReference_1_0=ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getJvmUpperBoundAndedRule());
              					}
              					set(
              						current,
              						"typeReference",
              						lv_typeReference_1_0,
              						"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleJvmLowerBound() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmLowerBound = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmLowerBoundRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmLowerBound=ruleJvmLowerBound();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmLowerBound; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmLowerBound() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_typeReference_1_0 = null;



        	enterRule();

        try {
            {
            {
            otherlv_0=(Token)match(input,KW_Super,FOLLOW_29); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getJvmLowerBoundAccess().getSuperKeyword_0());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getJvmLowerBoundAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_typeReference_1_0=ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getJvmLowerBoundRule());
              					}
              					set(
              						current,
              						"typeReference",
              						lv_typeReference_1_0,
              						"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleJvmLowerBoundAnded() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmLowerBoundAnded = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmLowerBoundAndedRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmLowerBoundAnded=ruleJvmLowerBoundAnded();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmLowerBoundAnded; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmLowerBoundAnded() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_typeReference_1_0 = null;



        	enterRule();

        try {
            {
            {
            otherlv_0=(Token)match(input,KW_Ampersand,FOLLOW_29); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getJvmLowerBoundAndedAccess().getAmpersandKeyword_0());
              		
            }
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getJvmLowerBoundAndedAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_typeReference_1_0=ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getJvmLowerBoundAndedRule());
              					}
              					set(
              						current,
              						"typeReference",
              						lv_typeReference_1_0,
              						"org.eclipse.xtext.xbase.Xtype.JvmTypeReference");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleJvmTypeParameter() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJvmTypeParameter = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getJvmTypeParameterRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleJvmTypeParameter=ruleJvmTypeParameter();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleJvmTypeParameter; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleJvmTypeParameter() throws RecognitionException {
        EObject current = null;

        AntlrDatatypeRuleToken lv_name_0_0 = null;

        EObject lv_constraints_1_0 = null;

        EObject lv_constraints_2_0 = null;



        	enterRule();

        try {
            {
            {
            {
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getJvmTypeParameterAccess().getNameValidIDParserRuleCall_0_0());
              				
            }
            pushFollow(FOLLOW_129);
            lv_name_0_0=ruleValidID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getJvmTypeParameterRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_0_0,
              						"org.eclipse.xtend.core.Xtend.ValidID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }
            int alt268=2;
            int LA268_0 = input.LA(1);

            if ( (LA268_0==KW_Extends) ) {
                alt268=1;
            }
            switch (alt268) {
                case 1 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getJvmTypeParameterAccess().getConstraintsJvmUpperBoundParserRuleCall_1_0_0());
                      					
                    }
                    pushFollow(FOLLOW_128);
                    lv_constraints_1_0=ruleJvmUpperBound();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getJvmTypeParameterRule());
                      						}
                      						add(
                      							current,
                      							"constraints",
                      							lv_constraints_1_0,
                      							"org.eclipse.xtext.xbase.Xtype.JvmUpperBound");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }
                    loop267:
                    do {
                        int alt267=2;
                        int LA267_0 = input.LA(1);

                        if ( (LA267_0==KW_Ampersand) ) {
                            alt267=1;
                        }


                        switch (alt267) {
                    	case 1 :
                    	    {
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      						newCompositeNode(grammarAccess.getJvmTypeParameterAccess().getConstraintsJvmUpperBoundAndedParserRuleCall_1_1_0());
                    	      					
                    	    }
                    	    pushFollow(FOLLOW_128);
                    	    lv_constraints_2_0=ruleJvmUpperBoundAnded();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      						if (current==null) {
                    	      							current = createModelElementForParent(grammarAccess.getJvmTypeParameterRule());
                    	      						}
                    	      						add(
                    	      							current,
                    	      							"constraints",
                    	      							lv_constraints_2_0,
                    	      							"org.eclipse.xtext.xbase.Xtype.JvmUpperBoundAnded");
                    	      						afterParserOrEnumRuleCall();
                    	      					
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop267;
                        }
                    } while (true);


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleQualifiedNameWithWildcard() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleQualifiedNameWithWildcard = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getQualifiedNameWithWildcardRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleQualifiedNameWithWildcard=ruleQualifiedNameWithWildcard();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleQualifiedNameWithWildcard.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleQualifiedNameWithWildcard() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_QualifiedName_0 = null;



        	enterRule();

        try {
            {
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_130);
            this_QualifiedName_0=ruleQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current.merge(this_QualifiedName_0);
              		
            }
            if ( state.backtracking==0 ) {

              			afterParserOrEnumRuleCall();
              		
            }
            kw=(Token)match(input,KW_FullStop,FOLLOW_131); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current.merge(kw);
              			newLeafNode(kw, grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopKeyword_1());
              		
            }
            kw=(Token)match(input,KW_Asterisk,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current.merge(kw);
              			newLeafNode(kw, grammarAccess.getQualifiedNameWithWildcardAccess().getAsteriskKeyword_2());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXImportSection() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXImportSection = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXImportSectionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXImportSection=ruleXImportSection();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXImportSection; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXImportSection() throws RecognitionException {
        EObject current = null;

        EObject lv_importDeclarations_0_0 = null;



        	enterRule();

        try {
            {
            int cnt269=0;
            loop269:
            do {
                int alt269=2;
                int LA269_0 = input.LA(1);

                if ( (LA269_0==KW_Import) ) {
                    alt269=1;
                }


                switch (alt269) {
            	case 1 :
            	    {
            	    {
            	    if ( state.backtracking==0 ) {

            	      				newCompositeNode(grammarAccess.getXImportSectionAccess().getImportDeclarationsXImportDeclarationParserRuleCall_0());
            	      			
            	    }
            	    pushFollow(FOLLOW_132);
            	    lv_importDeclarations_0_0=ruleXImportDeclaration();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      				if (current==null) {
            	      					current = createModelElementForParent(grammarAccess.getXImportSectionRule());
            	      				}
            	      				add(
            	      					current,
            	      					"importDeclarations",
            	      					lv_importDeclarations_0_0,
            	      					"org.eclipse.xtext.xbase.Xtype.XImportDeclaration");
            	      				afterParserOrEnumRuleCall();
            	      			
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt269 >= 1 ) break loop269;
            	    if (state.backtracking>0) {state.failed=true; return current;}
                        EarlyExitException eee =
                            new EarlyExitException(269, input);
                        throw eee;
                }
                cnt269++;
            } while (true);


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject entryRuleXImportDeclaration() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleXImportDeclaration = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getXImportDeclarationRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleXImportDeclaration=ruleXImportDeclaration();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleXImportDeclaration; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final EObject ruleXImportDeclaration() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_static_1_0=null;
        Token lv_extension_2_0=null;
        Token lv_wildcard_4_0=null;
        Token otherlv_8=null;
        AntlrDatatypeRuleToken lv_memberName_5_0 = null;

        AntlrDatatypeRuleToken lv_importedNamespace_7_0 = null;



        	enterRule();

        try {
            {
            {
            otherlv_0=(Token)match(input,KW_Import,FOLLOW_133); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getXImportDeclarationAccess().getImportKeyword_0());
              		
            }
            int alt272=3;
            alt272 = dfa272.predict(input);
            switch (alt272) {
                case 1 :
                    {
                    {
                    {
                    {
                    lv_static_1_0=(Token)match(input,KW_Static,FOLLOW_134); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							newLeafNode(lv_static_1_0, grammarAccess.getXImportDeclarationAccess().getStaticStaticKeyword_1_0_0_0());
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getXImportDeclarationRule());
                      							}
                      							setWithLastConsumed(current, "static", true, "static");
                      						
                    }

                    }


                    }
                    int alt270=2;
                    int LA270_0 = input.LA(1);

                    if ( (LA270_0==KW_Extension) ) {
                        alt270=1;
                    }
                    switch (alt270) {
                        case 1 :
                            {
                            {
                            lv_extension_2_0=(Token)match(input,KW_Extension,FOLLOW_134); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              							newLeafNode(lv_extension_2_0, grammarAccess.getXImportDeclarationAccess().getExtensionExtensionKeyword_1_0_1_0());
                              						
                            }
                            if ( state.backtracking==0 ) {

                              							if (current==null) {
                              								current = createModelElement(grammarAccess.getXImportDeclarationRule());
                              							}
                              							setWithLastConsumed(current, "extension", true, "extension");
                              						
                            }

                            }


                            }
                            break;

                    }
                    {
                    {
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getXImportDeclarationRule());
                      							}
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeCrossReference_1_0_2_0());
                      						
                    }
                    pushFollow(FOLLOW_135);
                    ruleQualifiedNameInStaticImport();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }
                    int alt271=2;
                    int LA271_0 = input.LA(1);

                    if ( (LA271_0==KW_Asterisk) ) {
                        alt271=1;
                    }
                    else if ( (LA271_0==KW_Annotation||LA271_0==KW_Create||(LA271_0>=KW_AFTER && LA271_0<=KW_SEPARATOR)||LA271_0==RULE_ID) ) {
                        alt271=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 271, 0, input);

                        throw nvae;
                    }
                    switch (alt271) {
                        case 1 :
                            {
                            {
                            {
                            lv_wildcard_4_0=(Token)match(input,KW_Asterisk,FOLLOW_35); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								newLeafNode(lv_wildcard_4_0, grammarAccess.getXImportDeclarationAccess().getWildcardAsteriskKeyword_1_0_3_0_0());
                              							
                            }
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElement(grammarAccess.getXImportDeclarationRule());
                              								}
                              								setWithLastConsumed(current, "wildcard", true, "*");
                              							
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            {
                            {
                            {
                            if ( state.backtracking==0 ) {

                              								newCompositeNode(grammarAccess.getXImportDeclarationAccess().getMemberNameValidIDParserRuleCall_1_0_3_1_0());
                              							
                            }
                            pushFollow(FOLLOW_35);
                            lv_memberName_5_0=ruleValidID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElementForParent(grammarAccess.getXImportDeclarationRule());
                              								}
                              								set(
                              									current,
                              									"memberName",
                              									lv_memberName_5_0,
                              									"org.eclipse.xtend.core.Xtend.ValidID");
                              								afterParserOrEnumRuleCall();
                              							
                            }

                            }


                            }


                            }
                            break;

                    }


                    }


                    }
                    break;
                case 2 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getXImportDeclarationRule());
                      						}
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeCrossReference_1_1_0());
                      					
                    }
                    pushFollow(FOLLOW_35);
                    ruleQualifiedName();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 3 :
                    {
                    {
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getXImportDeclarationAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_2_0());
                      					
                    }
                    pushFollow(FOLLOW_35);
                    lv_importedNamespace_7_0=ruleQualifiedNameWithWildcard();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getXImportDeclarationRule());
                      						}
                      						set(
                      							current,
                      							"importedNamespace",
                      							lv_importedNamespace_7_0,
                      							"org.eclipse.xtext.xbase.Xtype.QualifiedNameWithWildcard");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;

            }
            int alt273=2;
            int LA273_0 = input.LA(1);

            if ( (LA273_0==KW_Semicolon) ) {
                alt273=1;
            }
            switch (alt273) {
                case 1 :
                    {
                    otherlv_8=(Token)match(input,KW_Semicolon,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_8, grammarAccess.getXImportDeclarationAccess().getSemicolonKeyword_2());
                      			
                    }

                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final String entryRuleQualifiedNameInStaticImport() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleQualifiedNameInStaticImport = null;


        try {
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getQualifiedNameInStaticImportRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleQualifiedNameInStaticImport=ruleQualifiedNameInStaticImport();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleQualifiedNameInStaticImport.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final AntlrDatatypeRuleToken ruleQualifiedNameInStaticImport() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_ValidID_0 = null;



        	enterRule();

        try {
            {
            int cnt274=0;
            loop274:
            do {
                int alt274=2;
                switch ( input.LA(1) ) {
                case RULE_ID:
                    {
                    int LA274_2 = input.LA(2);

                    if ( (LA274_2==KW_FullStop) ) {
                        alt274=1;
                    }


                    }
                    break;
                case KW_Create:
                    {
                    int LA274_3 = input.LA(2);

                    if ( (LA274_3==KW_FullStop) ) {
                        alt274=1;
                    }


                    }
                    break;
                case KW_Annotation:
                    {
                    int LA274_4 = input.LA(2);

                    if ( (LA274_4==KW_FullStop) ) {
                        alt274=1;
                    }


                    }
                    break;
                case KW_AFTER:
                    {
                    int LA274_5 = input.LA(2);

                    if ( (LA274_5==KW_FullStop) ) {
                        alt274=1;
                    }


                    }
                    break;
                case KW_BEFORE:
                    {
                    int LA274_6 = input.LA(2);

                    if ( (LA274_6==KW_FullStop) ) {
                        alt274=1;
                    }


                    }
                    break;
                case KW_SEPARATOR:
                    {
                    int LA274_7 = input.LA(2);

                    if ( (LA274_7==KW_FullStop) ) {
                        alt274=1;
                    }


                    }
                    break;

                }

                switch (alt274) {
            	case 1 :
            	    {
            	    if ( state.backtracking==0 ) {

            	      			newCompositeNode(grammarAccess.getQualifiedNameInStaticImportAccess().getValidIDParserRuleCall_0());
            	      		
            	    }
            	    pushFollow(FOLLOW_130);
            	    this_ValidID_0=ruleValidID();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      			current.merge(this_ValidID_0);
            	      		
            	    }
            	    if ( state.backtracking==0 ) {

            	      			afterParserOrEnumRuleCall();
            	      		
            	    }
            	    kw=(Token)match(input,KW_FullStop,FOLLOW_136); if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      			current.merge(kw);
            	      			newLeafNode(kw, grammarAccess.getQualifiedNameInStaticImportAccess().getFullStopKeyword_1());
            	      		
            	    }

            	    }
            	    break;

            	default :
            	    if ( cnt274 >= 1 ) break loop274;
            	    if (state.backtracking>0) {state.failed=true; return current;}
                        EarlyExitException eee =
                            new EarlyExitException(274, input);
                        throw eee;
                }
                cnt274++;
            } while (true);


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    public final void synpred1_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        {
        pushFollow(FOLLOW_41);
        ruleJvmTypeReference();

        state._fsp--;
        if (state.failed) return ;

        }


        }
        {
        {
        pushFollow(FOLLOW_3);
        ruleCreateExtensionInfo();

        state._fsp--;
        if (state.failed) return ;

        }


        }
        {
        {
        pushFollow(FOLLOW_42);
        ruleValidID();

        state._fsp--;
        if (state.failed) return ;

        }


        }

        match(input,KW_LeftParenthesis,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred2_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        {
        pushFollow(FOLLOW_40);
        ruleTypeReferenceWithTypeArgs();

        state._fsp--;
        if (state.failed) return ;

        }


        }
        {
        {
        pushFollow(FOLLOW_42);
        ruleFunctionID();

        state._fsp--;
        if (state.failed) return ;

        }


        }

        match(input,KW_LeftParenthesis,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred3_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        {
        pushFollow(FOLLOW_40);
        ruleTypeReferenceNoTypeArgs();

        state._fsp--;
        if (state.failed) return ;

        }


        }
        {
        {
        pushFollow(FOLLOW_42);
        ruleFunctionID();

        state._fsp--;
        if (state.failed) return ;

        }


        }

        match(input,KW_LeftParenthesis,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred4_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        {
        pushFollow(FOLLOW_3);
        ruleCreateExtensionInfo();

        state._fsp--;
        if (state.failed) return ;

        }


        }
        {
        {
        pushFollow(FOLLOW_42);
        ruleValidID();

        state._fsp--;
        if (state.failed) return ;

        }


        }

        match(input,KW_LeftParenthesis,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred5_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        pushFollow(FOLLOW_2);
        ruleArrayBrackets();

        state._fsp--;
        if (state.failed) return ;

        }


        }
    }
    public final void synpred6_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        pushFollow(FOLLOW_2);
        ruleArrayBrackets();

        state._fsp--;
        if (state.failed) return ;

        }


        }
    }
    public final void synpred7_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_FullStop,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred8_InternalXtend_fragment() throws RecognitionException {   
        {
        match(input,KW_LessThanSign,FOLLOW_2); if (state.failed) return ;

        }
    }
    public final void synpred10_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        {
        pushFollow(FOLLOW_60);
        ruleJvmTypeReference();

        state._fsp--;
        if (state.failed) return ;

        }


        }
        {
        {
        pushFollow(FOLLOW_2);
        ruleInnerVarID();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred11_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_LeftCurlyBracket,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred12_InternalXtend_fragment() throws RecognitionException {   
        {
        match(input,KW_LessThanSign,FOLLOW_2); if (state.failed) return ;

        }
    }
    public final void synpred13_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        match(input,KW_LeftParenthesis,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred14_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        int alt280=2;
        int LA280_0 = input.LA(1);

        if ( (LA280_0==KW_Package||LA280_0==KW_Class||(LA280_0>=KW_Extends && LA280_0<=KW_Implements)||(LA280_0>=KW_Interface && LA280_0<=KW_LeftParenthesis)||LA280_0==KW_EqualsSignGreaterThanSign||(LA280_0>=KW_Extension && LA280_0<=KW_Throws)||(LA280_0>=KW_Public && LA280_0<=KW_Transient)||(LA280_0>=KW_Def && LA280_0<=KW_Create)||(LA280_0>=KW_AFTER && LA280_0<=KW_Import)||LA280_0==RULE_ID) ) {
            alt280=1;
        }
        switch (alt280) {
            case 1 :
                {
                {
                {
                pushFollow(FOLLOW_105);
                ruleJvmFormalParameter();

                state._fsp--;
                if (state.failed) return ;

                }


                }
                loop279:
                do {
                    int alt279=2;
                    int LA279_0 = input.LA(1);

                    if ( (LA279_0==KW_Comma) ) {
                        alt279=1;
                    }


                    switch (alt279) {
                	case 1 :
                	    {
                	    match(input,KW_Comma,FOLLOW_58); if (state.failed) return ;
                	    {
                	    {
                	    pushFollow(FOLLOW_105);
                	    ruleJvmFormalParameter();

                	    state._fsp--;
                	    if (state.failed) return ;

                	    }


                	    }


                	    }
                	    break;

                	default :
                	    break loop279;
                    }
                } while (true);


                }
                break;

        }
        {
        {
        match(input,KW_VerticalLine,FOLLOW_2); if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred15_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_LeftSquareBracket,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred16_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        match(input,KW_LeftParenthesis,FOLLOW_58); if (state.failed) return ;
        {
        {
        pushFollow(FOLLOW_56);
        ruleJvmFormalParameter();

        state._fsp--;
        if (state.failed) return ;

        }


        }

        match(input,KW_Colon,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred17_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        {
        pushFollow(FOLLOW_56);
        ruleJvmFormalParameter();

        state._fsp--;
        if (state.failed) return ;

        }


        }

        match(input,KW_Colon,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred18_InternalXtend_fragment() throws RecognitionException {   
        {
        match(input,KW_New,FOLLOW_2); if (state.failed) return ;

        }
    }
    public final void synpred19_InternalXtend_fragment() throws RecognitionException {   
        {
        match(input,KW_LeftParenthesis,FOLLOW_2); if (state.failed) return ;

        }
    }
    public final void synpred20_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        {
        pushFollow(FOLLOW_78);
        ruleValidID();

        state._fsp--;
        if (state.failed) return ;

        }


        }

        match(input,KW_EqualsSign,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred23_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_NumberSign,FOLLOW_51); if (state.failed) return ;
        match(input,KW_LeftSquareBracket,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred24_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_NumberSign,FOLLOW_51); if (state.failed) return ;
        match(input,KW_LeftSquareBracket,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred25_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        {
        {
        pushFollow(FOLLOW_2);
        ruleOpMultiAssign();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred26_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        {
        {
        pushFollow(FOLLOW_2);
        ruleOpOr();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred27_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        {
        {
        pushFollow(FOLLOW_2);
        ruleOpAnd();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred28_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        {
        {
        pushFollow(FOLLOW_2);
        ruleOpEquality();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred29_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_Instanceof,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred30_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        {
        {
        pushFollow(FOLLOW_2);
        ruleOpCompare();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred31_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        {
        {
        pushFollow(FOLLOW_2);
        ruleOpOther();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred32_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        match(input,KW_GreaterThanSign,FOLLOW_91); if (state.failed) return ;
        match(input,KW_GreaterThanSign,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred33_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        match(input,KW_LessThanSign,FOLLOW_52); if (state.failed) return ;
        match(input,KW_LessThanSign,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred34_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        {
        {
        pushFollow(FOLLOW_2);
        ruleOpAdd();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred35_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        {
        {
        pushFollow(FOLLOW_2);
        ruleOpMulti();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred36_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_As,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred37_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        {
        {
        pushFollow(FOLLOW_2);
        ruleOpPostfix();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred38_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        int alt281=2;
        int LA281_0 = input.LA(1);

        if ( (LA281_0==KW_FullStop) ) {
            alt281=1;
        }
        else if ( (LA281_0==KW_ColonColon) ) {
            alt281=2;
        }
        else {
            if (state.backtracking>0) {state.failed=true; return ;}
            NoViableAltException nvae =
                new NoViableAltException("", 281, 0, input);

            throw nvae;
        }
        switch (alt281) {
            case 1 :
                {
                match(input,KW_FullStop,FOLLOW_98); if (state.failed) return ;

                }
                break;
            case 2 :
                {
                {
                {
                match(input,KW_ColonColon,FOLLOW_98); if (state.failed) return ;

                }


                }


                }
                break;

        }
        {
        {
        pushFollow(FOLLOW_78);
        ruleFeatureCallID();

        state._fsp--;
        if (state.failed) return ;

        }


        }

        pushFollow(FOLLOW_2);
        ruleOpSingleAssign();

        state._fsp--;
        if (state.failed) return ;

        }


        }
    }
    public final void synpred39_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        int alt282=3;
        switch ( input.LA(1) ) {
        case KW_FullStop:
            {
            alt282=1;
            }
            break;
        case KW_QuestionMarkFullStop:
            {
            alt282=2;
            }
            break;
        case KW_ColonColon:
            {
            alt282=3;
            }
            break;
        default:
            if (state.backtracking>0) {state.failed=true; return ;}
            NoViableAltException nvae =
                new NoViableAltException("", 282, 0, input);

            throw nvae;
        }

        switch (alt282) {
            case 1 :
                {
                match(input,KW_FullStop,FOLLOW_2); if (state.failed) return ;

                }
                break;
            case 2 :
                {
                {
                {
                match(input,KW_QuestionMarkFullStop,FOLLOW_2); if (state.failed) return ;

                }


                }


                }
                break;
            case 3 :
                {
                {
                {
                match(input,KW_ColonColon,FOLLOW_2); if (state.failed) return ;

                }


                }


                }
                break;

        }


        }


        }
    }
    public final void synpred40_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        match(input,KW_LeftParenthesis,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred41_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        int alt284=2;
        int LA284_0 = input.LA(1);

        if ( (LA284_0==KW_Package||LA284_0==KW_Class||(LA284_0>=KW_Extends && LA284_0<=KW_Implements)||(LA284_0>=KW_Interface && LA284_0<=KW_LeftParenthesis)||LA284_0==KW_EqualsSignGreaterThanSign||(LA284_0>=KW_Extension && LA284_0<=KW_Throws)||(LA284_0>=KW_Public && LA284_0<=KW_Transient)||(LA284_0>=KW_Def && LA284_0<=KW_Create)||(LA284_0>=KW_AFTER && LA284_0<=KW_Import)||LA284_0==RULE_ID) ) {
            alt284=1;
        }
        switch (alt284) {
            case 1 :
                {
                {
                {
                pushFollow(FOLLOW_105);
                ruleJvmFormalParameter();

                state._fsp--;
                if (state.failed) return ;

                }


                }
                loop283:
                do {
                    int alt283=2;
                    int LA283_0 = input.LA(1);

                    if ( (LA283_0==KW_Comma) ) {
                        alt283=1;
                    }


                    switch (alt283) {
                	case 1 :
                	    {
                	    match(input,KW_Comma,FOLLOW_58); if (state.failed) return ;
                	    {
                	    {
                	    pushFollow(FOLLOW_105);
                	    ruleJvmFormalParameter();

                	    state._fsp--;
                	    if (state.failed) return ;

                	    }


                	    }


                	    }
                	    break;

                	default :
                	    break loop283;
                    }
                } while (true);


                }
                break;

        }
        {
        {
        match(input,KW_VerticalLine,FOLLOW_2); if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred42_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_LeftSquareBracket,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred43_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_Synchronized,FOLLOW_42); if (state.failed) return ;
        match(input,KW_LeftParenthesis,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred44_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_For,FOLLOW_42); if (state.failed) return ;
        match(input,KW_LeftParenthesis,FOLLOW_58); if (state.failed) return ;
        {
        {
        pushFollow(FOLLOW_56);
        ruleJvmFormalParameter();

        state._fsp--;
        if (state.failed) return ;

        }


        }

        match(input,KW_Colon,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred45_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_LeftSquareBracket,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred47_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        int alt286=2;
        int LA286_0 = input.LA(1);

        if ( (LA286_0==KW_Package||LA286_0==KW_Class||(LA286_0>=KW_Extends && LA286_0<=KW_Implements)||(LA286_0>=KW_Interface && LA286_0<=KW_LeftParenthesis)||LA286_0==KW_EqualsSignGreaterThanSign||(LA286_0>=KW_Extension && LA286_0<=KW_Throws)||(LA286_0>=KW_Public && LA286_0<=KW_Transient)||(LA286_0>=KW_Def && LA286_0<=KW_Create)||(LA286_0>=KW_AFTER && LA286_0<=KW_Import)||LA286_0==RULE_ID) ) {
            alt286=1;
        }
        switch (alt286) {
            case 1 :
                {
                {
                {
                pushFollow(FOLLOW_105);
                ruleJvmFormalParameter();

                state._fsp--;
                if (state.failed) return ;

                }


                }
                loop285:
                do {
                    int alt285=2;
                    int LA285_0 = input.LA(1);

                    if ( (LA285_0==KW_Comma) ) {
                        alt285=1;
                    }


                    switch (alt285) {
                	case 1 :
                	    {
                	    match(input,KW_Comma,FOLLOW_58); if (state.failed) return ;
                	    {
                	    {
                	    pushFollow(FOLLOW_105);
                	    ruleJvmFormalParameter();

                	    state._fsp--;
                	    if (state.failed) return ;

                	    }


                	    }


                	    }
                	    break;

                	default :
                	    break loop285;
                    }
                } while (true);


                }
                break;

        }
        {
        {
        match(input,KW_VerticalLine,FOLLOW_2); if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred49_InternalXtend_fragment() throws RecognitionException {   
        {
        match(input,KW_Else,FOLLOW_2); if (state.failed) return ;

        }
    }
    public final void synpred51_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        int alt292=2;
        int LA292_0 = input.LA(1);

        if ( ((LA292_0>=KW_Val && LA292_0<=KW_Var)) ) {
            alt292=1;
        }
        else if ( (LA292_0==KW_Extension) ) {
            alt292=2;
        }
        else {
            if (state.backtracking>0) {state.failed=true; return ;}
            NoViableAltException nvae =
                new NoViableAltException("", 292, 0, input);

            throw nvae;
        }
        switch (alt292) {
            case 1 :
                {
                {
                int alt289=2;
                int LA289_0 = input.LA(1);

                if ( (LA289_0==KW_Var) ) {
                    alt289=1;
                }
                else if ( (LA289_0==KW_Val) ) {
                    alt289=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 289, 0, input);

                    throw nvae;
                }
                switch (alt289) {
                    case 1 :
                        {
                        {
                        {
                        match(input,KW_Var,FOLLOW_137); if (state.failed) return ;

                        }


                        }


                        }
                        break;
                    case 2 :
                        {
                        match(input,KW_Val,FOLLOW_137); if (state.failed) return ;

                        }
                        break;

                }
                int alt290=2;
                int LA290_0 = input.LA(1);

                if ( (LA290_0==KW_Extension) ) {
                    alt290=1;
                }
                switch (alt290) {
                    case 1 :
                        {
                        {
                        match(input,KW_Extension,FOLLOW_2); if (state.failed) return ;

                        }


                        }
                        break;

                }


                }


                }
                break;
            case 2 :
                {
                {
                {
                {
                match(input,KW_Extension,FOLLOW_59); if (state.failed) return ;

                }


                }
                int alt291=2;
                int LA291_0 = input.LA(1);

                if ( (LA291_0==KW_Var) ) {
                    alt291=1;
                }
                else if ( (LA291_0==KW_Val) ) {
                    alt291=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 291, 0, input);

                    throw nvae;
                }
                switch (alt291) {
                    case 1 :
                        {
                        {
                        {
                        match(input,KW_Var,FOLLOW_2); if (state.failed) return ;

                        }


                        }


                        }
                        break;
                    case 2 :
                        {
                        match(input,KW_Val,FOLLOW_2); if (state.failed) return ;

                        }
                        break;

                }


                }


                }
                break;

        }


        }


        }
    }
    public final void synpred52_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        match(input,KW_LeftParenthesis,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred53_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }
        int alt294=2;
        int LA294_0 = input.LA(1);

        if ( (LA294_0==KW_Package||LA294_0==KW_Class||(LA294_0>=KW_Extends && LA294_0<=KW_Implements)||(LA294_0>=KW_Interface && LA294_0<=KW_LeftParenthesis)||LA294_0==KW_EqualsSignGreaterThanSign||(LA294_0>=KW_Extension && LA294_0<=KW_Throws)||(LA294_0>=KW_Public && LA294_0<=KW_Transient)||(LA294_0>=KW_Def && LA294_0<=KW_Create)||(LA294_0>=KW_AFTER && LA294_0<=KW_Import)||LA294_0==RULE_ID) ) {
            alt294=1;
        }
        switch (alt294) {
            case 1 :
                {
                {
                {
                pushFollow(FOLLOW_105);
                ruleJvmFormalParameter();

                state._fsp--;
                if (state.failed) return ;

                }


                }
                loop293:
                do {
                    int alt293=2;
                    int LA293_0 = input.LA(1);

                    if ( (LA293_0==KW_Comma) ) {
                        alt293=1;
                    }


                    switch (alt293) {
                	case 1 :
                	    {
                	    match(input,KW_Comma,FOLLOW_58); if (state.failed) return ;
                	    {
                	    {
                	    pushFollow(FOLLOW_105);
                	    ruleJvmFormalParameter();

                	    state._fsp--;
                	    if (state.failed) return ;

                	    }


                	    }


                	    }
                	    break;

                	default :
                	    break loop293;
                    }
                } while (true);


                }
                break;

        }
        {
        {
        match(input,KW_VerticalLine,FOLLOW_2); if (state.failed) return ;

        }


        }


        }


        }
    }
    public final void synpred54_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_LeftSquareBracket,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred55_InternalXtend_fragment() throws RecognitionException {   
        {
        if ( input.LA(1)==KW_Package||(input.LA(1)>=KW_Class && input.LA(1)<=KW_LessThanSign)||(input.LA(1)>=KW_Extends && input.LA(1)<=KW_LeftCurlyBracket)||(input.LA(1)>=KW_Interface && input.LA(1)<=KW_LeftParenthesis)||(input.LA(1)>=KW_Extension && input.LA(1)<=KW_New)||(input.LA(1)>=KW_Public && input.LA(1)<=KW_Transient)||(input.LA(1)>=KW_Def && input.LA(1)<=KW_Create)||(input.LA(1)>=KW_AFTER && input.LA(1)<=KW_Import)||input.LA(1)==KW_Switch||(input.LA(1)>=KW_NumberSign && input.LA(1)<=KW_LeftSquareBracket)||(input.LA(1)>=KW_PlusSign && input.LA(1)<=KW_HyphenMinus)||input.LA(1)==KW_ExclamationMark||input.LA(1)==KW_If||(input.LA(1)>=KW_For && input.LA(1)<=KW_Try)||(input.LA(1)>=RULE_ID && input.LA(1)<=RULE_RICH_TEXT_START)||(input.LA(1)>=RULE_HEX && input.LA(1)<=RULE_DECIMAL) ) {
            input.consume();
            state.errorRecovery=false;state.failed=false;
        }
        else {
            if (state.backtracking>0) {state.failed=true; return ;}
            MismatchedSetException mse = new MismatchedSetException(null,input);
            throw mse;
        }


        }
    }
    public final void synpred56_InternalXtend_fragment() throws RecognitionException {   
        {
        match(input,KW_Catch,FOLLOW_2); if (state.failed) return ;

        }
    }
    public final void synpred57_InternalXtend_fragment() throws RecognitionException {   
        {
        match(input,KW_Finally,FOLLOW_2); if (state.failed) return ;

        }
    }
    public final void synpred60_InternalXtend_fragment() throws RecognitionException {   
        {
        match(input,KW_FullStop,FOLLOW_2); if (state.failed) return ;

        }
    }
    public final void synpred61_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        pushFollow(FOLLOW_2);
        ruleArrayBrackets();

        state._fsp--;
        if (state.failed) return ;

        }


        }
    }
    public final void synpred62_InternalXtend_fragment() throws RecognitionException {   
        {
        match(input,KW_LessThanSign,FOLLOW_2); if (state.failed) return ;

        }
    }
    public final void synpred63_InternalXtend_fragment() throws RecognitionException {   
        {
        {
        {
        }

        match(input,KW_FullStop,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    public final void synpred64_InternalXtend_fragment() throws RecognitionException {   
        {
        match(input,KW_LessThanSign,FOLLOW_2); if (state.failed) return ;

        }
    }

    public final boolean synpred15_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred15_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred36_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred36_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred57_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred57_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred49_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred49_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred2_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred2_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred23_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred23_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred28_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred28_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred44_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred44_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred60_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred60_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred7_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred7_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred10_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred10_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred31_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred31_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred52_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred52_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred40_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred40_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred61_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred61_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred43_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred43_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred64_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred64_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred27_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred27_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred32_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred32_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred53_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred53_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred6_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred6_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred5_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred5_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred11_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred11_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred33_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred33_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred12_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred12_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred54_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred54_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred16_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred16_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred37_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred37_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred1_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred1_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred4_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred4_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred25_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred25_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred26_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred26_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred47_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred47_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred17_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred17_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred34_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred34_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred13_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred13_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred38_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred38_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred42_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred42_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred63_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred63_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred55_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred55_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred30_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred30_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred51_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred51_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred29_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred29_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred3_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred3_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred8_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred8_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred24_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred24_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred19_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred19_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred45_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred45_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred18_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred18_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred41_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred41_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred20_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred20_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred39_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred39_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred14_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred14_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred35_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred35_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred56_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred56_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred62_InternalXtend() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred62_InternalXtend_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA25 dfa25 = new DFA25(this);
    protected DFA57 dfa57 = new DFA57(this);
    protected DFA35 dfa35 = new DFA35(this);
    protected DFA33 dfa33 = new DFA33(this);
    protected DFA106 dfa106 = new DFA106(this);
    protected DFA67 dfa67 = new DFA67(this);
    protected DFA61 dfa61 = new DFA61(this);
    protected DFA63 dfa63 = new DFA63(this);
    protected DFA66 dfa66 = new DFA66(this);
    protected DFA74 dfa74 = new DFA74(this);
    protected DFA109 dfa109 = new DFA109(this);
    protected DFA112 dfa112 = new DFA112(this);
    protected DFA115 dfa115 = new DFA115(this);
    protected DFA132 dfa132 = new DFA132(this);
    protected DFA135 dfa135 = new DFA135(this);
    protected DFA137 dfa137 = new DFA137(this);
    protected DFA140 dfa140 = new DFA140(this);
    protected DFA139 dfa139 = new DFA139(this);
    protected DFA141 dfa141 = new DFA141(this);
    protected DFA147 dfa147 = new DFA147(this);
    protected DFA146 dfa146 = new DFA146(this);
    protected DFA150 dfa150 = new DFA150(this);
    protected DFA167 dfa167 = new DFA167(this);
    protected DFA166 dfa166 = new DFA166(this);
    protected DFA172 dfa172 = new DFA172(this);
    protected DFA175 dfa175 = new DFA175(this);
    protected DFA178 dfa178 = new DFA178(this);
    protected DFA177 dfa177 = new DFA177(this);
    protected DFA187 dfa187 = new DFA187(this);
    protected DFA190 dfa190 = new DFA190(this);
    protected DFA206 dfa206 = new DFA206(this);
    protected DFA205 dfa205 = new DFA205(this);
    protected DFA207 dfa207 = new DFA207(this);
    protected DFA209 dfa209 = new DFA209(this);
    protected DFA218 dfa218 = new DFA218(this);
    protected DFA239 dfa239 = new DFA239(this);
    protected DFA238 dfa238 = new DFA238(this);
    protected DFA240 dfa240 = new DFA240(this);
    protected DFA244 dfa244 = new DFA244(this);
    protected DFA248 dfa248 = new DFA248(this);
    protected DFA262 dfa262 = new DFA262(this);
    protected DFA261 dfa261 = new DFA261(this);
    protected DFA260 dfa260 = new DFA260(this);
    protected DFA272 dfa272 = new DFA272(this);
    static final String dfa_1s = "\22\uffff";
    static final String dfa_2s = "\16\4\4\uffff";
    static final String dfa_3s = "\16\44\4\uffff";
    static final String dfa_4s = "\16\uffff\1\1\1\2\1\3\1\4";
    static final String dfa_5s = "\22\uffff}>";
    static final String[] dfa_6s = {
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "\1\4\1\uffff\1\16\7\uffff\1\17\1\20\1\21\10\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_1 = DFA.unpackEncodedString(dfa_1s);
    static final char[] dfa_2 = DFA.unpackEncodedStringToUnsignedChars(dfa_2s);
    static final char[] dfa_3 = DFA.unpackEncodedStringToUnsignedChars(dfa_3s);
    static final short[] dfa_4 = DFA.unpackEncodedString(dfa_4s);
    static final short[] dfa_5 = DFA.unpackEncodedString(dfa_5s);
    static final short[][] dfa_6 = unpackEncodedStringArray(dfa_6s);

    class DFA25 extends DFA {

        public DFA25(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 25;
            this.eot = dfa_1;
            this.eof = dfa_1;
            this.min = dfa_2;
            this.max = dfa_3;
            this.accept = dfa_4;
            this.special = dfa_5;
            this.transition = dfa_6;
        }
        public String getDescription() {
            return "305:3: ( ( () ( (lv_modifiers_3_0= ruleCommonModifier ) )* otherlv_4= 'class' ( (lv_name_5_0= ruleValidID ) ) (otherlv_6= '<' ( (lv_typeParameters_7_0= ruleJvmTypeParameter ) ) (otherlv_8= ',' ( (lv_typeParameters_9_0= ruleJvmTypeParameter ) ) )* otherlv_10= '>' )? (otherlv_11= 'extends' ( (lv_extends_12_0= ruleJvmParameterizedTypeReference ) ) )? (otherlv_13= 'implements' ( (lv_implements_14_0= ruleJvmSuperTypeReference ) ) (otherlv_15= ',' ( (lv_implements_16_0= ruleJvmSuperTypeReference ) ) )* )? otherlv_17= '{' ( (lv_members_18_0= ruleMember ) )* otherlv_19= '}' ) | ( () ( (lv_modifiers_21_0= ruleCommonModifier ) )* otherlv_22= 'interface' ( (lv_name_23_0= ruleValidID ) ) (otherlv_24= '<' ( (lv_typeParameters_25_0= ruleJvmTypeParameter ) ) (otherlv_26= ',' ( (lv_typeParameters_27_0= ruleJvmTypeParameter ) ) )* otherlv_28= '>' )? (otherlv_29= 'extends' ( (lv_extends_30_0= ruleJvmSuperTypeReference ) ) (otherlv_31= ',' ( (lv_extends_32_0= ruleJvmSuperTypeReference ) ) )* )? otherlv_33= '{' ( (lv_members_34_0= ruleMember ) )* otherlv_35= '}' ) | ( () ( (lv_modifiers_37_0= ruleCommonModifier ) )* otherlv_38= 'enum' ( (lv_name_39_0= ruleValidID ) ) otherlv_40= '{' ( ( (lv_members_41_0= ruleXtendEnumLiteral ) ) (otherlv_42= ',' ( (lv_members_43_0= ruleXtendEnumLiteral ) ) )* )? (otherlv_44= ';' )? otherlv_45= '}' ) | ( () ( (lv_modifiers_47_0= ruleCommonModifier ) )* otherlv_48= 'annotation' ( (lv_name_49_0= ruleValidID ) ) otherlv_50= '{' ( (lv_members_51_0= ruleAnnotationField ) )* otherlv_52= '}' ) )";
        }
    }
    static final String dfa_7s = "\32\uffff";
    static final String dfa_8s = "\23\uffff\6\16\1\uffff";
    static final String dfa_9s = "\16\4\1\uffff\1\7\3\uffff\6\4\1\uffff";
    static final String dfa_10s = "\16\155\1\uffff\1\155\3\uffff\6\155\1\uffff";
    static final String dfa_11s = "\16\uffff\1\1\1\uffff\1\2\1\3\1\4\6\uffff\1\5";
    static final String dfa_12s = "\32\uffff}>";
    static final String[] dfa_13s = {
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\20\7\uffff\1\21\1\22\1\17\1\16\1\uffff\1\16\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\16\1\uffff\3\16\77\uffff\1\16",
            "",
            "\1\16\10\uffff\1\25\7\uffff\1\16\20\uffff\1\24\1\uffff\1\26\1\27\1\30\14\uffff\1\16\62\uffff\1\23",
            "",
            "",
            "",
            "\3\16\5\uffff\1\31\5\16\1\uffff\2\16\4\uffff\16\16\2\uffff\1\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            "\3\16\5\uffff\1\31\5\16\1\uffff\2\16\4\uffff\16\16\2\uffff\1\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            "\3\16\5\uffff\1\31\5\16\1\uffff\2\16\4\uffff\16\16\2\uffff\1\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            "\3\16\5\uffff\1\31\5\16\1\uffff\2\16\4\uffff\16\16\2\uffff\1\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            "\3\16\5\uffff\1\31\5\16\1\uffff\2\16\4\uffff\16\16\2\uffff\1\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            "\3\16\5\uffff\1\31\5\16\1\uffff\2\16\4\uffff\16\16\2\uffff\1\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            ""
    };

    static final short[] dfa_7 = DFA.unpackEncodedString(dfa_7s);
    static final short[] dfa_8 = DFA.unpackEncodedString(dfa_8s);
    static final char[] dfa_9 = DFA.unpackEncodedStringToUnsignedChars(dfa_9s);
    static final char[] dfa_10 = DFA.unpackEncodedStringToUnsignedChars(dfa_10s);
    static final short[] dfa_11 = DFA.unpackEncodedString(dfa_11s);
    static final short[] dfa_12 = DFA.unpackEncodedString(dfa_12s);
    static final short[][] dfa_13 = unpackEncodedStringArray(dfa_13s);

    class DFA57 extends DFA {

        public DFA57(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 57;
            this.eot = dfa_7;
            this.eof = dfa_8;
            this.min = dfa_9;
            this.max = dfa_10;
            this.accept = dfa_11;
            this.special = dfa_12;
            this.transition = dfa_13;
        }
        public String getDescription() {
            return "1077:3: ( ( ( ( () ( (lv_modifiers_3_0= ruleCommonModifier ) )* ( (lv_modifiers_4_0= ruleFieldModifier ) ) ( (lv_modifiers_5_0= ruleCommonModifier ) )* ( (lv_type_6_0= ruleJvmTypeReference ) )? ( (lv_name_7_0= ruleValidID ) ) ) | ( () ( (lv_modifiers_9_0= ruleCommonModifier ) )* ( (lv_type_10_0= ruleJvmTypeReference ) ) ( (lv_name_11_0= ruleValidID ) ) ) ) (otherlv_12= '=' ( (lv_initialValue_13_0= ruleXAnnotationElementValue ) ) )? (otherlv_14= ';' )? ) | ( () ( (lv_modifiers_16_0= ruleCommonModifier ) )* otherlv_17= 'class' ( (lv_name_18_0= ruleValidID ) ) (otherlv_19= '<' ( (lv_typeParameters_20_0= ruleJvmTypeParameter ) ) (otherlv_21= ',' ( (lv_typeParameters_22_0= ruleJvmTypeParameter ) ) )* otherlv_23= '>' )? (otherlv_24= 'extends' ( (lv_extends_25_0= ruleJvmParameterizedTypeReference ) ) )? (otherlv_26= 'implements' ( (lv_implements_27_0= ruleJvmParameterizedTypeReference ) ) (otherlv_28= ',' ( (lv_implements_29_0= ruleJvmParameterizedTypeReference ) ) )* )? otherlv_30= '{' ( (lv_members_31_0= ruleMember ) )* otherlv_32= '}' ) | ( () ( (lv_modifiers_34_0= ruleCommonModifier ) )* otherlv_35= 'interface' ( (lv_name_36_0= ruleValidID ) ) (otherlv_37= '<' ( (lv_typeParameters_38_0= ruleJvmTypeParameter ) ) (otherlv_39= ',' ( (lv_typeParameters_40_0= ruleJvmTypeParameter ) ) )* otherlv_41= '>' )? (otherlv_42= 'extends' ( (lv_extends_43_0= ruleJvmParameterizedTypeReference ) ) (otherlv_44= ',' ( (lv_extends_45_0= ruleJvmParameterizedTypeReference ) ) )* )? otherlv_46= '{' ( (lv_members_47_0= ruleMember ) )* otherlv_48= '}' ) | ( () ( (lv_modifiers_50_0= ruleCommonModifier ) )* otherlv_51= 'enum' ( (lv_name_52_0= ruleValidID ) ) otherlv_53= '{' ( ( (lv_members_54_0= ruleXtendEnumLiteral ) ) (otherlv_55= ',' ( (lv_members_56_0= ruleXtendEnumLiteral ) ) )* )? (otherlv_57= ';' )? otherlv_58= '}' ) | ( () ( (lv_modifiers_60_0= ruleCommonModifier ) )* otherlv_61= 'annotation' ( (lv_name_62_0= ruleValidID ) ) otherlv_63= '{' ( (lv_members_64_0= ruleAnnotationField ) )* otherlv_65= '}' ) )";
        }
    }
    static final String dfa_14s = "\20\uffff";
    static final String dfa_15s = "\16\4\2\uffff";
    static final String dfa_16s = "\16\155\2\uffff";
    static final String dfa_17s = "\16\uffff\1\1\1\2";
    static final String dfa_18s = "\20\uffff}>";
    static final String[] dfa_19s = {
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "\1\4\13\uffff\2\17\1\uffff\1\17\5\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\uffff\1\17\1\uffff\3\17\77\uffff\1\17",
            "",
            ""
    };

    static final short[] dfa_14 = DFA.unpackEncodedString(dfa_14s);
    static final char[] dfa_15 = DFA.unpackEncodedStringToUnsignedChars(dfa_15s);
    static final char[] dfa_16 = DFA.unpackEncodedStringToUnsignedChars(dfa_16s);
    static final short[] dfa_17 = DFA.unpackEncodedString(dfa_17s);
    static final short[] dfa_18 = DFA.unpackEncodedString(dfa_18s);
    static final short[][] dfa_19 = unpackEncodedStringArray(dfa_19s);

    class DFA35 extends DFA {

        public DFA35(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 35;
            this.eot = dfa_14;
            this.eof = dfa_14;
            this.min = dfa_15;
            this.max = dfa_16;
            this.accept = dfa_17;
            this.special = dfa_18;
            this.transition = dfa_19;
        }
        public String getDescription() {
            return "1079:5: ( ( () ( (lv_modifiers_3_0= ruleCommonModifier ) )* ( (lv_modifiers_4_0= ruleFieldModifier ) ) ( (lv_modifiers_5_0= ruleCommonModifier ) )* ( (lv_type_6_0= ruleJvmTypeReference ) )? ( (lv_name_7_0= ruleValidID ) ) ) | ( () ( (lv_modifiers_9_0= ruleCommonModifier ) )* ( (lv_type_10_0= ruleJvmTypeReference ) ) ( (lv_name_11_0= ruleValidID ) ) ) )";
        }
    }
    static final String dfa_20s = "\47\uffff";
    static final String dfa_21s = "\1\uffff\6\16\1\uffff\6\7\31\uffff";
    static final String dfa_22s = "\1\20\6\4\1\uffff\6\4\1\uffff\30\4";
    static final String dfa_23s = "\7\155\1\uffff\6\155\1\uffff\30\155";
    static final String dfa_24s = "\7\uffff\1\1\6\uffff\1\2\30\uffff";
    static final String dfa_25s = "\47\uffff}>";
    static final String[] dfa_26s = {
            "\1\3\1\7\1\uffff\1\7\25\uffff\1\2\1\uffff\1\4\1\5\1\6\77\uffff\1\1",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "",
            "\3\7\1\16\5\uffff\3\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\5\uffff\3\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\5\uffff\3\7\1\27\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\5\uffff\3\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\5\uffff\3\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\5\uffff\3\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "",
            "\3\16\1\7\5\uffff\3\16\1\35\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\16\1\uffff\1\7\62\uffff\1\33",
            "\3\16\1\7\5\uffff\3\16\1\35\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\16\1\uffff\1\7\62\uffff\1\33",
            "\3\16\1\7\5\uffff\3\16\1\43\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\42\1\uffff\1\44\1\45\1\46\12\uffff\1\16\1\uffff\1\7\62\uffff\1\41",
            "\3\16\1\7\5\uffff\3\16\1\35\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\16\1\uffff\1\7\62\uffff\1\33",
            "\3\16\1\7\5\uffff\3\16\1\35\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\16\1\uffff\1\7\62\uffff\1\33",
            "\3\16\1\7\5\uffff\3\16\1\35\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\16\1\uffff\1\7\62\uffff\1\33",
            "\3\16\1\7\4\uffff\4\16\1\35\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\16\1\uffff\1\7\62\uffff\1\33",
            "\3\16\1\7\4\uffff\4\16\1\35\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\16\1\uffff\1\7\62\uffff\1\33",
            "\3\16\1\7\4\uffff\4\16\1\43\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\42\1\uffff\1\44\1\45\1\46\12\uffff\1\16\1\uffff\1\7\62\uffff\1\41",
            "\3\16\1\7\4\uffff\4\16\1\35\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\16\1\uffff\1\7\62\uffff\1\33",
            "\3\16\1\7\4\uffff\4\16\1\35\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\16\1\uffff\1\7\62\uffff\1\33",
            "\3\16\1\7\4\uffff\4\16\1\35\1\16\1\uffff\2\16\3\uffff\1\7\16\16\2\uffff\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\16\1\uffff\1\7\62\uffff\1\33",
            "\3\7\1\16\5\uffff\3\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\5\uffff\3\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\5\uffff\3\7\1\27\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\5\uffff\3\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\5\uffff\3\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\5\uffff\3\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\4\uffff\4\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\4\uffff\4\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\4\uffff\4\7\1\27\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\4\uffff\4\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\4\uffff\4\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17",
            "\3\7\1\16\4\uffff\4\7\1\21\1\7\1\uffff\2\7\3\uffff\1\16\16\7\2\uffff\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\16\62\uffff\1\17"
    };

    static final short[] dfa_20 = DFA.unpackEncodedString(dfa_20s);
    static final short[] dfa_21 = DFA.unpackEncodedString(dfa_21s);
    static final char[] dfa_22 = DFA.unpackEncodedStringToUnsignedChars(dfa_22s);
    static final char[] dfa_23 = DFA.unpackEncodedStringToUnsignedChars(dfa_23s);
    static final short[] dfa_24 = DFA.unpackEncodedString(dfa_24s);
    static final short[] dfa_25 = DFA.unpackEncodedString(dfa_25s);
    static final short[][] dfa_26 = unpackEncodedStringArray(dfa_26s);

    class DFA33 extends DFA {

        public DFA33(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 33;
            this.eot = dfa_20;
            this.eof = dfa_21;
            this.min = dfa_22;
            this.max = dfa_23;
            this.accept = dfa_24;
            this.special = dfa_25;
            this.transition = dfa_26;
        }
        public String getDescription() {
            return "1145:7: ( (lv_type_6_0= ruleJvmTypeReference ) )?";
        }
    }
    static final String dfa_27s = "\34\uffff";
    static final String dfa_28s = "\25\uffff\6\16\1\uffff";
    static final String dfa_29s = "\16\4\1\uffff\1\7\5\uffff\6\4\1\uffff";
    static final String dfa_30s = "\16\155\1\uffff\1\155\5\uffff\6\155\1\uffff";
    static final String dfa_31s = "\16\uffff\1\1\1\uffff\1\2\1\3\1\4\1\5\1\6\6\uffff\1\7";
    static final String dfa_32s = "\34\uffff}>";
    static final String[] dfa_33s = {
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "\1\4\1\uffff\1\22\7\uffff\1\23\1\24\1\17\1\16\1\uffff\1\16\1\uffff\1\16\1\uffff\1\21\1\uffff\1\1\1\2\1\3\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\2\16\2\20\1\16\1\uffff\3\16\77\uffff\1\16",
            "",
            "\1\16\10\uffff\1\27\7\uffff\1\16\20\uffff\1\26\1\uffff\1\30\1\31\1\32\14\uffff\1\16\62\uffff\1\25",
            "",
            "",
            "",
            "",
            "",
            "\3\16\5\uffff\1\33\5\16\1\uffff\3\16\1\uffff\1\16\1\uffff\21\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            "\3\16\5\uffff\1\33\5\16\1\uffff\3\16\1\uffff\1\16\1\uffff\21\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            "\3\16\5\uffff\1\33\5\16\1\uffff\3\16\1\uffff\1\16\1\uffff\21\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            "\3\16\5\uffff\1\33\5\16\1\uffff\3\16\1\uffff\1\16\1\uffff\21\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            "\3\16\5\uffff\1\33\5\16\1\uffff\3\16\1\uffff\1\16\1\uffff\21\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            "\3\16\5\uffff\1\33\5\16\1\uffff\3\16\1\uffff\1\16\1\uffff\21\16\1\uffff\3\16\12\uffff\1\16\64\uffff\1\16",
            ""
    };

    static final short[] dfa_27 = DFA.unpackEncodedString(dfa_27s);
    static final short[] dfa_28 = DFA.unpackEncodedString(dfa_28s);
    static final char[] dfa_29 = DFA.unpackEncodedStringToUnsignedChars(dfa_29s);
    static final char[] dfa_30 = DFA.unpackEncodedStringToUnsignedChars(dfa_30s);
    static final short[] dfa_31 = DFA.unpackEncodedString(dfa_31s);
    static final short[] dfa_32 = DFA.unpackEncodedString(dfa_32s);
    static final short[][] dfa_33 = unpackEncodedStringArray(dfa_33s);

    class DFA106 extends DFA {

        public DFA106(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 106;
            this.eot = dfa_27;
            this.eof = dfa_28;
            this.min = dfa_29;
            this.max = dfa_30;
            this.accept = dfa_31;
            this.special = dfa_32;
            this.transition = dfa_33;
        }
        public String getDescription() {
            return "1912:3: ( ( () ( (lv_modifiers_3_0= ruleCommonModifier ) )* ( ( ( (lv_modifiers_4_0= ruleFieldModifier ) ) ( (lv_modifiers_5_0= ruleCommonModifier ) )* ( (lv_type_6_0= ruleJvmTypeReference ) )? ( (lv_name_7_0= ruleValidID ) ) ) | ( ( (lv_modifiers_8_0= 'extension' ) ) ( ( (lv_modifiers_9_0= ruleFieldModifier ) ) | ( (lv_modifiers_10_0= ruleCommonModifier ) ) )* ( (lv_type_11_0= ruleJvmTypeReference ) ) ( (lv_name_12_0= ruleValidID ) )? ) | ( ( (lv_modifiers_13_0= ruleFieldModifier ) ) ( (lv_modifiers_14_0= ruleCommonModifier ) )* ( (lv_modifiers_15_0= 'extension' ) ) ( (lv_modifiers_16_0= ruleCommonModifier ) )* ( (lv_type_17_0= ruleJvmTypeReference ) ) ( (lv_name_18_0= ruleValidID ) )? ) | ( ( (lv_type_19_0= ruleJvmTypeReference ) ) ( (lv_name_20_0= ruleValidID ) ) ) ) (otherlv_21= '=' ( (lv_initialValue_22_0= ruleXExpression ) ) )? (otherlv_23= ';' )? ) | ( () ( (lv_modifiers_25_0= ruleCommonModifier ) )* ( (lv_modifiers_26_0= ruleMethodModifier ) ) ( ( (lv_modifiers_27_0= ruleCommonModifier ) ) | ( (lv_modifiers_28_0= ruleMethodModifier ) ) )* (otherlv_29= '<' ( (lv_typeParameters_30_0= ruleJvmTypeParameter ) ) (otherlv_31= ',' ( (lv_typeParameters_32_0= ruleJvmTypeParameter ) ) )* otherlv_33= '>' )? ( ( ( ( ( ( ruleJvmTypeReference ) ) ( ( ruleCreateExtensionInfo ) ) ( ( ruleValidID ) ) '(' ) )=> ( ( (lv_returnType_34_0= ruleJvmTypeReference ) ) ( (lv_createExtensionInfo_35_0= ruleCreateExtensionInfo ) ) ( (lv_name_36_0= ruleValidID ) ) otherlv_37= '(' ) ) | ( ( ( ( ( ruleTypeReferenceWithTypeArgs ) ) ( ( ruleFunctionID ) ) '(' ) )=> ( ( (lv_returnType_38_0= ruleTypeReferenceWithTypeArgs ) ) ( (lv_name_39_0= ruleFunctionID ) ) otherlv_40= '(' ) ) | ( ( ( ( ( ruleTypeReferenceNoTypeArgs ) ) ( ( ruleFunctionID ) ) '(' ) )=> ( ( (lv_returnType_41_0= ruleTypeReferenceNoTypeArgs ) ) ( (lv_name_42_0= ruleFunctionID ) ) otherlv_43= '(' ) ) | ( ( ( ( ( ruleCreateExtensionInfo ) ) ( ( ruleValidID ) ) '(' ) )=> ( ( (lv_createExtensionInfo_44_0= ruleCreateExtensionInfo ) ) ( (lv_name_45_0= ruleValidID ) ) otherlv_46= '(' ) ) | ( ( (lv_name_47_0= ruleFunctionID ) ) otherlv_48= '(' ) ) ( ( (lv_parameters_49_0= ruleParameter ) ) (otherlv_50= ',' ( (lv_parameters_51_0= ruleParameter ) ) )* )? otherlv_52= ')' (otherlv_53= 'throws' ( (lv_exceptions_54_0= ruleJvmTypeReference ) ) (otherlv_55= ',' ( (lv_exceptions_56_0= ruleJvmTypeReference ) ) )* )? ( ( (lv_expression_57_0= ruleXBlockExpression ) ) | ( (lv_expression_58_0= ruleRichString ) ) | otherlv_59= ';' )? ) | ( () ( (lv_modifiers_61_0= ruleCommonModifier ) )* otherlv_62= 'new' (otherlv_63= '<' ( (lv_typeParameters_64_0= ruleJvmTypeParameter ) ) (otherlv_65= ',' ( (lv_typeParameters_66_0= ruleJvmTypeParameter ) ) )* otherlv_67= '>' )? otherlv_68= '(' ( ( (lv_parameters_69_0= ruleParameter ) ) (otherlv_70= ',' ( (lv_parameters_71_0= ruleParameter ) ) )* )? otherlv_72= ')' (otherlv_73= 'throws' ( (lv_exceptions_74_0= ruleJvmTypeReference ) ) (otherlv_75= ',' ( (lv_exceptions_76_0= ruleJvmTypeReference ) ) )* )? ( (lv_expression_77_0= ruleXBlockExpression ) ) ) | ( () ( (lv_modifiers_79_0= ruleCommonModifier ) )* otherlv_80= 'class' ( (lv_name_81_0= ruleValidID ) ) (otherlv_82= '<' ( (lv_typeParameters_83_0= ruleJvmTypeParameter ) ) (otherlv_84= ',' ( (lv_typeParameters_85_0= ruleJvmTypeParameter ) ) )* otherlv_86= '>' )? (otherlv_87= 'extends' ( (lv_extends_88_0= ruleJvmParameterizedTypeReference ) ) )? (otherlv_89= 'implements' ( (lv_implements_90_0= ruleJvmParameterizedTypeReference ) ) (otherlv_91= ',' ( (lv_implements_92_0= ruleJvmParameterizedTypeReference ) ) )* )? otherlv_93= '{' ( (lv_members_94_0= ruleMember ) )* otherlv_95= '}' ) | ( () ( (lv_modifiers_97_0= ruleCommonModifier ) )* otherlv_98= 'interface' ( (lv_name_99_0= ruleValidID ) ) (otherlv_100= '<' ( (lv_typeParameters_101_0= ruleJvmTypeParameter ) ) (otherlv_102= ',' ( (lv_typeParameters_103_0= ruleJvmTypeParameter ) ) )* otherlv_104= '>' )? (otherlv_105= 'extends' ( (lv_extends_106_0= ruleJvmParameterizedTypeReference ) ) (otherlv_107= ',' ( (lv_extends_108_0= ruleJvmParameterizedTypeReference ) ) )* )? otherlv_109= '{' ( (lv_members_110_0= ruleMember ) )* otherlv_111= '}' ) | ( () ( (lv_modifiers_113_0= ruleCommonModifier ) )* otherlv_114= 'enum' ( (lv_name_115_0= ruleValidID ) ) otherlv_116= '{' ( ( (lv_members_117_0= ruleXtendEnumLiteral ) ) (otherlv_118= ',' ( (lv_members_119_0= ruleXtendEnumLiteral ) ) )* )? (otherlv_120= ';' )? otherlv_121= '}' ) | ( () ( (lv_modifiers_123_0= ruleCommonModifier ) )* otherlv_124= 'annotation' ( (lv_name_125_0= ruleValidID ) ) otherlv_126= '{' ( (lv_members_127_0= ruleAnnotationField ) )* otherlv_128= '}' ) )";
        }
    }
    static final String dfa_34s = "\24\uffff";
    static final String dfa_35s = "\1\20\2\4\2\uffff\15\4\2\uffff";
    static final String dfa_36s = "\3\155\2\uffff\15\155\2\uffff";
    static final String dfa_37s = "\3\uffff\1\2\1\4\15\uffff\1\1\1\3";
    static final String dfa_38s = "\24\uffff}>";
    static final String[] dfa_39s = {
            "\2\4\1\uffff\1\4\1\uffff\1\3\17\uffff\1\1\1\2\2\uffff\1\4\1\uffff\3\4\77\uffff\1\4",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "",
            "",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "\1\10\13\uffff\2\22\1\uffff\1\22\1\uffff\1\23\3\uffff\1\5\1\6\1\7\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\4\uffff\1\22\1\uffff\3\22\77\uffff\1\22",
            "",
            ""
    };

    static final short[] dfa_34 = DFA.unpackEncodedString(dfa_34s);
    static final char[] dfa_35 = DFA.unpackEncodedStringToUnsignedChars(dfa_35s);
    static final char[] dfa_36 = DFA.unpackEncodedStringToUnsignedChars(dfa_36s);
    static final short[] dfa_37 = DFA.unpackEncodedString(dfa_37s);
    static final short[] dfa_38 = DFA.unpackEncodedString(dfa_38s);
    static final short[][] dfa_39 = unpackEncodedStringArray(dfa_39s);

    class DFA67 extends DFA {

        public DFA67(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 67;
            this.eot = dfa_34;
            this.eof = dfa_34;
            this.min = dfa_35;
            this.max = dfa_36;
            this.accept = dfa_37;
            this.special = dfa_38;
            this.transition = dfa_39;
        }
        public String getDescription() {
            return "1940:5: ( ( ( (lv_modifiers_4_0= ruleFieldModifier ) ) ( (lv_modifiers_5_0= ruleCommonModifier ) )* ( (lv_type_6_0= ruleJvmTypeReference ) )? ( (lv_name_7_0= ruleValidID ) ) ) | ( ( (lv_modifiers_8_0= 'extension' ) ) ( ( (lv_modifiers_9_0= ruleFieldModifier ) ) | ( (lv_modifiers_10_0= ruleCommonModifier ) ) )* ( (lv_type_11_0= ruleJvmTypeReference ) ) ( (lv_name_12_0= ruleValidID ) )? ) | ( ( (lv_modifiers_13_0= ruleFieldModifier ) ) ( (lv_modifiers_14_0= ruleCommonModifier ) )* ( (lv_modifiers_15_0= 'extension' ) ) ( (lv_modifiers_16_0= ruleCommonModifier ) )* ( (lv_type_17_0= ruleJvmTypeReference ) ) ( (lv_name_18_0= ruleValidID ) )? ) | ( ( (lv_type_19_0= ruleJvmTypeReference ) ) ( (lv_name_20_0= ruleValidID ) ) ) )";
        }
    }
    static final String dfa_40s = "\1\uffff\6\10\2\uffff\6\7\30\uffff";
    static final String dfa_41s = "\1\20\6\4\2\uffff\36\4";
    static final String dfa_42s = "\7\155\2\uffff\36\155";
    static final String dfa_43s = "\7\uffff\1\1\1\2\36\uffff";
    static final String[] dfa_44s = {
            "\1\3\1\7\1\uffff\1\7\25\uffff\1\2\1\uffff\1\4\1\5\1\6\77\uffff\1\1",
            "\3\10\1\7\5\uffff\3\10\1\13\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\12\1\uffff\1\14\1\15\1\16\12\uffff\1\10\1\uffff\1\7\62\uffff\1\11",
            "\3\10\1\7\5\uffff\3\10\1\13\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\12\1\uffff\1\14\1\15\1\16\12\uffff\1\10\1\uffff\1\7\62\uffff\1\11",
            "\3\10\1\7\5\uffff\3\10\1\13\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\12\1\uffff\1\14\1\15\1\16\12\uffff\1\10\1\uffff\1\7\62\uffff\1\11",
            "\3\10\1\7\5\uffff\3\10\1\13\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\12\1\uffff\1\14\1\15\1\16\12\uffff\1\10\1\uffff\1\7\62\uffff\1\11",
            "\3\10\1\7\5\uffff\3\10\1\13\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\12\1\uffff\1\14\1\15\1\16\12\uffff\1\10\1\uffff\1\7\62\uffff\1\11",
            "\3\10\1\7\5\uffff\3\10\1\13\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\12\1\uffff\1\14\1\15\1\16\12\uffff\1\10\1\uffff\1\7\62\uffff\1\11",
            "",
            "",
            "\3\7\1\10\5\uffff\3\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\5\uffff\3\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\5\uffff\3\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\10\62\uffff\1\25",
            "\3\7\1\10\5\uffff\3\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\5\uffff\3\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\5\uffff\3\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\10\1\7\5\uffff\3\10\1\35\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\10\1\uffff\1\7\62\uffff\1\33",
            "\3\10\1\7\5\uffff\3\10\1\35\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\10\1\uffff\1\7\62\uffff\1\33",
            "\3\10\1\7\5\uffff\3\10\1\43\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\42\1\uffff\1\44\1\45\1\46\12\uffff\1\10\1\uffff\1\7\62\uffff\1\41",
            "\3\10\1\7\5\uffff\3\10\1\35\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\10\1\uffff\1\7\62\uffff\1\33",
            "\3\10\1\7\5\uffff\3\10\1\35\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\10\1\uffff\1\7\62\uffff\1\33",
            "\3\10\1\7\5\uffff\3\10\1\35\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\10\1\uffff\1\7\62\uffff\1\33",
            "\3\10\1\7\4\uffff\4\10\1\35\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\10\1\uffff\1\7\62\uffff\1\33",
            "\3\10\1\7\4\uffff\4\10\1\35\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\10\1\uffff\1\7\62\uffff\1\33",
            "\3\10\1\7\4\uffff\4\10\1\43\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\42\1\uffff\1\44\1\45\1\46\12\uffff\1\10\1\uffff\1\7\62\uffff\1\41",
            "\3\10\1\7\4\uffff\4\10\1\35\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\10\1\uffff\1\7\62\uffff\1\33",
            "\3\10\1\7\4\uffff\4\10\1\35\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\10\1\uffff\1\7\62\uffff\1\33",
            "\3\10\1\7\4\uffff\4\10\1\35\1\10\1\uffff\3\10\1\uffff\1\10\1\7\20\10\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\10\1\uffff\1\7\62\uffff\1\33",
            "\3\7\1\10\5\uffff\3\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\5\uffff\3\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\5\uffff\3\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\10\62\uffff\1\25",
            "\3\7\1\10\5\uffff\3\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\5\uffff\3\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\5\uffff\3\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\4\uffff\4\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\4\uffff\4\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\4\uffff\4\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\10\62\uffff\1\25",
            "\3\7\1\10\4\uffff\4\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\4\uffff\4\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17",
            "\3\7\1\10\4\uffff\4\7\1\21\1\7\1\uffff\3\7\1\uffff\1\7\1\10\20\7\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\7\1\uffff\1\10\62\uffff\1\17"
    };
    static final short[] dfa_40 = DFA.unpackEncodedString(dfa_40s);
    static final char[] dfa_41 = DFA.unpackEncodedStringToUnsignedChars(dfa_41s);
    static final char[] dfa_42 = DFA.unpackEncodedStringToUnsignedChars(dfa_42s);
    static final short[] dfa_43 = DFA.unpackEncodedString(dfa_43s);
    static final short[][] dfa_44 = unpackEncodedStringArray(dfa_44s);

    class DFA61 extends DFA {

        public DFA61(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 61;
            this.eot = dfa_20;
            this.eof = dfa_40;
            this.min = dfa_41;
            this.max = dfa_42;
            this.accept = dfa_43;
            this.special = dfa_25;
            this.transition = dfa_44;
        }
        public String getDescription() {
            return "1980:7: ( (lv_type_6_0= ruleJvmTypeReference ) )?";
        }
    }
    static final String dfa_45s = "\41\uffff";
    static final String dfa_46s = "\1\7\6\16\32\uffff";
    static final String dfa_47s = "\7\4\1\uffff\6\4\1\uffff\22\4";
    static final String dfa_48s = "\7\155\1\uffff\6\155\1\uffff\22\155";
    static final String dfa_49s = "\7\uffff\1\2\6\uffff\1\1\22\uffff";
    static final String dfa_50s = "\41\uffff}>";
    static final String[] dfa_51s = {
            "\3\7\6\uffff\3\7\1\3\1\7\1\uffff\3\7\1\uffff\1\7\1\uffff\20\7\1\2\1\uffff\1\4\1\5\1\6\12\uffff\1\7\64\uffff\1\1",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\21\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\16\1\uffff\1\7\62\uffff\1\17",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "",
            "\3\7\1\16\5\uffff\3\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\5\uffff\3\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\5\uffff\3\7\1\35\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\7\1\uffff\1\16\62\uffff\1\33",
            "\3\7\1\16\5\uffff\3\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\5\uffff\3\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\5\uffff\3\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "",
            "\3\7\1\16\4\uffff\4\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\4\uffff\4\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\4\uffff\4\7\1\35\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\34\1\uffff\1\36\1\37\1\40\12\uffff\1\7\1\uffff\1\16\62\uffff\1\33",
            "\3\7\1\16\4\uffff\4\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\4\uffff\4\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\7\1\16\4\uffff\4\7\1\27\1\7\1\uffff\3\7\1\uffff\1\7\1\16\20\7\1\26\1\uffff\1\30\1\31\1\32\12\uffff\1\7\1\uffff\1\16\62\uffff\1\25",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\21\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\16\1\uffff\1\7\62\uffff\1\17",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\5\uffff\3\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\4\uffff\4\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\4\uffff\4\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\4\uffff\4\16\1\21\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\20\1\uffff\1\22\1\23\1\24\12\uffff\1\16\1\uffff\1\7\62\uffff\1\17",
            "\3\16\1\7\4\uffff\4\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\4\uffff\4\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10",
            "\3\16\1\7\4\uffff\4\16\1\12\1\16\1\uffff\3\16\1\uffff\1\16\1\7\20\16\1\11\1\uffff\1\13\1\14\1\15\12\uffff\1\16\1\uffff\1\7\62\uffff\1\10"
    };

    static final short[] dfa_45 = DFA.unpackEncodedString(dfa_45s);
    static final short[] dfa_46 = DFA.unpackEncodedString(dfa_46s);
    static final char[] dfa_47 = DFA.unpackEncodedStringToUnsignedChars(dfa_47s);
    static final char[] dfa_48 = DFA.unpackEncodedStringToUnsignedChars(dfa_48s);
    static final short[] dfa_49 = DFA.unpackEncodedString(dfa_49s);
    static final short[] dfa_50 = DFA.unpackEncodedString(dfa_50s);
    static final short[][] dfa_51 = unpackEncodedStringArray(dfa_51s);

    class DFA63 extends DFA {

        public DFA63(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 63;
            this.eot = dfa_45;
            this.eof = dfa_46;
            this.min = dfa_47;
            this.max = dfa_48;
            this.accept = dfa_49;
            this.special = dfa_50;
            this.transition = dfa_51;
        }
        public String getDescription() {
            return "2095:7: ( (lv_name_12_0= ruleValidID ) )?";
        }
    }

    class DFA66 extends DFA {

        public DFA66(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 66;
            this.eot = dfa_45;
            this.eof = dfa_46;
            this.min = dfa_47;
            this.max = dfa_48;
            this.accept = dfa_49;
            this.special = dfa_50;
            this.transition = dfa_51;
        }
        public String getDescription() {
            return "2207:7: ( (lv_name_18_0= ruleValidID ) )?";
        }
    }
    static final String dfa_52s = "\51\uffff";
    static final String dfa_53s = "\1\7\10\0\40\uffff";
    static final String dfa_54s = "\1\155\10\0\40\uffff";
    static final String dfa_55s = "\11\uffff\1\5\33\uffff\1\1\1\2\1\3\1\4";
    static final String dfa_56s = "\1\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\40\uffff}>";
    static final String[] dfa_57s = {
            "\1\11\1\uffff\1\11\6\uffff\1\3\1\7\1\uffff\1\10\25\uffff\1\2\1\uffff\1\4\1\5\1\6\16\uffff\14\11\1\uffff\14\11\1\uffff\2\11\25\uffff\1\1",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_52 = DFA.unpackEncodedString(dfa_52s);
    static final char[] dfa_53 = DFA.unpackEncodedStringToUnsignedChars(dfa_53s);
    static final char[] dfa_54 = DFA.unpackEncodedStringToUnsignedChars(dfa_54s);
    static final short[] dfa_55 = DFA.unpackEncodedString(dfa_55s);
    static final short[] dfa_56 = DFA.unpackEncodedString(dfa_56s);
    static final short[][] dfa_57 = unpackEncodedStringArray(dfa_57s);

    class DFA74 extends DFA {

        public DFA74(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 74;
            this.eot = dfa_52;
            this.eof = dfa_52;
            this.min = dfa_53;
            this.max = dfa_54;
            this.accept = dfa_55;
            this.special = dfa_56;
            this.transition = dfa_57;
        }
        public String getDescription() {
            return "2443:5: ( ( ( ( ( ( ruleJvmTypeReference ) ) ( ( ruleCreateExtensionInfo ) ) ( ( ruleValidID ) ) '(' ) )=> ( ( (lv_returnType_34_0= ruleJvmTypeReference ) ) ( (lv_createExtensionInfo_35_0= ruleCreateExtensionInfo ) ) ( (lv_name_36_0= ruleValidID ) ) otherlv_37= '(' ) ) | ( ( ( ( ( ruleTypeReferenceWithTypeArgs ) ) ( ( ruleFunctionID ) ) '(' ) )=> ( ( (lv_returnType_38_0= ruleTypeReferenceWithTypeArgs ) ) ( (lv_name_39_0= ruleFunctionID ) ) otherlv_40= '(' ) ) | ( ( ( ( ( ruleTypeReferenceNoTypeArgs ) ) ( ( ruleFunctionID ) ) '(' ) )=> ( ( (lv_returnType_41_0= ruleTypeReferenceNoTypeArgs ) ) ( (lv_name_42_0= ruleFunctionID ) ) otherlv_43= '(' ) ) | ( ( ( ( ( ruleCreateExtensionInfo ) ) ( ( ruleValidID ) ) '(' ) )=> ( ( (lv_createExtensionInfo_44_0= ruleCreateExtensionInfo ) ) ( (lv_name_45_0= ruleValidID ) ) otherlv_46= '(' ) ) | ( ( (lv_name_47_0= ruleFunctionID ) ) otherlv_48= '(' ) )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA74_1 = input.LA(1);

                         
                        int index74_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_InternalXtend()) ) {s = 37;}

                        else if ( (synpred2_InternalXtend()) ) {s = 38;}

                        else if ( (synpred3_InternalXtend()) ) {s = 39;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index74_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA74_2 = input.LA(1);

                         
                        int index74_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_InternalXtend()) ) {s = 37;}

                        else if ( (synpred2_InternalXtend()) ) {s = 38;}

                        else if ( (synpred3_InternalXtend()) ) {s = 39;}

                        else if ( (synpred4_InternalXtend()) ) {s = 40;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index74_2);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA74_3 = input.LA(1);

                         
                        int index74_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_InternalXtend()) ) {s = 37;}

                        else if ( (synpred2_InternalXtend()) ) {s = 38;}

                        else if ( (synpred3_InternalXtend()) ) {s = 39;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index74_3);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA74_4 = input.LA(1);

                         
                        int index74_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_InternalXtend()) ) {s = 37;}

                        else if ( (synpred2_InternalXtend()) ) {s = 38;}

                        else if ( (synpred3_InternalXtend()) ) {s = 39;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index74_4);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA74_5 = input.LA(1);

                         
                        int index74_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_InternalXtend()) ) {s = 37;}

                        else if ( (synpred2_InternalXtend()) ) {s = 38;}

                        else if ( (synpred3_InternalXtend()) ) {s = 39;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index74_5);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA74_6 = input.LA(1);

                         
                        int index74_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_InternalXtend()) ) {s = 37;}

                        else if ( (synpred2_InternalXtend()) ) {s = 38;}

                        else if ( (synpred3_InternalXtend()) ) {s = 39;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index74_6);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA74_7 = input.LA(1);

                         
                        int index74_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_InternalXtend()) ) {s = 37;}

                        else if ( (synpred2_InternalXtend()) ) {s = 38;}

                         
                        input.seek(index74_7);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA74_8 = input.LA(1);

                         
                        int index74_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred1_InternalXtend()) ) {s = 37;}

                        else if ( (synpred2_InternalXtend()) ) {s = 38;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index74_8);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 74, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_58s = "\21\uffff";
    static final String dfa_59s = "\1\20\6\7\1\uffff\1\20\2\uffff\6\7";
    static final String dfa_60s = "\1\155\6\72\1\uffff\1\155\2\uffff\6\72";
    static final String dfa_61s = "\7\uffff\1\3\1\uffff\1\1\1\2\6\uffff";
    static final String dfa_62s = "\21\uffff}>";
    static final String[] dfa_63s = {
            "\1\3\1\7\1\uffff\1\7\25\uffff\1\2\1\uffff\1\4\1\5\1\6\77\uffff\1\1",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "",
            "\1\15\30\uffff\1\14\1\uffff\1\16\1\17\1\20\77\uffff\1\13",
            "",
            "",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "\1\11\20\uffff\1\10\41\uffff\1\12",
            "\1\11\20\uffff\1\10\41\uffff\1\12"
    };

    static final short[] dfa_58 = DFA.unpackEncodedString(dfa_58s);
    static final char[] dfa_59 = DFA.unpackEncodedStringToUnsignedChars(dfa_59s);
    static final char[] dfa_60 = DFA.unpackEncodedStringToUnsignedChars(dfa_60s);
    static final short[] dfa_61 = DFA.unpackEncodedString(dfa_61s);
    static final short[] dfa_62 = DFA.unpackEncodedString(dfa_62s);
    static final short[][] dfa_63 = unpackEncodedStringArray(dfa_63s);

    class DFA109 extends DFA {

        public DFA109(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 109;
            this.eot = dfa_58;
            this.eof = dfa_58;
            this.min = dfa_59;
            this.max = dfa_60;
            this.accept = dfa_61;
            this.special = dfa_62;
            this.transition = dfa_63;
        }
        public String getDescription() {
            return "3729:2: ( (this_ParameterizedTypeReferenceWithTypeArgs_0= ruleParameterizedTypeReferenceWithTypeArgs ( ( ( () ruleArrayBrackets ) )=> ( () ruleArrayBrackets ) )* ) | (this_TypeReferenceNoTypeArgs_3= ruleTypeReferenceNoTypeArgs ( ( ( () ruleArrayBrackets ) )=> ( () ruleArrayBrackets ) )+ ) | this_XFunctionTypeRef_6= ruleXFunctionTypeRef )";
        }
    }
    static final String dfa_64s = "\50\uffff";
    static final String dfa_65s = "\1\2\47\uffff";
    static final String dfa_66s = "\1\7\1\0\46\uffff";
    static final String dfa_67s = "\1\155\1\0\46\uffff";
    static final String dfa_68s = "\2\uffff\1\2\44\uffff\1\1";
    static final String dfa_69s = "\1\uffff\1\0\46\uffff}>";
    static final String[] dfa_70s = {
            "\1\1\1\uffff\1\2\6\uffff\1\2\2\uffff\1\2\4\uffff\1\2\20\uffff\1\2\1\uffff\3\2\14\uffff\1\2\1\uffff\14\2\1\uffff\14\2\1\uffff\2\2\25\uffff\1\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_64 = DFA.unpackEncodedString(dfa_64s);
    static final short[] dfa_65 = DFA.unpackEncodedString(dfa_65s);
    static final char[] dfa_66 = DFA.unpackEncodedStringToUnsignedChars(dfa_66s);
    static final char[] dfa_67 = DFA.unpackEncodedStringToUnsignedChars(dfa_67s);
    static final short[] dfa_68 = DFA.unpackEncodedString(dfa_68s);
    static final short[] dfa_69 = DFA.unpackEncodedString(dfa_69s);
    static final short[][] dfa_70 = unpackEncodedStringArray(dfa_70s);

    class DFA112 extends DFA {

        public DFA112(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 112;
            this.eot = dfa_64;
            this.eof = dfa_65;
            this.min = dfa_66;
            this.max = dfa_67;
            this.accept = dfa_68;
            this.special = dfa_69;
            this.transition = dfa_70;
        }
        public String getDescription() {
            return "3934:5: ( ( ( '<' )=>otherlv_9= '<' ) ( (lv_arguments_10_0= ruleJvmArgumentTypeReference ) ) (otherlv_11= ',' ( (lv_arguments_12_0= ruleJvmArgumentTypeReference ) ) )* otherlv_13= '>' )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA112_1 = input.LA(1);

                         
                        int index112_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred8_InternalXtend()) ) {s = 39;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index112_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 112, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_71s = "\16\uffff";
    static final String dfa_72s = "\2\uffff\2\7\10\uffff\2\10";
    static final String dfa_73s = "\1\7\1\uffff\1\7\1\11\10\uffff\1\7\1\11";
    static final String dfa_74s = "\1\127\1\uffff\1\24\1\113\10\uffff\1\24\1\101";
    static final String dfa_75s = "\1\uffff\1\1\2\uffff\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\2\uffff";
    static final String dfa_76s = "\16\uffff}>";
    static final String[] dfa_77s = {
            "\1\2\1\uffff\1\3\11\uffff\1\10\50\uffff\5\1\1\7\1\4\1\5\4\6\1\uffff\5\10\2\12\4\11\1\12\1\uffff\2\13",
            "",
            "\1\14\11\uffff\1\7\1\uffff\1\10\1\7",
            "\1\15\7\uffff\1\7\57\uffff\1\1\11\uffff\1\10",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\10\11\uffff\1\10\2\uffff\1\1",
            "\1\10\7\uffff\1\10\57\uffff\1\1"
    };

    static final short[] dfa_71 = DFA.unpackEncodedString(dfa_71s);
    static final short[] dfa_72 = DFA.unpackEncodedString(dfa_72s);
    static final char[] dfa_73 = DFA.unpackEncodedStringToUnsignedChars(dfa_73s);
    static final char[] dfa_74 = DFA.unpackEncodedStringToUnsignedChars(dfa_74s);
    static final short[] dfa_75 = DFA.unpackEncodedString(dfa_75s);
    static final short[] dfa_76 = DFA.unpackEncodedString(dfa_76s);
    static final short[][] dfa_77 = unpackEncodedStringArray(dfa_77s);

    class DFA115 extends DFA {

        public DFA115(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 115;
            this.eot = dfa_71;
            this.eof = dfa_72;
            this.min = dfa_73;
            this.max = dfa_74;
            this.accept = dfa_75;
            this.special = dfa_76;
            this.transition = dfa_77;
        }
        public String getDescription() {
            return "4051:2: (this_OpMultiAssign_0= ruleOpMultiAssign | this_OpOr_1= ruleOpOr | this_OpAnd_2= ruleOpAnd | this_OpEquality_3= ruleOpEquality | this_OpCompare_4= ruleOpCompare | this_OpOther_5= ruleOpOther | this_OpMulti_6= ruleOpMulti | this_OpUnary_7= ruleOpUnary | this_OpPostfix_8= ruleOpPostfix )";
        }
    }
    static final String dfa_78s = "\37\uffff";
    static final String dfa_79s = "\1\4\6\0\30\uffff";
    static final String dfa_80s = "\1\155\6\0\30\uffff";
    static final String dfa_81s = "\7\uffff\2\1\1\2\25\uffff";
    static final String dfa_82s = "\1\0\1\1\1\2\1\3\1\4\1\5\1\6\30\uffff}>";
    static final String[] dfa_83s = {
            "\1\11\1\uffff\1\11\3\uffff\2\11\2\uffff\2\11\1\3\1\7\1\uffff\1\10\2\uffff\1\11\2\uffff\14\11\2\uffff\2\11\1\2\1\uffff\1\4\1\5\1\6\1\11\76\uffff\1\1",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_78 = DFA.unpackEncodedString(dfa_78s);
    static final char[] dfa_79 = DFA.unpackEncodedStringToUnsignedChars(dfa_79s);
    static final char[] dfa_80 = DFA.unpackEncodedStringToUnsignedChars(dfa_80s);
    static final short[] dfa_81 = DFA.unpackEncodedString(dfa_81s);
    static final short[] dfa_82 = DFA.unpackEncodedString(dfa_82s);
    static final short[][] dfa_83 = unpackEncodedStringArray(dfa_83s);

    class DFA132 extends DFA {

        public DFA132(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 132;
            this.eot = dfa_78;
            this.eof = dfa_78;
            this.min = dfa_79;
            this.max = dfa_80;
            this.accept = dfa_81;
            this.special = dfa_82;
            this.transition = dfa_83;
        }
        public String getDescription() {
            return "4981:3: ( ( ( ( ( ( ruleJvmTypeReference ) ) ( ( ruleInnerVarID ) ) ) )=> ( ( (lv_type_7_0= ruleJvmTypeReference ) ) ( (lv_name_8_0= ruleInnerVarID ) ) ) ) | ( (lv_name_9_0= ruleInnerVarID ) ) )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA132_0 = input.LA(1);

                         
                        int index132_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA132_0==RULE_ID) ) {s = 1;}

                        else if ( (LA132_0==KW_Create) ) {s = 2;}

                        else if ( (LA132_0==KW_Annotation) ) {s = 3;}

                        else if ( (LA132_0==KW_AFTER) ) {s = 4;}

                        else if ( (LA132_0==KW_BEFORE) ) {s = 5;}

                        else if ( (LA132_0==KW_SEPARATOR) ) {s = 6;}

                        else if ( (LA132_0==KW_LeftParenthesis) && (synpred10_InternalXtend())) {s = 7;}

                        else if ( (LA132_0==KW_EqualsSignGreaterThanSign) && (synpred10_InternalXtend())) {s = 8;}

                        else if ( (LA132_0==KW_Package||LA132_0==KW_Class||(LA132_0>=KW_Extends && LA132_0<=KW_Implements)||(LA132_0>=KW_Interface && LA132_0<=KW_Enum)||LA132_0==KW_Throws||(LA132_0>=KW_Public && LA132_0<=KW_Transient)||(LA132_0>=KW_Def && LA132_0<=KW_Override)||LA132_0==KW_Import) ) {s = 9;}

                         
                        input.seek(index132_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA132_1 = input.LA(1);

                         
                        int index132_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred10_InternalXtend()) ) {s = 8;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index132_1);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA132_2 = input.LA(1);

                         
                        int index132_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred10_InternalXtend()) ) {s = 8;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index132_2);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA132_3 = input.LA(1);

                         
                        int index132_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred10_InternalXtend()) ) {s = 8;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index132_3);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA132_4 = input.LA(1);

                         
                        int index132_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred10_InternalXtend()) ) {s = 8;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index132_4);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA132_5 = input.LA(1);

                         
                        int index132_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred10_InternalXtend()) ) {s = 8;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index132_5);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA132_6 = input.LA(1);

                         
                        int index132_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred10_InternalXtend()) ) {s = 8;}

                        else if ( (true) ) {s = 9;}

                         
                        input.seek(index132_6);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 132, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_84s = "\154\uffff";
    static final String dfa_85s = "\1\2\153\uffff";
    static final String dfa_86s = "\1\4\1\0\152\uffff";
    static final String dfa_87s = "\1\167\1\0\152\uffff";
    static final String dfa_88s = "\2\uffff\1\2\150\uffff\1\1";
    static final String dfa_89s = "\1\uffff\1\0\152\uffff}>";
    static final String[] dfa_90s = {
            "\10\2\1\1\7\2\1\uffff\32\2\1\uffff\2\2\6\uffff\42\2\1\uffff\20\2\2\uffff\13\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_84 = DFA.unpackEncodedString(dfa_84s);
    static final short[] dfa_85 = DFA.unpackEncodedString(dfa_85s);
    static final char[] dfa_86 = DFA.unpackEncodedStringToUnsignedChars(dfa_86s);
    static final char[] dfa_87 = DFA.unpackEncodedStringToUnsignedChars(dfa_87s);
    static final short[] dfa_88 = DFA.unpackEncodedString(dfa_88s);
    static final short[] dfa_89 = DFA.unpackEncodedString(dfa_89s);
    static final short[][] dfa_90 = unpackEncodedStringArray(dfa_90s);

    class DFA135 extends DFA {

        public DFA135(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 135;
            this.eot = dfa_84;
            this.eof = dfa_85;
            this.min = dfa_86;
            this.max = dfa_87;
            this.accept = dfa_88;
            this.special = dfa_89;
            this.transition = dfa_90;
        }
        public String getDescription() {
            return "5110:3: ( ( ( ( () '{' ) )=> ( () otherlv_2= '{' ) ) ( (lv_members_3_0= ruleMember ) )* otherlv_4= '}' )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA135_1 = input.LA(1);

                         
                        int index135_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred11_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index135_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 135, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String[] dfa_91s = {
            "\3\2\1\1\14\2\1\uffff\32\2\1\uffff\2\2\6\uffff\42\2\1\uffff\20\2\2\uffff\13\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[][] dfa_91 = unpackEncodedStringArray(dfa_91s);

    class DFA137 extends DFA {

        public DFA137(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 137;
            this.eot = dfa_84;
            this.eof = dfa_85;
            this.min = dfa_86;
            this.max = dfa_87;
            this.accept = dfa_88;
            this.special = dfa_89;
            this.transition = dfa_91;
        }
        public String getDescription() {
            return "5202:3: ( ( ( '<' )=>otherlv_3= '<' ) ( (lv_typeArguments_4_0= ruleJvmArgumentTypeReference ) ) (otherlv_5= ',' ( (lv_typeArguments_6_0= ruleJvmArgumentTypeReference ) ) )* otherlv_7= '>' )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA137_1 = input.LA(1);

                         
                        int index137_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred12_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index137_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 137, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String[] dfa_92s = {
            "\15\2\1\1\2\2\1\uffff\32\2\1\uffff\2\2\6\uffff\42\2\1\uffff\20\2\2\uffff\13\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[][] dfa_92 = unpackEncodedStringArray(dfa_92s);

    class DFA140 extends DFA {

        public DFA140(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 140;
            this.eot = dfa_84;
            this.eof = dfa_85;
            this.min = dfa_86;
            this.max = dfa_87;
            this.accept = dfa_88;
            this.special = dfa_89;
            this.transition = dfa_92;
        }
        public String getDescription() {
            return "5259:3: ( ( ( ( '(' ) )=> (lv_explicitConstructorCall_8_0= '(' ) ) ( ( ( ( () ( ( ( ruleJvmFormalParameter ) ) ( ',' ( ( ruleJvmFormalParameter ) ) )* )? ( ( '|' ) ) ) )=> (lv_arguments_9_0= ruleXShortClosure ) ) | ( ( (lv_arguments_10_0= ruleXExpression ) ) (otherlv_11= ',' ( (lv_arguments_12_0= ruleXExpression ) ) )* ) )? otherlv_13= ')' )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA140_1 = input.LA(1);

                         
                        int index140_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred13_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index140_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 140, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_93s = "\75\uffff";
    static final String dfa_94s = "\1\4\10\0\1\uffff\26\0\35\uffff";
    static final String dfa_95s = "\1\167\10\0\1\uffff\26\0\35\uffff";
    static final String dfa_96s = "\11\uffff\1\1\26\uffff\1\1\1\2\32\uffff\1\3";
    static final String dfa_97s = "\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\uffff\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34\1\35\1\36\35\uffff}>";
    static final String[] dfa_98s = {
            "\1\25\1\uffff\1\13\1\41\2\uffff\1\17\1\21\1\41\1\uffff\1\23\1\16\1\4\1\10\1\74\1\11\1\uffff\1\1\1\32\1\41\1\uffff\1\26\1\27\1\30\1\12\1\31\1\15\1\20\1\33\1\34\1\35\1\36\1\37\2\uffff\1\14\1\24\1\3\1\uffff\1\5\1\6\1\7\1\22\1\uffff\1\41\10\uffff\2\41\23\uffff\2\41\4\uffff\1\41\5\uffff\1\40\1\41\2\uffff\13\41\4\uffff\1\2\3\41\4\uffff\3\41",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_93 = DFA.unpackEncodedString(dfa_93s);
    static final char[] dfa_94 = DFA.unpackEncodedStringToUnsignedChars(dfa_94s);
    static final char[] dfa_95 = DFA.unpackEncodedStringToUnsignedChars(dfa_95s);
    static final short[] dfa_96 = DFA.unpackEncodedString(dfa_96s);
    static final short[] dfa_97 = DFA.unpackEncodedString(dfa_97s);
    static final short[][] dfa_98 = unpackEncodedStringArray(dfa_98s);

    class DFA139 extends DFA {

        public DFA139(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 139;
            this.eot = dfa_93;
            this.eof = dfa_93;
            this.min = dfa_94;
            this.max = dfa_95;
            this.accept = dfa_96;
            this.special = dfa_97;
            this.transition = dfa_98;
        }
        public String getDescription() {
            return "5278:4: ( ( ( ( () ( ( ( ruleJvmFormalParameter ) ) ( ',' ( ( ruleJvmFormalParameter ) ) )* )? ( ( '|' ) ) ) )=> (lv_arguments_9_0= ruleXShortClosure ) ) | ( ( (lv_arguments_10_0= ruleXExpression ) ) (otherlv_11= ',' ( (lv_arguments_12_0= ruleXExpression ) ) )* ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA139_0 = input.LA(1);

                         
                        int index139_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA139_0==KW_Extension) ) {s = 1;}

                        else if ( (LA139_0==RULE_ID) ) {s = 2;}

                        else if ( (LA139_0==KW_Create) ) {s = 3;}

                        else if ( (LA139_0==KW_Annotation) ) {s = 4;}

                        else if ( (LA139_0==KW_AFTER) ) {s = 5;}

                        else if ( (LA139_0==KW_BEFORE) ) {s = 6;}

                        else if ( (LA139_0==KW_SEPARATOR) ) {s = 7;}

                        else if ( (LA139_0==KW_LeftParenthesis) ) {s = 8;}

                        else if ( (LA139_0==KW_EqualsSignGreaterThanSign) && (synpred14_InternalXtend())) {s = 9;}

                        else if ( (LA139_0==KW_Abstract) ) {s = 10;}

                        else if ( (LA139_0==KW_Class) ) {s = 11;}

                        else if ( (LA139_0==KW_Def) ) {s = 12;}

                        else if ( (LA139_0==KW_Dispatch) ) {s = 13;}

                        else if ( (LA139_0==KW_Enum) ) {s = 14;}

                        else if ( (LA139_0==KW_Extends) ) {s = 15;}

                        else if ( (LA139_0==KW_Final) ) {s = 16;}

                        else if ( (LA139_0==KW_Implements) ) {s = 17;}

                        else if ( (LA139_0==KW_Import) ) {s = 18;}

                        else if ( (LA139_0==KW_Interface) ) {s = 19;}

                        else if ( (LA139_0==KW_Override) ) {s = 20;}

                        else if ( (LA139_0==KW_Package) ) {s = 21;}

                        else if ( (LA139_0==KW_Public) ) {s = 22;}

                        else if ( (LA139_0==KW_Private) ) {s = 23;}

                        else if ( (LA139_0==KW_Protected) ) {s = 24;}

                        else if ( (LA139_0==KW_Static) ) {s = 25;}

                        else if ( (LA139_0==KW_Throws) ) {s = 26;}

                        else if ( (LA139_0==KW_Strictfp) ) {s = 27;}

                        else if ( (LA139_0==KW_Native) ) {s = 28;}

                        else if ( (LA139_0==KW_Volatile) ) {s = 29;}

                        else if ( (LA139_0==KW_Synchronized) ) {s = 30;}

                        else if ( (LA139_0==KW_Transient) ) {s = 31;}

                        else if ( (LA139_0==KW_VerticalLine) && (synpred14_InternalXtend())) {s = 32;}

                        else if ( (LA139_0==KW_LessThanSign||LA139_0==KW_LeftCurlyBracket||LA139_0==KW_New||LA139_0==KW_Switch||(LA139_0>=KW_NumberSign && LA139_0<=KW_LeftSquareBracket)||(LA139_0>=KW_PlusSign && LA139_0<=KW_HyphenMinus)||LA139_0==KW_ExclamationMark||LA139_0==KW_If||(LA139_0>=KW_For && LA139_0<=KW_Try)||(LA139_0>=RULE_STRING && LA139_0<=RULE_RICH_TEXT_START)||(LA139_0>=RULE_HEX && LA139_0<=RULE_DECIMAL)) ) {s = 33;}

                        else if ( (LA139_0==KW_RightParenthesis) ) {s = 60;}

                         
                        input.seek(index139_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA139_1 = input.LA(1);

                         
                        int index139_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_1);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA139_2 = input.LA(1);

                         
                        int index139_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_2);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA139_3 = input.LA(1);

                         
                        int index139_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_3);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA139_4 = input.LA(1);

                         
                        int index139_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_4);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA139_5 = input.LA(1);

                         
                        int index139_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_5);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA139_6 = input.LA(1);

                         
                        int index139_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_6);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA139_7 = input.LA(1);

                         
                        int index139_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_7);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA139_8 = input.LA(1);

                         
                        int index139_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_8);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA139_10 = input.LA(1);

                         
                        int index139_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_10);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA139_11 = input.LA(1);

                         
                        int index139_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_11);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA139_12 = input.LA(1);

                         
                        int index139_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_12);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA139_13 = input.LA(1);

                         
                        int index139_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_13);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA139_14 = input.LA(1);

                         
                        int index139_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_14);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA139_15 = input.LA(1);

                         
                        int index139_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_15);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA139_16 = input.LA(1);

                         
                        int index139_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_16);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA139_17 = input.LA(1);

                         
                        int index139_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_17);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA139_18 = input.LA(1);

                         
                        int index139_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_18);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA139_19 = input.LA(1);

                         
                        int index139_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_19);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA139_20 = input.LA(1);

                         
                        int index139_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_20);
                        if ( s>=0 ) return s;
                        break;
                    case 20 : 
                        int LA139_21 = input.LA(1);

                         
                        int index139_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_21);
                        if ( s>=0 ) return s;
                        break;
                    case 21 : 
                        int LA139_22 = input.LA(1);

                         
                        int index139_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_22);
                        if ( s>=0 ) return s;
                        break;
                    case 22 : 
                        int LA139_23 = input.LA(1);

                         
                        int index139_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_23);
                        if ( s>=0 ) return s;
                        break;
                    case 23 : 
                        int LA139_24 = input.LA(1);

                         
                        int index139_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_24);
                        if ( s>=0 ) return s;
                        break;
                    case 24 : 
                        int LA139_25 = input.LA(1);

                         
                        int index139_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_25);
                        if ( s>=0 ) return s;
                        break;
                    case 25 : 
                        int LA139_26 = input.LA(1);

                         
                        int index139_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_26);
                        if ( s>=0 ) return s;
                        break;
                    case 26 : 
                        int LA139_27 = input.LA(1);

                         
                        int index139_27 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_27);
                        if ( s>=0 ) return s;
                        break;
                    case 27 : 
                        int LA139_28 = input.LA(1);

                         
                        int index139_28 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_28);
                        if ( s>=0 ) return s;
                        break;
                    case 28 : 
                        int LA139_29 = input.LA(1);

                         
                        int index139_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_29);
                        if ( s>=0 ) return s;
                        break;
                    case 29 : 
                        int LA139_30 = input.LA(1);

                         
                        int index139_30 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_30);
                        if ( s>=0 ) return s;
                        break;
                    case 30 : 
                        int LA139_31 = input.LA(1);

                         
                        int index139_31 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred14_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index139_31);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 139, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String[] dfa_99s = {
            "\20\2\1\uffff\32\2\1\uffff\2\2\6\uffff\2\2\1\1\37\2\1\uffff\20\2\2\uffff\13\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[][] dfa_99 = unpackEncodedStringArray(dfa_99s);

    class DFA141 extends DFA {

        public DFA141(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 141;
            this.eot = dfa_84;
            this.eof = dfa_85;
            this.min = dfa_86;
            this.max = dfa_87;
            this.accept = dfa_88;
            this.special = dfa_89;
            this.transition = dfa_99;
        }
        public String getDescription() {
            return "5376:3: ( ( ( () '[' ) )=> (lv_arguments_14_0= ruleXClosure ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA141_1 = input.LA(1);

                         
                        int index141_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred15_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index141_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 141, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_100s = "\74\uffff";
    static final String dfa_101s = "\1\4\1\0\72\uffff";
    static final String dfa_102s = "\1\167\1\0\72\uffff";
    static final String dfa_103s = "\2\uffff\1\2\70\uffff\1\1";
    static final String dfa_104s = "\1\uffff\1\0\72\uffff}>";
    static final String[] dfa_105s = {
            "\1\2\1\uffff\2\2\2\uffff\3\2\1\uffff\3\2\1\1\1\uffff\1\2\1\uffff\3\2\1\uffff\14\2\2\uffff\3\2\1\uffff\4\2\1\uffff\1\2\10\uffff\2\2\23\uffff\2\2\4\uffff\1\2\6\uffff\1\2\2\uffff\13\2\4\uffff\4\2\4\uffff\3\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_100 = DFA.unpackEncodedString(dfa_100s);
    static final char[] dfa_101 = DFA.unpackEncodedStringToUnsignedChars(dfa_101s);
    static final char[] dfa_102 = DFA.unpackEncodedStringToUnsignedChars(dfa_102s);
    static final short[] dfa_103 = DFA.unpackEncodedString(dfa_103s);
    static final short[] dfa_104 = DFA.unpackEncodedString(dfa_104s);
    static final short[][] dfa_105 = unpackEncodedStringArray(dfa_105s);

    class DFA147 extends DFA {

        public DFA147(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 147;
            this.eot = dfa_100;
            this.eof = dfa_100;
            this.min = dfa_101;
            this.max = dfa_102;
            this.accept = dfa_103;
            this.special = dfa_104;
            this.transition = dfa_105;
        }
        public String getDescription() {
            return "5609:3: ( ( ( ( ( '(' ( ( ruleJvmFormalParameter ) ) ':' ) )=> (otherlv_2= '(' ( (lv_declaredParam_3_0= ruleJvmFormalParameter ) ) otherlv_4= ':' ) ) ( (lv_switch_5_0= ruleXExpression ) ) otherlv_6= ')' ) | ( ( ( ( ( ( ruleJvmFormalParameter ) ) ':' ) )=> ( ( (lv_declaredParam_7_0= ruleJvmFormalParameter ) ) otherlv_8= ':' ) )? ( (lv_switch_9_0= ruleXExpressionOrSimpleConstructorCall ) ) ) )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA147_1 = input.LA(1);

                         
                        int index147_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred16_InternalXtend()) ) {s = 59;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index147_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 147, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_106s = "\73\uffff";
    static final String dfa_107s = "\1\4\10\0\1\uffff\26\0\33\uffff";
    static final String dfa_108s = "\1\167\10\0\1\uffff\26\0\33\uffff";
    static final String dfa_109s = "\11\uffff\1\1\26\uffff\1\2\32\uffff";
    static final String dfa_110s = "\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\uffff\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34\1\35\1\36\33\uffff}>";
    static final String[] dfa_111s = {
            "\1\25\1\uffff\1\13\1\40\2\uffff\1\17\1\21\1\40\1\uffff\1\23\1\16\1\4\1\10\1\uffff\1\11\1\uffff\1\1\1\32\1\40\1\uffff\1\26\1\27\1\30\1\12\1\31\1\15\1\20\1\33\1\34\1\35\1\36\1\37\2\uffff\1\14\1\24\1\3\1\uffff\1\5\1\6\1\7\1\22\1\uffff\1\40\10\uffff\2\40\23\uffff\2\40\4\uffff\1\40\6\uffff\1\40\2\uffff\13\40\4\uffff\1\2\3\40\4\uffff\3\40",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_106 = DFA.unpackEncodedString(dfa_106s);
    static final char[] dfa_107 = DFA.unpackEncodedStringToUnsignedChars(dfa_107s);
    static final char[] dfa_108 = DFA.unpackEncodedStringToUnsignedChars(dfa_108s);
    static final short[] dfa_109 = DFA.unpackEncodedString(dfa_109s);
    static final short[] dfa_110 = DFA.unpackEncodedString(dfa_110s);
    static final short[][] dfa_111 = unpackEncodedStringArray(dfa_111s);

    class DFA146 extends DFA {

        public DFA146(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 146;
            this.eot = dfa_106;
            this.eof = dfa_106;
            this.min = dfa_107;
            this.max = dfa_108;
            this.accept = dfa_109;
            this.special = dfa_110;
            this.transition = dfa_111;
        }
        public String getDescription() {
            return "5678:5: ( ( ( ( ( ruleJvmFormalParameter ) ) ':' ) )=> ( ( (lv_declaredParam_7_0= ruleJvmFormalParameter ) ) otherlv_8= ':' ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA146_0 = input.LA(1);

                         
                        int index146_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA146_0==KW_Extension) ) {s = 1;}

                        else if ( (LA146_0==RULE_ID) ) {s = 2;}

                        else if ( (LA146_0==KW_Create) ) {s = 3;}

                        else if ( (LA146_0==KW_Annotation) ) {s = 4;}

                        else if ( (LA146_0==KW_AFTER) ) {s = 5;}

                        else if ( (LA146_0==KW_BEFORE) ) {s = 6;}

                        else if ( (LA146_0==KW_SEPARATOR) ) {s = 7;}

                        else if ( (LA146_0==KW_LeftParenthesis) ) {s = 8;}

                        else if ( (LA146_0==KW_EqualsSignGreaterThanSign) && (synpred17_InternalXtend())) {s = 9;}

                        else if ( (LA146_0==KW_Abstract) ) {s = 10;}

                        else if ( (LA146_0==KW_Class) ) {s = 11;}

                        else if ( (LA146_0==KW_Def) ) {s = 12;}

                        else if ( (LA146_0==KW_Dispatch) ) {s = 13;}

                        else if ( (LA146_0==KW_Enum) ) {s = 14;}

                        else if ( (LA146_0==KW_Extends) ) {s = 15;}

                        else if ( (LA146_0==KW_Final) ) {s = 16;}

                        else if ( (LA146_0==KW_Implements) ) {s = 17;}

                        else if ( (LA146_0==KW_Import) ) {s = 18;}

                        else if ( (LA146_0==KW_Interface) ) {s = 19;}

                        else if ( (LA146_0==KW_Override) ) {s = 20;}

                        else if ( (LA146_0==KW_Package) ) {s = 21;}

                        else if ( (LA146_0==KW_Public) ) {s = 22;}

                        else if ( (LA146_0==KW_Private) ) {s = 23;}

                        else if ( (LA146_0==KW_Protected) ) {s = 24;}

                        else if ( (LA146_0==KW_Static) ) {s = 25;}

                        else if ( (LA146_0==KW_Throws) ) {s = 26;}

                        else if ( (LA146_0==KW_Strictfp) ) {s = 27;}

                        else if ( (LA146_0==KW_Native) ) {s = 28;}

                        else if ( (LA146_0==KW_Volatile) ) {s = 29;}

                        else if ( (LA146_0==KW_Synchronized) ) {s = 30;}

                        else if ( (LA146_0==KW_Transient) ) {s = 31;}

                        else if ( (LA146_0==KW_LessThanSign||LA146_0==KW_LeftCurlyBracket||LA146_0==KW_New||LA146_0==KW_Switch||(LA146_0>=KW_NumberSign && LA146_0<=KW_LeftSquareBracket)||(LA146_0>=KW_PlusSign && LA146_0<=KW_HyphenMinus)||LA146_0==KW_ExclamationMark||LA146_0==KW_If||(LA146_0>=KW_For && LA146_0<=KW_Try)||(LA146_0>=RULE_STRING && LA146_0<=RULE_RICH_TEXT_START)||(LA146_0>=RULE_HEX && LA146_0<=RULE_DECIMAL)) ) {s = 32;}

                         
                        input.seek(index146_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA146_1 = input.LA(1);

                         
                        int index146_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_1);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA146_2 = input.LA(1);

                         
                        int index146_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_2);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA146_3 = input.LA(1);

                         
                        int index146_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_3);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA146_4 = input.LA(1);

                         
                        int index146_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_4);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA146_5 = input.LA(1);

                         
                        int index146_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_5);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA146_6 = input.LA(1);

                         
                        int index146_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_6);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA146_7 = input.LA(1);

                         
                        int index146_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_7);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA146_8 = input.LA(1);

                         
                        int index146_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_8);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA146_10 = input.LA(1);

                         
                        int index146_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_10);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA146_11 = input.LA(1);

                         
                        int index146_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_11);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA146_12 = input.LA(1);

                         
                        int index146_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_12);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA146_13 = input.LA(1);

                         
                        int index146_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_13);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA146_14 = input.LA(1);

                         
                        int index146_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_14);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA146_15 = input.LA(1);

                         
                        int index146_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_15);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA146_16 = input.LA(1);

                         
                        int index146_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_16);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA146_17 = input.LA(1);

                         
                        int index146_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_17);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA146_18 = input.LA(1);

                         
                        int index146_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_18);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA146_19 = input.LA(1);

                         
                        int index146_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_19);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA146_20 = input.LA(1);

                         
                        int index146_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_20);
                        if ( s>=0 ) return s;
                        break;
                    case 20 : 
                        int LA146_21 = input.LA(1);

                         
                        int index146_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_21);
                        if ( s>=0 ) return s;
                        break;
                    case 21 : 
                        int LA146_22 = input.LA(1);

                         
                        int index146_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_22);
                        if ( s>=0 ) return s;
                        break;
                    case 22 : 
                        int LA146_23 = input.LA(1);

                         
                        int index146_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_23);
                        if ( s>=0 ) return s;
                        break;
                    case 23 : 
                        int LA146_24 = input.LA(1);

                         
                        int index146_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_24);
                        if ( s>=0 ) return s;
                        break;
                    case 24 : 
                        int LA146_25 = input.LA(1);

                         
                        int index146_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_25);
                        if ( s>=0 ) return s;
                        break;
                    case 25 : 
                        int LA146_26 = input.LA(1);

                         
                        int index146_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_26);
                        if ( s>=0 ) return s;
                        break;
                    case 26 : 
                        int LA146_27 = input.LA(1);

                         
                        int index146_27 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_27);
                        if ( s>=0 ) return s;
                        break;
                    case 27 : 
                        int LA146_28 = input.LA(1);

                         
                        int index146_28 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_28);
                        if ( s>=0 ) return s;
                        break;
                    case 28 : 
                        int LA146_29 = input.LA(1);

                         
                        int index146_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_29);
                        if ( s>=0 ) return s;
                        break;
                    case 29 : 
                        int LA146_30 = input.LA(1);

                         
                        int index146_30 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_30);
                        if ( s>=0 ) return s;
                        break;
                    case 30 : 
                        int LA146_31 = input.LA(1);

                         
                        int index146_31 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred17_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 32;}

                         
                        input.seek(index146_31);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 146, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_112s = "\12\uffff";
    static final String dfa_113s = "\1\4\1\20\1\uffff\6\0\1\uffff";
    static final String dfa_114s = "\1\167\1\155\1\uffff\6\0\1\uffff";
    static final String dfa_115s = "\2\uffff\1\2\6\uffff\1\1";
    static final String dfa_116s = "\3\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\uffff}>";
    static final String[] dfa_117s = {
            "\1\2\1\uffff\2\2\2\uffff\3\2\1\uffff\4\2\3\uffff\2\2\1\1\1\uffff\14\2\2\uffff\3\2\1\uffff\4\2\1\uffff\1\2\10\uffff\2\2\23\uffff\2\2\4\uffff\1\2\6\uffff\1\2\2\uffff\13\2\4\uffff\4\2\4\uffff\3\2",
            "\1\5\30\uffff\1\4\1\uffff\1\6\1\7\1\10\77\uffff\1\3",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };

    static final short[] dfa_112 = DFA.unpackEncodedString(dfa_112s);
    static final char[] dfa_113 = DFA.unpackEncodedStringToUnsignedChars(dfa_113s);
    static final char[] dfa_114 = DFA.unpackEncodedStringToUnsignedChars(dfa_114s);
    static final short[] dfa_115 = DFA.unpackEncodedString(dfa_115s);
    static final short[] dfa_116 = DFA.unpackEncodedString(dfa_116s);
    static final short[][] dfa_117 = unpackEncodedStringArray(dfa_117s);

    class DFA150 extends DFA {

        public DFA150(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 150;
            this.eot = dfa_112;
            this.eof = dfa_112;
            this.min = dfa_113;
            this.max = dfa_114;
            this.accept = dfa_115;
            this.special = dfa_116;
            this.transition = dfa_117;
        }
        public String getDescription() {
            return "5809:2: ( ( ( 'new' )=>this_XbaseConstructorCall_0= ruleXbaseConstructorCall ) | this_XExpression_1= ruleXExpression )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA150_3 = input.LA(1);

                         
                        int index150_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred18_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index150_3);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA150_4 = input.LA(1);

                         
                        int index150_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred18_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index150_4);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA150_5 = input.LA(1);

                         
                        int index150_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred18_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index150_5);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA150_6 = input.LA(1);

                         
                        int index150_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred18_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index150_6);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA150_7 = input.LA(1);

                         
                        int index150_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred18_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index150_7);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA150_8 = input.LA(1);

                         
                        int index150_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred18_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index150_8);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 150, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_118s = "\1\2\46\uffff";
    static final String dfa_119s = "\1\4\1\0\45\uffff";
    static final String dfa_120s = "\1\155\1\0\45\uffff";
    static final String dfa_121s = "\2\uffff\1\2\43\uffff\1\1";
    static final String dfa_122s = "\1\uffff\1\0\45\uffff}>";
    static final String[] dfa_123s = {
            "\3\2\1\uffff\1\2\4\uffff\4\2\1\1\2\2\1\uffff\1\2\1\uffff\1\2\1\uffff\21\2\1\uffff\3\2\12\uffff\1\2\2\uffff\1\2\61\uffff\1\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[] dfa_118 = DFA.unpackEncodedString(dfa_118s);
    static final char[] dfa_119 = DFA.unpackEncodedStringToUnsignedChars(dfa_119s);
    static final char[] dfa_120 = DFA.unpackEncodedStringToUnsignedChars(dfa_120s);
    static final short[] dfa_121 = DFA.unpackEncodedString(dfa_121s);
    static final short[] dfa_122 = DFA.unpackEncodedString(dfa_122s);
    static final short[][] dfa_123 = unpackEncodedStringArray(dfa_123s);

    class DFA167 extends DFA {

        public DFA167(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 167;
            this.eot = dfa_20;
            this.eof = dfa_118;
            this.min = dfa_119;
            this.max = dfa_120;
            this.accept = dfa_121;
            this.special = dfa_122;
            this.transition = dfa_123;
        }
        public String getDescription() {
            return "6764:3: ( ( ( '(' )=>otherlv_3= '(' ) ( ( ( ( ( ( ( ruleValidID ) ) '=' ) )=> (lv_elementValuePairs_4_0= ruleXAnnotationElementValuePair ) ) (otherlv_5= ',' ( ( ( ( ( ruleValidID ) ) '=' ) )=> (lv_elementValuePairs_6_0= ruleXAnnotationElementValuePair ) ) )* ) | ( (lv_value_7_0= ruleXAnnotationElementValueOrCommaList ) ) )? otherlv_8= ')' )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA167_1 = input.LA(1);

                         
                        int index167_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred19_InternalXtend()) ) {s = 38;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index167_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 167, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_124s = "\1\4\6\0\66\uffff";
    static final String dfa_125s = "\1\167\6\0\66\uffff";
    static final String dfa_126s = "\7\uffff\1\2\63\uffff\1\3\1\1";
    static final String dfa_127s = "\1\uffff\1\0\1\1\1\2\1\3\1\4\1\5\66\uffff}>";
    static final String[] dfa_128s = {
            "\1\7\1\uffff\2\7\2\uffff\3\7\1\uffff\2\7\1\3\1\7\1\73\2\uffff\3\7\1\uffff\14\7\2\uffff\2\7\1\2\1\uffff\1\4\1\5\1\6\1\7\1\uffff\1\7\7\uffff\3\7\23\uffff\2\7\4\uffff\1\7\6\uffff\1\7\2\uffff\13\7\4\uffff\1\1\3\7\4\uffff\3\7",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final char[] dfa_124 = DFA.unpackEncodedStringToUnsignedChars(dfa_124s);
    static final char[] dfa_125 = DFA.unpackEncodedStringToUnsignedChars(dfa_125s);
    static final short[] dfa_126 = DFA.unpackEncodedString(dfa_126s);
    static final short[] dfa_127 = DFA.unpackEncodedString(dfa_127s);
    static final short[][] dfa_128 = unpackEncodedStringArray(dfa_128s);

    class DFA166 extends DFA {

        public DFA166(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 166;
            this.eot = dfa_93;
            this.eof = dfa_93;
            this.min = dfa_124;
            this.max = dfa_125;
            this.accept = dfa_126;
            this.special = dfa_127;
            this.transition = dfa_128;
        }
        public String getDescription() {
            return "6772:4: ( ( ( ( ( ( ( ruleValidID ) ) '=' ) )=> (lv_elementValuePairs_4_0= ruleXAnnotationElementValuePair ) ) (otherlv_5= ',' ( ( ( ( ( ruleValidID ) ) '=' ) )=> (lv_elementValuePairs_6_0= ruleXAnnotationElementValuePair ) ) )* ) | ( (lv_value_7_0= ruleXAnnotationElementValueOrCommaList ) ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA166_1 = input.LA(1);

                         
                        int index166_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred20_InternalXtend()) ) {s = 60;}

                        else if ( (true) ) {s = 7;}

                         
                        input.seek(index166_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA166_2 = input.LA(1);

                         
                        int index166_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred20_InternalXtend()) ) {s = 60;}

                        else if ( (true) ) {s = 7;}

                         
                        input.seek(index166_2);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA166_3 = input.LA(1);

                         
                        int index166_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred20_InternalXtend()) ) {s = 60;}

                        else if ( (true) ) {s = 7;}

                         
                        input.seek(index166_3);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA166_4 = input.LA(1);

                         
                        int index166_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred20_InternalXtend()) ) {s = 60;}

                        else if ( (true) ) {s = 7;}

                         
                        input.seek(index166_4);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA166_5 = input.LA(1);

                         
                        int index166_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred20_InternalXtend()) ) {s = 60;}

                        else if ( (true) ) {s = 7;}

                         
                        input.seek(index166_5);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA166_6 = input.LA(1);

                         
                        int index166_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred20_InternalXtend()) ) {s = 60;}

                        else if ( (true) ) {s = 7;}

                         
                        input.seek(index166_6);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 166, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String[] dfa_129s = {
            "\1\2\1\uffff\2\2\2\uffff\3\2\1\uffff\4\2\3\uffff\3\2\1\uffff\14\2\2\uffff\3\2\1\uffff\4\2\1\uffff\1\2\7\uffff\1\2\1\1\1\2\23\uffff\2\2\4\uffff\1\2\6\uffff\1\2\2\uffff\13\2\4\uffff\4\2\4\uffff\3\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[][] dfa_129 = unpackEncodedStringArray(dfa_129s);

    class DFA172 extends DFA {

        public DFA172(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 172;
            this.eot = dfa_100;
            this.eof = dfa_100;
            this.min = dfa_101;
            this.max = dfa_102;
            this.accept = dfa_103;
            this.special = dfa_104;
            this.transition = dfa_129;
        }
        public String getDescription() {
            return "6952:2: ( ( ( ( ( () '#' '[' ) )=> ( () otherlv_1= '#' otherlv_2= '[' ) ) ( ( (lv_elements_3_0= ruleXAnnotationOrExpression ) ) (otherlv_4= ',' ( (lv_elements_5_0= ruleXAnnotationOrExpression ) ) )* )? otherlv_6= ']' ) | (this_XAnnotationOrExpression_7= ruleXAnnotationOrExpression ( () (otherlv_9= ',' ( (lv_elements_10_0= ruleXAnnotationOrExpression ) ) )+ )? ) )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA172_1 = input.LA(1);

                         
                        int index172_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred23_InternalXtend()) ) {s = 59;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index172_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 172, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA175 extends DFA {

        public DFA175(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 175;
            this.eot = dfa_100;
            this.eof = dfa_100;
            this.min = dfa_101;
            this.max = dfa_102;
            this.accept = dfa_103;
            this.special = dfa_104;
            this.transition = dfa_129;
        }
        public String getDescription() {
            return "7094:2: ( ( ( ( ( () '#' '[' ) )=> ( () otherlv_1= '#' otherlv_2= '[' ) ) ( ( (lv_elements_3_0= ruleXAnnotationOrExpression ) ) (otherlv_4= ',' ( (lv_elements_5_0= ruleXAnnotationOrExpression ) ) )* )? otherlv_6= ']' ) | this_XAnnotationOrExpression_7= ruleXAnnotationOrExpression )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA175_1 = input.LA(1);

                         
                        int index175_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred24_InternalXtend()) ) {s = 59;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index175_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 175, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_130s = "\40\uffff";
    static final String dfa_131s = "\1\uffff\35\36\2\uffff";
    static final String dfa_132s = "\36\4\2\uffff";
    static final String dfa_133s = "\36\167\2\uffff";
    static final String dfa_134s = "\36\uffff\1\2\1\1";
    static final String dfa_135s = "\40\uffff}>";
    static final String[] dfa_136s = {
            "\1\17\1\uffff\1\4\1\36\2\uffff\1\11\1\13\1\36\1\uffff\1\15\1\10\1\3\1\36\3\uffff\1\35\1\24\1\36\1\uffff\1\20\1\21\1\22\1\2\1\23\1\7\1\12\1\25\1\26\1\27\1\30\1\31\2\uffff\1\6\1\16\1\5\1\uffff\1\32\1\33\1\34\1\14\1\uffff\1\36\10\uffff\2\36\23\uffff\2\36\4\uffff\1\36\6\uffff\1\36\2\uffff\13\36\4\uffff\1\1\3\36\4\uffff\3\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "\20\36\1\37\32\36\1\uffff\2\36\6\uffff\42\36\1\uffff\20\36\2\uffff\13\36",
            "",
            ""
    };

    static final short[] dfa_130 = DFA.unpackEncodedString(dfa_130s);
    static final short[] dfa_131 = DFA.unpackEncodedString(dfa_131s);
    static final char[] dfa_132 = DFA.unpackEncodedStringToUnsignedChars(dfa_132s);
    static final char[] dfa_133 = DFA.unpackEncodedStringToUnsignedChars(dfa_133s);
    static final short[] dfa_134 = DFA.unpackEncodedString(dfa_134s);
    static final short[] dfa_135 = DFA.unpackEncodedString(dfa_135s);
    static final short[][] dfa_136 = unpackEncodedStringArray(dfa_136s);

    class DFA178 extends DFA {

        public DFA178(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 178;
            this.eot = dfa_130;
            this.eof = dfa_131;
            this.min = dfa_132;
            this.max = dfa_133;
            this.accept = dfa_134;
            this.special = dfa_135;
            this.transition = dfa_136;
        }
        public String getDescription() {
            return "7261:2: ( ( () ( ( ruleFeatureCallID ) ) ruleOpSingleAssign ( (lv_value_3_0= ruleXAssignment ) ) ) | (this_XOrExpression_4= ruleXOrExpression ( ( ( ( () ( ( ruleOpMultiAssign ) ) ) )=> ( () ( ( ruleOpMultiAssign ) ) ) ) ( (lv_rightOperand_7_0= ruleXAssignment ) ) )? ) )";
        }
    }
    static final String dfa_137s = "\1\10\11\uffff";
    static final String dfa_138s = "\1\4\7\0\2\uffff";
    static final String dfa_139s = "\1\167\7\0\2\uffff";
    static final String dfa_140s = "\10\uffff\1\2\1\1";
    static final String dfa_141s = "\1\uffff\1\0\1\1\1\2\1\3\1\4\1\6\1\5\2\uffff}>";
    static final String[] dfa_142s = {
            "\3\10\1\6\1\10\1\7\12\10\1\uffff\32\10\1\uffff\2\10\6\uffff\4\10\1\1\1\2\1\3\1\4\1\5\31\10\1\uffff\20\10\2\uffff\13\10",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            ""
    };
    static final short[] dfa_137 = DFA.unpackEncodedString(dfa_137s);
    static final char[] dfa_138 = DFA.unpackEncodedStringToUnsignedChars(dfa_138s);
    static final char[] dfa_139 = DFA.unpackEncodedStringToUnsignedChars(dfa_139s);
    static final short[] dfa_140 = DFA.unpackEncodedString(dfa_140s);
    static final short[] dfa_141 = DFA.unpackEncodedString(dfa_141s);
    static final short[][] dfa_142 = unpackEncodedStringArray(dfa_142s);

    class DFA177 extends DFA {

        public DFA177(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 177;
            this.eot = dfa_112;
            this.eof = dfa_137;
            this.min = dfa_138;
            this.max = dfa_139;
            this.accept = dfa_140;
            this.special = dfa_141;
            this.transition = dfa_142;
        }
        public String getDescription() {
            return "7323:4: ( ( ( ( () ( ( ruleOpMultiAssign ) ) ) )=> ( () ( ( ruleOpMultiAssign ) ) ) ) ( (lv_rightOperand_7_0= ruleXAssignment ) ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA177_1 = input.LA(1);

                         
                        int index177_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred25_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index177_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA177_2 = input.LA(1);

                         
                        int index177_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred25_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index177_2);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA177_3 = input.LA(1);

                         
                        int index177_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred25_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index177_3);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA177_4 = input.LA(1);

                         
                        int index177_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred25_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index177_4);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA177_5 = input.LA(1);

                         
                        int index177_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred25_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index177_5);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA177_7 = input.LA(1);

                         
                        int index177_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred25_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index177_7);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA177_6 = input.LA(1);

                         
                        int index177_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred25_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index177_6);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 177, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_143s = "\13\uffff";
    static final String dfa_144s = "\1\1\12\uffff";
    static final String dfa_145s = "\1\4\1\uffff\10\0\1\uffff";
    static final String dfa_146s = "\1\167\1\uffff\10\0\1\uffff";
    static final String dfa_147s = "\1\uffff\1\2\10\uffff\1\1";
    static final String dfa_148s = "\2\uffff\1\7\1\1\1\0\1\2\1\3\1\4\1\5\1\6\1\uffff}>";
    static final String[] dfa_149s = {
            "\3\1\1\2\1\1\1\3\11\1\1\4\1\uffff\32\1\1\uffff\2\1\6\uffff\21\1\1\5\1\6\1\7\1\10\1\11\14\1\1\uffff\20\1\2\uffff\13\1",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };

    static final short[] dfa_143 = DFA.unpackEncodedString(dfa_143s);
    static final short[] dfa_144 = DFA.unpackEncodedString(dfa_144s);
    static final char[] dfa_145 = DFA.unpackEncodedStringToUnsignedChars(dfa_145s);
    static final char[] dfa_146 = DFA.unpackEncodedStringToUnsignedChars(dfa_146s);
    static final short[] dfa_147 = DFA.unpackEncodedString(dfa_147s);
    static final short[] dfa_148 = DFA.unpackEncodedString(dfa_148s);
    static final short[][] dfa_149 = unpackEncodedStringArray(dfa_149s);

    class DFA187 extends DFA {

        public DFA187(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 187;
            this.eot = dfa_143;
            this.eof = dfa_144;
            this.min = dfa_145;
            this.max = dfa_146;
            this.accept = dfa_147;
            this.special = dfa_148;
            this.transition = dfa_149;
        }
        public String getDescription() {
            return "()* loopback of 8037:3: ( ( ( ( () ( ( ruleOpOther ) ) ) )=> ( () ( ( ruleOpOther ) ) ) ) ( (lv_rightOperand_3_0= ruleXAdditiveExpression ) ) )*";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA187_4 = input.LA(1);

                         
                        int index187_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred31_InternalXtend()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index187_4);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA187_3 = input.LA(1);

                         
                        int index187_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred31_InternalXtend()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index187_3);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA187_5 = input.LA(1);

                         
                        int index187_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred31_InternalXtend()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index187_5);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA187_6 = input.LA(1);

                         
                        int index187_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred31_InternalXtend()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index187_6);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA187_7 = input.LA(1);

                         
                        int index187_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred31_InternalXtend()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index187_7);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA187_8 = input.LA(1);

                         
                        int index187_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred31_InternalXtend()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index187_8);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA187_9 = input.LA(1);

                         
                        int index187_9 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred31_InternalXtend()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index187_9);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA187_2 = input.LA(1);

                         
                        int index187_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred31_InternalXtend()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index187_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 187, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_150s = "\1\7\2\uffff\1\11\7\uffff";
    static final String dfa_151s = "\1\115\2\uffff\1\113\7\uffff";
    static final String dfa_152s = "\1\uffff\1\1\1\2\1\uffff\1\4\1\5\1\7\1\10\1\11\1\3\1\6";
    static final String dfa_153s = "\13\uffff}>";
    static final String[] dfa_154s = {
            "\1\6\1\uffff\1\3\11\uffff\1\5\65\uffff\1\1\1\2\1\4\1\7\1\10",
            "",
            "",
            "\1\12\101\uffff\1\11",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final char[] dfa_150 = DFA.unpackEncodedStringToUnsignedChars(dfa_150s);
    static final char[] dfa_151 = DFA.unpackEncodedStringToUnsignedChars(dfa_151s);
    static final short[] dfa_152 = DFA.unpackEncodedString(dfa_152s);
    static final short[] dfa_153 = DFA.unpackEncodedString(dfa_153s);
    static final short[][] dfa_154 = unpackEncodedStringArray(dfa_154s);

    class DFA190 extends DFA {

        public DFA190(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 190;
            this.eot = dfa_143;
            this.eof = dfa_143;
            this.min = dfa_150;
            this.max = dfa_151;
            this.accept = dfa_152;
            this.special = dfa_153;
            this.transition = dfa_154;
        }
        public String getDescription() {
            return "8113:2: (kw= '->' | kw= '..<' | (kw= '>' kw= '..' ) | kw= '..' | kw= '=>' | (kw= '>' ( ( ( ( '>' '>' ) )=> (kw= '>' kw= '>' ) ) | kw= '>' ) ) | (kw= '<' ( ( ( ( '<' '<' ) )=> (kw= '<' kw= '<' ) ) | kw= '<' | kw= '=>' ) ) | kw= '<>' | kw= '?:' )";
        }
    }

    class DFA206 extends DFA {

        public DFA206(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 206;
            this.eot = dfa_84;
            this.eof = dfa_85;
            this.min = dfa_86;
            this.max = dfa_87;
            this.accept = dfa_88;
            this.special = dfa_89;
            this.transition = dfa_92;
        }
        public String getDescription() {
            return "9014:5: ( ( ( ( '(' ) )=> (lv_explicitOperationCall_17_0= '(' ) ) ( ( ( ( () ( ( ( ruleJvmFormalParameter ) ) ( ',' ( ( ruleJvmFormalParameter ) ) )* )? ( ( '|' ) ) ) )=> (lv_memberCallArguments_18_0= ruleXShortClosure ) ) | ( ( (lv_memberCallArguments_19_0= ruleXExpression ) ) (otherlv_20= ',' ( (lv_memberCallArguments_21_0= ruleXExpression ) ) )* ) )? otherlv_22= ')' )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA206_1 = input.LA(1);

                         
                        int index206_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred40_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index206_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 206, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA205 extends DFA {

        public DFA205(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 205;
            this.eot = dfa_93;
            this.eof = dfa_93;
            this.min = dfa_94;
            this.max = dfa_95;
            this.accept = dfa_96;
            this.special = dfa_97;
            this.transition = dfa_98;
        }
        public String getDescription() {
            return "9033:6: ( ( ( ( () ( ( ( ruleJvmFormalParameter ) ) ( ',' ( ( ruleJvmFormalParameter ) ) )* )? ( ( '|' ) ) ) )=> (lv_memberCallArguments_18_0= ruleXShortClosure ) ) | ( ( (lv_memberCallArguments_19_0= ruleXExpression ) ) (otherlv_20= ',' ( (lv_memberCallArguments_21_0= ruleXExpression ) ) )* ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA205_0 = input.LA(1);

                         
                        int index205_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA205_0==KW_Extension) ) {s = 1;}

                        else if ( (LA205_0==RULE_ID) ) {s = 2;}

                        else if ( (LA205_0==KW_Create) ) {s = 3;}

                        else if ( (LA205_0==KW_Annotation) ) {s = 4;}

                        else if ( (LA205_0==KW_AFTER) ) {s = 5;}

                        else if ( (LA205_0==KW_BEFORE) ) {s = 6;}

                        else if ( (LA205_0==KW_SEPARATOR) ) {s = 7;}

                        else if ( (LA205_0==KW_LeftParenthesis) ) {s = 8;}

                        else if ( (LA205_0==KW_EqualsSignGreaterThanSign) && (synpred41_InternalXtend())) {s = 9;}

                        else if ( (LA205_0==KW_Abstract) ) {s = 10;}

                        else if ( (LA205_0==KW_Class) ) {s = 11;}

                        else if ( (LA205_0==KW_Def) ) {s = 12;}

                        else if ( (LA205_0==KW_Dispatch) ) {s = 13;}

                        else if ( (LA205_0==KW_Enum) ) {s = 14;}

                        else if ( (LA205_0==KW_Extends) ) {s = 15;}

                        else if ( (LA205_0==KW_Final) ) {s = 16;}

                        else if ( (LA205_0==KW_Implements) ) {s = 17;}

                        else if ( (LA205_0==KW_Import) ) {s = 18;}

                        else if ( (LA205_0==KW_Interface) ) {s = 19;}

                        else if ( (LA205_0==KW_Override) ) {s = 20;}

                        else if ( (LA205_0==KW_Package) ) {s = 21;}

                        else if ( (LA205_0==KW_Public) ) {s = 22;}

                        else if ( (LA205_0==KW_Private) ) {s = 23;}

                        else if ( (LA205_0==KW_Protected) ) {s = 24;}

                        else if ( (LA205_0==KW_Static) ) {s = 25;}

                        else if ( (LA205_0==KW_Throws) ) {s = 26;}

                        else if ( (LA205_0==KW_Strictfp) ) {s = 27;}

                        else if ( (LA205_0==KW_Native) ) {s = 28;}

                        else if ( (LA205_0==KW_Volatile) ) {s = 29;}

                        else if ( (LA205_0==KW_Synchronized) ) {s = 30;}

                        else if ( (LA205_0==KW_Transient) ) {s = 31;}

                        else if ( (LA205_0==KW_VerticalLine) && (synpred41_InternalXtend())) {s = 32;}

                        else if ( (LA205_0==KW_LessThanSign||LA205_0==KW_LeftCurlyBracket||LA205_0==KW_New||LA205_0==KW_Switch||(LA205_0>=KW_NumberSign && LA205_0<=KW_LeftSquareBracket)||(LA205_0>=KW_PlusSign && LA205_0<=KW_HyphenMinus)||LA205_0==KW_ExclamationMark||LA205_0==KW_If||(LA205_0>=KW_For && LA205_0<=KW_Try)||(LA205_0>=RULE_STRING && LA205_0<=RULE_RICH_TEXT_START)||(LA205_0>=RULE_HEX && LA205_0<=RULE_DECIMAL)) ) {s = 33;}

                        else if ( (LA205_0==KW_RightParenthesis) ) {s = 60;}

                         
                        input.seek(index205_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA205_1 = input.LA(1);

                         
                        int index205_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_1);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA205_2 = input.LA(1);

                         
                        int index205_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_2);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA205_3 = input.LA(1);

                         
                        int index205_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_3);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA205_4 = input.LA(1);

                         
                        int index205_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_4);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA205_5 = input.LA(1);

                         
                        int index205_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_5);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA205_6 = input.LA(1);

                         
                        int index205_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_6);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA205_7 = input.LA(1);

                         
                        int index205_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_7);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA205_8 = input.LA(1);

                         
                        int index205_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_8);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA205_10 = input.LA(1);

                         
                        int index205_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_10);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA205_11 = input.LA(1);

                         
                        int index205_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_11);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA205_12 = input.LA(1);

                         
                        int index205_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_12);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA205_13 = input.LA(1);

                         
                        int index205_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_13);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA205_14 = input.LA(1);

                         
                        int index205_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_14);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA205_15 = input.LA(1);

                         
                        int index205_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_15);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA205_16 = input.LA(1);

                         
                        int index205_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_16);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA205_17 = input.LA(1);

                         
                        int index205_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_17);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA205_18 = input.LA(1);

                         
                        int index205_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_18);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA205_19 = input.LA(1);

                         
                        int index205_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_19);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA205_20 = input.LA(1);

                         
                        int index205_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_20);
                        if ( s>=0 ) return s;
                        break;
                    case 20 : 
                        int LA205_21 = input.LA(1);

                         
                        int index205_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_21);
                        if ( s>=0 ) return s;
                        break;
                    case 21 : 
                        int LA205_22 = input.LA(1);

                         
                        int index205_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_22);
                        if ( s>=0 ) return s;
                        break;
                    case 22 : 
                        int LA205_23 = input.LA(1);

                         
                        int index205_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_23);
                        if ( s>=0 ) return s;
                        break;
                    case 23 : 
                        int LA205_24 = input.LA(1);

                         
                        int index205_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_24);
                        if ( s>=0 ) return s;
                        break;
                    case 24 : 
                        int LA205_25 = input.LA(1);

                         
                        int index205_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_25);
                        if ( s>=0 ) return s;
                        break;
                    case 25 : 
                        int LA205_26 = input.LA(1);

                         
                        int index205_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_26);
                        if ( s>=0 ) return s;
                        break;
                    case 26 : 
                        int LA205_27 = input.LA(1);

                         
                        int index205_27 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_27);
                        if ( s>=0 ) return s;
                        break;
                    case 27 : 
                        int LA205_28 = input.LA(1);

                         
                        int index205_28 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_28);
                        if ( s>=0 ) return s;
                        break;
                    case 28 : 
                        int LA205_29 = input.LA(1);

                         
                        int index205_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_29);
                        if ( s>=0 ) return s;
                        break;
                    case 29 : 
                        int LA205_30 = input.LA(1);

                         
                        int index205_30 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_30);
                        if ( s>=0 ) return s;
                        break;
                    case 30 : 
                        int LA205_31 = input.LA(1);

                         
                        int index205_31 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index205_31);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 205, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA207 extends DFA {

        public DFA207(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 207;
            this.eot = dfa_84;
            this.eof = dfa_85;
            this.min = dfa_86;
            this.max = dfa_87;
            this.accept = dfa_88;
            this.special = dfa_89;
            this.transition = dfa_99;
        }
        public String getDescription() {
            return "9131:5: ( ( ( () '[' ) )=> (lv_memberCallArguments_23_0= ruleXClosure ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA207_1 = input.LA(1);

                         
                        int index207_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred42_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index207_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 207, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_155s = "\72\uffff";
    static final String dfa_156s = "\1\4\3\uffff\1\0\53\uffff\1\0\11\uffff";
    static final String dfa_157s = "\1\167\3\uffff\1\0\53\uffff\1\0\11\uffff";
    static final String dfa_158s = "\1\uffff\1\1\1\2\1\3\1\uffff\1\5\35\uffff\1\6\13\uffff\1\7\1\uffff\1\12\1\13\1\14\1\15\1\16\1\17\1\4\1\10\1\11";
    static final String dfa_159s = "\4\uffff\1\0\53\uffff\1\1\11\uffff}>";
    static final String[] dfa_160s = {
            "\1\5\1\uffff\2\5\2\uffff\2\5\1\2\1\uffff\3\5\1\66\3\uffff\2\5\1\1\1\uffff\12\5\1\4\1\5\2\uffff\3\5\1\uffff\4\5\1\uffff\1\3\10\uffff\2\43\40\uffff\1\57\2\uffff\1\60\1\61\1\62\1\5\4\43\1\63\1\64\1\65\4\uffff\1\5\3\43\4\uffff\3\43",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_155 = DFA.unpackEncodedString(dfa_155s);
    static final char[] dfa_156 = DFA.unpackEncodedStringToUnsignedChars(dfa_156s);
    static final char[] dfa_157 = DFA.unpackEncodedStringToUnsignedChars(dfa_157s);
    static final short[] dfa_158 = DFA.unpackEncodedString(dfa_158s);
    static final short[] dfa_159 = DFA.unpackEncodedString(dfa_159s);
    static final short[][] dfa_160 = unpackEncodedStringArray(dfa_160s);

    class DFA209 extends DFA {

        public DFA209(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 209;
            this.eot = dfa_155;
            this.eof = dfa_155;
            this.min = dfa_156;
            this.max = dfa_157;
            this.accept = dfa_158;
            this.special = dfa_159;
            this.transition = dfa_160;
        }
        public String getDescription() {
            return "9176:2: (this_XConstructorCall_0= ruleXConstructorCall | this_XBlockExpression_1= ruleXBlockExpression | this_XSwitchExpression_2= ruleXSwitchExpression | ( ( ( () 'synchronized' '(' ) )=>this_XSynchronizedExpression_3= ruleXSynchronizedExpression ) | this_XFeatureCall_4= ruleXFeatureCall | this_XLiteral_5= ruleXLiteral | this_XIfExpression_6= ruleXIfExpression | ( ( ( () 'for' '(' ( ( ruleJvmFormalParameter ) ) ':' ) )=>this_XForLoopExpression_7= ruleXForLoopExpression ) | this_XBasicForLoopExpression_8= ruleXBasicForLoopExpression | this_XWhileExpression_9= ruleXWhileExpression | this_XDoWhileExpression_10= ruleXDoWhileExpression | this_XThrowExpression_11= ruleXThrowExpression | this_XReturnExpression_12= ruleXReturnExpression | this_XTryCatchFinallyExpression_13= ruleXTryCatchFinallyExpression | this_XParenthesizedExpression_14= ruleXParenthesizedExpression )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA209_4 = input.LA(1);

                         
                        int index209_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred43_InternalXtend()) ) {s = 55;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index209_4);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA209_48 = input.LA(1);

                         
                        int index209_48 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred44_InternalXtend()) ) {s = 56;}

                        else if ( (true) ) {s = 57;}

                         
                        input.seek(index209_48);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 209, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_161s = "\77\uffff";
    static final String dfa_162s = "\1\4\10\0\1\uffff\26\0\37\uffff";
    static final String dfa_163s = "\1\167\10\0\1\uffff\26\0\37\uffff";
    static final String dfa_164s = "\11\uffff\1\1\26\uffff\1\1\1\2\35\uffff";
    static final String dfa_165s = "\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\uffff\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34\1\35\1\36\37\uffff}>";
    static final String[] dfa_166s = {
            "\1\25\1\uffff\1\13\1\41\2\uffff\1\17\1\21\1\41\1\uffff\1\23\1\16\1\4\1\10\1\uffff\1\11\1\uffff\1\1\1\32\1\41\1\uffff\1\26\1\27\1\30\1\12\1\31\1\15\1\20\1\33\1\34\1\35\1\36\1\37\2\41\1\14\1\24\1\3\1\uffff\1\5\1\6\1\7\1\22\1\uffff\1\41\10\uffff\3\41\22\uffff\2\41\4\uffff\1\41\5\uffff\1\40\1\41\2\uffff\13\41\4\uffff\1\2\3\41\4\uffff\3\41",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_161 = DFA.unpackEncodedString(dfa_161s);
    static final char[] dfa_162 = DFA.unpackEncodedStringToUnsignedChars(dfa_162s);
    static final char[] dfa_163 = DFA.unpackEncodedStringToUnsignedChars(dfa_163s);
    static final short[] dfa_164 = DFA.unpackEncodedString(dfa_164s);
    static final short[] dfa_165 = DFA.unpackEncodedString(dfa_165s);
    static final short[][] dfa_166 = unpackEncodedStringArray(dfa_166s);

    class DFA218 extends DFA {

        public DFA218(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 218;
            this.eot = dfa_161;
            this.eof = dfa_161;
            this.min = dfa_162;
            this.max = dfa_163;
            this.accept = dfa_164;
            this.special = dfa_165;
            this.transition = dfa_166;
        }
        public String getDescription() {
            return "9668:3: ( ( ( ( ( ( ruleJvmFormalParameter ) ) ( ',' ( ( ruleJvmFormalParameter ) ) )* )? ( ( '|' ) ) ) )=> ( ( ( (lv_declaredFormalParameters_2_0= ruleJvmFormalParameter ) ) (otherlv_3= ',' ( (lv_declaredFormalParameters_4_0= ruleJvmFormalParameter ) ) )* )? ( (lv_explicitSyntax_5_0= '|' ) ) ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA218_0 = input.LA(1);

                         
                        int index218_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA218_0==KW_Extension) ) {s = 1;}

                        else if ( (LA218_0==RULE_ID) ) {s = 2;}

                        else if ( (LA218_0==KW_Create) ) {s = 3;}

                        else if ( (LA218_0==KW_Annotation) ) {s = 4;}

                        else if ( (LA218_0==KW_AFTER) ) {s = 5;}

                        else if ( (LA218_0==KW_BEFORE) ) {s = 6;}

                        else if ( (LA218_0==KW_SEPARATOR) ) {s = 7;}

                        else if ( (LA218_0==KW_LeftParenthesis) ) {s = 8;}

                        else if ( (LA218_0==KW_EqualsSignGreaterThanSign) && (synpred47_InternalXtend())) {s = 9;}

                        else if ( (LA218_0==KW_Abstract) ) {s = 10;}

                        else if ( (LA218_0==KW_Class) ) {s = 11;}

                        else if ( (LA218_0==KW_Def) ) {s = 12;}

                        else if ( (LA218_0==KW_Dispatch) ) {s = 13;}

                        else if ( (LA218_0==KW_Enum) ) {s = 14;}

                        else if ( (LA218_0==KW_Extends) ) {s = 15;}

                        else if ( (LA218_0==KW_Final) ) {s = 16;}

                        else if ( (LA218_0==KW_Implements) ) {s = 17;}

                        else if ( (LA218_0==KW_Import) ) {s = 18;}

                        else if ( (LA218_0==KW_Interface) ) {s = 19;}

                        else if ( (LA218_0==KW_Override) ) {s = 20;}

                        else if ( (LA218_0==KW_Package) ) {s = 21;}

                        else if ( (LA218_0==KW_Public) ) {s = 22;}

                        else if ( (LA218_0==KW_Private) ) {s = 23;}

                        else if ( (LA218_0==KW_Protected) ) {s = 24;}

                        else if ( (LA218_0==KW_Static) ) {s = 25;}

                        else if ( (LA218_0==KW_Throws) ) {s = 26;}

                        else if ( (LA218_0==KW_Strictfp) ) {s = 27;}

                        else if ( (LA218_0==KW_Native) ) {s = 28;}

                        else if ( (LA218_0==KW_Volatile) ) {s = 29;}

                        else if ( (LA218_0==KW_Synchronized) ) {s = 30;}

                        else if ( (LA218_0==KW_Transient) ) {s = 31;}

                        else if ( (LA218_0==KW_VerticalLine) && (synpred47_InternalXtend())) {s = 32;}

                        else if ( (LA218_0==KW_LessThanSign||LA218_0==KW_LeftCurlyBracket||LA218_0==KW_New||(LA218_0>=KW_Val && LA218_0<=KW_Var)||LA218_0==KW_Switch||(LA218_0>=KW_NumberSign && LA218_0<=KW_RightSquareBracket)||(LA218_0>=KW_PlusSign && LA218_0<=KW_HyphenMinus)||LA218_0==KW_ExclamationMark||LA218_0==KW_If||(LA218_0>=KW_For && LA218_0<=KW_Try)||(LA218_0>=RULE_STRING && LA218_0<=RULE_RICH_TEXT_START)||(LA218_0>=RULE_HEX && LA218_0<=RULE_DECIMAL)) ) {s = 33;}

                         
                        input.seek(index218_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA218_1 = input.LA(1);

                         
                        int index218_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_1);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA218_2 = input.LA(1);

                         
                        int index218_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_2);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA218_3 = input.LA(1);

                         
                        int index218_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_3);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA218_4 = input.LA(1);

                         
                        int index218_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_4);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA218_5 = input.LA(1);

                         
                        int index218_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_5);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA218_6 = input.LA(1);

                         
                        int index218_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_6);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA218_7 = input.LA(1);

                         
                        int index218_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_7);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA218_8 = input.LA(1);

                         
                        int index218_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_8);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA218_10 = input.LA(1);

                         
                        int index218_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_10);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA218_11 = input.LA(1);

                         
                        int index218_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_11);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA218_12 = input.LA(1);

                         
                        int index218_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_12);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA218_13 = input.LA(1);

                         
                        int index218_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_13);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA218_14 = input.LA(1);

                         
                        int index218_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_14);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA218_15 = input.LA(1);

                         
                        int index218_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_15);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA218_16 = input.LA(1);

                         
                        int index218_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_16);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA218_17 = input.LA(1);

                         
                        int index218_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_17);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA218_18 = input.LA(1);

                         
                        int index218_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_18);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA218_19 = input.LA(1);

                         
                        int index218_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_19);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA218_20 = input.LA(1);

                         
                        int index218_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_20);
                        if ( s>=0 ) return s;
                        break;
                    case 20 : 
                        int LA218_21 = input.LA(1);

                         
                        int index218_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_21);
                        if ( s>=0 ) return s;
                        break;
                    case 21 : 
                        int LA218_22 = input.LA(1);

                         
                        int index218_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_22);
                        if ( s>=0 ) return s;
                        break;
                    case 22 : 
                        int LA218_23 = input.LA(1);

                         
                        int index218_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_23);
                        if ( s>=0 ) return s;
                        break;
                    case 23 : 
                        int LA218_24 = input.LA(1);

                         
                        int index218_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_24);
                        if ( s>=0 ) return s;
                        break;
                    case 24 : 
                        int LA218_25 = input.LA(1);

                         
                        int index218_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_25);
                        if ( s>=0 ) return s;
                        break;
                    case 25 : 
                        int LA218_26 = input.LA(1);

                         
                        int index218_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_26);
                        if ( s>=0 ) return s;
                        break;
                    case 26 : 
                        int LA218_27 = input.LA(1);

                         
                        int index218_27 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_27);
                        if ( s>=0 ) return s;
                        break;
                    case 27 : 
                        int LA218_28 = input.LA(1);

                         
                        int index218_28 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_28);
                        if ( s>=0 ) return s;
                        break;
                    case 28 : 
                        int LA218_29 = input.LA(1);

                         
                        int index218_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_29);
                        if ( s>=0 ) return s;
                        break;
                    case 29 : 
                        int LA218_30 = input.LA(1);

                         
                        int index218_30 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_30);
                        if ( s>=0 ) return s;
                        break;
                    case 30 : 
                        int LA218_31 = input.LA(1);

                         
                        int index218_31 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred47_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index218_31);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 218, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA239 extends DFA {

        public DFA239(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 239;
            this.eot = dfa_84;
            this.eof = dfa_85;
            this.min = dfa_86;
            this.max = dfa_87;
            this.accept = dfa_88;
            this.special = dfa_89;
            this.transition = dfa_92;
        }
        public String getDescription() {
            return "10899:3: ( ( ( ( '(' ) )=> (lv_explicitOperationCall_7_0= '(' ) ) ( ( ( ( () ( ( ( ruleJvmFormalParameter ) ) ( ',' ( ( ruleJvmFormalParameter ) ) )* )? ( ( '|' ) ) ) )=> (lv_featureCallArguments_8_0= ruleXShortClosure ) ) | ( ( (lv_featureCallArguments_9_0= ruleXExpression ) ) (otherlv_10= ',' ( (lv_featureCallArguments_11_0= ruleXExpression ) ) )* ) )? otherlv_12= ')' )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA239_1 = input.LA(1);

                         
                        int index239_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred52_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index239_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 239, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA238 extends DFA {

        public DFA238(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 238;
            this.eot = dfa_93;
            this.eof = dfa_93;
            this.min = dfa_94;
            this.max = dfa_95;
            this.accept = dfa_96;
            this.special = dfa_97;
            this.transition = dfa_98;
        }
        public String getDescription() {
            return "10918:4: ( ( ( ( () ( ( ( ruleJvmFormalParameter ) ) ( ',' ( ( ruleJvmFormalParameter ) ) )* )? ( ( '|' ) ) ) )=> (lv_featureCallArguments_8_0= ruleXShortClosure ) ) | ( ( (lv_featureCallArguments_9_0= ruleXExpression ) ) (otherlv_10= ',' ( (lv_featureCallArguments_11_0= ruleXExpression ) ) )* ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA238_0 = input.LA(1);

                         
                        int index238_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA238_0==KW_Extension) ) {s = 1;}

                        else if ( (LA238_0==RULE_ID) ) {s = 2;}

                        else if ( (LA238_0==KW_Create) ) {s = 3;}

                        else if ( (LA238_0==KW_Annotation) ) {s = 4;}

                        else if ( (LA238_0==KW_AFTER) ) {s = 5;}

                        else if ( (LA238_0==KW_BEFORE) ) {s = 6;}

                        else if ( (LA238_0==KW_SEPARATOR) ) {s = 7;}

                        else if ( (LA238_0==KW_LeftParenthesis) ) {s = 8;}

                        else if ( (LA238_0==KW_EqualsSignGreaterThanSign) && (synpred53_InternalXtend())) {s = 9;}

                        else if ( (LA238_0==KW_Abstract) ) {s = 10;}

                        else if ( (LA238_0==KW_Class) ) {s = 11;}

                        else if ( (LA238_0==KW_Def) ) {s = 12;}

                        else if ( (LA238_0==KW_Dispatch) ) {s = 13;}

                        else if ( (LA238_0==KW_Enum) ) {s = 14;}

                        else if ( (LA238_0==KW_Extends) ) {s = 15;}

                        else if ( (LA238_0==KW_Final) ) {s = 16;}

                        else if ( (LA238_0==KW_Implements) ) {s = 17;}

                        else if ( (LA238_0==KW_Import) ) {s = 18;}

                        else if ( (LA238_0==KW_Interface) ) {s = 19;}

                        else if ( (LA238_0==KW_Override) ) {s = 20;}

                        else if ( (LA238_0==KW_Package) ) {s = 21;}

                        else if ( (LA238_0==KW_Public) ) {s = 22;}

                        else if ( (LA238_0==KW_Private) ) {s = 23;}

                        else if ( (LA238_0==KW_Protected) ) {s = 24;}

                        else if ( (LA238_0==KW_Static) ) {s = 25;}

                        else if ( (LA238_0==KW_Throws) ) {s = 26;}

                        else if ( (LA238_0==KW_Strictfp) ) {s = 27;}

                        else if ( (LA238_0==KW_Native) ) {s = 28;}

                        else if ( (LA238_0==KW_Volatile) ) {s = 29;}

                        else if ( (LA238_0==KW_Synchronized) ) {s = 30;}

                        else if ( (LA238_0==KW_Transient) ) {s = 31;}

                        else if ( (LA238_0==KW_VerticalLine) && (synpred53_InternalXtend())) {s = 32;}

                        else if ( (LA238_0==KW_LessThanSign||LA238_0==KW_LeftCurlyBracket||LA238_0==KW_New||LA238_0==KW_Switch||(LA238_0>=KW_NumberSign && LA238_0<=KW_LeftSquareBracket)||(LA238_0>=KW_PlusSign && LA238_0<=KW_HyphenMinus)||LA238_0==KW_ExclamationMark||LA238_0==KW_If||(LA238_0>=KW_For && LA238_0<=KW_Try)||(LA238_0>=RULE_STRING && LA238_0<=RULE_RICH_TEXT_START)||(LA238_0>=RULE_HEX && LA238_0<=RULE_DECIMAL)) ) {s = 33;}

                        else if ( (LA238_0==KW_RightParenthesis) ) {s = 60;}

                         
                        input.seek(index238_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA238_1 = input.LA(1);

                         
                        int index238_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_1);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA238_2 = input.LA(1);

                         
                        int index238_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_2);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA238_3 = input.LA(1);

                         
                        int index238_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_3);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA238_4 = input.LA(1);

                         
                        int index238_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_4);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA238_5 = input.LA(1);

                         
                        int index238_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_5);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA238_6 = input.LA(1);

                         
                        int index238_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_6);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA238_7 = input.LA(1);

                         
                        int index238_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_7);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA238_8 = input.LA(1);

                         
                        int index238_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_8);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA238_10 = input.LA(1);

                         
                        int index238_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_10);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA238_11 = input.LA(1);

                         
                        int index238_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_11);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA238_12 = input.LA(1);

                         
                        int index238_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_12);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA238_13 = input.LA(1);

                         
                        int index238_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_13);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA238_14 = input.LA(1);

                         
                        int index238_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_14);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA238_15 = input.LA(1);

                         
                        int index238_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_15);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA238_16 = input.LA(1);

                         
                        int index238_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_16);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA238_17 = input.LA(1);

                         
                        int index238_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_17);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA238_18 = input.LA(1);

                         
                        int index238_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_18);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA238_19 = input.LA(1);

                         
                        int index238_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_19);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA238_20 = input.LA(1);

                         
                        int index238_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_20);
                        if ( s>=0 ) return s;
                        break;
                    case 20 : 
                        int LA238_21 = input.LA(1);

                         
                        int index238_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_21);
                        if ( s>=0 ) return s;
                        break;
                    case 21 : 
                        int LA238_22 = input.LA(1);

                         
                        int index238_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_22);
                        if ( s>=0 ) return s;
                        break;
                    case 22 : 
                        int LA238_23 = input.LA(1);

                         
                        int index238_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_23);
                        if ( s>=0 ) return s;
                        break;
                    case 23 : 
                        int LA238_24 = input.LA(1);

                         
                        int index238_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_24);
                        if ( s>=0 ) return s;
                        break;
                    case 24 : 
                        int LA238_25 = input.LA(1);

                         
                        int index238_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_25);
                        if ( s>=0 ) return s;
                        break;
                    case 25 : 
                        int LA238_26 = input.LA(1);

                         
                        int index238_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_26);
                        if ( s>=0 ) return s;
                        break;
                    case 26 : 
                        int LA238_27 = input.LA(1);

                         
                        int index238_27 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_27);
                        if ( s>=0 ) return s;
                        break;
                    case 27 : 
                        int LA238_28 = input.LA(1);

                         
                        int index238_28 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_28);
                        if ( s>=0 ) return s;
                        break;
                    case 28 : 
                        int LA238_29 = input.LA(1);

                         
                        int index238_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_29);
                        if ( s>=0 ) return s;
                        break;
                    case 29 : 
                        int LA238_30 = input.LA(1);

                         
                        int index238_30 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_30);
                        if ( s>=0 ) return s;
                        break;
                    case 30 : 
                        int LA238_31 = input.LA(1);

                         
                        int index238_31 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred53_InternalXtend()) ) {s = 32;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index238_31);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 238, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA240 extends DFA {

        public DFA240(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 240;
            this.eot = dfa_84;
            this.eof = dfa_85;
            this.min = dfa_86;
            this.max = dfa_87;
            this.accept = dfa_88;
            this.special = dfa_89;
            this.transition = dfa_99;
        }
        public String getDescription() {
            return "11016:3: ( ( ( () '[' ) )=> (lv_featureCallArguments_13_0= ruleXClosure ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA240_1 = input.LA(1);

                         
                        int index240_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred54_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index240_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 240, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_167s = "\1\72\153\uffff";
    static final String dfa_168s = "\1\4\71\0\62\uffff";
    static final String dfa_169s = "\1\167\71\0\62\uffff";
    static final String dfa_170s = "\72\uffff\1\2\60\uffff\1\1";
    static final String dfa_171s = "\1\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64\1\65\1\66\1\67\1\70\62\uffff}>";
    static final String[] dfa_172s = {
            "\1\17\1\72\1\4\1\44\2\72\1\11\1\13\1\42\1\72\1\15\1\10\1\3\1\71\2\72\1\uffff\1\35\1\24\1\41\1\72\1\20\1\21\1\22\1\2\1\23\1\7\1\12\1\25\1\26\1\27\1\30\1\31\2\72\1\6\1\16\1\5\1\72\1\32\1\33\1\34\1\14\1\uffff\1\43\1\72\6\uffff\1\72\1\46\1\47\23\72\1\40\1\37\4\72\1\36\5\72\1\uffff\1\62\2\72\1\63\1\64\1\65\1\45\1\50\1\51\1\55\1\61\1\66\1\67\1\70\2\72\2\uffff\1\1\1\56\1\57\1\60\4\72\1\52\1\53\1\54",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[] dfa_167 = DFA.unpackEncodedString(dfa_167s);
    static final char[] dfa_168 = DFA.unpackEncodedStringToUnsignedChars(dfa_168s);
    static final char[] dfa_169 = DFA.unpackEncodedStringToUnsignedChars(dfa_169s);
    static final short[] dfa_170 = DFA.unpackEncodedString(dfa_170s);
    static final short[] dfa_171 = DFA.unpackEncodedString(dfa_171s);
    static final short[][] dfa_172 = unpackEncodedStringArray(dfa_172s);

    class DFA244 extends DFA {

        public DFA244(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 244;
            this.eot = dfa_84;
            this.eof = dfa_167;
            this.min = dfa_168;
            this.max = dfa_169;
            this.accept = dfa_170;
            this.special = dfa_171;
            this.transition = dfa_172;
        }
        public String getDescription() {
            return "11350:3: ( ( 'abstract' | 'annotation' | 'class' | 'create' | 'def' | 'dispatch' | 'enum' | 'extends' | 'final' | 'implements' | 'import' | 'interface' | 'override' | 'package' | 'public' | 'private' | 'protected' | 'static' | 'throws' | 'strictfp' | 'native' | 'volatile' | 'synchronized' | 'transient' | 'AFTER' | 'BEFORE' | 'SEPARATOR' | 'extension' | '!' | '-' | '+' | 'new' | '{' | 'switch' | '<' | 'super' | '#' | '[' | 'false' | 'true' | 'null' | 'typeof' | 'if' | 'for' | 'while' | 'do' | 'throw' | 'return' | 'try' | '(' | RULE_ID | RULE_HEX | RULE_INT | RULE_DECIMAL | RULE_STRING | RULE_RICH_TEXT | RULE_RICH_TEXT_START )=> (lv_expression_2_0= ruleXExpression ) )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA244_1 = input.LA(1);

                         
                        int index244_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA244_2 = input.LA(1);

                         
                        int index244_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_2);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA244_3 = input.LA(1);

                         
                        int index244_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_3);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA244_4 = input.LA(1);

                         
                        int index244_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_4);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA244_5 = input.LA(1);

                         
                        int index244_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_5);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA244_6 = input.LA(1);

                         
                        int index244_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_6);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA244_7 = input.LA(1);

                         
                        int index244_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_7);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA244_8 = input.LA(1);

                         
                        int index244_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_8);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA244_9 = input.LA(1);

                         
                        int index244_9 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_9);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA244_10 = input.LA(1);

                         
                        int index244_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_10);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA244_11 = input.LA(1);

                         
                        int index244_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_11);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA244_12 = input.LA(1);

                         
                        int index244_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_12);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA244_13 = input.LA(1);

                         
                        int index244_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_13);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA244_14 = input.LA(1);

                         
                        int index244_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_14);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA244_15 = input.LA(1);

                         
                        int index244_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_15);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA244_16 = input.LA(1);

                         
                        int index244_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_16);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA244_17 = input.LA(1);

                         
                        int index244_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_17);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA244_18 = input.LA(1);

                         
                        int index244_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_18);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA244_19 = input.LA(1);

                         
                        int index244_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_19);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA244_20 = input.LA(1);

                         
                        int index244_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_20);
                        if ( s>=0 ) return s;
                        break;
                    case 20 : 
                        int LA244_21 = input.LA(1);

                         
                        int index244_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_21);
                        if ( s>=0 ) return s;
                        break;
                    case 21 : 
                        int LA244_22 = input.LA(1);

                         
                        int index244_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_22);
                        if ( s>=0 ) return s;
                        break;
                    case 22 : 
                        int LA244_23 = input.LA(1);

                         
                        int index244_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_23);
                        if ( s>=0 ) return s;
                        break;
                    case 23 : 
                        int LA244_24 = input.LA(1);

                         
                        int index244_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_24);
                        if ( s>=0 ) return s;
                        break;
                    case 24 : 
                        int LA244_25 = input.LA(1);

                         
                        int index244_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_25);
                        if ( s>=0 ) return s;
                        break;
                    case 25 : 
                        int LA244_26 = input.LA(1);

                         
                        int index244_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_26);
                        if ( s>=0 ) return s;
                        break;
                    case 26 : 
                        int LA244_27 = input.LA(1);

                         
                        int index244_27 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_27);
                        if ( s>=0 ) return s;
                        break;
                    case 27 : 
                        int LA244_28 = input.LA(1);

                         
                        int index244_28 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_28);
                        if ( s>=0 ) return s;
                        break;
                    case 28 : 
                        int LA244_29 = input.LA(1);

                         
                        int index244_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_29);
                        if ( s>=0 ) return s;
                        break;
                    case 29 : 
                        int LA244_30 = input.LA(1);

                         
                        int index244_30 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_30);
                        if ( s>=0 ) return s;
                        break;
                    case 30 : 
                        int LA244_31 = input.LA(1);

                         
                        int index244_31 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_31);
                        if ( s>=0 ) return s;
                        break;
                    case 31 : 
                        int LA244_32 = input.LA(1);

                         
                        int index244_32 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_32);
                        if ( s>=0 ) return s;
                        break;
                    case 32 : 
                        int LA244_33 = input.LA(1);

                         
                        int index244_33 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_33);
                        if ( s>=0 ) return s;
                        break;
                    case 33 : 
                        int LA244_34 = input.LA(1);

                         
                        int index244_34 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_34);
                        if ( s>=0 ) return s;
                        break;
                    case 34 : 
                        int LA244_35 = input.LA(1);

                         
                        int index244_35 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_35);
                        if ( s>=0 ) return s;
                        break;
                    case 35 : 
                        int LA244_36 = input.LA(1);

                         
                        int index244_36 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_36);
                        if ( s>=0 ) return s;
                        break;
                    case 36 : 
                        int LA244_37 = input.LA(1);

                         
                        int index244_37 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_37);
                        if ( s>=0 ) return s;
                        break;
                    case 37 : 
                        int LA244_38 = input.LA(1);

                         
                        int index244_38 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_38);
                        if ( s>=0 ) return s;
                        break;
                    case 38 : 
                        int LA244_39 = input.LA(1);

                         
                        int index244_39 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_39);
                        if ( s>=0 ) return s;
                        break;
                    case 39 : 
                        int LA244_40 = input.LA(1);

                         
                        int index244_40 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_40);
                        if ( s>=0 ) return s;
                        break;
                    case 40 : 
                        int LA244_41 = input.LA(1);

                         
                        int index244_41 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_41);
                        if ( s>=0 ) return s;
                        break;
                    case 41 : 
                        int LA244_42 = input.LA(1);

                         
                        int index244_42 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_42);
                        if ( s>=0 ) return s;
                        break;
                    case 42 : 
                        int LA244_43 = input.LA(1);

                         
                        int index244_43 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_43);
                        if ( s>=0 ) return s;
                        break;
                    case 43 : 
                        int LA244_44 = input.LA(1);

                         
                        int index244_44 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_44);
                        if ( s>=0 ) return s;
                        break;
                    case 44 : 
                        int LA244_45 = input.LA(1);

                         
                        int index244_45 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_45);
                        if ( s>=0 ) return s;
                        break;
                    case 45 : 
                        int LA244_46 = input.LA(1);

                         
                        int index244_46 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_46);
                        if ( s>=0 ) return s;
                        break;
                    case 46 : 
                        int LA244_47 = input.LA(1);

                         
                        int index244_47 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_47);
                        if ( s>=0 ) return s;
                        break;
                    case 47 : 
                        int LA244_48 = input.LA(1);

                         
                        int index244_48 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_48);
                        if ( s>=0 ) return s;
                        break;
                    case 48 : 
                        int LA244_49 = input.LA(1);

                         
                        int index244_49 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_49);
                        if ( s>=0 ) return s;
                        break;
                    case 49 : 
                        int LA244_50 = input.LA(1);

                         
                        int index244_50 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_50);
                        if ( s>=0 ) return s;
                        break;
                    case 50 : 
                        int LA244_51 = input.LA(1);

                         
                        int index244_51 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_51);
                        if ( s>=0 ) return s;
                        break;
                    case 51 : 
                        int LA244_52 = input.LA(1);

                         
                        int index244_52 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_52);
                        if ( s>=0 ) return s;
                        break;
                    case 52 : 
                        int LA244_53 = input.LA(1);

                         
                        int index244_53 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_53);
                        if ( s>=0 ) return s;
                        break;
                    case 53 : 
                        int LA244_54 = input.LA(1);

                         
                        int index244_54 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_54);
                        if ( s>=0 ) return s;
                        break;
                    case 54 : 
                        int LA244_55 = input.LA(1);

                         
                        int index244_55 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_55);
                        if ( s>=0 ) return s;
                        break;
                    case 55 : 
                        int LA244_56 = input.LA(1);

                         
                        int index244_56 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_56);
                        if ( s>=0 ) return s;
                        break;
                    case 56 : 
                        int LA244_57 = input.LA(1);

                         
                        int index244_57 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred55_InternalXtend()) ) {s = 107;}

                        else if ( (true) ) {s = 58;}

                         
                        input.seek(index244_57);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 244, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_173s = "\1\1\11\uffff";
    static final String dfa_174s = "\1\4\1\uffff\1\4\6\0\1\uffff";
    static final String dfa_175s = "\1\167\1\uffff\1\155\6\0\1\uffff";
    static final String dfa_176s = "\1\uffff\1\2\7\uffff\1\1";
    static final String dfa_177s = "\3\uffff\1\0\1\4\1\1\1\2\1\5\1\3\1\uffff}>";
    static final String[] dfa_178s = {
            "\24\1\1\2\31\1\6\uffff\42\1\1\uffff\20\1\1\uffff\14\1",
            "",
            "\1\1\1\uffff\2\1\2\uffff\2\1\2\uffff\2\1\1\4\4\uffff\2\1\2\uffff\14\1\2\uffff\2\1\1\5\1\uffff\1\6\1\7\1\10\1\1\41\uffff\1\1\20\uffff\1\1\13\uffff\1\3",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };
    static final short[] dfa_173 = DFA.unpackEncodedString(dfa_173s);
    static final char[] dfa_174 = DFA.unpackEncodedStringToUnsignedChars(dfa_174s);
    static final char[] dfa_175 = DFA.unpackEncodedStringToUnsignedChars(dfa_175s);
    static final short[] dfa_176 = DFA.unpackEncodedString(dfa_176s);
    static final short[] dfa_177 = DFA.unpackEncodedString(dfa_177s);
    static final short[][] dfa_178 = unpackEncodedStringArray(dfa_178s);

    class DFA248 extends DFA {

        public DFA248(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 248;
            this.eot = dfa_112;
            this.eof = dfa_173;
            this.min = dfa_174;
            this.max = dfa_175;
            this.accept = dfa_176;
            this.special = dfa_177;
            this.transition = dfa_178;
        }
        public String getDescription() {
            return "()* loopback of 11685:3: ( ( ( '.' )=>kw= '.' ) this_ValidID_2= ruleValidID )*";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA248_3 = input.LA(1);

                         
                        int index248_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred60_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index248_3);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA248_5 = input.LA(1);

                         
                        int index248_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred60_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index248_5);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA248_6 = input.LA(1);

                         
                        int index248_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred60_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index248_6);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA248_8 = input.LA(1);

                         
                        int index248_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred60_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index248_8);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA248_4 = input.LA(1);

                         
                        int index248_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred60_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index248_4);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA248_7 = input.LA(1);

                         
                        int index248_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred60_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index248_7);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 248, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_179s = "\157\uffff";
    static final String dfa_180s = "\1\2\156\uffff";
    static final String dfa_181s = "\1\4\1\0\155\uffff";
    static final String dfa_182s = "\1\167\1\0\155\uffff";
    static final String dfa_183s = "\2\uffff\1\2\153\uffff\1\1";
    static final String dfa_184s = "\1\uffff\1\0\155\uffff}>";
    static final String[] dfa_185s = {
            "\3\2\1\1\52\2\6\uffff\42\2\1\uffff\20\2\1\uffff\14\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_179 = DFA.unpackEncodedString(dfa_179s);
    static final short[] dfa_180 = DFA.unpackEncodedString(dfa_180s);
    static final char[] dfa_181 = DFA.unpackEncodedStringToUnsignedChars(dfa_181s);
    static final char[] dfa_182 = DFA.unpackEncodedStringToUnsignedChars(dfa_182s);
    static final short[] dfa_183 = DFA.unpackEncodedString(dfa_183s);
    static final short[] dfa_184 = DFA.unpackEncodedString(dfa_184s);
    static final short[][] dfa_185 = unpackEncodedStringArray(dfa_185s);

    class DFA262 extends DFA {

        public DFA262(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 262;
            this.eot = dfa_179;
            this.eof = dfa_180;
            this.min = dfa_181;
            this.max = dfa_182;
            this.accept = dfa_183;
            this.special = dfa_184;
            this.transition = dfa_185;
        }
        public String getDescription() {
            return "12008:3: ( ( ( '<' )=>otherlv_1= '<' ) ( (lv_arguments_2_0= ruleJvmArgumentTypeReference ) ) (otherlv_3= ',' ( (lv_arguments_4_0= ruleJvmArgumentTypeReference ) ) )* otherlv_5= '>' ( ( ( ( () '.' ) )=> ( () otherlv_7= '.' ) ) ( ( ruleValidID ) ) ( ( ( '<' )=>otherlv_9= '<' ) ( (lv_arguments_10_0= ruleJvmArgumentTypeReference ) ) (otherlv_11= ',' ( (lv_arguments_12_0= ruleJvmArgumentTypeReference ) ) )* otherlv_13= '>' )? )* )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA262_1 = input.LA(1);

                         
                        int index262_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred62_InternalXtend()) ) {s = 110;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index262_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 262, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_186s = "\3\uffff\1\2\1\0\1\3\1\4\1\1\1\5\1\uffff}>";
    static final String[] dfa_187s = {
            "\24\1\1\2\31\1\6\uffff\42\1\1\uffff\20\1\1\uffff\14\1",
            "",
            "\1\1\1\uffff\2\1\2\uffff\2\1\2\uffff\2\1\1\4\4\uffff\2\1\2\uffff\14\1\2\uffff\2\1\1\5\1\uffff\1\6\1\7\1\10\1\1\62\uffff\1\1\13\uffff\1\3",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };
    static final short[] dfa_186 = DFA.unpackEncodedString(dfa_186s);
    static final short[][] dfa_187 = unpackEncodedStringArray(dfa_187s);

    class DFA261 extends DFA {

        public DFA261(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 261;
            this.eot = dfa_112;
            this.eof = dfa_173;
            this.min = dfa_174;
            this.max = dfa_175;
            this.accept = dfa_176;
            this.special = dfa_186;
            this.transition = dfa_187;
        }
        public String getDescription() {
            return "()* loopback of 12064:4: ( ( ( ( () '.' ) )=> ( () otherlv_7= '.' ) ) ( ( ruleValidID ) ) ( ( ( '<' )=>otherlv_9= '<' ) ( (lv_arguments_10_0= ruleJvmArgumentTypeReference ) ) (otherlv_11= ',' ( (lv_arguments_12_0= ruleJvmArgumentTypeReference ) ) )* otherlv_13= '>' )? )*";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA261_4 = input.LA(1);

                         
                        int index261_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred63_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index261_4);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA261_7 = input.LA(1);

                         
                        int index261_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred63_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index261_7);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA261_3 = input.LA(1);

                         
                        int index261_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred63_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index261_3);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA261_5 = input.LA(1);

                         
                        int index261_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred63_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index261_5);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA261_6 = input.LA(1);

                         
                        int index261_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred63_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index261_6);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA261_8 = input.LA(1);

                         
                        int index261_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred63_InternalXtend()) ) {s = 9;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index261_8);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 261, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA260 extends DFA {

        public DFA260(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 260;
            this.eot = dfa_179;
            this.eof = dfa_180;
            this.min = dfa_181;
            this.max = dfa_182;
            this.accept = dfa_183;
            this.special = dfa_184;
            this.transition = dfa_185;
        }
        public String getDescription() {
            return "12102:5: ( ( ( '<' )=>otherlv_9= '<' ) ( (lv_arguments_10_0= ruleJvmArgumentTypeReference ) ) (otherlv_11= ',' ( (lv_arguments_12_0= ruleJvmArgumentTypeReference ) ) )* otherlv_13= '>' )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA260_1 = input.LA(1);

                         
                        int index260_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred64_InternalXtend()) ) {s = 110;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index260_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 260, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_188s = "\2\uffff\6\11\3\uffff\6\11";
    static final String dfa_189s = "\1\20\1\uffff\6\4\1\20\2\uffff\6\4";
    static final String dfa_190s = "\1\155\1\uffff\6\70\1\155\2\uffff\6\70";
    static final String dfa_191s = "\1\uffff\1\1\7\uffff\1\2\1\3\6\uffff";
    static final String[] dfa_192s = {
            "\1\4\14\uffff\1\1\13\uffff\1\3\1\uffff\1\5\1\6\1\7\77\uffff\1\2",
            "",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\1\15\30\uffff\1\14\1\uffff\1\16\1\17\1\20\42\uffff\1\12\34\uffff\1\13",
            "",
            "",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11",
            "\3\11\7\uffff\3\11\7\uffff\1\10\14\11\11\uffff\1\11\11\uffff\1\11"
    };
    static final short[] dfa_188 = DFA.unpackEncodedString(dfa_188s);
    static final char[] dfa_189 = DFA.unpackEncodedStringToUnsignedChars(dfa_189s);
    static final char[] dfa_190 = DFA.unpackEncodedStringToUnsignedChars(dfa_190s);
    static final short[] dfa_191 = DFA.unpackEncodedString(dfa_191s);
    static final short[][] dfa_192 = unpackEncodedStringArray(dfa_192s);

    class DFA272 extends DFA {

        public DFA272(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 272;
            this.eot = dfa_58;
            this.eof = dfa_188;
            this.min = dfa_189;
            this.max = dfa_190;
            this.accept = dfa_191;
            this.special = dfa_62;
            this.transition = dfa_192;
        }
        public String getDescription() {
            return "12654:3: ( ( ( (lv_static_1_0= 'static' ) ) ( (lv_extension_2_0= 'extension' ) )? ( ( ruleQualifiedNameInStaticImport ) ) ( ( (lv_wildcard_4_0= '*' ) ) | ( (lv_memberName_5_0= ruleValidID ) ) ) ) | ( ( ruleQualifiedName ) ) | ( (lv_importedNamespace_7_0= ruleQualifiedNameWithWildcard ) ) )";
        }
    }
 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x00003A0000010000L,0x0000200000000000L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0100401FFE01C072L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0100401FFE01C052L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0100001FFE01C052L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0100001FFE01C050L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000001FFE000050L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000001C80L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000000300L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000001C00L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000001800L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x00003A00000B0000L,0x0000200000000000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000001100L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x01003BFFFEABE050L,0x0000200000000000L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000001FFE004010L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000001480L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000000001400L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000001FFE008010L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x01003A0000012020L,0x0000200000000000L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x0000000000002120L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x01003A0000010000L,0x0000200000000000L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x0000001FFE010010L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x01003A7FFE2BE050L,0x0000200000000000L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x00003A7FFE2F0010L,0x0000200000000000L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x0000000000040100L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x00003A7FFE2B0010L,0x0000200000000000L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x01003A7FFE2BC050L,0x0000200000000000L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x0000007FFE000010L});
    public static final BitSet FOLLOW_33 = new BitSet(new long[]{0x0000000000100022L});
    public static final BitSet FOLLOW_34 = new BitSet(new long[]{0x07017B9FFEE3DCD0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_35 = new BitSet(new long[]{0x0000000000000022L});
    public static final BitSet FOLLOW_36 = new BitSet(new long[]{0x01003BFFFEABC050L,0x0000200000000000L});
    public static final BitSet FOLLOW_37 = new BitSet(new long[]{0x00003A0000110022L,0x0000200000000000L});
    public static final BitSet FOLLOW_38 = new BitSet(new long[]{0x0000001FFE200010L});
    public static final BitSet FOLLOW_39 = new BitSet(new long[]{0x0000019FFE000010L});
    public static final BitSet FOLLOW_40 = new BitSet(new long[]{0xF0003BFFFE2B0290L,0x0000200000DFFEFFL});
    public static final BitSet FOLLOW_41 = new BitSet(new long[]{0x0000020000000000L});
    public static final BitSet FOLLOW_42 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_43 = new BitSet(new long[]{0x01003A7FFE2F0010L,0x0000200000000000L});
    public static final BitSet FOLLOW_44 = new BitSet(new long[]{0x01003A7FFE2B0010L,0x0000200000000000L});
    public static final BitSet FOLLOW_45 = new BitSet(new long[]{0x0000000000401022L,0x0001C00000000000L});
    public static final BitSet FOLLOW_46 = new BitSet(new long[]{0x0000000000001122L,0x0001C00000000000L});
    public static final BitSet FOLLOW_47 = new BitSet(new long[]{0x0000001FFE800010L});
    public static final BitSet FOLLOW_48 = new BitSet(new long[]{0x0000000000020080L});
    public static final BitSet FOLLOW_49 = new BitSet(new long[]{0x0000000000401000L});
    public static final BitSet FOLLOW_50 = new BitSet(new long[]{0x0400000000000002L});
    public static final BitSet FOLLOW_51 = new BitSet(new long[]{0x0400000000000000L});
    public static final BitSet FOLLOW_52 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_53 = new BitSet(new long[]{0x00003A7FFE2B0010L,0x0000280000000000L});
    public static final BitSet FOLLOW_54 = new BitSet(new long[]{0x0000000001000002L});
    public static final BitSet FOLLOW_55 = new BitSet(new long[]{0x0000000001000082L});
    public static final BitSet FOLLOW_56 = new BitSet(new long[]{0x0000040000000000L});
    public static final BitSet FOLLOW_57 = new BitSet(new long[]{0x0000BA0000010000L,0x0000200000000000L});
    public static final BitSet FOLLOW_58 = new BitSet(new long[]{0x00007BFFFE6BCC50L,0x0000200000000000L});
    public static final BitSet FOLLOW_59 = new BitSet(new long[]{0x0000006000000000L});
    public static final BitSet FOLLOW_60 = new BitSet(new long[]{0x00007B9FFE41CC50L,0x0000200000000000L});
    public static final BitSet FOLLOW_61 = new BitSet(new long[]{0x0000000000100002L});
    public static final BitSet FOLLOW_62 = new BitSet(new long[]{0x0000000000001002L});
    public static final BitSet FOLLOW_63 = new BitSet(new long[]{0x0400000000020082L});
    public static final BitSet FOLLOW_64 = new BitSet(new long[]{0x0400000000020002L});
    public static final BitSet FOLLOW_65 = new BitSet(new long[]{0x07017BFFFEEFDCD0L,0x00E1E1FFCC10C000L});
    public static final BitSet FOLLOW_66 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_67 = new BitSet(new long[]{0x07017BFFFEEBDCD0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_68 = new BitSet(new long[]{0x00023E7FFE2B2110L,0x0000200020000000L});
    public static final BitSet FOLLOW_69 = new BitSet(new long[]{0x07157BFFFEE3DCD0L,0x00FFE1FFC810C000L});
    public static final BitSet FOLLOW_70 = new BitSet(new long[]{0x07157BFFFEE3DCD2L,0x00E7E1FFC810C000L});
    public static final BitSet FOLLOW_71 = new BitSet(new long[]{0x0000000000000000L,0x0006000000000000L});
    public static final BitSet FOLLOW_72 = new BitSet(new long[]{0x0000380000000000L,0x0006000000000000L});
    public static final BitSet FOLLOW_73 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_74 = new BitSet(new long[]{0x00E0000000000000L});
    public static final BitSet FOLLOW_75 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_76 = new BitSet(new long[]{0x0000000000020002L});
    public static final BitSet FOLLOW_77 = new BitSet(new long[]{0x07017B9FFEE7DCD0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_78 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_79 = new BitSet(new long[]{0x0F017B9FFEE3DCD0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_80 = new BitSet(new long[]{0x0800000000000100L});
    public static final BitSet FOLLOW_81 = new BitSet(new long[]{0x0000000000000102L});
    public static final BitSet FOLLOW_82 = new BitSet(new long[]{0xF000000000000282L,0x0000000000000001L});
    public static final BitSet FOLLOW_83 = new BitSet(new long[]{0x0000000000000200L,0x0000000000000002L});
    public static final BitSet FOLLOW_84 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_85 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000004L});
    public static final BitSet FOLLOW_86 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000008L});
    public static final BitSet FOLLOW_87 = new BitSet(new long[]{0x0000000000000002L,0x00000000000000F0L});
    public static final BitSet FOLLOW_88 = new BitSet(new long[]{0x0000000000000282L,0x0000000000000102L});
    public static final BitSet FOLLOW_89 = new BitSet(new long[]{0x0000000000080282L,0x0000000000003E00L});
    public static final BitSet FOLLOW_90 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_91 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_92 = new BitSet(new long[]{0x0000000000080080L});
    public static final BitSet FOLLOW_93 = new BitSet(new long[]{0x0000000000000002L,0x000000000000C000L});
    public static final BitSet FOLLOW_94 = new BitSet(new long[]{0x0000000000000002L,0x00000000000F0000L});
    public static final BitSet FOLLOW_95 = new BitSet(new long[]{0x0000000000000002L,0x0000000000200000L});
    public static final BitSet FOLLOW_96 = new BitSet(new long[]{0xF0003BFFFE2B0292L,0x0000200000DFFEFFL});
    public static final BitSet FOLLOW_97 = new BitSet(new long[]{0x0000000001000002L,0x0000000003000000L});
    public static final BitSet FOLLOW_98 = new BitSet(new long[]{0x00007B9FFE61CC50L,0x0000200000000000L});
    public static final BitSet FOLLOW_99 = new BitSet(new long[]{0x00007B9FFE61CCD0L,0x0000200200000000L});
    public static final BitSet FOLLOW_100 = new BitSet(new long[]{0x0400000001020002L,0x0000000003000000L});
    public static final BitSet FOLLOW_101 = new BitSet(new long[]{0x0400000001000002L,0x0000000003000000L});
    public static final BitSet FOLLOW_102 = new BitSet(new long[]{0x07017B9FFEE3FCD0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_103 = new BitSet(new long[]{0x0000000000002100L});
    public static final BitSet FOLLOW_104 = new BitSet(new long[]{0x0F017BFFFEEBDCD0L,0x00E1E1FFCC10C000L});
    public static final BitSet FOLLOW_105 = new BitSet(new long[]{0x0000000000000100L,0x0000000004000000L});
    public static final BitSet FOLLOW_106 = new BitSet(new long[]{0x0F017BFFFEE3DCD0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_107 = new BitSet(new long[]{0x0800000000000000L});
    public static final BitSet FOLLOW_108 = new BitSet(new long[]{0x07017BFFFEE3DCF2L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_109 = new BitSet(new long[]{0x07017BFFFEE3DCD2L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_110 = new BitSet(new long[]{0x0000000000000002L,0x0000000010000000L});
    public static final BitSet FOLLOW_111 = new BitSet(new long[]{0x0000040000000100L,0x0000000020000000L});
    public static final BitSet FOLLOW_112 = new BitSet(new long[]{0x0000040000000100L});
    public static final BitSet FOLLOW_113 = new BitSet(new long[]{0x07017BFFFEE3DCF0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_114 = new BitSet(new long[]{0x0000000000000120L});
    public static final BitSet FOLLOW_115 = new BitSet(new long[]{0x07017BFFFEE3DCD0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_116 = new BitSet(new long[]{0x07017B9FFEE3DCF0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_117 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_118 = new BitSet(new long[]{0x0000000000000000L,0x0000000080000000L});
    public static final BitSet FOLLOW_119 = new BitSet(new long[]{0x07017BFFFEE3FCD0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_120 = new BitSet(new long[]{0x07017BFFFEE3FCF0L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_121 = new BitSet(new long[]{0x0400000000040000L});
    public static final BitSet FOLLOW_122 = new BitSet(new long[]{0x07017B9FFEE3DCD2L,0x00E1E1FFC810C000L});
    public static final BitSet FOLLOW_123 = new BitSet(new long[]{0x0000000000000000L,0x0000060000000000L});
    public static final BitSet FOLLOW_124 = new BitSet(new long[]{0x0000000000000002L,0x0000060000000000L});
    public static final BitSet FOLLOW_125 = new BitSet(new long[]{0x0000000000000000L,0x00C0000000000000L});
    public static final BitSet FOLLOW_126 = new BitSet(new long[]{0x0000000000000082L});
    public static final BitSet FOLLOW_127 = new BitSet(new long[]{0x0000000000000402L,0x0000000200000000L});
    public static final BitSet FOLLOW_128 = new BitSet(new long[]{0x0000000000000002L,0x0000100000000000L});
    public static final BitSet FOLLOW_129 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_130 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_131 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_132 = new BitSet(new long[]{0x0000400000000002L});
    public static final BitSet FOLLOW_133 = new BitSet(new long[]{0x00003A0020010000L,0x0000200000000000L});
    public static final BitSet FOLLOW_134 = new BitSet(new long[]{0x00003A0000210000L,0x0000200000000000L});
    public static final BitSet FOLLOW_135 = new BitSet(new long[]{0x00003A0000010000L,0x0000200000010000L});
    public static final BitSet FOLLOW_136 = new BitSet(new long[]{0x00003A0000010002L,0x0000200000000000L});
    public static final BitSet FOLLOW_137 = new BitSet(new long[]{0x0000000000200002L});

}